/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "igniteui-react";
import { WCNativeHelper } from "igniteui-react";
import { Base, markType, enumGetBox, EnumUtil, typeGetValue, typeCast, Date_$type } from "igniteui-react-core";
import { BaseEventArgs } from "./BaseEventArgs";
import { RowExportingEventArgs } from "./RowExportingEventArgs";
import { GridCellIdentifier } from "./GridCellIdentifier";
import { GridValidationState } from "./GridValidationState";
import { SummaryResult } from "./SummaryResult";
import { GridColumnDataType_$type } from "./GridColumnDataType";
import { FilteringOperand } from "./FilteringOperand";
import { SortingStrategy } from "./SortingStrategy";
import { SummaryTemplateContext } from "./SummaryTemplateContext";
import { ColumnPipeArgs } from "./ColumnPipeArgs";
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { ObservableCollection$1 } from "igniteui-react-core";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { DisplayDensityBase } from "./DisplayDensityBase";
import { ActionStrip } from "./ActionStrip";
import { DataCloneStrategy } from "./DataCloneStrategy";
import { ClipboardOptions } from "./ClipboardOptions";
import { ActionStripCollection } from "./ActionStripCollection";
import { GridRowEditTextTemplateContext } from "./GridRowEditTextTemplateContext";
import { GridEmptyTemplateContext } from "./GridEmptyTemplateContext";
import { GridRowEditActionsTemplateContext } from "./GridRowEditActionsTemplateContext";
import { PaginatorCollection } from "./PaginatorCollection";
import { GridResourceStrings } from "./GridResourceStrings";
import { FilteringLogic_$type } from "./FilteringLogic";
import { GridPagingMode_$type } from "./GridPagingMode";
import { GridValidationTrigger_$type } from "./GridValidationTrigger";
import { PinningConfig } from "./PinningConfig";
import { FilterMode_$type } from "./FilterMode";
import { GridSummaryPosition_$type } from "./GridSummaryPosition";
import { GridSummaryCalculationMode_$type } from "./GridSummaryCalculationMode";
import { SortingOptions } from "./SortingOptions";
import { HeadSelectorTemplateContext } from "./HeadSelectorTemplateContext";
import { RowSelectorTemplateContext } from "./RowSelectorTemplateContext";
import { SortingExpression } from "./SortingExpression";
import { GridSelectionMode_$type } from "./GridSelectionMode";
import { ForOfState } from "./ForOfState";
import { OverlayOutletDirective } from "./OverlayOutletDirective";
import { StateCollection } from "./StateCollection";
import { FilteringExpressionsTreeEventArgs } from "./FilteringExpressionsTreeEventArgs";
import { GridScrollEventArgs } from "./GridScrollEventArgs";
import { RowSelectionEventArgs } from "./RowSelectionEventArgs";
import { ColumnSelectionEventArgs } from "./ColumnSelectionEventArgs";
import { SortingEventArgs } from "./SortingEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { FilteringEventArgs } from "./FilteringEventArgs";
import { RowDataEventArgs } from "./RowDataEventArgs";
import { ColumnVisibilityChangingEventArgs } from "./ColumnVisibilityChangingEventArgs";
import { ColumnVisibilityChangedEventArgs } from "./ColumnVisibilityChangedEventArgs";
import { GridKeydownEventArgs } from "./GridKeydownEventArgs";
import { GridClipboardEventEventArgs } from "./GridClipboardEventEventArgs";
import { RowToggleEventArgs } from "./RowToggleEventArgs";
import { ActiveNodeChangeEventArgs } from "./ActiveNodeChangeEventArgs";
import { GridSelectionRangeEventArgs } from "./GridSelectionRangeEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { ForOfDataChangingEventArgs } from "./ForOfDataChangingEventArgs";
import { DropPosition_$type } from "./DropPosition";
import { GridSelectionRange } from "./GridSelectionRange";
import { CellPosition } from "./CellPosition";
import { Paginator } from "./Paginator";
import { GridState } from "./GridState";
import { DisplayDensityBaseElement } from "./DisplayDensityBaseElement";
import { GridToolbarContentCollection } from "./GridToolbarContentCollection";
import { ValidationStatus_$type } from "./ValidationStatus";
import { DisplayDensity_$type } from "./DisplayDensity";
import { SortingDirection_$type } from "./SortingDirection";
import { TreeGridRecord } from "./TreeGridRecord";
/**
 * @hidden
 */
export let BaseExporter = /*@__PURE__*/ (() => {
    class BaseExporter extends BaseElement {
        constructor() {
            super(...arguments);
            this.d = new WCNativeHelper();
            this.f = null;
            this.exportEnded = null;
            this.rowExporting = null;
            this.columnExporting = null;
        }
        get e() {
            return this.d;
        }
        get nativeElement() {
            return this.f;
        }
        set nativeElement(a) {
            this.f = a;
            this.d.o = this.f;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        exportEndedChanged() {
            if (this.exportEnded != null) {
                this.e.r("exportEnded", (a) => this.exportEnded(this, BaseEventArgs.a(a)), false);
            }
            else {
                this.e.u("exportEnded");
            }
        }
        rowExportingChanged() {
            if (this.rowExporting != null) {
                this.e.r("rowExporting", (a) => this.rowExporting(this, RowExportingEventArgs.a(a)), false);
            }
            else {
                this.e.u("rowExporting");
            }
        }
        columnExportingChanged() {
            if (this.columnExporting != null) {
                this.e.r("columnExporting", (a) => this.columnExporting(this, ColumnExportingEventArgs.a(a)), false);
            }
            else {
                this.e.u("columnExporting");
            }
        }
        l(a, b) {
            this.nativeElement.export(this.e.i(a), this.e.i(b));
        }
        j(a, b) {
            this.nativeElement.exportData(this.e.i(a), this.e.i(b));
        }
        h(a) {
            this.nativeElement.addPivotGridColumns(this.e.i(a));
        }
    }
    BaseExporter.$t = /*@__PURE__*/ markType(BaseExporter, 'BaseExporter', BaseElement.$);
    return BaseExporter;
})();
/**
 * @hidden
 */
export let CellTemplateContext = /*@__PURE__*/ (() => {
    class CellTemplateContext extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get f() {
            let ret_ = this.c.n("implicit");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.c.v("implicit", value_);
        }
        get e() {
            let ret_ = this.c.n("additionalTemplateContext");
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.c.v("additionalTemplateContext", value_);
        }
        get a() {
            let ret_ = this.c.m("cell", (a) => new CellType());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("cell", value_);
        }
    }
    CellTemplateContext.$t = /*@__PURE__*/ markType(CellTemplateContext, 'CellTemplateContext');
    return CellTemplateContext;
})();
/**
 * @hidden
 */
export let CellType = /*@__PURE__*/ (() => {
    class CellType extends Base {
        constructor() {
            super(...arguments);
            this.g = new WCNativeHelper();
            this.p = null;
        }
        get h() {
            return this.g;
        }
        get nativeElement() {
            return this.p;
        }
        set nativeElement(a) {
            this.p = a;
            this.g.o = this.p;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get u() {
            let ret_ = this.h.n("value");
            return ret_;
        }
        set u(a) {
            let value_ = a;
            this.h.v("value", value_);
        }
        get r() {
            let ret_ = this.h.n("editValue");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.h.v("editValue", value_);
        }
        get m() {
            let ret_ = this.h.n("selected");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.h.v("selected", value_);
        }
        get i() {
            let ret_ = this.h.n("active");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.h.v("active", value_);
        }
        get j() {
            let ret_ = this.h.n("editable");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.h.v("editable", value_);
        }
        get k() {
            let ret_ = this.h.n("editMode");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.h.v("editMode", value_);
        }
        get b() {
            let ret_ = this.h.m("column", (a) => new Column());
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.h.v("column", value_);
        }
        get f() {
            let ret_ = this.h.m("row", (a) => new RowType());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.h.v("row", value_);
        }
        get c() {
            let ret_ = this.h.n("grid");
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.h.v("grid", value_);
        }
        get d() {
            let ret_ = this.h.m("id", (a) => new GridCellIdentifier());
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.h.v("id", value_);
        }
        get q() {
            let ret_ = this.h.n("cellID");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.h.v("cellID", value_);
        }
        get e() {
            let ret_ = this.h.m("validation", (a) => new GridValidationState());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.h.v("validation", value_);
        }
        get l() {
            let ret_ = this.h.n("readonly");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.h.v("readonly", value_);
        }
        get t() {
            let ret_ = this.h.n("title");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.h.v("title", value_);
        }
        get v() {
            let ret_ = this.h.n("width");
            return ret_;
        }
        set v(a) {
            let value_ = a;
            this.h.v("width", value_);
        }
        get o() {
            let ret_ = this.h.n("visibleColumnIndex");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.h.v("visibleColumnIndex", value_);
        }
        y(a) {
            this.nativeElement.update(this.h.i(a));
        }
        w(a) {
            this.nativeElement.setEditMode(this.h.i(a));
        }
        n(a) {
            return (this.nativeElement.calculateSizeToFit(this.h.i(a)));
        }
    }
    CellType.$t = /*@__PURE__*/ markType(CellType, 'CellType');
    CellType.__marshalByValueIgnore = ["row"];
    return CellType;
})();
/**
 * @hidden
 */
export let Column = /*@__PURE__*/ (() => {
    class Column extends BaseElement {
        constructor() {
            super(...arguments);
            this.h = new WCNativeHelper();
            this.ah = null;
            this.av = null;
            this.aq = null;
            this.at = null;
            this.au = null;
            this.ar = null;
            this.as = null;
        }
        get i() {
            return this.h;
        }
        get nativeElement() {
            return this.ah;
        }
        set nativeElement(a) {
            this.ah = a;
            this.h.o = this.ah;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a2() {
            let ret_ = this.i.n("field");
            return ret_;
        }
        set a2(a) {
            let value_ = a;
            this.i.v("field", value_);
        }
        get a3() {
            let ret_ = this.i.n("header");
            return ret_;
        }
        set a3(a) {
            let value_ = a;
            this.i.v("header", value_);
        }
        get a9() {
            let ret_ = this.i.n("title");
            return ret_;
        }
        set a9(a) {
            let value_ = a;
            this.i.v("title", value_);
        }
        get z() {
            let ret_ = this.i.n("sortable");
            return ret_;
        }
        set z(a) {
            let value_ = a;
            this.i.v("sortable", value_);
        }
        get x() {
            let ret_ = this.i.n("selectable");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.i.v("selectable", value_);
        }
        get p() {
            let ret_ = this.i.n("groupable");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.i.v("groupable", value_);
        }
        get m() {
            let ret_ = this.i.n("editable");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.i.v("editable", value_);
        }
        get n() {
            let ret_ = this.i.n("filterable");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.i.v("filterable", value_);
        }
        get v() {
            let ret_ = this.i.n("resizable");
            return ret_;
        }
        set v(a) {
            let value_ = a;
            this.i.v("resizable", value_);
        }
        get j() {
            let ret_ = this.i.n("autosizeHeader");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.i.v("autosizeHeader", value_);
        }
        get q() {
            let ret_ = this.i.n("hasSummary");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.i.v("hasSummary", value_);
        }
        get r() {
            let ret_ = this.i.n("hidden");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.i.v("hidden", value_);
        }
        get y() {
            let ret_ = this.i.n("selected");
            return ret_;
        }
        set y(a) {
            let value_ = a;
            this.i.v("selected", value_);
        }
        get k() {
            let ret_ = this.i.n("disableHiding");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.i.v("disableHiding", value_);
        }
        get l() {
            let ret_ = this.i.n("disablePinning");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.i.v("disablePinning", value_);
        }
        get s() {
            let ret_ = this.i.n("movable");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.i.v("movable", value_);
        }
        get ba() {
            let ret_ = this.i.n("width");
            return ret_;
        }
        set ba(a) {
            let value_ = a;
            this.i.v("width", value_);
        }
        get a6() {
            let ret_ = this.i.n("maxWidth");
            return ret_;
        }
        set a6(a) {
            let value_ = a;
            this.i.v("maxWidth", value_);
        }
        get a4() {
            let ret_ = this.i.n("headerClasses");
            return ret_;
        }
        set a4(a) {
            let value_ = a;
            this.i.v("headerClasses", value_);
        }
        get am() {
            let ret_ = this.i.n("headerStyles");
            return ret_;
        }
        set am(a) {
            let value_ = a;
            this.i.v("headerStyles", value_);
        }
        get a5() {
            let ret_ = this.i.n("headerGroupClasses");
            return ret_;
        }
        set a5(a) {
            let value_ = a;
            this.i.v("headerGroupClasses", value_);
        }
        get al() {
            let ret_ = this.i.n("headerGroupStyles");
            return ret_;
        }
        set al(a) {
            let value_ = a;
            this.i.v("headerGroupStyles", value_);
        }
        get aj() {
            let ret_ = this.i.n("cellClasses");
            return ret_;
        }
        set aj(a) {
            let value_ = a;
            this.i.v("cellClasses", value_);
        }
        get ak() {
            let ret_ = this.i.n("cellStyles");
            return ret_;
        }
        set ak(a) {
            let value_ = a;
            this.i.v("cellStyles", value_);
        }
        get b() {
            let ret_ = this.i.n("formatter");
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.i.v("formatter", value_);
        }
        get g() {
            let ret_ = this.i.n("summaryFormatter");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.i.v("summaryFormatter", value_);
        }
        get o() {
            let ret_ = this.i.n("filteringIgnoreCase");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.i.v("filteringIgnoreCase", value_);
        }
        get aa() {
            let ret_ = this.i.n("sortingIgnoreCase");
            return ret_;
        }
        set aa(a) {
            let value_ = a;
            this.i.v("sortingIgnoreCase", value_);
        }
        get w() {
            let ret_ = this.i.n("searchable");
            return ret_;
        }
        set w(a) {
            let value_ = a;
            this.i.v("searchable", value_);
        }
        get e() {
            let ret_ = this.i.n("dataType");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridColumnDataType_$type, EnumUtil.getEnumValue(GridColumnDataType_$type, this.i.f(GridColumnDataType_$type, ret_)));
            return EnumUtil.getEnumValue(GridColumnDataType_$type, ret_);
        }
        set e(a) {
            let value_ = enumGetBox(GridColumnDataType_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.i.v("dataType", value_);
        }
        get af() {
            let ret_ = this.i.n("rowEnd");
            return ret_;
        }
        set af(a) {
            let value_ = a;
            this.i.v("rowEnd", value_);
        }
        get ad() {
            let ret_ = this.i.n("colEnd");
            return ret_;
        }
        set ad(a) {
            let value_ = a;
            this.i.v("colEnd", value_);
        }
        get ag() {
            let ret_ = this.i.n("rowStart");
            return ret_;
        }
        set ag(a) {
            let value_ = a;
            this.i.v("rowStart", value_);
        }
        get ae() {
            let ret_ = this.i.n("colStart");
            return ret_;
        }
        set ae(a) {
            let value_ = a;
            this.i.v("colStart", value_);
        }
        get ai() {
            let ret_ = this.i.n("additionalTemplateContext");
            return ret_;
        }
        set ai(a) {
            let value_ = a;
            this.i.v("additionalTemplateContext", value_);
        }
        get a7() {
            let ret_ = this.i.n("minWidth");
            return ret_;
        }
        set a7(a) {
            let value_ = a;
            this.i.v("minWidth", value_);
        }
        get u() {
            let ret_ = this.i.n("pinned");
            return ret_;
        }
        set u(a) {
            let value_ = a;
            this.i.v("pinned", value_);
        }
        get ap() {
            let ret_ = this.i.n("summaries");
            return ret_;
        }
        set ap(a) {
            let value_ = a;
            this.i.v("summaries", value_);
        }
        get d() {
            let ret_ = this.i.m("filters", (a) => new FilteringOperand());
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.i.v("filters", value_);
        }
        get f() {
            let ret_ = this.i.m("sortStrategy", (a) => new SortingStrategy());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.i.v("sortStrategy", value_);
        }
        get a1() {
            return this.av;
        }
        set a1(a) {
            this.av = a;
            this.i.s("summaryTemplate", (b) => new SummaryTemplateContext(), this.av);
        }
        get aw() {
            return this.aq;
        }
        set aw(a) {
            this.aq = a;
            this.i.s("bodyTemplate", (b) => new CellTemplateContext(), this.aq);
        }
        get az() {
            return this.at;
        }
        set az(a) {
            this.at = a;
            this.i.s("headerTemplate", (b) => new ColumnTemplateContext(), this.at);
        }
        get a0() {
            return this.au;
        }
        set a0(a) {
            this.au = a;
            this.i.s("inlineEditorTemplate", (b) => new CellTemplateContext(), this.au);
        }
        get ax() {
            return this.ar;
        }
        set ax(a) {
            this.ar = a;
            this.i.s("errorTemplate", (b) => new CellTemplateContext(), this.ar);
        }
        get ay() {
            return this.as;
        }
        set ay(a) {
            this.as = a;
            this.i.s("filterCellTemplate", (b) => new ColumnTemplateContext(), this.as);
        }
        get ac() {
            let ret_ = this.i.n("visibleWhenCollapsed");
            return ret_;
        }
        set ac(a) {
            let value_ = a;
            this.i.v("visibleWhenCollapsed", value_);
        }
        get c() {
            let ret_ = this.i.m("pipeArgs", (a) => new ColumnPipeArgs());
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.i.v("pipeArgs", value_);
        }
        get ao() {
            let ret_ = this.i.n("parent");
            return ret_;
        }
        set ao(a) {
            let value_ = a;
            this.i.v("parent", value_);
        }
        get a() {
            let ret_ = this.i.m("columnChildren", (a) => new Column());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.i.v("columnChildren", value_);
        }
        t(a = -1) {
            return (this.nativeElement.pin(this.i.i(a)));
        }
        ab(a = -1) {
            return (this.nativeElement.unpin(this.i.i(a)));
        }
        bc(a) {
            this.nativeElement.move(this.i.i(a));
        }
        bb(a = false) {
            this.nativeElement.autosize(this.i.i(a));
        }
        get a8() {
            let ret_ = this.i.n("name");
            return ret_;
        }
        set a8(a) {
            let value_ = a;
            this.i.v("name", value_);
        }
    }
    Column.$t = /*@__PURE__*/ markType(Column, 'Column', BaseElement.$);
    return Column;
})();
/**
 * @hidden
 */
export let ColumnComponentEventArgs = /*@__PURE__*/ (() => {
    class ColumnComponentEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
        static b(a) {
            return ((() => {
                let $ret = new ColumnComponentEventArgs();
                $ret.a = WCNativeHelper.h(a, (b) => new Column());
                return $ret;
            })());
        }
    }
    ColumnComponentEventArgs.$t = /*@__PURE__*/ markType(ColumnComponentEventArgs, 'ColumnComponentEventArgs');
    return ColumnComponentEventArgs;
})();
/**
 * @hidden
 */
export let ColumnExportingEventArgs = /*@__PURE__*/ (() => {
    class ColumnExportingEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new ColumnExportingEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new ColumnExportingEventArgsDetail());
                return $ret;
            })());
        }
    }
    ColumnExportingEventArgs.$t = /*@__PURE__*/ markType(ColumnExportingEventArgs, 'ColumnExportingEventArgs');
    return ColumnExportingEventArgs;
})();
/**
 * @hidden
 */
export let ColumnExportingEventArgsDetail = /*@__PURE__*/ (() => {
    class ColumnExportingEventArgsDetail extends BaseEventArgsDetail {
        get l() {
            let ret_ = this.b.n("header");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.b.v("header", value_);
        }
        get k() {
            let ret_ = this.b.n("field");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.b.v("field", value_);
        }
        get j() {
            let ret_ = this.b.n("columnIndex");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.b.v("columnIndex", value_);
        }
        get h() {
            let ret_ = this.b.n("cancel");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("cancel", value_);
        }
        get i() {
            let ret_ = this.b.n("skipFormatter");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("skipFormatter", value_);
        }
        get g() {
            let ret_ = this.b.n("grid");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("grid", value_);
        }
    }
    ColumnExportingEventArgsDetail.$t = /*@__PURE__*/ markType(ColumnExportingEventArgsDetail, 'ColumnExportingEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnExportingEventArgsDetail;
})();
/**
 * @hidden
 */
export let ColumnMovingEndEventArgs = /*@__PURE__*/ (() => {
    class ColumnMovingEndEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new ColumnMovingEndEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new ColumnMovingEndEventArgsDetail());
                return $ret;
            })());
        }
    }
    ColumnMovingEndEventArgs.$t = /*@__PURE__*/ markType(ColumnMovingEndEventArgs, 'ColumnMovingEndEventArgs');
    return ColumnMovingEndEventArgs;
})();
/**
 * @hidden
 */
export let ColumnMovingEndEventArgsDetail = /*@__PURE__*/ (() => {
    class ColumnMovingEndEventArgsDetail extends BaseEventArgsDetail {
        get g() {
            let ret_ = this.b.m("source", (a) => new Column());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("source", value_);
        }
        get h() {
            let ret_ = this.b.m("target", (a) => new Column());
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("target", value_);
        }
        get i() {
            let ret_ = this.b.n("cancel");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("cancel", value_);
        }
    }
    ColumnMovingEndEventArgsDetail.$t = /*@__PURE__*/ markType(ColumnMovingEndEventArgsDetail, 'ColumnMovingEndEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnMovingEndEventArgsDetail;
})();
/**
 * @hidden
 */
export let ColumnMovingEventArgs = /*@__PURE__*/ (() => {
    class ColumnMovingEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new ColumnMovingEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new ColumnMovingEventArgsDetail());
                return $ret;
            })());
        }
    }
    ColumnMovingEventArgs.$t = /*@__PURE__*/ markType(ColumnMovingEventArgs, 'ColumnMovingEventArgs');
    return ColumnMovingEventArgs;
})();
/**
 * @hidden
 */
export let ColumnMovingEventArgsDetail = /*@__PURE__*/ (() => {
    class ColumnMovingEventArgsDetail extends BaseEventArgsDetail {
        get g() {
            let ret_ = this.b.m("source", (a) => new Column());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("source", value_);
        }
        get h() {
            let ret_ = this.b.n("cancel");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("cancel", value_);
        }
    }
    ColumnMovingEventArgsDetail.$t = /*@__PURE__*/ markType(ColumnMovingEventArgsDetail, 'ColumnMovingEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnMovingEventArgsDetail;
})();
/**
 * @hidden
 */
export let ColumnMovingStartEventArgs = /*@__PURE__*/ (() => {
    class ColumnMovingStartEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new ColumnMovingStartEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new ColumnMovingStartEventArgsDetail());
                return $ret;
            })());
        }
    }
    ColumnMovingStartEventArgs.$t = /*@__PURE__*/ markType(ColumnMovingStartEventArgs, 'ColumnMovingStartEventArgs');
    return ColumnMovingStartEventArgs;
})();
/**
 * @hidden
 */
export let ColumnMovingStartEventArgsDetail = /*@__PURE__*/ (() => {
    class ColumnMovingStartEventArgsDetail extends BaseEventArgsDetail {
        get g() {
            let ret_ = this.b.m("source", (a) => new Column());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("source", value_);
        }
    }
    ColumnMovingStartEventArgsDetail.$t = /*@__PURE__*/ markType(ColumnMovingStartEventArgsDetail, 'ColumnMovingStartEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnMovingStartEventArgsDetail;
})();
/**
 * @hidden
 */
export let ColumnResizeEventArgs = /*@__PURE__*/ (() => {
    class ColumnResizeEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new ColumnResizeEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new ColumnResizeEventArgsDetail());
                return $ret;
            })());
        }
    }
    ColumnResizeEventArgs.$t = /*@__PURE__*/ markType(ColumnResizeEventArgs, 'ColumnResizeEventArgs');
    return ColumnResizeEventArgs;
})();
/**
 * @hidden
 */
export let ColumnResizeEventArgsDetail = /*@__PURE__*/ (() => {
    class ColumnResizeEventArgsDetail extends BaseEventArgsDetail {
        get g() {
            let ret_ = this.b.m("column", (a) => new Column());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("column", value_);
        }
        get i() {
            let ret_ = this.b.n("prevWidth");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("prevWidth", value_);
        }
        get h() {
            let ret_ = this.b.n("newWidth");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("newWidth", value_);
        }
    }
    ColumnResizeEventArgsDetail.$t = /*@__PURE__*/ markType(ColumnResizeEventArgsDetail, 'ColumnResizeEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnResizeEventArgsDetail;
})();
/**
 * @hidden
 */
export let ColumnsAutoGeneratedEventArgs = /*@__PURE__*/ (() => {
    class ColumnsAutoGeneratedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new ColumnsAutoGeneratedEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new ColumnsAutoGeneratedEventArgsDetail());
                return $ret;
            })());
        }
    }
    ColumnsAutoGeneratedEventArgs.$t = /*@__PURE__*/ markType(ColumnsAutoGeneratedEventArgs, 'ColumnsAutoGeneratedEventArgs');
    return ColumnsAutoGeneratedEventArgs;
})();
/**
 * @hidden
 */
export let ColumnsAutoGeneratedEventArgsDetail = /*@__PURE__*/ (() => {
    class ColumnsAutoGeneratedEventArgsDetail extends BaseEventArgsDetail {
        get g() {
            let ret_ = this.b.k("columns", (a) => new ColumnCollection(), (a) => new Column());
            return ret_;
        }
    }
    ColumnsAutoGeneratedEventArgsDetail.$t = /*@__PURE__*/ markType(ColumnsAutoGeneratedEventArgsDetail, 'ColumnsAutoGeneratedEventArgsDetail', BaseEventArgsDetail.$);
    return ColumnsAutoGeneratedEventArgsDetail;
})();
/**
 * @hidden
 */
export let ColumnCollection = /*@__PURE__*/ (() => {
    class ColumnCollection extends ObservableCollection$1 {
        constructor() {
            super(Column.$, 0);
        }
    }
    ColumnCollection.$t = /*@__PURE__*/ markType(ColumnCollection, 'ColumnCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(Column.$));
    return ColumnCollection;
})();
/**
 * @hidden
 */
export let ColumnTemplateContext = /*@__PURE__*/ (() => {
    class ColumnTemplateContext extends Base {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.e = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.c.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.d.m("implicit", (a) => new Column());
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.d.v("implicit", value_);
        }
        get a() {
            let ret_ = this.d.m("column", (a) => new Column());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.d.v("column", value_);
        }
    }
    ColumnTemplateContext.$t = /*@__PURE__*/ markType(ColumnTemplateContext, 'ColumnTemplateContext');
    return ColumnTemplateContext;
})();
/**
 * @hidden
 */
export let SummaryOperand = /*@__PURE__*/ (() => {
    class SummaryOperand extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.e = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.b.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        d(a) {
            return (this.nativeElement.count(this.c.i(a)));
        }
        a(a, b, c, d) {
            return this.c.g(this.nativeElement.operate(this.c.i(a), this.c.i(b), this.c.i(c), this.c.i(d)), (e) => new SummaryResult());
        }
    }
    SummaryOperand.$t = /*@__PURE__*/ markType(SummaryOperand, 'SummaryOperand');
    return SummaryOperand;
})();
/**
 * @hidden
 */
export let FilteringStrategy = /*@__PURE__*/ (() => {
    class FilteringStrategy extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        a(a, b, c, d) {
            return (this.nativeElement.filter(this.c.i(a), this.c.i(b), this.c.i(c), this.c.i(d)));
        }
    }
    FilteringStrategy.$t = /*@__PURE__*/ markType(FilteringStrategy, 'FilteringStrategy');
    return FilteringStrategy;
})();
/**
 * @hidden
 */
export let GridBaseDirective = /*@__PURE__*/ (() => {
    class GridBaseDirective extends DisplayDensityBase {
        constructor() {
            super(...arguments);
            this.c9 = null;
            this.c6 = null;
            this.de = null;
            this.c7 = null;
            this.di = null;
            this.df = null;
            this.dh = null;
            this.dj = null;
            this.dg = null;
            this.dc = null;
            this.db = null;
            this.da = null;
            this.dl = null;
            this.dm = null;
            this.dn = null;
            this.dd = null;
            this.dk = null;
            this.c8 = null;
            this.filteringExpressionsTreeChange = null;
            this.advancedFilteringExpressionsTreeChange = null;
            this.gridScroll = null;
            this.cellClick = null;
            this.formGroupCreated = null;
            this.validationStatusChange = null;
            this.selected = null;
            this.rowSelectionChanging = null;
            this.columnSelectionChanging = null;
            this.columnPin = null;
            this.columnPinned = null;
            this.cellEditEnter = null;
            this.cellEditExit = null;
            this.cellEdit = null;
            this.cellEditDone = null;
            this.rowEditEnter = null;
            this.rowEdit = null;
            this.rowEditDone = null;
            this.rowEditExit = null;
            this.columnInit = null;
            this.columnsAutogenerated = null;
            this.sorting = null;
            this.sortingDone = null;
            this.filtering = null;
            this.filteringDone = null;
            this.rowAdded = null;
            this.rowDeleted = null;
            this.rowDelete = null;
            this.rowAdd = null;
            this.columnResized = null;
            this.contextMenu = null;
            this.doubleClick = null;
            this.columnVisibilityChanging = null;
            this.columnVisibilityChanged = null;
            this.columnMovingStart = null;
            this.columnMoving = null;
            this.columnMovingEnd = null;
            this.gridKeydown = null;
            this.rowDragStart = null;
            this.rowDragEnd = null;
            this.gridCopy = null;
            this.rowToggle = null;
            this.rowPinning = null;
            this.rowPinned = null;
            this.activeNodeChange = null;
            this.sortingExpressionsChange = null;
            this.toolbarExporting = null;
            this.rangeSelected = null;
            this.rendered = null;
            this.dataChanging = null;
            this.dataChanged = null;
            this.z = new ColumnCollection();
        }
        get cy() {
            let ret_ = this.d.n("snackbarDisplayTime");
            return ret_;
        }
        set cy(a) {
            let value_ = a;
            this.d.v("snackbarDisplayTime", value_);
        }
        get ce() {
            let ret_ = this.d.n("autoGenerate");
            return ret_;
        }
        set ce(a) {
            let value_ = a;
            this.d.v("autoGenerate", value_);
        }
        get i() {
            let ret_ = this.d.n("autoGenerateExclude");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.d.v("autoGenerateExclude", value_);
        }
        get ci() {
            let ret_ = this.d.n("moving");
            return ret_;
        }
        set ci(a) {
            let value_ = a;
            this.d.v("moving", value_);
        }
        get ds() {
            return this.c9;
        }
        set ds(a) {
            this.c9 = a;
            this.d.s("emptyGridTemplate", (b) => b, this.c9);
        }
        get dp() {
            return this.c6;
        }
        set dp(a) {
            this.c6 = a;
            this.d.s("addRowEmptyTemplate", (b) => b, this.c6);
        }
        get dx() {
            return this.de;
        }
        set dx(a) {
            this.de = a;
            this.d.s("loadingGridTemplate", (b) => b, this.de);
        }
        get cz() {
            let ret_ = this.d.n("summaryRowHeight");
            return ret_;
        }
        set cz(a) {
            let value_ = a;
            this.d.v("summaryRowHeight", value_);
        }
        get al() {
            let ret_ = this.d.m("dataCloneStrategy", (a) => new DataCloneStrategy());
            return ret_;
        }
        set al(a) {
            let value_ = a;
            this.d.v("dataCloneStrategy", value_);
        }
        get w() {
            let ret_ = this.d.m("clipboardOptions", (a) => new ClipboardOptions());
            return ret_;
        }
        set w(a) {
            let value_ = a;
            this.d.v("clipboardOptions", value_);
        }
        get c4() {
            let ret_ = this.d.n("rowClasses");
            return ret_;
        }
        set c4(a) {
            let value_ = a;
            this.d.v("rowClasses", value_);
        }
        get c5() {
            let ret_ = this.d.n("rowStyles");
            return ret_;
        }
        set c5(a) {
            let value_ = a;
            this.d.v("rowStyles", value_);
        }
        get ed() {
            let ret_ = this.d.n("primaryKey");
            return ret_;
        }
        set ed(a) {
            let value_ = a;
            this.d.v("primaryKey", value_);
        }
        get s() {
            let ret_ = this.d.l("actionStripComponents", (a) => new ActionStripCollection(), (a) => new ActionStrip(), ["ActionStrip"]);
            return ret_;
        }
        get dq() {
            return this.c7;
        }
        set dq(a) {
            this.c7 = a;
            this.d.s("dragGhostCustomTemplate", (b) => new GridRowDragGhostContext(), this.c7);
        }
        get d1() {
            return this.di;
        }
        set d1(a) {
            this.di = a;
            this.d.s("rowEditTextTemplate", (b) => new GridRowEditTextTemplateContext(), this.di);
        }
        get dy() {
            return this.df;
        }
        set dy(a) {
            this.df = a;
            this.d.s("rowAddTextTemplate", (b) => new GridEmptyTemplateContext(), this.df);
        }
        get d0() {
            return this.dh;
        }
        set d0(a) {
            this.dh = a;
            this.d.s("rowEditActionsTemplate", (b) => new GridRowEditActionsTemplateContext(), this.dh);
        }
        get d2() {
            return this.dj;
        }
        set d2(a) {
            this.dj = a;
            this.d.s("rowExpandedIndicatorTemplate", (b) => new GridRowTemplateContext(), this.dj);
        }
        get dz() {
            return this.dg;
        }
        set dz(a) {
            this.dg = a;
            this.d.s("rowCollapsedIndicatorTemplate", (b) => new GridRowTemplateContext(), this.dg);
        }
        get dv() {
            return this.dc;
        }
        set dv(a) {
            this.dc = a;
            this.d.s("headerExpandedIndicatorTemplate", (b) => new GridTemplateContext(), this.dc);
        }
        get du() {
            return this.db;
        }
        set du(a) {
            this.db = a;
            this.d.s("headerCollapsedIndicatorTemplate", (b) => new GridTemplateContext(), this.db);
        }
        get dt() {
            return this.da;
        }
        set dt(a) {
            this.da = a;
            this.d.s("excelStyleHeaderIconTemplate", (b) => new GridHeaderTemplateContext(), this.da);
        }
        get d4() {
            return this.dl;
        }
        set d4(a) {
            this.dl = a;
            this.d.s("sortAscendingHeaderIconTemplate", (b) => new GridHeaderTemplateContext(), this.dl);
        }
        get d5() {
            return this.dm;
        }
        set d5(a) {
            this.dm = a;
            this.d.s("sortDescendingHeaderIconTemplate", (b) => new GridHeaderTemplateContext(), this.dm);
        }
        get d6() {
            return this.dn;
        }
        set d6(a) {
            this.dn = a;
            this.d.s("sortHeaderIconTemplate", (b) => new GridHeaderTemplateContext(), this.dn);
        }
        get bo() {
            let ret_ = this.d.l("toolbar", (a) => new GridToolbarCollection(), (a) => new GridToolbar(), ["GridToolbar"]);
            return ret_;
        }
        get bt() {
            let ret_ = this.d.l("paginationComponents", (a) => new PaginatorCollection(), (a) => new Paginator(), ["Paginator"]);
            return ret_;
        }
        get bf() {
            let ret_ = this.d.m("resourceStrings", (a) => new GridResourceStrings());
            return ret_;
        }
        set bf(a) {
            let value_ = a;
            this.d.v("resourceStrings", value_);
        }
        get as() {
            let ret_ = this.d.n("filteringLogic");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilteringLogic_$type, EnumUtil.getEnumValue(FilteringLogic_$type, this.d.f(FilteringLogic_$type, ret_)));
            return EnumUtil.getEnumValue(FilteringLogic_$type, ret_);
        }
        set as(a) {
            let value_ = enumGetBox(FilteringLogic_$type, a);
            value_ = this.d.f(FilteringLogic_$type, value_);
            this.d.v("filteringLogic", value_);
        }
        get ao() {
            let ret_ = this.d.m("filteringExpressionsTree", (a) => new FilteringExpressionsTree());
            return ret_;
        }
        set ao(a) {
            let value_ = a;
            this.d.v("filteringExpressionsTree", value_);
        }
        get an() {
            let ret_ = this.d.m("advancedFilteringExpressionsTree", (a) => new FilteringExpressionsTree());
            return ret_;
        }
        set an(a) {
            let value_ = a;
            this.d.v("advancedFilteringExpressionsTree", value_);
        }
        get ec() {
            let ret_ = this.d.n("locale");
            return ret_;
        }
        set ec(a) {
            let value_ = a;
            this.d.v("locale", value_);
        }
        get be() {
            let ret_ = this.d.n("pagingMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridPagingMode_$type, EnumUtil.getEnumValue(GridPagingMode_$type, this.d.f(GridPagingMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridPagingMode_$type, ret_);
        }
        set be(a) {
            let value_ = enumGetBox(GridPagingMode_$type, a);
            value_ = this.d.f(GridPagingMode_$type, value_);
            this.d.v("pagingMode", value_);
        }
        get cg() {
            let ret_ = this.d.n("hideRowSelectors");
            return ret_;
        }
        set cg(a) {
            let value_ = a;
            this.d.v("hideRowSelectors", value_);
        }
        get ck() {
            let ret_ = this.d.n("rowDraggable");
            return ret_;
        }
        set ck(a) {
            let value_ = a;
            this.d.v("rowDraggable", value_);
        }
        get br() {
            let ret_ = this.d.n("validationTrigger");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridValidationTrigger_$type, EnumUtil.getEnumValue(GridValidationTrigger_$type, this.d.f(GridValidationTrigger_$type, ret_)));
            return EnumUtil.getEnumValue(GridValidationTrigger_$type, ret_);
        }
        set br(a) {
            let value_ = enumGetBox(GridValidationTrigger_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("validationTrigger", value_);
        }
        get cl() {
            let ret_ = this.d.n("rowEditable");
            return ret_;
        }
        set cl(a) {
            let value_ = a;
            this.d.v("rowEditable", value_);
        }
        get eb() {
            let ret_ = this.d.n("height");
            return ret_;
        }
        set eb(a) {
            let value_ = a;
            this.d.v("height", value_);
        }
        get ee() {
            let ret_ = this.d.n("width");
            return ret_;
        }
        set ee(a) {
            let value_ = a;
            this.d.v("width", value_);
        }
        get cx() {
            let ret_ = this.d.n("rowHeight");
            return ret_;
        }
        set cx(a) {
            let value_ = a;
            this.d.v("rowHeight", value_);
        }
        get d7() {
            let ret_ = this.d.n("columnWidth");
            return ret_;
        }
        set d7(a) {
            let value_ = a;
            this.d.v("columnWidth", value_);
        }
        get d9() {
            let ret_ = this.d.n("emptyGridMessage");
            return ret_;
        }
        set d9(a) {
            let value_ = a;
            this.d.v("emptyGridMessage", value_);
        }
        get ch() {
            let ret_ = this.d.n("isLoading");
            return ret_;
        }
        set ch(a) {
            let value_ = a;
            this.d.v("isLoading", value_);
        }
        get cn() {
            let ret_ = this.d.n("shouldGenerate");
            return ret_;
        }
        set cn(a) {
            let value_ = a;
            this.d.v("shouldGenerate", value_);
        }
        get d8() {
            let ret_ = this.d.n("emptyFilteredGridMessage");
            return ret_;
        }
        set d8(a) {
            let value_ = a;
            this.d.v("emptyFilteredGridMessage", value_);
        }
        get bw() {
            let ret_ = this.d.m("pinning", (a) => new PinningConfig());
            return ret_;
        }
        set bw(a) {
            let value_ = a;
            this.d.v("pinning", value_);
        }
        get cd() {
            let ret_ = this.d.n("allowFiltering");
            return ret_;
        }
        set cd(a) {
            let value_ = a;
            this.d.v("allowFiltering", value_);
        }
        get cc() {
            let ret_ = this.d.n("allowAdvancedFiltering");
            return ret_;
        }
        set cc(a) {
            let value_ = a;
            this.d.v("allowAdvancedFiltering", value_);
        }
        get au() {
            let ret_ = this.d.n("filterMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(FilterMode_$type, EnumUtil.getEnumValue(FilterMode_$type, this.d.f(FilterMode_$type, ret_)));
            return EnumUtil.getEnumValue(FilterMode_$type, ret_);
        }
        set au(a) {
            let value_ = enumGetBox(FilterMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("filterMode", value_);
        }
        get bn() {
            let ret_ = this.d.n("summaryPosition");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSummaryPosition_$type, EnumUtil.getEnumValue(GridSummaryPosition_$type, this.d.f(GridSummaryPosition_$type, ret_)));
            return EnumUtil.getEnumValue(GridSummaryPosition_$type, ret_);
        }
        set bn(a) {
            let value_ = enumGetBox(GridSummaryPosition_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("summaryPosition", value_);
        }
        get bm() {
            let ret_ = this.d.n("summaryCalculationMode");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSummaryCalculationMode_$type, EnumUtil.getEnumValue(GridSummaryCalculationMode_$type, this.d.f(GridSummaryCalculationMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSummaryCalculationMode_$type, ret_);
        }
        set bm(a) {
            let value_ = enumGetBox(GridSummaryCalculationMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("summaryCalculationMode", value_);
        }
        get co() {
            let ret_ = this.d.n("showSummaryOnCollapse");
            return ret_;
        }
        set co(a) {
            let value_ = a;
            this.d.v("showSummaryOnCollapse", value_);
        }
        get at() {
            let ret_ = this.d.m("filterStrategy", (a) => new FilteringStrategy());
            return ret_;
        }
        set at(a) {
            let value_ = a;
            this.d.v("filterStrategy", value_);
        }
        get bl() {
            let ret_ = this.d.m("sortStrategy", (a) => new GridSortingStrategy());
            return ret_;
        }
        set bl(a) {
            let value_ = a;
            this.d.v("sortStrategy", value_);
        }
        get b8() {
            let ret_ = this.d.m("sortingOptions", (a) => new SortingOptions());
            return ret_;
        }
        set b8(a) {
            let value_ = a;
            this.d.v("sortingOptions", value_);
        }
        get o() {
            let ret_ = this.d.n("selectedRows");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.d.v("selectedRows", value_);
        }
        get dw() {
            return this.dd;
        }
        set dw(a) {
            this.dd = a;
            this.d.s("headSelectorTemplate", (b) => new HeadSelectorTemplateContext(), this.dd);
        }
        get d3() {
            return this.dk;
        }
        set d3(a) {
            this.dk = a;
            this.d.s("rowSelectorTemplate", (b) => new RowSelectorTemplateContext(), this.dk);
        }
        get dr() {
            return this.c8;
        }
        set dr(a) {
            this.c8 = a;
            this.d.s("dragIndicatorIconTemplate", (b) => new GridEmptyTemplateContext(), this.c8);
        }
        get p() {
            let ret_ = this.d.m("sortingExpressions", (a) => new SortingExpression());
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.d.v("sortingExpressions", value_);
        }
        get cu() {
            let ret_ = this.d.n("hiddenColumnsCount");
            return ret_;
        }
        get cv() {
            let ret_ = this.d.n("pinnedColumnsCount");
            return ret_;
        }
        get cf() {
            let ret_ = this.d.n("batchEditing");
            return ret_;
        }
        set cf(a) {
            let value_ = a;
            this.d.v("batchEditing", value_);
        }
        get bh() {
            let ret_ = this.d.n("cellSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.d.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        }
        set bh(a) {
            let value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("cellSelection", value_);
        }
        get bj() {
            let ret_ = this.d.n("rowSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.d.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        }
        set bj(a) {
            let value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("rowSelection", value_);
        }
        get bi() {
            let ret_ = this.d.n("columnSelection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(GridSelectionMode_$type, EnumUtil.getEnumValue(GridSelectionMode_$type, this.d.f(GridSelectionMode_$type, ret_)));
            return EnumUtil.getEnumValue(GridSelectionMode_$type, ret_);
        }
        set bi(a) {
            let value_ = enumGetBox(GridSelectionMode_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("columnSelection", value_);
        }
        get c2() {
            let ret_ = this.d.n("filteredData");
            return ret_;
        }
        get k() {
            let ret_ = this.d.n("filteredSortedData");
            return ret_;
        }
        get aw() {
            let ret_ = this.d.m("virtualizationState", (a) => new ForOfState());
            return ret_;
        }
        get bs() {
            let ret_ = this.d.m("outlet", (a) => new OverlayOutletDirective());
            return ret_;
        }
        set bs(a) {
            let value_ = a;
            this.d.v("outlet", value_);
        }
        get cr() {
            let ret_ = this.d.n("defaultRowHeight");
            return ret_;
        }
        get cq() {
            let ret_ = this.d.n("defaultHeaderGroupMinWidth");
            return ret_;
        }
        get ab() {
            let ret_ = this.d.l("columns", (a) => new ColumnCollection(), (a) => new Column(), ["Column", "ColumnGroup", "ColumnLayout"]);
            return ret_;
        }
        get m() {
            let ret_ = this.d.m("pinnedColumns", (a) => new Column());
            return ret_;
        }
        get q() {
            let ret_ = this.d.m("unpinnedColumns", (a) => new Column());
            return ret_;
        }
        get r() {
            let ret_ = this.d.m("visibleColumns", (a) => new Column());
            return ret_;
        }
        get c0() {
            let ret_ = this.d.n("totalRecords");
            return ret_;
        }
        set c0(a) {
            let value_ = a;
            this.d.v("totalRecords", value_);
        }
        get j() {
            let ret_ = this.d.n("dataView");
            return ret_;
        }
        get cm() {
            let ret_ = this.d.n("selectRowOnClick");
            return ret_;
        }
        set cm(a) {
            let value_ = a;
            this.d.v("selectRowOnClick", value_);
        }
        filteringExpressionsTreeChangeChanged() {
            if (this.filteringExpressionsTreeChange != null) {
                this.d.r("filteringExpressionsTreeChange", (a) => this.filteringExpressionsTreeChange(this, FilteringExpressionsTreeEventArgs.b(a)), false);
            }
            else {
                this.d.u("filteringExpressionsTreeChange");
            }
        }
        advancedFilteringExpressionsTreeChangeChanged() {
            if (this.advancedFilteringExpressionsTreeChange != null) {
                this.d.r("advancedFilteringExpressionsTreeChange", (a) => this.advancedFilteringExpressionsTreeChange(this, FilteringExpressionsTreeEventArgs.b(a)), false);
            }
            else {
                this.d.u("advancedFilteringExpressionsTreeChange");
            }
        }
        gridScrollChanged() {
            if (this.gridScroll != null) {
                this.d.r("gridScroll", (a) => this.gridScroll(this, GridScrollEventArgs.a(a)), false);
            }
            else {
                this.d.u("gridScroll");
            }
        }
        cellClickChanged() {
            if (this.cellClick != null) {
                this.d.r("cellClick", (a) => this.cellClick(this, GridCellEventArgs.a(a)), false);
            }
            else {
                this.d.u("cellClick");
            }
        }
        formGroupCreatedChanged() {
            if (this.formGroupCreated != null) {
                this.d.r("formGroupCreated", (a) => this.formGroupCreated(this, GridFormGroupCreatedEventArgs.a(a)), false);
            }
            else {
                this.d.u("formGroupCreated");
            }
        }
        validationStatusChangeChanged() {
            if (this.validationStatusChange != null) {
                this.d.r("validationStatusChange", (a) => this.validationStatusChange(this, GridValidationStatusEventArgs.a(a)), false);
            }
            else {
                this.d.u("validationStatusChange");
            }
        }
        selectedChanged() {
            if (this.selected != null) {
                this.d.r("selected", (a) => this.selected(this, GridCellEventArgs.a(a)), false);
            }
            else {
                this.d.u("selected");
            }
        }
        rowSelectionChangingChanged() {
            if (this.rowSelectionChanging != null) {
                this.d.r("rowSelectionChanging", (a) => this.rowSelectionChanging(this, RowSelectionEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowSelectionChanging");
            }
        }
        columnSelectionChangingChanged() {
            if (this.columnSelectionChanging != null) {
                this.d.r("columnSelectionChanging", (a) => this.columnSelectionChanging(this, ColumnSelectionEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnSelectionChanging");
            }
        }
        columnPinChanged() {
            if (this.columnPin != null) {
                this.d.r("columnPin", (a) => this.columnPin(this, PinColumnCancellableEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnPin");
            }
        }
        columnPinnedChanged() {
            if (this.columnPinned != null) {
                this.d.r("columnPinned", (a) => this.columnPinned(this, PinColumnEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnPinned");
            }
        }
        cellEditEnterChanged() {
            if (this.cellEditEnter != null) {
                this.d.r("cellEditEnter", (a) => this.cellEditEnter(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.d.u("cellEditEnter");
            }
        }
        cellEditExitChanged() {
            if (this.cellEditExit != null) {
                this.d.r("cellEditExit", (a) => this.cellEditExit(this, GridEditDoneEventArgs.a(a)), false);
            }
            else {
                this.d.u("cellEditExit");
            }
        }
        cellEditChanged() {
            if (this.cellEdit != null) {
                this.d.r("cellEdit", (a) => this.cellEdit(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.d.u("cellEdit");
            }
        }
        cellEditDoneChanged() {
            if (this.cellEditDone != null) {
                this.d.r("cellEditDone", (a) => this.cellEditDone(this, GridEditDoneEventArgs.a(a)), false);
            }
            else {
                this.d.u("cellEditDone");
            }
        }
        rowEditEnterChanged() {
            if (this.rowEditEnter != null) {
                this.d.r("rowEditEnter", (a) => this.rowEditEnter(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowEditEnter");
            }
        }
        rowEditChanged() {
            if (this.rowEdit != null) {
                this.d.r("rowEdit", (a) => this.rowEdit(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowEdit");
            }
        }
        rowEditDoneChanged() {
            if (this.rowEditDone != null) {
                this.d.r("rowEditDone", (a) => this.rowEditDone(this, GridEditDoneEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowEditDone");
            }
        }
        rowEditExitChanged() {
            if (this.rowEditExit != null) {
                this.d.r("rowEditExit", (a) => this.rowEditExit(this, GridEditDoneEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowEditExit");
            }
        }
        columnInitChanged() {
            if (this.columnInit != null) {
                this.d.r("columnInit", (a) => this.columnInit(this, ColumnComponentEventArgs.b(a)), false);
            }
            else {
                this.d.u("columnInit");
            }
        }
        columnsAutogeneratedChanged() {
            if (this.columnsAutogenerated != null) {
                this.d.r("columnsAutogenerated", (a) => this.columnsAutogenerated(this, ColumnsAutoGeneratedEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnsAutogenerated");
            }
        }
        sortingChanged() {
            if (this.sorting != null) {
                this.d.r("sorting", (a) => this.sorting(this, SortingEventArgs.a(a)), false);
            }
            else {
                this.d.u("sorting");
            }
        }
        sortingDoneChanged() {
            if (this.sortingDone != null) {
                this.d.r("sortingDone", (a) => this.sortingDone(this, SortingExpressionEventArgs.b(a)), false);
            }
            else {
                this.d.u("sortingDone");
            }
        }
        filteringChanged() {
            if (this.filtering != null) {
                this.d.r("filtering", (a) => this.filtering(this, FilteringEventArgs.a(a)), false);
            }
            else {
                this.d.u("filtering");
            }
        }
        filteringDoneChanged() {
            if (this.filteringDone != null) {
                this.d.r("filteringDone", (a) => this.filteringDone(this, FilteringExpressionsTreeEventArgs.b(a)), false);
            }
            else {
                this.d.u("filteringDone");
            }
        }
        rowAddedChanged() {
            if (this.rowAdded != null) {
                this.d.r("rowAdded", (a) => this.rowAdded(this, RowDataEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowAdded");
            }
        }
        rowDeletedChanged() {
            if (this.rowDeleted != null) {
                this.d.r("rowDeleted", (a) => this.rowDeleted(this, RowDataEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowDeleted");
            }
        }
        rowDeleteChanged() {
            if (this.rowDelete != null) {
                this.d.r("rowDelete", (a) => this.rowDelete(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowDelete");
            }
        }
        rowAddChanged() {
            if (this.rowAdd != null) {
                this.d.r("rowAdd", (a) => this.rowAdd(this, GridEditEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowAdd");
            }
        }
        columnResizedChanged() {
            if (this.columnResized != null) {
                this.d.r("columnResized", (a) => this.columnResized(this, ColumnResizeEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnResized");
            }
        }
        contextMenuChanged() {
            if (this.contextMenu != null) {
                this.d.r("contextMenu", (a) => this.contextMenu(this, GridCellEventArgs.a(a)), false);
            }
            else {
                this.d.u("contextMenu");
            }
        }
        doubleClickChanged() {
            if (this.doubleClick != null) {
                this.d.r("doubleClick", (a) => this.doubleClick(this, GridCellEventArgs.a(a)), false);
            }
            else {
                this.d.u("doubleClick");
            }
        }
        columnVisibilityChangingChanged() {
            if (this.columnVisibilityChanging != null) {
                this.d.r("columnVisibilityChanging", (a) => this.columnVisibilityChanging(this, ColumnVisibilityChangingEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnVisibilityChanging");
            }
        }
        columnVisibilityChangedChanged() {
            if (this.columnVisibilityChanged != null) {
                this.d.r("columnVisibilityChanged", (a) => this.columnVisibilityChanged(this, ColumnVisibilityChangedEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnVisibilityChanged");
            }
        }
        columnMovingStartChanged() {
            if (this.columnMovingStart != null) {
                this.d.r("columnMovingStart", (a) => this.columnMovingStart(this, ColumnMovingStartEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnMovingStart");
            }
        }
        columnMovingChanged() {
            if (this.columnMoving != null) {
                this.d.r("columnMoving", (a) => this.columnMoving(this, ColumnMovingEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnMoving");
            }
        }
        columnMovingEndChanged() {
            if (this.columnMovingEnd != null) {
                this.d.r("columnMovingEnd", (a) => this.columnMovingEnd(this, ColumnMovingEndEventArgs.a(a)), false);
            }
            else {
                this.d.u("columnMovingEnd");
            }
        }
        gridKeydownChanged() {
            if (this.gridKeydown != null) {
                this.d.r("gridKeydown", (a) => this.gridKeydown(this, GridKeydownEventArgs.a(a)), false);
            }
            else {
                this.d.u("gridKeydown");
            }
        }
        rowDragStartChanged() {
            if (this.rowDragStart != null) {
                this.d.r("rowDragStart", (a) => this.rowDragStart(this, RowDragStartEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowDragStart");
            }
        }
        rowDragEndChanged() {
            if (this.rowDragEnd != null) {
                this.d.r("rowDragEnd", (a) => this.rowDragEnd(this, RowDragEndEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowDragEnd");
            }
        }
        gridCopyChanged() {
            if (this.gridCopy != null) {
                this.d.r("gridCopy", (a) => this.gridCopy(this, GridClipboardEventEventArgs.b(a)), false);
            }
            else {
                this.d.u("gridCopy");
            }
        }
        rowToggleChanged() {
            if (this.rowToggle != null) {
                this.d.r("rowToggle", (a) => this.rowToggle(this, RowToggleEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowToggle");
            }
        }
        rowPinningChanged() {
            if (this.rowPinning != null) {
                this.d.r("rowPinning", (a) => this.rowPinning(this, PinRowEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowPinning");
            }
        }
        rowPinnedChanged() {
            if (this.rowPinned != null) {
                this.d.r("rowPinned", (a) => this.rowPinned(this, PinRowEventArgs.a(a)), false);
            }
            else {
                this.d.u("rowPinned");
            }
        }
        activeNodeChangeChanged() {
            if (this.activeNodeChange != null) {
                this.d.r("activeNodeChange", (a) => this.activeNodeChange(this, ActiveNodeChangeEventArgs.a(a)), false);
            }
            else {
                this.d.u("activeNodeChange");
            }
        }
        sortingExpressionsChangeChanged() {
            if (this.sortingExpressionsChange != null) {
                this.d.r("sortingExpressionsChange", (a) => this.sortingExpressionsChange(this, SortingExpressionEventArgs.b(a)), false);
            }
            else {
                this.d.u("sortingExpressionsChange");
            }
        }
        toolbarExportingChanged() {
            if (this.toolbarExporting != null) {
                this.d.r("toolbarExporting", (a) => this.toolbarExporting(this, GridToolbarExportEventArgs.a(a)), false);
            }
            else {
                this.d.u("toolbarExporting");
            }
        }
        rangeSelectedChanged() {
            if (this.rangeSelected != null) {
                this.d.r("rangeSelected", (a) => this.rangeSelected(this, GridSelectionRangeEventArgs.b(a)), false);
            }
            else {
                this.d.u("rangeSelected");
            }
        }
        renderedChanged() {
            if (this.rendered != null) {
                this.d.r("rendered", (a) => this.rendered(this, VoidEventArgs.b(a)), false);
            }
            else {
                this.d.u("rendered");
            }
        }
        dataChangingChanged() {
            if (this.dataChanging != null) {
                this.d.r("dataChanging", (a) => this.dataChanging(this, ForOfDataChangingEventArgs.a(a)), false);
            }
            else {
                this.d.u("dataChanging");
            }
        }
        dataChangedChanged() {
            if (this.dataChanged != null) {
                this.d.r("dataChanged", (a) => this.dataChanged(this, VoidEventArgs.b(a)), false);
            }
            else {
                this.d.u("dataChanged");
            }
        }
        fu(a) {
            this.nativeElement.isRecordPinnedByIndex(this.d.i(a));
        }
        gr(a) {
            this.nativeElement.toggleColumnVisibility(this.d.i(a));
        }
        fg() {
            this.nativeElement.expandAll();
        }
        es() {
            this.nativeElement.collapseAll();
        }
        fh(a) {
            this.nativeElement.expandRow(this.d.i(a));
        }
        et(a) {
            this.nativeElement.collapseRow(this.d.i(a));
        }
        gs(a) {
            this.nativeElement.toggleRow(this.d.i(a));
        }
        ea(a) {
            return (this.nativeElement.getHeaderGroupWidth(this.d.i(a)));
        }
        x(a) {
            return this.d.g(this.nativeElement.getColumnByName(this.d.i(a)), (b) => new Column());
        }
        y(a) {
            return this.d.g(this.nativeElement.getColumnByVisibleIndex(this.d.i(a)), (b) => new Column());
        }
        f0() {
            this.nativeElement.recalculateAutoSizes();
        }
        fw(a, b, c) {
            this.nativeElement.moveColumn(this.d.i(a), this.d.i(b), this.d.i(typeGetValue(this.d.f(DropPosition_$type, c))));
        }
        fv() {
            this.nativeElement.markForCheck();
        }
        c1(a) {
            return (this.nativeElement.deleteRow(this.d.i(a)));
        }
        gu(a, b, c) {
            this.nativeElement.updateCell(this.d.i(a), this.d.i(b), this.d.i(c));
        }
        gv(a, b) {
            this.nativeElement.updateRow(this.d.i(a), this.d.i(b));
        }
        c3(a) {
            return (this.nativeElement.getRowData(this.d.i(a)));
        }
        gn(a) {
            this.nativeElement.sort(this.d.i(a));
        }
        fi(a, b, c, d = false) {
            this.nativeElement.filter(this.d.i(a), this.d.i(b), this.d.i(c), this.d.i(d));
        }
        fj(a, b, c) {
            this.nativeElement.filterGlobal(this.d.i(a), this.d.i(b), this.d.i(c));
        }
        fe(a) {
            this.nativeElement.enableSummaries(this.d.i(a));
        }
        fc(a) {
            this.nativeElement.disableSummaries(this.d.i(a));
        }
        eo(a) {
            this.nativeElement.clearFilter(this.d.i(a));
        }
        eq(a) {
            this.nativeElement.clearSort(this.d.i(a));
        }
        cj(a, b) {
            return (this.nativeElement.pinColumn(this.d.i(a), this.d.i(b)));
        }
        cp(a, b) {
            return (this.nativeElement.unpinColumn(this.d.i(a), this.d.i(b)));
        }
        f1() {
            this.nativeElement.reflow();
        }
        cs(a, b = false, c = false) {
            return (this.nativeElement.findNext(this.d.i(a), this.d.i(b), this.d.i(c)));
        }
        ct(a, b = false, c = false) {
            return (this.nativeElement.findPrev(this.d.i(a), this.d.i(b), this.d.i(c)));
        }
        cw(a = false, b = false) {
            return (this.nativeElement.refreshSearch(this.d.i(a), this.d.i(b)));
        }
        ep() {
            this.nativeElement.clearSearch();
        }
        fo(a = false) {
            this.nativeElement.getPinnedWidth(this.d.i(a));
        }
        gm(a, b = false) {
            this.nativeElement.selectRows(this.d.i(a), this.d.i(b));
        }
        fb(a) {
            this.nativeElement.deselectRows(this.d.i(a));
        }
        gi(a = false) {
            this.nativeElement.selectAllRows(this.d.i(a));
        }
        e9(a = false) {
            this.nativeElement.deselectAllRows(this.d.i(a));
        }
        en() {
            this.nativeElement.clearCellSelection();
        }
        gl(a) {
            this.nativeElement.selectRange(this.d.i(a));
        }
        l() {
            return this.d.g(this.nativeElement.getSelectedRanges(), (a) => new GridSelectionRange());
        }
        fq(a = false, b = false) {
            this.nativeElement.getSelectedData(this.d.i(a), this.d.i(b));
        }
        n() {
            return this.d.g(this.nativeElement.selectedColumns(), (a) => new Column());
        }
        gj(a, b = false) {
            this.nativeElement.selectColumns(this.d.i(a), this.d.i(b));
        }
        fa(a) {
            this.nativeElement.deselectColumns(this.d.i(a));
        }
        e8() {
            this.nativeElement.deselectAllColumns();
        }
        gh() {
            this.nativeElement.selectAllColumns();
        }
        fp(a, b = false) {
            this.nativeElement.getSelectedColumnsData(this.d.i(a), this.d.i(b));
        }
        fx(a, b, c) {
            this.nativeElement.navigateTo(this.d.i(a), this.d.i(b), this.d.i(c));
        }
        u(a, b, c) {
            return this.d.g(this.nativeElement.getNextCell(this.d.i(a), this.d.i(b), this.d.i(c)), (d) => new CellPosition());
        }
        v(a, b, c) {
            return this.d.g(this.nativeElement.getPreviousCell(this.d.i(a), this.d.i(b), this.d.i(c)), (d) => new CellPosition());
        }
        fy(a) {
            this.nativeElement.openAdvancedFilteringDialog(this.d.i(a));
        }
        er(a) {
            this.nativeElement.closeAdvancedFilteringDialog(this.d.i(a));
        }
        ff(a, b) {
            this.nativeElement.endEdit(this.d.i(a), this.d.i(b));
        }
        eh(a, b = false) {
            this.nativeElement.beginAddRowById(this.d.i(a), this.d.i(b));
        }
        get aa() {
            return this.z;
        }
        get b9() {
            let ret_ = this.d.l("stateComponents", (a) => new StateCollection(), (a) => new GridState(), ["GridState"]);
            return ret_;
        }
    }
    GridBaseDirective.$t = /*@__PURE__*/ markType(GridBaseDirective, 'GridBaseDirective', DisplayDensityBase.$);
    return GridBaseDirective;
})();
/**
 * @hidden
 */
export let GridToolbar = /*@__PURE__*/ (() => {
    class GridToolbar extends DisplayDensityBaseElement {
        constructor() {
            super(...arguments);
            this.j = null;
        }
        get l() {
            let ret_ = this.d.n("showProgress");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.d.v("showProgress", value_);
        }
        get i() {
            let ret_ = this.d.n("grid");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.d.v("grid", value_);
        }
        get m() {
            let ret_ = this.d.n("name");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.d.v("name", value_);
        }
        get k() {
            if (this.j == null) {
                this.j = this.d.l("tools", (a) => new GridToolbarContentCollection(), null, ["GridToolbarActions", "GridToolbarTitle"]);
            }
            return this.j;
        }
    }
    GridToolbar.$t = /*@__PURE__*/ markType(GridToolbar, 'GridToolbar', DisplayDensityBaseElement.$);
    return GridToolbar;
})();
/**
 * @hidden
 */
export let GridToolbarCollection = /*@__PURE__*/ (() => {
    class GridToolbarCollection extends ObservableCollection$1 {
        constructor() {
            super(GridToolbar.$, 0);
        }
    }
    GridToolbarCollection.$t = /*@__PURE__*/ markType(GridToolbarCollection, 'GridToolbarCollection', /*@__PURE__*/ ObservableCollection$1.$.specialize(GridToolbar.$));
    return GridToolbarCollection;
})();
/**
 * @hidden
 */
export let GridCellEventArgs = /*@__PURE__*/ (() => {
    class GridCellEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new GridCellEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new GridCellEventArgsDetail());
                return $ret;
            })());
        }
    }
    GridCellEventArgs.$t = /*@__PURE__*/ markType(GridCellEventArgs, 'GridCellEventArgs');
    return GridCellEventArgs;
})();
/**
 * @hidden
 */
export let GridCellEventArgsDetail = /*@__PURE__*/ (() => {
    class GridCellEventArgsDetail extends BaseEventArgsDetail {
        get h() {
            let ret_ = this.b.m("cell", (a) => new CellType());
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("cell", value_);
        }
        get i() {
            let ret_ = this.b.n("event");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("event", value_);
        }
    }
    GridCellEventArgsDetail.$t = /*@__PURE__*/ markType(GridCellEventArgsDetail, 'GridCellEventArgsDetail', BaseEventArgsDetail.$);
    GridCellEventArgsDetail.__marshalByValueIgnore = ["event"];
    return GridCellEventArgsDetail;
})();
/**
 * @hidden
 */
export let GridEditDoneEventArgs = /*@__PURE__*/ (() => {
    class GridEditDoneEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new GridEditDoneEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new GridEditDoneEventArgsDetail());
                return $ret;
            })());
        }
    }
    GridEditDoneEventArgs.$t = /*@__PURE__*/ markType(GridEditDoneEventArgs, 'GridEditDoneEventArgs');
    return GridEditDoneEventArgs;
})();
/**
 * @hidden
 */
export let GridEditDoneEventArgsDetail = /*@__PURE__*/ (() => {
    class GridEditDoneEventArgsDetail extends BaseEventArgsDetail {
        get p() {
            let ret_ = this.b.n("rowID");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.b.v("rowID", value_);
        }
        get n() {
            let ret_ = this.b.n("primaryKey");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.b.v("primaryKey", value_);
        }
        get i() {
            let ret_ = this.b.m("cellID", (a) => new GridCellIdentifier());
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("cellID", value_);
        }
        get o() {
            let ret_ = this.b.n("rowData");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.b.v("rowData", value_);
        }
        get m() {
            let ret_ = this.b.n("oldValue");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.b.v("oldValue", value_);
        }
        get l() {
            let ret_ = this.b.n("newValue");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.b.v("newValue", value_);
        }
        get g() {
            let ret_ = this.b.m("column", (a) => new Column());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("column", value_);
        }
        get h() {
            let ret_ = this.b.n("owner");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("owner", value_);
        }
        get j() {
            let ret_ = this.b.n("isAddRow");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.b.v("isAddRow", value_);
        }
        get k() {
            let ret_ = this.b.n("valid");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.b.v("valid", value_);
        }
    }
    GridEditDoneEventArgsDetail.$t = /*@__PURE__*/ markType(GridEditDoneEventArgsDetail, 'GridEditDoneEventArgsDetail', BaseEventArgsDetail.$);
    return GridEditDoneEventArgsDetail;
})();
/**
 * @hidden
 */
export let GridEditEventArgs = /*@__PURE__*/ (() => {
    class GridEditEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new GridEditEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new GridEditEventArgsDetail());
                return $ret;
            })());
        }
    }
    GridEditEventArgs.$t = /*@__PURE__*/ markType(GridEditEventArgs, 'GridEditEventArgs');
    return GridEditEventArgs;
})();
/**
 * @hidden
 */
export let GridEditEventArgsDetail = /*@__PURE__*/ (() => {
    class GridEditEventArgsDetail extends Base {
        constructor() {
            super(...arguments);
            this.d = new WCNativeHelper();
            this.i = null;
        }
        get e() {
            return this.d;
        }
        get nativeElement() {
            return this.i;
        }
        set nativeElement(a) {
            this.i = a;
            this.d.o = this.i;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get f() {
            let ret_ = this.e.n("cancel");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.e.v("cancel", value_);
        }
        get o() {
            let ret_ = this.e.n("rowID");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.e.v("rowID", value_);
        }
        get m() {
            let ret_ = this.e.n("primaryKey");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.e.v("primaryKey", value_);
        }
        get c() {
            let ret_ = this.e.m("cellID", (a) => new GridCellIdentifier());
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.e.v("cellID", value_);
        }
        get n() {
            let ret_ = this.e.n("rowData");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.e.v("rowData", value_);
        }
        get l() {
            let ret_ = this.e.n("oldValue");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.e.v("oldValue", value_);
        }
        get k() {
            let ret_ = this.e.n("newValue");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.e.v("newValue", value_);
        }
        get a() {
            let ret_ = this.e.m("column", (a) => new Column());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.e.v("column", value_);
        }
        get b() {
            let ret_ = this.e.n("owner");
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.e.v("owner", value_);
        }
        get g() {
            let ret_ = this.e.n("isAddRow");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.e.v("isAddRow", value_);
        }
        get h() {
            let ret_ = this.e.n("valid");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.e.v("valid", value_);
        }
    }
    GridEditEventArgsDetail.$t = /*@__PURE__*/ markType(GridEditEventArgsDetail, 'GridEditEventArgsDetail');
    return GridEditEventArgsDetail;
})();
/**
 * @hidden
 */
export let GridFormGroupCreatedEventArgs = /*@__PURE__*/ (() => {
    class GridFormGroupCreatedEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new GridFormGroupCreatedEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new GridFormGroupCreatedEventArgsDetail());
                return $ret;
            })());
        }
    }
    GridFormGroupCreatedEventArgs.$t = /*@__PURE__*/ markType(GridFormGroupCreatedEventArgs, 'GridFormGroupCreatedEventArgs');
    return GridFormGroupCreatedEventArgs;
})();
/**
 * @hidden
 */
export let GridFormGroupCreatedEventArgsDetail = /*@__PURE__*/ (() => {
    class GridFormGroupCreatedEventArgsDetail extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.c.n("owner");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("owner", value_);
        }
    }
    GridFormGroupCreatedEventArgsDetail.$t = /*@__PURE__*/ markType(GridFormGroupCreatedEventArgsDetail, 'GridFormGroupCreatedEventArgsDetail');
    return GridFormGroupCreatedEventArgsDetail;
})();
/**
 * @hidden
 */
export let GridSortingStrategy = /*@__PURE__*/ (() => {
    class GridSortingStrategy extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        a(a, b, c) {
            return (this.nativeElement.sort(this.c.i(a), this.c.i(b), this.c.i(c)));
        }
    }
    GridSortingStrategy.$t = /*@__PURE__*/ markType(GridSortingStrategy, 'GridSortingStrategy');
    return GridSortingStrategy;
})();
/**
 * @hidden
 */
export let GridHeaderTemplateContext = /*@__PURE__*/ (() => {
    class GridHeaderTemplateContext extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.c.m("implicit", (a) => new HeaderType());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("implicit", value_);
        }
    }
    GridHeaderTemplateContext.$t = /*@__PURE__*/ markType(GridHeaderTemplateContext, 'GridHeaderTemplateContext');
    return GridHeaderTemplateContext;
})();
/**
 * @hidden
 */
export let GridRowDragGhostContext = /*@__PURE__*/ (() => {
    class GridRowDragGhostContext extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get f() {
            let ret_ = this.c.n("implicit");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.c.v("implicit", value_);
        }
        get e() {
            let ret_ = this.c.n("data");
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.c.v("data", value_);
        }
        get a() {
            let ret_ = this.c.n("grid");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("grid", value_);
        }
    }
    GridRowDragGhostContext.$t = /*@__PURE__*/ markType(GridRowDragGhostContext, 'GridRowDragGhostContext');
    return GridRowDragGhostContext;
})();
/**
 * @hidden
 */
export let GridRowTemplateContext = /*@__PURE__*/ (() => {
    class GridRowTemplateContext extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.c.m("implicit", (a) => new RowType());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("implicit", value_);
        }
    }
    GridRowTemplateContext.$t = /*@__PURE__*/ markType(GridRowTemplateContext, 'GridRowTemplateContext');
    return GridRowTemplateContext;
})();
/**
 * @hidden
 */
export let GridTemplateContext = /*@__PURE__*/ (() => {
    class GridTemplateContext extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.c.n("implicit");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("implicit", value_);
        }
    }
    GridTemplateContext.$t = /*@__PURE__*/ markType(GridTemplateContext, 'GridTemplateContext');
    return GridTemplateContext;
})();
/**
 * @hidden
 */
export let GridToolbarExportEventArgs = /*@__PURE__*/ (() => {
    class GridToolbarExportEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new GridToolbarExportEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new GridToolbarExportEventArgsDetail());
                return $ret;
            })());
        }
    }
    GridToolbarExportEventArgs.$t = /*@__PURE__*/ markType(GridToolbarExportEventArgs, 'GridToolbarExportEventArgs');
    return GridToolbarExportEventArgs;
})();
/**
 * @hidden
 */
export let GridToolbarExportEventArgsDetail = /*@__PURE__*/ (() => {
    class GridToolbarExportEventArgsDetail extends BaseEventArgsDetail {
        get i() {
            let ret_ = this.b.n("grid");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("grid", value_);
        }
        get g() {
            let ret_ = this.b.n("exporter");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("exporter", value_);
        }
        get h() {
            let ret_ = this.b.n("options");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("options", value_);
        }
        get j() {
            let ret_ = this.b.n("cancel");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.b.v("cancel", value_);
        }
    }
    GridToolbarExportEventArgsDetail.$t = /*@__PURE__*/ markType(GridToolbarExportEventArgsDetail, 'GridToolbarExportEventArgsDetail', BaseEventArgsDetail.$);
    return GridToolbarExportEventArgsDetail;
})();
/**
 * @hidden
 */
export let GridValidationStatusEventArgs = /*@__PURE__*/ (() => {
    class GridValidationStatusEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new GridValidationStatusEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new GridValidationStatusEventArgsDetail());
                return $ret;
            })());
        }
    }
    GridValidationStatusEventArgs.$t = /*@__PURE__*/ markType(GridValidationStatusEventArgs, 'GridValidationStatusEventArgs');
    return GridValidationStatusEventArgs;
})();
/**
 * @hidden
 */
export let GridValidationStatusEventArgsDetail = /*@__PURE__*/ (() => {
    class GridValidationStatusEventArgsDetail extends Base {
        constructor() {
            super(...arguments);
            this.c = new WCNativeHelper();
            this.e = null;
        }
        get d() {
            return this.c;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.c.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.d.n("status");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(ValidationStatus_$type, EnumUtil.getEnumValue(ValidationStatus_$type, this.d.f(ValidationStatus_$type, ret_)));
            return EnumUtil.getEnumValue(ValidationStatus_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(ValidationStatus_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.d.v("status", value_);
        }
        get a() {
            let ret_ = this.d.n("owner");
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.d.v("owner", value_);
        }
    }
    GridValidationStatusEventArgsDetail.$t = /*@__PURE__*/ markType(GridValidationStatusEventArgsDetail, 'GridValidationStatusEventArgsDetail');
    return GridValidationStatusEventArgsDetail;
})();
/**
 * @hidden
 */
export let GroupByRecord = /*@__PURE__*/ (() => {
    class GroupByRecord extends Base {
        constructor() {
            super(...arguments);
            this.f = new WCNativeHelper();
            this.j = null;
        }
        get g() {
            return this.f;
        }
        get nativeElement() {
            return this.j;
        }
        set nativeElement(a) {
            this.j = a;
            this.f.o = this.j;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get e() {
            let ret_ = this.g.m("expression", (a) => new SortingExpression());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.g.v("expression", value_);
        }
        get i() {
            let ret_ = this.g.n("level");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.g.v("level", value_);
        }
        get b() {
            let ret_ = this.g.n("records");
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.g.v("records", value_);
        }
        get l() {
            let ret_ = this.g.n("value");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.g.v("value", value_);
        }
        get d() {
            let ret_ = this.g.m("groupParent", (a) => new GroupByRecord());
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.g.v("groupParent", value_);
        }
        get a() {
            let ret_ = this.g.m("groups", (a) => new GroupByRecord());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.g.v("groups", value_);
        }
        get h() {
            let ret_ = this.g.n("height");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.g.v("height", value_);
        }
        get c() {
            let ret_ = this.g.m("column", (a) => new Column());
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.g.v("column", value_);
        }
    }
    GroupByRecord.$t = /*@__PURE__*/ markType(GroupByRecord, 'GroupByRecord');
    return GroupByRecord;
})();
/**
 * @hidden
 */
export let HeaderType = /*@__PURE__*/ (() => {
    class HeaderType extends Base {
        constructor() {
            super(...arguments);
            this.d = new WCNativeHelper();
            this.j = null;
        }
        get e() {
            return this.d;
        }
        get nativeElement() {
            return this.j;
        }
        set nativeElement(a) {
            this.j = a;
            this.d.o = this.j;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.e.m("column", (a) => new Column());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.e.v("column", value_);
        }
        get b() {
            let ret_ = this.e.n("density");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(DisplayDensity_$type, EnumUtil.getEnumValue(DisplayDensity_$type, this.e.f(DisplayDensity_$type, ret_)));
            return EnumUtil.getEnumValue(DisplayDensity_$type, ret_);
        }
        set b(a) {
            let value_ = enumGetBox(DisplayDensity_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.e.v("density", value_);
        }
        get h() {
            let ret_ = this.e.n("sorted");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.e.v("sorted", value_);
        }
        get f() {
            let ret_ = this.e.n("selectable");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.e.v("selectable", value_);
        }
        get g() {
            let ret_ = this.e.n("selected");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.e.v("selected", value_);
        }
        get i() {
            let ret_ = this.e.n("title");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.e.v("title", value_);
        }
        get c() {
            let ret_ = this.e.n("sortDirection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SortingDirection_$type, EnumUtil.getEnumValue(SortingDirection_$type, this.e.f(SortingDirection_$type, ret_)));
            return EnumUtil.getEnumValue(SortingDirection_$type, ret_);
        }
        set c(a) {
            let value_ = enumGetBox(SortingDirection_$type, a);
            value_ = this.e.f(SortingDirection_$type, value_);
            this.e.v("sortDirection", value_);
        }
    }
    HeaderType.$t = /*@__PURE__*/ markType(HeaderType, 'HeaderType');
    return HeaderType;
})();
/**
 * @hidden
 */
export let PinColumnCancellableEventArgs = /*@__PURE__*/ (() => {
    class PinColumnCancellableEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new PinColumnCancellableEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new PinColumnCancellableEventArgsDetail());
                return $ret;
            })());
        }
    }
    PinColumnCancellableEventArgs.$t = /*@__PURE__*/ markType(PinColumnCancellableEventArgs, 'PinColumnCancellableEventArgs');
    return PinColumnCancellableEventArgs;
})();
/**
 * @hidden
 */
export let PinColumnCancellableEventArgsDetail = /*@__PURE__*/ (() => {
    class PinColumnCancellableEventArgsDetail extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.g = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.g;
        }
        set nativeElement(a) {
            this.g = a;
            this.b.o = this.g;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get a() {
            let ret_ = this.c.m("column", (a) => new Column());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("column", value_);
        }
        get f() {
            let ret_ = this.c.n("insertAtIndex");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.c.v("insertAtIndex", value_);
        }
        get e() {
            let ret_ = this.c.n("isPinned");
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.c.v("isPinned", value_);
        }
        get d() {
            let ret_ = this.c.n("cancel");
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.c.v("cancel", value_);
        }
    }
    PinColumnCancellableEventArgsDetail.$t = /*@__PURE__*/ markType(PinColumnCancellableEventArgsDetail, 'PinColumnCancellableEventArgsDetail');
    return PinColumnCancellableEventArgsDetail;
})();
/**
 * @hidden
 */
export let PinColumnEventArgs = /*@__PURE__*/ (() => {
    class PinColumnEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new PinColumnEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new PinColumnEventArgsDetail());
                return $ret;
            })());
        }
    }
    PinColumnEventArgs.$t = /*@__PURE__*/ markType(PinColumnEventArgs, 'PinColumnEventArgs');
    return PinColumnEventArgs;
})();
/**
 * @hidden
 */
export let PinColumnEventArgsDetail = /*@__PURE__*/ (() => {
    class PinColumnEventArgsDetail extends BaseEventArgsDetail {
        get g() {
            let ret_ = this.b.m("column", (a) => new Column());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("column", value_);
        }
        get i() {
            let ret_ = this.b.n("insertAtIndex");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("insertAtIndex", value_);
        }
        get h() {
            let ret_ = this.b.n("isPinned");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("isPinned", value_);
        }
    }
    PinColumnEventArgsDetail.$t = /*@__PURE__*/ markType(PinColumnEventArgsDetail, 'PinColumnEventArgsDetail', BaseEventArgsDetail.$);
    return PinColumnEventArgsDetail;
})();
/**
 * @hidden
 */
export let PinRowEventArgs = /*@__PURE__*/ (() => {
    class PinRowEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new PinRowEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new PinRowEventArgsDetail());
                return $ret;
            })());
        }
    }
    PinRowEventArgs.$t = /*@__PURE__*/ markType(PinRowEventArgs, 'PinRowEventArgs');
    return PinRowEventArgs;
})();
/**
 * @hidden
 */
export let PinRowEventArgsDetail = /*@__PURE__*/ (() => {
    class PinRowEventArgsDetail extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.g = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.g;
        }
        set nativeElement(a) {
            this.g = a;
            this.b.o = this.g;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get j() {
            let ret_ = this.c.n("rowID");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.c.v("rowID", value_);
        }
        get a() {
            let ret_ = this.c.m("row", (a) => new RowType());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("row", value_);
        }
        get f() {
            let ret_ = this.c.n("insertAtIndex");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.c.v("insertAtIndex", value_);
        }
        get e() {
            let ret_ = this.c.n("isPinned");
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.c.v("isPinned", value_);
        }
        get i() {
            let ret_ = this.c.n("owner");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.c.v("owner", value_);
        }
        get d() {
            let ret_ = this.c.n("cancel");
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.c.v("cancel", value_);
        }
    }
    PinRowEventArgsDetail.$t = /*@__PURE__*/ markType(PinRowEventArgsDetail, 'PinRowEventArgsDetail');
    return PinRowEventArgsDetail;
})();
/**
 * @hidden
 */
export let RowDragEndEventArgs = /*@__PURE__*/ (() => {
    class RowDragEndEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new RowDragEndEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new RowDragEndEventArgsDetail());
                return $ret;
            })());
        }
    }
    RowDragEndEventArgs.$t = /*@__PURE__*/ markType(RowDragEndEventArgs, 'RowDragEndEventArgs');
    return RowDragEndEventArgs;
})();
/**
 * @hidden
 */
export let RowDragEndEventArgsDetail = /*@__PURE__*/ (() => {
    class RowDragEndEventArgsDetail extends BaseEventArgsDetail {
        get i() {
            let ret_ = this.b.n("dragDirective");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.b.v("dragDirective", value_);
        }
        get g() {
            let ret_ = this.b.m("dragData", (a) => new RowType());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.b.v("dragData", value_);
        }
        get h() {
            let ret_ = this.b.n("animation");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.b.v("animation", value_);
        }
    }
    RowDragEndEventArgsDetail.$t = /*@__PURE__*/ markType(RowDragEndEventArgsDetail, 'RowDragEndEventArgsDetail', BaseEventArgsDetail.$);
    return RowDragEndEventArgsDetail;
})();
/**
 * @hidden
 */
export let RowDragStartEventArgs = /*@__PURE__*/ (() => {
    class RowDragStartEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.b = null;
        }
        static a(a) {
            return ((() => {
                let $ret = new RowDragStartEventArgs();
                $ret.b = WCNativeHelper.h(a, (b) => new RowDragStartEventArgsDetail());
                return $ret;
            })());
        }
    }
    RowDragStartEventArgs.$t = /*@__PURE__*/ markType(RowDragStartEventArgs, 'RowDragStartEventArgs');
    return RowDragStartEventArgs;
})();
/**
 * @hidden
 */
export let RowDragStartEventArgsDetail = /*@__PURE__*/ (() => {
    class RowDragStartEventArgsDetail extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.e = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.e;
        }
        set nativeElement(a) {
            this.e = a;
            this.b.o = this.e;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get f() {
            let ret_ = this.c.n("dragDirective");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.c.v("dragDirective", value_);
        }
        get a() {
            let ret_ = this.c.m("dragData", (a) => new RowType());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("dragData", value_);
        }
        get d() {
            let ret_ = this.c.n("cancel");
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.c.v("cancel", value_);
        }
        get h() {
            let ret_ = this.c.n("owner");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.c.v("owner", value_);
        }
    }
    RowDragStartEventArgsDetail.$t = /*@__PURE__*/ markType(RowDragStartEventArgsDetail, 'RowDragStartEventArgsDetail');
    return RowDragStartEventArgsDetail;
})();
/**
 * @hidden
 */
export let RowType = /*@__PURE__*/ (() => {
    class RowType extends Base {
        constructor() {
            super(...arguments);
            this.h = new WCNativeHelper();
            this.w = null;
        }
        get i() {
            return this.h;
        }
        get nativeElement() {
            return this.w;
        }
        set nativeElement(a) {
            this.w = a;
            this.h.o = this.w;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get u() {
            let ret_ = this.i.n("index");
            return ret_;
        }
        set u(a) {
            let value_ = a;
            this.i.v("index", value_);
        }
        get v() {
            let ret_ = this.i.n("viewIndex");
            return ret_;
        }
        set v(a) {
            let value_ = a;
            this.i.v("viewIndex", value_);
        }
        get q() {
            let ret_ = this.i.n("isGroupByRow");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.i.v("isGroupByRow", value_);
        }
        get r() {
            let ret_ = this.i.n("isSummaryRow");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.i.v("isSummaryRow", value_);
        }
        get e() {
            let ret_ = this.i.m("groupRow", (a) => new GroupByRecord());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.i.v("groupRow", value_);
        }
        get z() {
            let ret_ = this.i.n("key");
            return ret_;
        }
        set z(a) {
            let value_ = a;
            this.i.v("key", value_);
        }
        get d() {
            let ret_ = this.i.m("validation", (a) => new GridValidationState());
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.i.v("validation", value_);
        }
        get x() {
            let ret_ = this.i.n("data");
            return ret_;
        }
        set x(a) {
            let value_ = a;
            this.i.v("data", value_);
        }
        get a() {
            let ret_ = this.i.m("cells", (a) => new CellType());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.i.v("cells", value_);
        }
        get l() {
            let ret_ = this.i.n("disabled");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.i.v("disabled", value_);
        }
        get s() {
            let ret_ = this.i.n("pinned");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.i.v("pinned", value_);
        }
        get t() {
            let ret_ = this.i.n("selected");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.i.v("selected", value_);
        }
        get m() {
            let ret_ = this.i.n("expanded");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.i.v("expanded", value_);
        }
        get k() {
            let ret_ = this.i.n("deleted");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.i.v("deleted", value_);
        }
        get p() {
            let ret_ = this.i.n("inEditMode");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.i.v("inEditMode", value_);
        }
        get b() {
            let ret_ = this.i.m("children", (a) => new RowType());
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.i.v("children", value_);
        }
        get f() {
            let ret_ = this.i.m("parent", (a) => new RowType());
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.i.v("parent", value_);
        }
        get o() {
            let ret_ = this.i.n("hasChildren");
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.i.v("hasChildren", value_);
        }
        get g() {
            let ret_ = this.i.m("treeRow", (a) => new TreeGridRecord());
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.i.v("treeRow", value_);
        }
        get j() {
            let ret_ = this.i.n("addRowUI");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.i.v("addRowUI", value_);
        }
        get n() {
            let ret_ = this.i.n("focused");
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.i.v("focused", value_);
        }
        get c() {
            let ret_ = this.i.n("grid");
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.i.v("grid", value_);
        }
        af(a) {
            this.nativeElement.update(this.i.i(a));
        }
        y() {
            return (this.nativeElement.delete());
        }
        ac() {
            this.nativeElement.pin();
        }
        ae() {
            this.nativeElement.unpin();
        }
        get ab() {
            if (this.z == null) {
                return "Index:" + this.u.toString();
            }
            if (typeof this.z === 'string' || typeof this.z === 'number' || typeof this.z === 'number' || typeCast(Date_$type, this.z) !== null) {
                return "Key:" + this.z.toString();
            }
            else {
                return "Index:" + this.u.toString();
            }
        }
    }
    RowType.$t = /*@__PURE__*/ markType(RowType, 'RowType');
    return RowType;
})();
