/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridCellBase } from "./GridCellBase";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { enumGetBox, runOn, delegateCombine, delegateRemove, markType } from "igniteui-react-core";
import { EditorType_$type } from "./EditorType";
import { Popup } from "igniteui-react-core";
import { TextEditorView } from "./TextEditorView";
import { NumericEditorView } from "./NumericEditorView";
import { DateEditorView } from "./DateEditorView";
import { ComboEditorView } from "./ComboEditorView";
import { Rect } from "igniteui-react-core";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
/**
 * @hidden
 */
export let EditorCell = /*@__PURE__*/ (() => {
    class EditorCell extends GridCellBase {
        get ck() {
            return this.cj;
        }
        set ck(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.bp("DataType", enumGetBox(DataSourceSchemaPropertyType_$type, b), enumGetBox(DataSourceSchemaPropertyType_$type, this.cj));
            }
        }
        get di() {
            return this.dg;
        }
        set di(a) {
            let b = this.dg;
            this.dg = a;
            this.bp("Value", b, this.dg);
        }
        get cz() {
            return this.cy;
        }
        set cz(a) {
            let b = this.cy;
            this.cy = a;
            if (b != this.cy) {
                this.bp("FontInfo", b, this.cy);
            }
        }
        get cm() {
            return this.cl;
        }
        set cm(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.bp("EditorType", enumGetBox(EditorType_$type, b), enumGetBox(EditorType_$type, this.cl));
            }
        }
        get dh() {
            return this.df;
        }
        set dh(a) {
            let b = this.df;
            this.df = a;
            if (b != this.df) {
                this.bp("ComboItemsSource", b, this.df);
            }
        }
        get dm() {
            return this.dj;
        }
        set dm(a) {
            let b = this.dj;
            this.dj = a;
            if (b != this.dj) {
                this.bp("ComboTextField", b, this.dj);
            }
        }
        get ci() {
            return this.ch;
        }
        set ci(a) {
            let b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.bp("ComboValueField", b, this.ch);
            }
        }
        get da() {
            return this.c2;
        }
        set da(a) {
            let b = this.c2;
            this.c2 = a;
            if (b != this.c2) {
                this.bp("IsHidden", b, this.c2);
            }
        }
        get dr() {
            return this.dk;
        }
        set dr(a) {
            let b = this.dk;
            this.dk = a;
            if (b != this.dk) {
                this.bp("DateFormatString", b, this.dk);
            }
        }
        get db() {
            return this.c3;
        }
        set db(a) {
            let b = this.c3;
            this.c3 = a;
            if (b != this.c3) {
                this.bp("ShowTodayButton", b, this.c3);
            }
        }
        constructor(a) {
            super(a);
            this.cn = null;
            this.cw = null;
            this.cv = null;
            this.cu = null;
            this.ct = null;
            this.dc = null;
            this.dd = null;
            this.de = null;
            this.cx = null;
            this.c0 = false;
            this.c4 = false;
            this.c1 = false;
            this.cj = 0;
            this.dg = null;
            this.cy = null;
            this.cl = 1;
            this.df = null;
            this.dj = null;
            this.ch = null;
            this.c2 = true;
            this.dk = null;
            this.c3 = false;
            this.c6 = false;
            this.c7 = false;
            this.c5 = false;
            this.ae.setAttribute("tabindex", "-1");
            this.ae.setStyleProperty("outline", "none");
            this.ae.setStyleProperty("display", "flex");
            this.ae.setStyleProperty("align-items", "center");
            this.ae.listen("focusout", runOn(this, this.eb));
            this.ae.listen("focusin", runOn(this, this.d9));
        }
        cs(a) {
            if (this.dc == null) {
                this.dc = this.ab.createElement("div");
                let b = this.ab.getSubRenderer(this.dc);
                this.cx = new Popup();
                this.cx.provideRenderer(b);
                this.de = this.ab.createElement("div");
                this.de.setStyleProperty("background-color", "rgba(0,0,0,0.7)");
                this.de.setStyleProperty("color", "#fff");
                this.de.setStyleProperty("padding", "5px");
                this.de.setStyleProperty("outline", "none");
                this.de.setAttribute("tabindex", "-1");
                this.dd = this.ab.createElement("div");
                this.dd.setStyleProperty("white-space", "pre");
                if (this.cz != null) {
                    this.dd.setStyleProperty("font", this.cz.fontString);
                }
                this.de.append(this.dd);
                this.cx.appendPopupContent(this.de);
            }
            let c = null;
            switch (a) {
                case 1:
                    c = this.cr();
                    break;
                case 2:
                    c = this.cq();
                    break;
                case 3:
                    c = this.cp();
                    break;
                case 4:
                    c = this.co();
                    break;
            }
            return c;
        }
        cr() {
            if (this.cw != null) {
                this.d3();
                this.d8();
                return this.cw;
            }
            this.cw = new TextEditorView(this.ab, this.f.getTheme(), this.b);
            this.cw.setFont(this.cz);
            return this.cw;
        }
        cq() {
            if (this.cv != null) {
                this.d3();
                this.d8();
                return this.cv;
            }
            this.cv = new NumericEditorView(this.ab, this.f.getTheme(), this.b);
            this.cv.setFont(this.cz);
            return this.cv;
        }
        cp() {
            if (this.cu != null) {
                this.d3();
                this.d8();
                return this.cu;
            }
            this.cu = new DateEditorView(this.ab, this.f.getTheme(), this.b);
            this.cu.setFont(this.cz);
            return this.cu;
        }
        co() {
            if (this.ct != null) {
                this.d2();
                this.d3();
                this.d8();
                return this.ct;
            }
            this.ct = new ComboEditorView(this.ab, this.f.getTheme(), this.b);
            this.ct.setFont(this.cz);
            this.ct.ag = this.dh;
            this.ct.aj = this.dm;
            this.ct.z = this.ci;
            return this.ct;
        }
        ea(a, b) {
            if (b.g != b.d || b.h != b.e) {
                if (this.ct != null) {
                    this.ct.am();
                }
                if (this.cu != null) {
                    this.cu.ag();
                }
                this.d0();
            }
        }
        dy() {
            if (!this.c1) {
                if (this.cn != null) {
                    this.cn.attachEvents();
                    let a = this.cn;
                    a.valueProvided = delegateCombine(a.valueProvided, runOn(this, this.eg));
                    let b = this.cn;
                    b.lostFocus = delegateCombine(b.lostFocus, runOn(this, this.d6));
                    let c = this.cn;
                    c.gotFocus = delegateCombine(c.gotFocus, runOn(this, this.d5));
                    let d = this.cn;
                    d.userTyping = delegateCombine(d.userTyping, runOn(this, this.ee));
                    this.c1 = true;
                }
            }
        }
        dz() {
            if (this.c1) {
                if (this.cn != null) {
                    this.cn.detachEvents();
                    let a = this.cn;
                    a.valueProvided = delegateRemove(a.valueProvided, runOn(this, this.eg));
                    let b = this.cn;
                    b.lostFocus = delegateRemove(b.lostFocus, runOn(this, this.d6));
                    let c = this.cn;
                    c.gotFocus = delegateRemove(c.gotFocus, runOn(this, this.d5));
                    let d = this.cn;
                    d.userTyping = delegateRemove(d.userTyping, runOn(this, this.ee));
                    this.c1 = false;
                }
            }
        }
        ed(a) {
            this.c6 = false;
            this.c7 = false;
            this.c5 = false;
            if (!a) {
                this.c7 = true;
                this.cn.onTargetChanged();
            }
        }
        ef() {
            if (this.cn != null) {
                this.cn.value = this.di;
            }
        }
        d3() {
        }
        d7() {
            this.c0 = true;
            this.dz();
            this.ae.removeChildren();
            if (this.cn != null) {
                this.cn.cleanUp();
            }
            this.cn = this.cs(this.cm);
            this.ae.append(this.cn.container);
            this.dy();
            if (this.cn != null) {
                this.cn.isEnabled = !this.isRemoved;
                if (!this.da) {
                    this.cn.onEditStarted();
                }
            }
            this.c0 = false;
        }
        d2() {
            if (this.ct != null) {
                this.ct.ag = this.dh;
                this.ct.aj = this.dm;
                this.ct.z = this.ci;
            }
        }
        d8() {
            if (this.cz != null) {
                if (this.cw != null) {
                    this.cw.setFont(this.cz);
                }
                if (this.cv != null) {
                    this.cv.setFont(this.cz);
                }
                if (this.cu != null) {
                    this.cu.setFont(this.cz);
                }
                if (this.ct != null) {
                    this.ct.setFont(this.cz);
                }
                this.dd.setStyleProperty("font", this.cz.fontString);
            }
        }
        d1() {
            this.c4 = false;
            if (this.cn != null) {
                if (!this.da) {
                    this.cn.onEditStarted();
                }
                else {
                    this.cn.onEditEnded();
                    this.cn.value = null;
                    this.cn.value = this.di;
                }
            }
        }
        d4() {
            if (this.cn != null && this.cu == this.cn) {
                this.cu.ae = this.dr;
            }
        }
        ec() {
            if (this.cn != null && this.cu == this.cn) {
                this.cu.ac = this.db;
            }
        }
        eh(a, b, c, d, e) {
            if (!stringIsNullOrWhiteSpace(a)) {
                this.dd.setRawText(a);
                this.cx.b8();
                this.ei();
            }
        }
        ei() {
            let rect_ = this.ae.getNativeElement().getBoundingClientRect();
            let a = new Rect(4);
            a.left = (rect_.left + window.pageXOffset);
            a.top = (rect_.top + window.pageYOffset);
            a.right = (rect_.right + window.pageXOffset);
            a.bottom = (rect_.bottom + window.pageYOffset);
            this.cx.showRelativeToExclusionRect(a, 1, 0);
        }
        d0() {
            if (this.cx.aw) {
                this.cx.b5();
            }
        }
        bo() {
            if (this.cn == null) {
                this.d7();
                this.f.setViewportChangedHandler(runOn(this, this.ea));
            }
        }
        be() {
            if (this.cn != null) {
                this.cn.focus();
            }
        }
        bp(a, b, c) {
            super.bp(a, b, c);
            switch (a) {
                case "EditorType":
                    this.d7();
                    break;
                case "ComboItemsSource":
                case "ComboTextField":
                case "ComboValueField":
                    this.d2();
                    break;
                case "DataType":
                    this.d3();
                    break;
                case "Value":
                    this.ef();
                    break;
                case "FontInfo":
                    this.d8();
                    break;
                case "IsHidden":
                    this.d1();
                    break;
                case "DateFormatString":
                    this.d4();
                    break;
                case "ShowTodayButton":
                    this.ec();
                    break;
                case "IsRemoved":
                    if (this.cn != null) {
                        this.cn.isEnabled = !this.isRemoved;
                        if (!this.isRemoved) {
                            this.cn.onTargetChanged();
                        }
                    }
                    break;
            }
        }
        eg(a, b, c) {
            if (a == this.cn) {
                if (!c) {
                    this.b.updateCellEditValue(b);
                }
            }
        }
        ee(a) {
            if (a == this.cn) {
                this.b.startEditMode();
            }
        }
        c9(a) {
            if (a != null && this.cx != null && this.cx.aw) {
                let b = this.de.getNativeElement();
                return b.contains(a);
            }
            return false;
        }
        c8(a) {
            if (a != null) {
                let b = this.ae.getNativeElement();
                return b.contains(a);
            }
            return false;
        }
        eb(a) {
            if (!this.c0) {
                let b = (a.originalEvent.relatedTarget);
                if (this.c5 && !this.c8(b) && !this.c9(b)) {
                    this.b.editorCellLostFocus();
                    this.d0();
                }
                let c = this.ab.rootWrapper.getNativeElement();
                if (c.contains(b)) {
                    window.setTimeout(() => {
                        let d = document.activeElement.nodeName;
                        if (d == "INPUT" || d == "SELECT" || d == "TEXTAREA" || d == "BUTTON" || d == "OPTION") {
                            return;
                        }
                        if (this.b.isEditRefocusDesired && this.cn != null) {
                            this.cn.focus();
                        }
                    }, 0);
                }
            }
        }
        d9(a) {
            if (this.c6 && !this.cx.aw) {
                this.ei();
            }
        }
        d6(a) {
            this.c5 = true;
        }
        d5(a) {
            this.c5 = false;
        }
        onContactStarted(a, b) {
            a.stopPropagation();
        }
        onContactCompleted(a, b) {
            a.stopPropagation();
        }
        onDoubleClick(a) {
            a.stopPropagation();
        }
    }
    EditorCell.$t = /*@__PURE__*/ markType(EditorCell, 'EditorCell', GridCellBase.$);
    return EditorCell;
})();
