/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridBaseDirective } from "./GridBaseDirective";
import { markType } from "igniteui-react-core";
import { GridMasterDetailContext } from "./GridMasterDetailContext";
import { GroupByRecord } from "./GroupByRecord";
import { GroupingExpression } from "./GroupingExpression";
import { GroupByExpandState } from "./GroupByExpandState";
import { GridGroupingStrategy } from "./GridGroupingStrategy";
import { GroupByRowSelectorTemplateContext } from "./GroupByRowSelectorTemplateContext";
import { GroupByRowTemplateContext } from "./GroupByRowTemplateContext";
import { CellType } from "./CellType";
import { ForOfStateEventArgs } from "./ForOfStateEventArgs";
import { GroupingDoneEventArgs } from "./GroupingDoneEventArgs";
import { RowType } from "./RowType";
import { stringStartsWith } from "igniteui-react-core";
import { parseBool } from "igniteui-react-core";
/**
 * @hidden
 */
export let Grid = /*@__PURE__*/ (() => {
    class Grid extends GridBaseDirective {
        constructor() {
            super(...arguments);
            this.hj = null;
            this.hi = null;
            this.hk = null;
            this.hl = null;
            this.dataPreLoad = null;
            this.groupingDone = null;
        }
        get ha() {
            let ret_ = this.d.n("groupsExpanded");
            return ret_;
        }
        set ha(a) {
            let value_ = a;
            this.d.v("groupsExpanded", value_);
        }
        get hn() {
            return this.hj;
        }
        set hn(a) {
            this.hj = a;
            this.d.s("dropAreaTemplate", (b) => b, this.hj);
        }
        get hm() {
            return this.hi;
        }
        set hm(a) {
            this.hi = a;
            this.d.s("detailTemplate", (b) => new GridMasterDetailContext(), this.hi);
        }
        get hr() {
            let ret_ = this.d.n("id");
            return ret_;
        }
        set hr(a) {
            let value_ = a;
            this.d.v("id", value_);
        }
        get g1() {
            let ret_ = this.d.m("groupsRecords", (a) => new GroupByRecord());
            return ret_;
        }
        get gx() {
            let ret_ = this.d.n("data");
            return ret_;
        }
        set gx(a) {
            let value_ = a;
            this.d.v("data", value_);
        }
        get hg() {
            let ret_ = this.d.n("totalItemCount");
            return ret_;
        }
        set hg(a) {
            let value_ = a;
            this.d.v("totalItemCount", value_);
        }
        get g0() {
            let ret_ = this.d.m("groupingExpressions", (a) => new GroupingExpression());
            return ret_;
        }
        set g0(a) {
            let value_ = a;
            this.d.v("groupingExpressions", value_);
        }
        get gz() {
            let ret_ = this.d.m("groupingExpansionState", (a) => new GroupByExpandState());
            return ret_;
        }
        set gz(a) {
            let value_ = a;
            this.d.v("groupingExpansionState", value_);
        }
        get hb() {
            let ret_ = this.d.n("hideGroupedColumns");
            return ret_;
        }
        set hb(a) {
            let value_ = a;
            this.d.v("hideGroupedColumns", value_);
        }
        get g6() {
            let ret_ = this.d.m("groupStrategy", (a) => new GridGroupingStrategy());
            return ret_;
        }
        set g6(a) {
            let value_ = a;
            this.d.v("groupStrategy", value_);
        }
        get hq() {
            let ret_ = this.d.n("dropAreaMessage");
            return ret_;
        }
        set hq(a) {
            let value_ = a;
            this.d.v("dropAreaMessage", value_);
        }
        get ho() {
            return this.hk;
        }
        set ho(a) {
            this.hk = a;
            this.d.s("groupByRowSelectorTemplate", (b) => new GroupByRowSelectorTemplateContext(), this.hk);
        }
        get hp() {
            return this.hl;
        }
        set hp(a) {
            this.hl = a;
            this.d.s("groupRowTemplate", (b) => new GroupByRowTemplateContext(), this.hl);
        }
        get he() {
            let ret_ = this.d.n("showGroupArea");
            return ret_;
        }
        set he(a) {
            let value_ = a;
            this.d.v("showGroupArea", value_);
        }
        get g2() {
            let ret_ = this.d.m("selectedCells", (a) => new CellType());
            return ret_;
        }
        dataPreLoadChanged() {
            if (this.dataPreLoad != null) {
                this.d.r("dataPreLoad", (a) => this.dataPreLoad(this, ForOfStateEventArgs.b(a)), false);
            }
            else {
                this.d.u("dataPreLoad");
            }
        }
        groupingDoneChanged() {
            if (this.groupingDone != null) {
                this.d.r("groupingDone", (a) => this.groupingDone(this, GroupingDoneEventArgs.a(a)), false);
            }
            else {
                this.d.u("groupingDone");
            }
        }
        hy(a) {
            this.nativeElement.groupBy(this.d.i(a));
        }
        hu(a) {
            this.nativeElement.clearGrouping(this.d.i(a));
        }
        hc(a) {
            return (this.nativeElement.isExpandedGroup(this.d.i(a)));
        }
        h2(a) {
            this.nativeElement.toggleGroup(this.d.i(a));
        }
        h0(a, b = false) {
            this.nativeElement.selectRowsInGroup(this.d.i(a), this.d.i(b));
        }
        hw(a) {
            this.nativeElement.deselectRowsInGroup(this.d.i(a));
        }
        hx(a) {
            this.nativeElement.fullyExpandGroup(this.d.i(a));
        }
        h1() {
            this.nativeElement.toggleAllGroupRows();
        }
        gy(a = false, b = false) {
            return (this.nativeElement.getSelectedData(this.d.i(a), this.d.i(b)));
        }
        g8(a) {
            return this.d.g(this.nativeElement.getRowByIndex(this.d.i(a)), (b) => new RowType());
        }
        g9(a) {
            return this.d.g(this.nativeElement.getRowByKey(this.d.i(a)), (b) => new RowType());
        }
        g3(a, b) {
            return this.d.g(this.nativeElement.getCellByColumn(this.d.i(a), this.d.i(b)), (c) => new CellType());
        }
        g4(a, b) {
            return this.d.g(this.nativeElement.getCellByKey(this.d.i(a), this.d.i(b)), (c) => new CellType());
        }
        hd(a, b = -1) {
            return (this.nativeElement.pinRow(this.d.i(a), this.d.i(b)));
        }
        hf(a) {
            return (this.nativeElement.unpinRow(this.d.i(a)));
        }
        hh(a) {
            if (a == null) {
                return null;
            }
            if (!stringStartsWith(a, "@@e:")) {
                return null;
            }
            a = a.substr(4);
            let b = a.split('@');
            let c = b[0];
            let d = b[1];
            switch (c) {
                case "RowType":
                    if (stringStartsWith(d, "Index:")) {
                        d = d.substr(6);
                        return this.externalObject.getRowByIndex(parseInt(d));
                    }
                    else if (stringStartsWith(d, "Key:")) {
                        d = d.substr(4);
                        let g = this.gx;
                        for (let f = 0; f < g.length; f++) {
                            let e = g[f];
                            let h = e[this.ed];
                            if (h != null) {
                                if ((typeof h == "string")) {
                                    return this.externalObject.getRowByKey(d);
                                }
                                if ((typeof h == "number")) {
                                    return this.externalObject.getRowByKey(parseFloat(d));
                                }
                                if ((typeof h == "boolean")) {
                                    return this.externalObject.getRowByKey(parseBool(d));
                                }
                                if ((h instanceof Date)) {
                                    return this.externalObject.getRowByKey(new Date(d));
                                }
                                break;
                            }
                        }
                        return this.externalObject.getRowByKey(d);
                    }
                    return null;
            }
            return null;
        }
        hs(a) {
            this.nativeElement.addRow(a);
        }
        ht(a) {
            this.nativeElement.beginAddRowByIndex(a);
        }
    }
    Grid.$t = /*@__PURE__*/ markType(Grid, 'Grid', GridBaseDirective.$);
    return Grid;
})();
