/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridStateBaseDirective } from "./GridStateBaseDirective";
import { Base, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { ColumnState } from "./ColumnState";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { PagingState } from "./PagingState";
import { SortingExpression } from "./SortingExpression";
import { GroupingState } from "./GroupingState";
import { GridSelectionRange } from "./GridSelectionRange";
import { PinningConfig } from "./PinningConfig";
import { PivotConfiguration } from "./PivotConfiguration";
/**
 * @hidden
 */
export let GridState = /*@__PURE__*/ (() => {
    class GridState extends GridStateBaseDirective {
        constructor() {
            super(...arguments);
            this.stateParsed = null;
        }
        stateParsedChanged() {
            if (this.stateParsed != null) {
                this.c.r("stateParsed", (a) => this.stateParsed(this, GridStateInfoEventArgs.b(a)), false);
            }
            else {
                this.c.u("stateParsed");
            }
        }
        k(a, b) {
            this.nativeElement.applyState(this.c.i(a), this.c.i(b));
        }
        l(a, b) {
            this.nativeElement.applyStateFromString(this.c.i(a), this.c.i(b));
        }
        h(a) {
            return this.c.g(this.nativeElement.getState(this.c.i(a)), (b) => new GridStateInfo());
        }
        j(a) {
            return (this.nativeElement.getStateAsString(this.c.i(a)));
        }
    }
    GridState.$t = /*@__PURE__*/ markType(GridState, 'GridState', GridStateBaseDirective.$);
    return GridState;
})();
/**
 * @hidden
 */
export let GridStateCollection = /*@__PURE__*/ (() => {
    class GridStateCollection extends Base {
        constructor() {
            super(...arguments);
            this.b = new WCNativeHelper();
            this.d = null;
        }
        get c() {
            return this.b;
        }
        get nativeElement() {
            return this.d;
        }
        set nativeElement(a) {
            this.d = a;
            this.b.o = this.d;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get g() {
            let ret_ = this.c.n("id");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.c.v("id", value_);
        }
        get f() {
            let ret_ = this.c.n("parentRowID");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.c.v("parentRowID", value_);
        }
        get a() {
            let ret_ = this.c.m("state", (a) => new GridState());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.c.v("state", value_);
        }
    }
    GridStateCollection.$t = /*@__PURE__*/ markType(GridStateCollection, 'GridStateCollection');
    return GridStateCollection;
})();
/**
 * @hidden
 */
export let GridStateInfo = /*@__PURE__*/ (() => {
    class GridStateInfo extends Base {
        constructor() {
            super(...arguments);
            this.o = new WCNativeHelper();
            this.r = null;
        }
        get p() {
            return this.o;
        }
        get nativeElement() {
            return this.r;
        }
        set nativeElement(a) {
            this.r = a;
            this.o.o = this.r;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get b() {
            let ret_ = this.p.m("columns", (a) => new ColumnState());
            return ret_;
        }
        set b(a) {
            let value_ = a;
            this.p.v("columns", value_);
        }
        get j() {
            let ret_ = this.p.m("filtering", (a) => new FilteringExpressionsTree());
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.p.v("filtering", value_);
        }
        get i() {
            let ret_ = this.p.m("advancedFiltering", (a) => new FilteringExpressionsTree());
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.p.v("advancedFiltering", value_);
        }
        get l() {
            let ret_ = this.p.m("paging", (a) => new PagingState());
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.p.v("paging", value_);
        }
        get q() {
            let ret_ = this.p.n("moving");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.p.v("moving", value_);
        }
        get h() {
            let ret_ = this.p.m("sorting", (a) => new SortingExpression());
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.p.v("sorting", value_);
        }
        get k() {
            let ret_ = this.p.m("groupBy", (a) => new GroupingState());
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.p.v("groupBy", value_);
        }
        get a() {
            let ret_ = this.p.m("cellSelection", (a) => new GridSelectionRange());
            return ret_;
        }
        set a(a) {
            let value_ = a;
            this.p.v("cellSelection", value_);
        }
        get g() {
            let ret_ = this.p.n("rowSelection");
            return ret_;
        }
        set g(a) {
            let value_ = a;
            this.p.v("rowSelection", value_);
        }
        get c() {
            let ret_ = this.p.n("columnSelection");
            return ret_;
        }
        set c(a) {
            let value_ = a;
            this.p.v("columnSelection", value_);
        }
        get f() {
            let ret_ = this.p.n("rowPinning");
            return ret_;
        }
        set f(a) {
            let value_ = a;
            this.p.v("rowPinning", value_);
        }
        get m() {
            let ret_ = this.p.m("pinningConfig", (a) => new PinningConfig());
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.p.v("pinningConfig", value_);
        }
        get d() {
            let ret_ = this.p.n("expansion");
            return ret_;
        }
        set d(a) {
            let value_ = a;
            this.p.v("expansion", value_);
        }
        get e() {
            let ret_ = this.p.m("rowIslands", (a) => new GridStateCollection());
            return ret_;
        }
        set e(a) {
            let value_ = a;
            this.p.v("rowIslands", value_);
        }
        get t() {
            let ret_ = this.p.n("id");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.p.v("id", value_);
        }
        get n() {
            let ret_ = this.p.m("pivotConfiguration", (a) => new PivotConfiguration());
            return ret_;
        }
        set n(a) {
            let value_ = a;
            this.p.v("pivotConfiguration", value_);
        }
    }
    GridStateInfo.$t = /*@__PURE__*/ markType(GridStateInfo, 'GridStateInfo');
    return GridStateInfo;
})();
/**
 * @hidden
 */
export let GridStateInfoEventArgs = /*@__PURE__*/ (() => {
    class GridStateInfoEventArgs extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
        }
        static b(a) {
            return ((() => {
                let $ret = new GridStateInfoEventArgs();
                $ret.a = WCNativeHelper.h(a, (b) => new GridStateInfo());
                return $ret;
            })());
        }
    }
    GridStateInfoEventArgs.$t = /*@__PURE__*/ markType(GridStateInfoEventArgs, 'GridStateInfoEventArgs');
    return GridStateInfoEventArgs;
})();
