/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DisplayDensityBaseElement } from "./DisplayDensityBaseElement";
import { markType } from "igniteui-react-core";
import { OverlaySettings } from "./OverlaySettings";
import { PaginatorResourceStrings } from "./PaginatorResourceStrings";
import { NumberEventArgs } from "igniteui-react";
import { PageCancellableEventArgs } from "./PageCancellableEventArgs";
import { PageEventArgs } from "./PageEventArgs";
/**
 * @hidden
 */
export let Paginator = /*@__PURE__*/ (() => {
    class Paginator extends DisplayDensityBaseElement {
        constructor() {
            super(...arguments);
            this.perPageChange = null;
            this.pageChange = null;
            this.paging = null;
            this.pagingDone = null;
        }
        get r() {
            let ret_ = this.d.n("totalPages");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.d.v("totalPages", value_);
        }
        get p() {
            let ret_ = this.d.n("page");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.d.v("page", value_);
        }
        get q() {
            let ret_ = this.d.n("perPage");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.d.v("perPage", value_);
        }
        get s() {
            let ret_ = this.d.n("totalRecords");
            return ret_;
        }
        set s(a) {
            let value_ = a;
            this.d.v("totalRecords", value_);
        }
        get i() {
            let ret_ = this.d.n("selectOptions");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.d.v("selectOptions", value_);
        }
        get l() {
            let ret_ = this.d.m("overlaySettings", (a) => new OverlaySettings());
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.d.v("overlaySettings", value_);
        }
        get o() {
            let ret_ = this.d.m("resourceStrings", (a) => new PaginatorResourceStrings());
            return ret_;
        }
        set o(a) {
            let value_ = a;
            this.d.v("resourceStrings", value_);
        }
        perPageChangeChanged() {
            if (this.perPageChange != null) {
                this.d.r("perPageChange", (a) => this.perPageChange(this, NumberEventArgs.a(a)), false);
            }
            else {
                this.d.u("perPageChange");
            }
        }
        pageChangeChanged() {
            if (this.pageChange != null) {
                this.d.r("pageChange", (a) => this.pageChange(this, NumberEventArgs.a(a)), false);
            }
            else {
                this.d.u("pageChange");
            }
        }
        pagingChanged() {
            if (this.paging != null) {
                this.d.r("paging", (a) => this.paging(this, PageCancellableEventArgs.a(a)), false);
            }
            else {
                this.d.u("paging");
            }
        }
        pagingDoneChanged() {
            if (this.pagingDone != null) {
                this.d.r("pagingDone", (a) => this.pagingDone(this, PageEventArgs.a(a)), false);
            }
            else {
                this.d.u("pagingDone");
            }
        }
        u() {
            this.nativeElement.nextPage();
        }
        aa() {
            this.nativeElement.previousPage();
        }
        w(a) {
            this.nativeElement.paginate(this.d.i(a));
        }
        get t() {
            let ret_ = this.d.n("name");
            return ret_;
        }
        set t(a) {
            let value_ = a;
            this.d.v("name", value_);
        }
    }
    Paginator.$t = /*@__PURE__*/ markType(Paginator, 'Paginator', DisplayDensityBaseElement.$);
    return Paginator;
})();
