/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GridBaseDirective } from "./GridBaseDirective";
import { SortingExpression } from "./SortingExpression";
import { typeGetValue, markType } from "igniteui-react-core";
import { PivotGridValueTemplateContext } from "./PivotGridValueTemplateContext";
import { PivotConfiguration } from "./PivotConfiguration";
import { PivotDimension } from "./PivotDimension";
import { DimensionsChangeEventArgs } from "./DimensionsChangeEventArgs";
import { PivotConfigurationChangedEventArgs } from "./PivotConfigurationChangedEventArgs";
import { PivotDimensionEventArgs } from "./PivotDimensionEventArgs";
import { PivotValueEventArgs } from "./PivotValueEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { ValuesChangeEventArgs } from "./ValuesChangeEventArgs";
import { PivotDimensionType_$type } from "./PivotDimensionType";
import { SortingDirection_$type } from "./SortingDirection";
/**
 * @hidden
 */
export let PivotGrid = /*@__PURE__*/ (() => {
    class PivotGrid extends GridBaseDirective {
        constructor() {
            super(...arguments);
            this.hb = null;
            this.ha = null;
            this.dimensionsChange = null;
            this.pivotConfigurationChange = null;
            this.dimensionInit = null;
            this.valueInit = null;
            this.dimensionsSortingExpressionsChange = null;
            this.valuesChange = null;
        }
        get gy() {
            let ret_ = this.d.m("dimensionsSortingExpressions", (a) => new SortingExpression());
            return ret_;
        }
        get hd() {
            return this.hb;
        }
        set hd(a) {
            this.hb = a;
            this.d.s("valueChipTemplate", (b) => new PivotGridValueTemplateContext(), this.hb);
        }
        get g0() {
            let ret_ = this.d.m("pivotConfiguration", (a) => new PivotConfiguration());
            return ret_;
        }
        set g0(a) {
            let value_ = a;
            this.d.v("pivotConfiguration", value_);
        }
        get g7() {
            let ret_ = this.d.n("showPivotConfigurationUI");
            return ret_;
        }
        set g7(a) {
            let value_ = a;
            this.d.v("showPivotConfigurationUI", value_);
        }
        get g8() {
            let ret_ = this.d.n("superCompactMode");
            return ret_;
        }
        set g8(a) {
            let value_ = a;
            this.d.v("superCompactMode", value_);
        }
        get g6() {
            let ret_ = this.d.n("defaultExpandState");
            return ret_;
        }
        set g6(a) {
            let value_ = a;
            this.d.v("defaultExpandState", value_);
        }
        get gx() {
            let ret_ = this.d.m("allDimensions", (a) => new PivotDimension());
            return ret_;
        }
        get g9() {
            let ret_ = this.d.n("data");
            return ret_;
        }
        set g9(a) {
            let value_ = a;
            this.d.v("data", value_);
        }
        get hc() {
            return this.ha;
        }
        set hc(a) {
            this.ha = a;
            this.d.s("emptyPivotGridTemplate", (b) => b, this.ha);
        }
        dimensionsChangeChanged() {
            if (this.dimensionsChange != null) {
                this.d.r("dimensionsChange", (a) => this.dimensionsChange(this, DimensionsChangeEventArgs.b(a)), false);
            }
            else {
                this.d.u("dimensionsChange");
            }
        }
        pivotConfigurationChangeChanged() {
            if (this.pivotConfigurationChange != null) {
                this.d.r("pivotConfigurationChange", (a) => this.pivotConfigurationChange(this, PivotConfigurationChangedEventArgs.a(a)), false);
            }
            else {
                this.d.u("pivotConfigurationChange");
            }
        }
        dimensionInitChanged() {
            if (this.dimensionInit != null) {
                this.d.r("dimensionInit", (a) => this.dimensionInit(this, PivotDimensionEventArgs.b(a)), false);
            }
            else {
                this.d.u("dimensionInit");
            }
        }
        valueInitChanged() {
            if (this.valueInit != null) {
                this.d.r("valueInit", (a) => this.valueInit(this, PivotValueEventArgs.b(a)), false);
            }
            else {
                this.d.u("valueInit");
            }
        }
        dimensionsSortingExpressionsChangeChanged() {
            if (this.dimensionsSortingExpressionsChange != null) {
                this.d.r("dimensionsSortingExpressionsChange", (a) => this.dimensionsSortingExpressionsChange(this, SortingExpressionEventArgs.b(a)), false);
            }
            else {
                this.d.u("dimensionsSortingExpressionsChange");
            }
        }
        valuesChangeChanged() {
            if (this.valuesChange != null) {
                this.d.r("valuesChange", (a) => this.valuesChange(this, ValuesChangeEventArgs.b(a)), false);
            }
            else {
                this.d.u("valuesChange");
            }
        }
        ho(a = false) {
            this.nativeElement.notifyDimensionChange(this.d.i(a));
        }
        ht(a) {
            this.nativeElement.toggleColumn(this.d.i(a));
        }
        hj(a) {
            this.nativeElement.getColumnGroupExpandState(this.d.i(a));
        }
        hv(a, b) {
            this.nativeElement.toggleRowGroup(this.d.i(a), this.d.i(b));
        }
        he(a) {
            this.nativeElement.autoSizeRowDimension(this.d.i(a));
        }
        hk(a, b, c = -1) {
            this.nativeElement.insertDimensionAt(this.d.i(a), this.d.i(typeGetValue(this.d.f(PivotDimensionType_$type, b))), this.d.i(typeGetValue(this.d.f(PivotDimensionType_$type, c))));
        }
        hm(a, b, c = -1) {
            this.nativeElement.moveDimension(this.d.i(a), this.d.i(typeGetValue(this.d.f(PivotDimensionType_$type, b))), this.d.i(typeGetValue(this.d.f(PivotDimensionType_$type, c))));
        }
        hq(a) {
            this.nativeElement.removeDimension(this.d.i(a));
        }
        hu(a) {
            this.nativeElement.toggleDimension(this.d.i(a));
        }
        hl(a, b = -1) {
            this.nativeElement.insertValueAt(this.d.i(a), this.d.i(b));
        }
        hn(a, b = -1) {
            this.nativeElement.moveValue(this.d.i(a), this.d.i(b));
        }
        hr(a) {
            this.nativeElement.removeValue(this.d.i(a));
        }
        hw(a) {
            this.nativeElement.toggleValue(this.d.i(a));
        }
        hs(a, b) {
            this.nativeElement.sortDimension(this.d.i(a), this.d.i(typeGetValue(this.d.f(SortingDirection_$type, b))));
        }
        hi(a, b, c) {
            this.nativeElement.filterDimension(this.d.i(a), this.d.i(b), this.d.i(c));
        }
    }
    PivotGrid.$t = /*@__PURE__*/ markType(PivotGrid, 'PivotGrid', GridBaseDirective.$);
    return PivotGrid;
})();
