import { IgrColumn } from "./igr-column";
import { IgrRowType } from "./igr-row-type";
import { IgrGridCellIdentifier } from "./igr-grid-cell-identifier";
import { CellType as CellType_internal } from "./CellType";
import { ensureBool, interfaceToInternal } from "igniteui-react-core";
import { GridValidationState } from "./GridValidationState";
export class IgrCellType {
    createImplementation() {
        return new CellType_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get value() {
        return this.i.u;
    }
    set value(v) {
        this.i.u = v;
    }
    get editValue() {
        return this.i.r;
    }
    set editValue(v) {
        this.i.r = v;
    }
    get selected() {
        return this.i.m;
    }
    set selected(v) {
        this.i.m = ensureBool(v);
    }
    get active() {
        return this.i.i;
    }
    set active(v) {
        this.i.i = ensureBool(v);
    }
    get editable() {
        return this.i.j;
    }
    set editable(v) {
        this.i.j = ensureBool(v);
    }
    get editMode() {
        return this.i.k;
    }
    set editMode(v) {
        this.i.k = ensureBool(v);
    }
    get column() {
        const r = this.i.b;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.b = null : this.i.b = v.i;
    }
    get row() {
        const r = this.i.f;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrRowType();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set row(v) {
        v == null ? this.i.f = null : this.i.f = v.i;
    }
    get grid() {
        const r = this.i.c;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set grid(v) {
        v == null ? this.i.c = null : this.i.c = v.i;
    }
    get id() {
        const r = this.i.d;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrGridCellIdentifier();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set id(v) {
        v == null ? this.i.d = null : this.i.d = v.i;
    }
    get cellID() {
        return this.i.q;
    }
    set cellID(v) {
        this.i.q = v;
    }
    get validation() {
        return this.i.e.nativeElement;
    }
    set validation(v) {
        this.i.e = interfaceToInternal(v, () => new GridValidationState());
    }
    get readonly() {
        return this.i.l;
    }
    set readonly(v) {
        this.i.l = ensureBool(v);
    }
    get title() {
        return this.i.t;
    }
    set title(v) {
        this.i.t = v;
    }
    get width() {
        return this.i.v;
    }
    set width(v) {
        this.i.v = v;
    }
    get visibleColumnIndex() {
        return this.i.o;
    }
    set visibleColumnIndex(v) {
        this.i.o = +v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        if (this.row && this.row.name && this.row.name == name) {
            return this.row;
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        if (this.id && this.id.name && this.id.name == name) {
            return this.id;
        }
        if (this.validation && this.validation.name && this.validation.name == name) {
            return this.validation;
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
    update(value) {
        this.i.y(value);
    }
    setEditMode(value) {
        this.i.w(value);
    }
    calculateSizeToFit(range) {
        let iv = this.i.n(range);
        return (iv);
    }
}
