import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { Column as Column_internal } from './Column';
import { IgrColumn as IgrColumn } from './igr-column';
export class IgrColumnCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrColumn.$type) {
            IgrColumn.$type = markType(IgrColumn, "IgrColumn");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrColumn.$type) {
            IgrColumn.$type = markType(IgrColumn, "IgrColumn");
        }
        let coll = new SyncableObservableCollection$2(IgrColumn.$type, Column_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgrColumn._createFromInternal(int);
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
