import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnExportingEventArgsDetail as ColumnExportingEventArgsDetail_internal } from "./ColumnExportingEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
/**
 * columnExporting event arguments
 * ```typescript
 * this.exporterService.columnExporting.subscribe((args: IColumnExportingEventArgs) => {
 * // set args properties here
 * });
 * ```
*/
export class IgrColumnExportingEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new ColumnExportingEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Contains the exporting column header
    */
    get header() {
        return this.i.l;
    }
    set header(v) {
        this.i.l = v;
    }
    /**
     * Contains the exporting column field name
    */
    get field() {
        return this.i.k;
    }
    set field(v) {
        this.i.k = v;
    }
    /**
     * Contains the exporting column index
    */
    get columnIndex() {
        return this.i.j;
    }
    set columnIndex(v) {
        this.i.j = +v;
    }
    /**
     * Skip the exporting column when set to true
    */
    get cancel() {
        return this.i.h;
    }
    set cancel(v) {
        this.i.h = ensureBool(v);
    }
    /**
     * Export the column's data without applying its formatter, when set to true
    */
    get skipFormatter() {
        return this.i.i;
    }
    set skipFormatter(v) {
        this.i.i = ensureBool(v);
    }
    /**
     * A reference to the grid owner.
    */
    get grid() {
        const r = this.i.g;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set grid(v) {
        v == null ? this.i.g = null : this.i.g = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        return null;
    }
}
