import * as React from 'react';
import { IgrColumnGroup } from "./igr-column-group";
import { ColumnLayout } from "./ColumnLayout";
/**
 * Column layout for declaration of Multi-row Layout
 * @igxParent IgxGridComponent
*/
export class IgrColumnLayout extends IgrColumnGroup {
    createImplementation() {
        let impl = new ColumnLayout();
        let nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-column-layout");
        }
        else {
            nat = {
                style: {}
            };
        }
        impl.setNativeElement(nat);
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._getMainRef = this._getMainRef.bind(this);
    }
    render() {
        let children = this._contentChildrenManager.getChildren(this.props.children);
        this._portalManager.onRender(children);
        let style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        let div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    }
    _getMainRef(ref) {
        this._elRef = ref;
    }
}
