import { IgrDataGridColumn } from "./igr-data-grid-column";
import { PinnedPositions_$type } from "./PinnedPositions";
import { ColumnPinnedChangedEventArgs as ColumnPinnedChangedEventArgs_internal } from "./ColumnPinnedChangedEventArgs";
import { ensureEnum } from "igniteui-react-core";
/**
 * Event arguments for the ColumnPinnedChanged event.
*/
export class IgrColumnPinnedChangedEventArgs {
    createImplementation() {
        return new ColumnPinnedChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The column whose pinned state has changed.
    */
    get column() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrDataGridColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    /**
     * The new pinned state for the column.
    */
    get pinned() {
        return this.i.b;
    }
    set pinned(v) {
        this.i.b = ensureEnum(PinnedPositions_$type, v);
    }
}
