import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnToggledEventArgsDetail as ColumnToggledEventArgsDetail_internal } from "./ColumnToggledEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
/**
 * Event emitted when a checkbox in the checkbox
 * list of an IgxColumnActions component is clicked.
*/
export class IgrColumnToggledEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new ColumnToggledEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * The column that is toggled.
    */
    get column() {
        const r = this.i.g;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.g = null : this.i.g = v.i;
    }
    /**
     * The checked state after the action.
    */
    get checked() {
        return this.i.h;
    }
    set checked(v) {
        this.i.h = ensureBool(v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        return null;
    }
}
