import { IgrDataGridColumn } from "./igr-data-grid-column";
import { ComboBoxColumn } from "./ComboBoxColumn";
/**
 * A combobox column.
*/
export class IgrComboBoxColumn extends IgrDataGridColumn {
    createImplementation() {
        return new ComboBoxColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets the actual data source that is being used by the combo. If a collection was provided for the combobox data, an implicit LocalDataSource is created, and this is available via this property.
    */
    get actualDataSource() {
        return this.i.ln;
    }
    set actualDataSource(v) {
        this.i.ln = v;
    }
    /**
     * Gets or sets the ComboBox data source.
    */
    get dataSource() {
        return this.i.lo;
    }
    set dataSource(v) {
        this.i.lo = v;
    }
    /**
     * Gets or sets the ComboBox text field.
    */
    get textField() {
        return this.i.ls;
    }
    set textField(v) {
        this.i.ls = v;
    }
    /**
     * Gets or sets the ComboBox value field.
    */
    get valueField() {
        return this.i.lt;
    }
    set valueField(v) {
        this.i.lt = v;
    }
    /**
     * Gets or sets the ComboBox value field.
    */
    get valueMultiField() {
        return this.i.ll;
    }
    set valueMultiField(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.ll = v;
    }
}
