import { PivotDimensionType_$type } from "./PivotDimensionType";
import { DimensionsChangeDetail as DimensionsChangeDetail_internal } from "./DimensionsChangeDetail";
import { IgrPivotDimension } from "./igr-pivot-dimension";
import { ensureEnum } from "igniteui-react-core";
/**
 * Event emitted when dimension collection for rows, columns of filters is changed.
*/
export class IgrDimensionsChangeDetail {
    createImplementation() {
        return new DimensionsChangeDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The new list of dimensions.
    */
    get dimensions() {
        if (!this.i.a) {
            return undefined;
        }
        let ret = [];
        for (let i = 0; i < this.i.a.length; i++) {
            let impl = this.i.a[i];
            if (!impl.externalObject) {
                if (impl instanceof IgrPivotDimension) {
                    ret.push(impl);
                    continue;
                }
                let e = new IgrPivotDimension();
                e._implementation = impl;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    }
    set dimensions(v) {
        let arr = [];
        for (let i = 0; i < v.length; i++) {
            arr.push(v[i].i);
        }
        this.i.a = arr;
    }
    /**
     * The dimension list type - Row, Column or Filter.
    */
    get dimensionCollectionType() {
        return this.i.b;
    }
    set dimensionCollectionType(v) {
        this.i.b = ensureEnum(PivotDimensionType_$type, v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
