import { IgrDefinitionBase } from "./igr-definition-base";
import { FilterRowDefinition } from "./FilterRowDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export class IgrFilterRowDefinition extends IgrDefinitionBase {
    createImplementation() {
        return new FilterRowDefinition();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    get paddingLeft() {
        return this.i.er;
    }
    set paddingLeft(v) {
        this.i.er = +v;
    }
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    get paddingTop() {
        return this.i.et;
    }
    set paddingTop(v) {
        this.i.et = +v;
    }
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    get paddingRight() {
        return this.i.es;
    }
    set paddingRight(v) {
        this.i.es = +v;
    }
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    get paddingBottom() {
        return this.i.eq;
    }
    set paddingBottom(v) {
        this.i.eq = +v;
    }
}
