import { IgrGridCellPosition } from "./igr-grid-cell-position";
import { GridActiveCellChangedEventArgs as GridActiveCellChangedEventArgs_internal } from "./GridActiveCellChangedEventArgs";
/**
 * Information about the change to the selected cells in the grid.
*/
export class IgrGridActiveCellChangedEventArgs {
    createImplementation() {
        return new GridActiveCellChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The new active cell.
    */
    get newActiveCell() {
        const r = this.i.newActiveCell;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrGridCellPosition();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set newActiveCell(v) {
        v == null ? this.i.newActiveCell = null : this.i.newActiveCell = v.i;
    }
    /**
     * The old active cell.
    */
    get oldActiveCell() {
        const r = this.i.oldActiveCell;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrGridCellPosition();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set oldActiveCell(v) {
        v == null ? this.i.oldActiveCell = null : this.i.oldActiveCell = v.i;
    }
}
