import { IgrDataGridColumn } from "./igr-data-grid-column";
import { GridCellEditStartedEventArgs as GridCellEditStartedEventArgs_internal } from "./GridCellEditStartedEventArgs";
export class IgrGridCellEditStartedEventArgs {
    createImplementation() {
        return new GridCellEditStartedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the column of the cell that started editing.
    */
    get column() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrDataGridColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    /**
     * Gets the row index of the cell that started editing.
    */
    get row() {
        return this.i.b;
    }
    set row(v) {
        this.i.b = +v;
    }
    /**
     * Gets the row item.
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
}
