import { GridCellPosition as GridCellPosition_internal } from "./GridCellPosition";
export class IgrGridCellPosition {
    createImplementation() {
        return new GridCellPosition_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets or sets the row position of the cell.
    */
    get rowIndex() {
        return this.i.b;
    }
    set rowIndex(v) {
        this.i.b = +v;
    }
    /**
     * Gets or sets the column position of the cell.  Can be null for spanning elements like section headers.
    */
    get columnUniqueKey() {
        return this.i.d;
    }
    set columnUniqueKey(v) {
        this.i.d = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
