import { IgrDataGridColumn } from "./igr-data-grid-column";
import { IgrFilterOperand } from "./igr-filter-operand";
import { GridCustomFilterRequestedEventArgs as GridCustomFilterRequestedEventArgs_internal } from "./GridCustomFilterRequestedEventArgs";
export class IgrGridCustomFilterRequestedEventArgs {
    createImplementation() {
        return new GridCustomFilterRequestedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The column that requested the filter.
    */
    get column() {
        const r = this.i.c;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrDataGridColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.c = null : this.i.c = v.i;
    }
    /**
     * The custom filter that was chosen.
    */
    get filter() {
        const r = this.i.d;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrFilterOperand();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set filter(v) {
        v == null ? this.i.d = null : this.i.d = v.i;
    }
    /**
     * The value that was provided in the editor for the filter.
    */
    get value() {
        return this.i.e;
    }
    set value(v) {
        this.i.e = v;
    }
    /**
     * Sets the filter expression to be used.
    */
    get expression() {
        return this.i.b;
    }
    set expression(v) {
        this.i.b = v;
    }
    /**
     * Gets the filter factory.
    */
    get filterFactory() {
        return this.i.a;
    }
}
