/**
 * Event arguments for the DataCommitted event.
*/
export class IgrGridDataCommittedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the ID for this commit.
    */
    get commitID() {
        return this.i.b;
    }
    set commitID(v) {
        this.i.b = +v;
    }
    /**
     * Gets a list of the changes that were committed.
    */
    get changes() {
        return this.i.a;
    }
    set changes(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.a = v;
    }
}
