/**
 * Event arguments for the DataCommitting event.
*/
export class IgrGridDataCommittingEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets a list of changes that are about to be committed.
    */
    get changes() {
        return this.i.a;
    }
    set changes(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.a = v;
    }
    /**
     * The ID for the commit. Use this as the argument for the AcceptCommit or RejectCommit methods.
    */
    get commitID() {
        return this.i.b;
    }
    set commitID(v) {
        this.i.b = +v;
    }
}
