import { IgrGridCellIdentifier } from "./igr-grid-cell-identifier";
import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridEditDoneEventArgsDetail as GridEditDoneEventArgsDetail_internal } from "./GridEditDoneEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
export class IgrGridEditDoneEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new GridEditDoneEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get rowID() {
        return this.i.p;
    }
    set rowID(v) {
        this.i.p = v;
    }
    get primaryKey() {
        return this.i.n;
    }
    set primaryKey(v) {
        this.i.n = v;
    }
    get cellID() {
        const r = this.i.i;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrGridCellIdentifier();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set cellID(v) {
        v == null ? this.i.i = null : this.i.i = v.i;
    }
    get rowData() {
        return this.i.o;
    }
    set rowData(v) {
        this.i.o = v;
    }
    get oldValue() {
        return this.i.m;
    }
    set oldValue(v) {
        this.i.m = v;
    }
    get newValue() {
        return this.i.l;
    }
    set newValue(v) {
        this.i.l = v;
    }
    get column() {
        const r = this.i.g;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.g = null : this.i.g = v.i;
    }
    get owner() {
        const r = this.i.h;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set owner(v) {
        v == null ? this.i.h = null : this.i.h = v.i;
    }
    get isAddRow() {
        return this.i.j;
    }
    set isAddRow(v) {
        this.i.j = ensureBool(v);
    }
    get valid() {
        return this.i.k;
    }
    set valid(v) {
        this.i.k = ensureBool(v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.cellID && this.cellID.name && this.cellID.name == name) {
            return this.cellID;
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        if (this.owner && this.owner.name && this.owner.name == name) {
            return this.owner;
        }
        return null;
    }
}
