import { IgrGridCellIdentifier } from "./igr-grid-cell-identifier";
import { IgrColumn } from "./igr-column";
import { GridEditEventArgsDetail as GridEditEventArgsDetail_internal } from "./GridEditEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
export class IgrGridEditEventArgsDetail {
    createImplementation() {
        return new GridEditEventArgsDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Provides the ability to cancel the event.
    */
    get cancel() {
        return this.i.f;
    }
    set cancel(v) {
        this.i.f = ensureBool(v);
    }
    get rowID() {
        return this.i.o;
    }
    set rowID(v) {
        this.i.o = v;
    }
    get primaryKey() {
        return this.i.m;
    }
    set primaryKey(v) {
        this.i.m = v;
    }
    get cellID() {
        const r = this.i.c;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrGridCellIdentifier();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set cellID(v) {
        v == null ? this.i.c = null : this.i.c = v.i;
    }
    get rowData() {
        return this.i.n;
    }
    set rowData(v) {
        this.i.n = v;
    }
    get oldValue() {
        return this.i.l;
    }
    set oldValue(v) {
        this.i.l = v;
    }
    get newValue() {
        return this.i.k;
    }
    set newValue(v) {
        this.i.k = v;
    }
    get column() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get owner() {
        const r = this.i.b;
        if (r == null) {
            return null;
        }
        return r.externalObject;
    }
    set owner(v) {
        v == null ? this.i.b = null : this.i.b = v.i;
    }
    get isAddRow() {
        return this.i.g;
    }
    set isAddRow(v) {
        this.i.g = ensureBool(v);
    }
    get valid() {
        return this.i.h;
    }
    set valid(v) {
        this.i.h = ensureBool(v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.cellID && this.cellID.name && this.cellID.name == name) {
            return this.cellID;
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        if (this.owner && this.owner.name && this.owner.name == name) {
            return this.owner;
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
