import * as React from 'react';
import { IgrGridActionsBaseDirective } from "./igr-grid-actions-base-directive";
import { GridPinningActions } from "./GridPinningActions";
/**
 * Grid Pinning Actions for the Action Strip
 * @igxParent IgxActionStripComponent
*/
export class IgrGridPinningActions extends IgrGridActionsBaseDirective {
    createImplementation() {
        let impl = new GridPinningActions();
        let nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-grid-pinning-actions");
        }
        else {
            nat = {
                style: {}
            };
        }
        impl.setNativeElement(nat);
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._getMainRef = this._getMainRef.bind(this);
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        React.Children.forEach(propChildren, (ch) => {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        let style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        let div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    }
    _getMainRef(ref) {
        this._elRef = ref;
    }
    /**
     * Pin the row according to the context.
     * @example
     * ```typescript
     * this.gridPinningActions.pin();
     * ```
    
    */
    pin(evt) {
        this.i.h(evt);
    }
    /**
     * Unpin the row according to the context.
     * @example
     * ```typescript
     * this.gridPinningActions.unpin();
     * ```
    
    */
    unpin(evt) {
        this.i.j(evt);
    }
    scrollToRow(evt) {
        this.i.i(evt);
    }
}
