import * as React from 'react';
import { IgrRowDirective } from "./igr-row-directive";
import { GridRow } from "./GridRow";
export class IgrGridRow extends IgrRowDirective {
    createImplementation() {
        let impl = new GridRow();
        let nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-grid-row");
        }
        else {
            nat = {
                style: {}
            };
        }
        nat.style.width = "100%";
        nat.style.height = "100%";
        impl.setNativeElement(nat);
        return impl;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._getMainRef = this._getMainRef.bind(this);
    }
    componentDidMount() {
        this.mounted = true;
        super.componentDidMount();
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        React.Children.forEach(propChildren, (ch) => {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        let style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        let div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    }
    _getMainRef(ref) {
        this._elRef = ref;
    }
    getContext(col, row) {
        this.i.q(col, row);
    }
    getContextMRL(pinnedCols, row) {
        this.i.r(pinnedCols, row);
    }
}
