import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GridScrollEventArgsDetail as GridScrollEventArgsDetail_internal } from "./GridScrollEventArgsDetail";
/**
 * Event emitted when a grid is scrolled.
*/
export class IgrGridScrollEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new GridScrollEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * The scroll direction - vertical or horizontal.
    */
    get direction() {
        return this.i.j;
    }
    set direction(v) {
        this.i.j = v;
    }
    /**
     * The original browser scroll event.
    */
    get event() {
        return this.i.i;
    }
    set event(v) {
        this.i.i = v;
    }
    /**
     * The new scroll position
    */
    get scrollPosition() {
        return this.i.h;
    }
    set scrollPosition(v) {
        this.i.h = +v;
    }
}
