import { IgCollection } from "igniteui-react-core";
import { markType } from "igniteui-react-core";
import { SyncableObservableCollection$2 } from "igniteui-react-core";
import { CellKey as CellKey_internal } from './CellKey';
import { IgrCellKey as IgrCellKey } from './igr-cell-key';
export class IgrGridSelectedCellsCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgrCellKey.$type) {
            IgrCellKey.$type = markType(IgrCellKey, "IgrCellKey");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgrCellKey.$type) {
            IgrCellKey.$type = markType(IgrCellKey, "IgrCellKey");
        }
        let coll = new SyncableObservableCollection$2(IgrCellKey.$type, CellKey_internal.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgrCellKey();
                if (ext) {
                    if (!int.$type && ext._implementation.setNativeElement) {
                        ext._implementation.setNativeElement(int);
                    }
                    else {
                        ext._implementation = int;
                    }
                }
            }
            return ext;
        };
        return coll;
    }
}
