import { IgrColumnSortDescriptionCollection } from "./igr-column-sort-description-collection";
import { GridSortDescriptionsChangedEventArgs as GridSortDescriptionsChangedEventArgs_internal } from "./GridSortDescriptionsChangedEventArgs";
/**
 * Information about the current sorting applied to the grid.
*/
export class IgrGridSortDescriptionsChangedEventArgs {
    createImplementation() {
        return new GridSortDescriptionsChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get sortDescriptions() {
        const r = this.i.sortDescriptions;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrColumnSortDescriptionCollection();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set sortDescriptions(v) {
        v == null ? this.i.sortDescriptions = null : this.i.sortDescriptions = v.i;
    }
}
