import { IgrGridState } from "./igr-grid-state";
import { GridStateCollection as GridStateCollection_internal } from "./GridStateCollection";
export class IgrGridStateCollection {
    createImplementation() {
        let impl = new GridStateCollection_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get id() {
        return this.i.g;
    }
    set id(v) {
        this.i.g = v;
    }
    get parentRowID() {
        return this.i.f;
    }
    set parentRowID(v) {
        this.i.f = v;
    }
    get state() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrGridState._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set state(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.state && this.state.name && this.state.name == name) {
            return this.state;
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
