import { IgrColumnSummaryDescriptionCollection } from "./igr-column-summary-description-collection";
import { GridSummaryDescriptionsChangedEventArgs as GridSummaryDescriptionsChangedEventArgs_internal } from "./GridSummaryDescriptionsChangedEventArgs";
/**
 * Information about the current summaries applied to the grid.
*/
export class IgrGridSummaryDescriptionsChangedEventArgs {
    createImplementation() {
        return new GridSummaryDescriptionsChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get summaryDescriptions() {
        const r = this.i.summaryDescriptions;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrColumnSummaryDescriptionCollection();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set summaryDescriptions(v) {
        v == null ? this.i.summaryDescriptions = null : this.i.summaryDescriptions = v.i;
    }
}
