import { GridValidationService as GridValidationService_internal } from "./GridValidationService";
export class IgrGridValidationService {
    createImplementation() {
        return new GridValidationService_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
    /**
     * Returns all invalid record states.
    
    */
    getInvalid() {
        let iv = this.i.a();
        let ret = [];
        for (let i = 0; i < iv.length; i++) {
            let impl = iv[i];
            if (!impl.externalObject) {
                let e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    }
    markAsTouched(key, field) {
        this.i.g(key, field);
    }
    /**
     * Clears validation state by key or all states if none is provided.
     * key Optional. The key of the record for which to clear state.
    
    * @param key  * Optional. The key of the record for which to clear state.
    */
    clear(key) {
        this.i.f(key);
    }
}
