import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { GroupingDoneEventArgsDetail as GroupingDoneEventArgsDetail_internal } from "./GroupingDoneEventArgsDetail";
import { IgrColumn } from "./igr-column";
export class IgrGroupingDoneEventArgsDetail extends IgrBaseEventArgsDetail {
    createImplementation() {
        return new GroupingDoneEventArgsDetail_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    get expressions() {
        if (!this.i.g) {
            return undefined;
        }
        let ret = [];
        for (let i = 0; i < this.i.g.length; i++) {
            let impl = this.i.g[i];
            ret.push(impl.nativeElement);
        }
        return ret;
    }
    set expressions(v) {
        let arr = [];
        for (let i = 0; i < v.length; i++) {
            arr.push(v[i]);
        }
        this.i.g = arr;
    }
    get groupedColumns() {
        if (!this.i.h) {
            return undefined;
        }
        let ret = [];
        for (let i = 0; i < this.i.h.length; i++) {
            let impl = this.i.h[i];
            if (!impl.externalObject) {
                if (impl instanceof IgrColumn) {
                    ret.push(impl);
                    continue;
                }
                let e = IgrColumn._createFromInternal(impl);
                e._implementation = impl;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    }
    set groupedColumns(v) {
        let arr = [];
        for (let i = 0; i < v.length; i++) {
            arr.push(v[i].i);
        }
        this.i.h = arr;
    }
    get ungroupedColumns() {
        if (!this.i.i) {
            return undefined;
        }
        let ret = [];
        for (let i = 0; i < this.i.i.length; i++) {
            let impl = this.i.i[i];
            if (!impl.externalObject) {
                if (impl instanceof IgrColumn) {
                    ret.push(impl);
                    continue;
                }
                let e = IgrColumn._createFromInternal(impl);
                e._implementation = impl;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    }
    set ungroupedColumns(v) {
        let arr = [];
        for (let i = 0; i < v.length; i++) {
            arr.push(v[i].i);
        }
        this.i.i = arr;
    }
}
