import { IgrColumn } from "./igr-column";
import { DisplayDensity_$type } from "./DisplayDensity";
import { SortingDirection_$type } from "./SortingDirection";
import { HeaderType as HeaderType_internal } from "./HeaderType";
import { ensureEnum, ensureBool } from "igniteui-react-core";
export class IgrHeaderType {
    createImplementation() {
        return new HeaderType_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get column() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = IgrColumn._createFromInternal(r);
            if (e) {
                e._implementation = r;
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set column(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    get density() {
        return this.i.b;
    }
    set density(v) {
        this.i.b = ensureEnum(DisplayDensity_$type, v);
    }
    get sorted() {
        return this.i.h;
    }
    set sorted(v) {
        this.i.h = ensureBool(v);
    }
    get selectable() {
        return this.i.f;
    }
    set selectable(v) {
        this.i.f = ensureBool(v);
    }
    get selected() {
        return this.i.g;
    }
    set selected(v) {
        this.i.g = ensureBool(v);
    }
    get title() {
        return this.i.i;
    }
    set title(v) {
        this.i.i = ensureBool(v);
    }
    get sortDirection() {
        return this.i.c;
    }
    set sortDirection(v) {
        this.i.c = ensureEnum(SortingDirection_$type, v);
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
