import { ImageStretchOptions_$type } from "./ImageStretchOptions";
import { ImageResourceType_$type } from "./ImageResourceType";
import { IgrCellInfo } from "./igr-cell-info";
import { ImageCellModel as ImageCellModel_internal } from "./ImageCellModel";
import { ensureEnum } from "igniteui-react-core";
/**
 * Backing information for an image cell in the grid.
*/
export class IgrImageCellInfo extends IgrCellInfo {
    createImplementation() {
        return new ImageCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the resource path to use to get the image for the cell.
    */
    get imagePath() {
        return this.i.lr;
    }
    set imagePath(v) {
        this.i.lr = v;
    }
    /**
     * Sets or gets the image stretching behavior for the image.
    */
    get imageStretchOption() {
        return this.i.lm;
    }
    set imageStretchOption(v) {
        this.i.lm = ensureEnum(ImageStretchOptions_$type, v);
    }
    /**
     * Sets or gets the image resource type. Indicates which type of resource should be fetched and how ImagePath should be interpreted.
    */
    get imageResourceType() {
        return this.i.lk;
    }
    set imageResourceType(v) {
        this.i.lk = ensureEnum(ImageResourceType_$type, v);
    }
}
