import { ImageStretchOptions_$type } from "./ImageStretchOptions";
import { EditorType_$type } from "./EditorType";
import { IgrDataGridColumn } from "./igr-data-grid-column";
import { ImageColumn } from "./ImageColumn";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents an Image grid column, used to allow the developer to display an image in a cell.
*/
export class IgrImageColumn extends IgrDataGridColumn {
    createImplementation() {
        return new ImageColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the stretch option to use when rendering images
    */
    get imageStretchOption() {
        return this.i.lp;
    }
    set imageStretchOption(v) {
        this.i.lp = ensureEnum(ImageStretchOptions_$type, v);
    }
    /**
     * Gets or sets the editor type used for editing cells in this column.
    */
    get editorType() {
        return this.i.ll;
    }
    set editorType(v) {
        this.i.ll = ensureEnum(EditorType_$type, v);
    }
    /**
     * Gets or sets the ComboBox data source.
    */
    get editorDataSource() {
        return this.i.lq;
    }
    set editorDataSource(v) {
        this.i.lq = v;
    }
    /**
     * Gets or sets the ComboBox text field.
    */
    get editorTextField() {
        return this.i.lr;
    }
    set editorTextField(v) {
        this.i.lr = v;
    }
    /**
     * Gets or sets the ComboBox value field.
    */
    get editorValueField() {
        return this.i.ls;
    }
    set editorValueField(v) {
        this.i.ls = v;
    }
}
