import { PageChangedEventArgs as PageChangedEventArgs_internal } from "./PageChangedEventArgs";
export class IgrPageChangedEventArgs {
    createImplementation() {
        return new PageChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the index for the page that just changed.
    */
    get page() {
        return this.i.page;
    }
    set page(v) {
        this.i.page = +v;
    }
    /**
     * Gets the data for the page that just changed.
    */
    get data() {
        return this.i.data;
    }
    set data(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.data = v;
    }
}
