import { IgrPinRowEventArgsDetail } from "./igr-pin-row-event-args-detail";
import { PinRowEventArgs as PinRowEventArgs_internal } from "./PinRowEventArgs";
/**
 * Event emitted when a row's pin state changes.
*/
export class IgrPinRowEventArgs {
    createImplementation() {
        return new PinRowEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get detail() {
        const r = this.i.b;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrPinRowEventArgsDetail();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set detail(v) {
        v == null ? this.i.b = null : this.i.b = v.i;
    }
}
