import { IgrPivotConfiguration } from "./igr-pivot-configuration";
import { PivotConfigurationChangedEventArgsDetail as PivotConfigurationChangedEventArgsDetail_internal } from "./PivotConfigurationChangedEventArgsDetail";
/**
 * Event emitted when pivot configuration is changed.
*/
export class IgrPivotConfigurationChangedEventArgsDetail {
    createImplementation() {
        return new PivotConfigurationChangedEventArgsDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * The new configuration.
    */
    get pivotConfiguration() {
        const r = this.i.a;
        if (r == null) {
            return null;
        }
        if (!r.externalObject) {
            let e = new IgrPivotConfiguration();
            if (r.$type) {
                e._implementation = r;
            }
            else {
                if (e.i.setNativeElement) {
                    e.i.setNativeElement(r);
                }
            }
            r.externalObject = e;
        }
        return r.externalObject;
    }
    set pivotConfiguration(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.pivotConfiguration && this.pivotConfiguration.name && this.pivotConfiguration.name == name) {
            return this.pivotConfiguration;
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
