import { PivotKeys as PivotKeys_internal } from "./PivotKeys";
/**
 * Interface describing the Pivot data keys used for data generation.
 * Can be used for custom remote scenarios where the data is pre-populated.
*/
export class IgrPivotKeys {
    createImplementation() {
        let impl = new PivotKeys_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Field that stores children for hierarchy building.
    */
    get children() {
        return this.i.f;
    }
    set children(v) {
        this.i.f = v;
    }
    /**
     * Field that stores reference to the original data records.
    */
    get records() {
        return this.i.i;
    }
    set records(v) {
        this.i.i = v;
    }
    /**
     * Field that stores aggregation values.
    */
    get aggregations() {
        return this.i.e;
    }
    set aggregations(v) {
        this.i.e = v;
    }
    /**
     * Field that stores dimension level based on its hierarchy.
    */
    get level() {
        return this.i.h;
    }
    set level(v) {
        this.i.h = v;
    }
    /**
     * Separator used when generating the unique column field values.
    */
    get columnDimensionSeparator() {
        return this.i.g;
    }
    set columnDimensionSeparator(v) {
        this.i.g = v;
    }
    /**
     * Separator used when generating the unique row field values.
    */
    get rowDimensionSeparator() {
        return this.i.j;
    }
    set rowDimensionSeparator(v) {
        this.i.j = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
