import { RowSelectionEventArgsDetail as RowSelectionEventArgsDetail_internal } from "./RowSelectionEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
export class IgrRowSelectionEventArgsDetail {
    createImplementation() {
        return new RowSelectionEventArgsDetail_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get oldSelection() {
        return this.i.c;
    }
    set oldSelection(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.c = v;
    }
    get newSelection() {
        return this.i.b;
    }
    set newSelection(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.b = v;
    }
    get added() {
        return this.i.a;
    }
    set added(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.a = v;
    }
    get removed() {
        return this.i.d;
    }
    set removed(v) {
        if (v && !Array.isArray(v) && typeof (v) == "string") {
            const re = /\s*(?:,|\s|$)\s*/gm;
            v = v.split(re);
        }
        this.i.d = v;
    }
    get allRowsSelected() {
        return this.i.g;
    }
    set allRowsSelected(v) {
        this.i.g = ensureBool(v);
    }
    /**
     * Provides the ability to cancel the event.
    */
    get cancel() {
        return this.i.h;
    }
    set cancel(v) {
        this.i.h = ensureBool(v);
    }
    /**
     * Provides reference to the owner component.
    */
    get owner() {
        return this.i.k;
    }
    set owner(v) {
        this.i.k = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
    setNativeElement(element) {
        this.i.setNativeElement(element);
    }
}
