import { GroupSummaryDisplayMode_$type } from "./GroupSummaryDisplayMode";
import { IgrCellInfo } from "./igr-cell-info";
import { SectionHeaderCellModel as SectionHeaderCellModel_internal } from "./SectionHeaderCellModel";
import { ensureEnum } from "igniteui-react-core";
/**
 * Backing information for a section header cell in the grid.
*/
export class IgrSectionHeaderCellInfo extends IgrCellInfo {
    createImplementation() {
        return new SectionHeaderCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the resolved text for the section header cell.
    */
    get resolvedText() {
        return this.i.lz;
    }
    set resolvedText(v) {
        this.i.lz = v;
    }
    /**
     * Sets or gets the resolved summary text for the section header cell.
    */
    get resolvedSummaryText() {
        return this.i.lx;
    }
    set resolvedSummaryText(v) {
        this.i.lx = v;
    }
    /**
     * Sets or gets how summaries are displayed in the section header cell.
    */
    get summaryDisplayMode() {
        return this.i.lo;
    }
    set summaryDisplayMode(v) {
        this.i.lo = ensureEnum(GroupSummaryDisplayMode_$type, v);
    }
}
