import { IgrCellInfo } from "./igr-cell-info";
import { SummaryCellModel as SummaryCellModel_internal } from "./SummaryCellModel";
import { brushToString, stringToBrush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
/**
 * Backing information for a section header cell in the grid.
*/
export class IgrSummaryCellInfo extends IgrCellInfo {
    createImplementation() {
        return new SummaryCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets the resolved summary label for the summary cell.
    */
    get resolvedSummaryLabel() {
        return this.i.lr;
    }
    set resolvedSummaryLabel(v) {
        this.i.lr = v;
    }
    /**
     * Sets or gets the resolved summary value for the sumamry cell.
    */
    get resolvedSummaryValue() {
        return this.i.lt;
    }
    set resolvedSummaryValue(v) {
        this.i.lt = v;
    }
    /**
     * Gets or sets the color of the text for the summary label in the cell.
    */
    get summaryLabelTextColor() {
        return brushToString(this.i.ly);
    }
    set summaryLabelTextColor(v) {
        this.i.ly = stringToBrush(v);
    }
    get font() {
        if (this.i.lk == null) {
            return null;
        }
        return this.i.lk.fontString;
    }
    set font(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.lk = fi;
    }
}
