import { SummaryChangedEventArgs as SummaryChangedEventArgs_internal } from "./SummaryChangedEventArgs";
import { ensureBool } from "igniteui-react-core";
/**
 * Event args for the SummaryChanged event.
*/
export class IgrSummaryChangedEventArgs {
    createImplementation() {
        return new SummaryChangedEventArgs_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    /**
     * Gets the unique ID for the changed summary.
    */
    get iD() {
        return this.i.b;
    }
    set iD(v) {
        this.i.b = v;
    }
    /**
     * Gets the current state of the changed summary.
    */
    get isEnabled() {
        return this.i.a;
    }
    set isEnabled(v) {
        this.i.a = ensureBool(v);
    }
}
