import { DataSourceSummaryOperand_$type } from "igniteui-react-core";
import { SummaryData as SummaryData_internal } from "./SummaryData";
import { ensureEnum } from "igniteui-react-core";
/**
 * Object used to store summary information for group headers.
*/
export class IgrSummaryData {
    createImplementation() {
        return new SummaryData_internal();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    get summaryName() {
        return this.i.e;
    }
    set summaryName(v) {
        this.i.e = v;
    }
    get summaryValue() {
        return this.i.b;
    }
    set summaryValue(v) {
        this.i.b = v;
    }
    get summaryOperand() {
        return this.i.a;
    }
    set summaryOperand(v) {
        this.i.a = ensureEnum(DataSourceSummaryOperand_$type, v);
    }
    get formattedText() {
        return this.i.c;
    }
    set formattedText(v) {
        this.i.c = v;
    }
    get formattedValue() {
        return this.i.d;
    }
    set formattedValue(v) {
        this.i.d = v;
    }
    findByName(name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    }
}
