import { IgrTemplateCellInfo } from "./igr-template-cell-info";
import { TemplateHeaderCellModel as TemplateHeaderCellModel_internal } from "./TemplateHeaderCellModel";
import { ensureBool } from "igniteui-react-core";
/**
 * Backing information for the template header cells.
*/
export class IgrTemplateHeaderCellInfo extends IgrTemplateCellInfo {
    createImplementation() {
        return new TemplateHeaderCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets whether the filter UI should be visible in the header.
    */
    get isFilterUIVisible() {
        return this.i.lo;
    }
    set isFilterUIVisible(v) {
        this.i.lo = ensureBool(v);
    }
}
