import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { IgrTemplateSectionHeaderCellUpdatingEventArgs } from "./igr-template-section-header-cell-updating-event-args";
import { IgrSectionHeader } from "./igr-section-header";
import { TemplateSectionHeader } from "./TemplateSectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
export class IgrTemplateSectionHeader extends IgrSectionHeader {
    createImplementation() {
        return new TemplateSectionHeader();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
        this._cellUpdating = null;
        this._cellUpdating_wrapped = null;
    }
    /**
     * Called when the cell content is being created or updated.
    */
    get cellUpdating() {
        return this._cellUpdating;
    }
    set cellUpdating(ev) {
        if (this._cellUpdating_wrapped !== null) {
            this.i.cellUpdating = delegateRemove(this.i.cellUpdating, this._cellUpdating_wrapped);
            this._cellUpdating_wrapped = null;
            this._cellUpdating = null;
        }
        this._cellUpdating = ev;
        this._cellUpdating_wrapped = (o, e) => {
            let outerArgs = new IgrTemplateSectionHeaderCellUpdatingEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeCellUpdating) {
                this.beforeCellUpdating(this, outerArgs);
            }
            if (this._cellUpdating) {
                this._cellUpdating(this, outerArgs);
            }
        };
        this.i.cellUpdating = delegateCombine(this.i.cellUpdating, this._cellUpdating_wrapped);
        ;
    }
}
