import { EditorType_$type } from "./EditorType";
import { IgrDataGridColumn } from "./igr-data-grid-column";
import { TextColumn } from "./TextColumn";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
export class IgrTextColumn extends IgrDataGridColumn {
    createImplementation() {
        return new TextColumn();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Gets or sets the editor type used for editing cells in this column.
    */
    get editorType() {
        return this.i.ll;
    }
    set editorType(v) {
        this.i.ll = ensureEnum(EditorType_$type, v);
    }
    /**
     * Gets or sets the ComboBox data source.
    */
    get editorDataSource() {
        return this.i.lm;
    }
    set editorDataSource(v) {
        this.i.lm = v;
    }
    /**
     * Gets or sets the ComboBox text field.
    */
    get editorTextField() {
        return this.i.lo;
    }
    set editorTextField(v) {
        this.i.lo = v;
    }
    /**
     * Gets or sets the ComboBox value field.
    */
    get editorValueField() {
        return this.i.lp;
    }
    set editorValueField(v) {
        this.i.lp = v;
    }
}
