import { SortIndicatorStyle_$type } from "./SortIndicatorStyle";
import { ColumnOptionsIconAlignment_$type } from "./ColumnOptionsIconAlignment";
import { ColumnOptionsIconBehavior_$type } from "./ColumnOptionsIconBehavior";
import { IgrTextCellInfo } from "./igr-text-cell-info";
import { TextHeaderCellModel as TextHeaderCellModel_internal } from "./TextHeaderCellModel";
import { ensureBool, ensureEnum, brushToString, stringToBrush } from "igniteui-react-core";
/**
 * Backing information for a text header cell.
*/
export class IgrTextHeaderCellInfo extends IgrTextCellInfo {
    createImplementation() {
        return new TextHeaderCellModel_internal();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Sets or gets whether the filter UI should be visible in the header.
    */
    get isColumnOptionsEnabled() {
        return this.i.lu;
    }
    set isColumnOptionsEnabled(v) {
        this.i.lu = ensureBool(v);
    }
    get sortIndicatorStyle() {
        return this.i.ls;
    }
    set sortIndicatorStyle(v) {
        this.i.ls = ensureEnum(SortIndicatorStyle_$type, v);
    }
    /**
     * Gets or sets the alignment of the column options icon within the header cell.
    */
    get columnOptionsIconAlignment() {
        return this.i.lo;
    }
    set columnOptionsIconAlignment(v) {
        this.i.lo = ensureEnum(ColumnOptionsIconAlignment_$type, v);
    }
    /**
     * Gets or sets the color for the column options icon in the header.
    */
    get columnOptionsIconColor() {
        return brushToString(this.i.l6);
    }
    set columnOptionsIconColor(v) {
        this.i.l6 = stringToBrush(v);
    }
    /**
     * Gets or sets how the column option icon will behave in the header.
    */
    get columnOptionsIconBehavior() {
        return this.i.lq;
    }
    set columnOptionsIconBehavior(v) {
        this.i.lq = ensureEnum(ColumnOptionsIconBehavior_$type, v);
    }
}
