/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseEditorView } from "./BaseEditorView";
import { runOn, delegateCombine, delegateRemove, typeCast, markType } from "igniteui-react-core";
import { IDataSource_$type } from "igniteui-react-core";
import { stringIsNullOrWhiteSpace } from "igniteui-react-core";
/**
 * @hidden
 */
var ComboEditorView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ComboEditorView, _super);
    function ComboEditorView(a, b, c) {
        var _this = _super.call(this, a, c) || this;
        _this.ab = null;
        _this.aa = null;
        _this.ae = null;
        _this.ac = false;
        _this.af = null;
        _this.ah = null;
        _this.y = null;
        _this.ad = false;
        var d = a.createElement("div");
        d.setRawStyleProperty("margin-top", "-10px");
        d.setRawStyleProperty("height", "38px");
        d.setRawStyleProperty("width", "100%");
        _this.container = d;
        a.getPortal(d, "MultiColumnComboBox", function (e) {
            _this.aa = e.componentRef;
            _this.ae = _this.aa.i;
            _this.aa.height = "100%";
            _this.aa.density = 3;
            _this.aa.baseTheme = b;
            _this.aa.labelVisible = false;
            _this.aa.columnHeadersVisible = false;
            _this.aa.rowSeparatorsVisible = false;
            _this.ae.disallowTabFocus = true;
            _this.ap();
            _this.w();
            if (_this.ab != null) {
                _this.aa.textStyle = _this.ab.fontString;
            }
            _this.attachEvents();
            if (_this.ac) {
                _this.onEditStarted();
                window.setTimeout(function () { return _this.aa.select(); }, 0);
                _this.ac = false;
            }
        }, false);
        return _this;
    }
    Object.defineProperty(ComboEditorView.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.af;
            this.af = a;
            if (b != this.af) {
                this.u("DataSource", b, this.af);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditorView.prototype, "aj", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.u("TextField", b, this.ah);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(ComboEditorView.prototype, "z", {
        get: function () {
            return this.y;
        },
        set: function (a) {
            var b = this.y;
            this.y = a;
            if (b != this.y) {
                this.u("ValueField", b, this.y);
            }
        },
        enumerable: false,
        configurable: true
    });
    ComboEditorView.prototype.setFont = function (a) {
        this.ab = a;
        if (this.aa != null && this.ab != null) {
            this.aa.textStyle = this.ab.fontString;
        }
    };
    ComboEditorView.prototype.attachEvents = function () {
        if (this.aa != null) {
            var a = this.aa;
            a.selectedValueChanged = delegateCombine(a.selectedValueChanged, runOn(this, this.onComboValueChanged));
            var b = this.aa;
            b.textValueChanged = delegateCombine(b.textValueChanged, runOn(this, this.onComboTextChanged));
            var c = this.aa;
            c.gotFocus = delegateCombine(c.gotFocus, runOn(this, this.onComboGotFocus));
            var d = this.aa;
            d.lostFocus = delegateCombine(d.lostFocus, runOn(this, this.onComboLostFocus));
            var e = this.aa;
            e.keyDown = delegateCombine(e.keyDown, runOn(this, this.onInputKeyDown));
            var f = this.aa;
            f.changing = delegateCombine(f.changing, runOn(this, this.onInputChanging));
        }
    };
    ComboEditorView.prototype.detachEvents = function () {
        if (this.aa != null) {
            var a = this.aa;
            a.selectedValueChanged = delegateRemove(a.selectedValueChanged, runOn(this, this.onComboValueChanged));
            var b = this.aa;
            b.textValueChanged = delegateRemove(b.textValueChanged, runOn(this, this.onComboTextChanged));
            var c = this.aa;
            c.gotFocus = delegateRemove(c.gotFocus, runOn(this, this.onComboGotFocus));
            var d = this.aa;
            d.lostFocus = delegateRemove(d.lostFocus, runOn(this, this.onComboLostFocus));
            var e = this.aa;
            e.keyDown = delegateRemove(e.keyDown, runOn(this, this.onInputKeyDown));
            var f = this.aa;
            f.changing = delegateRemove(f.changing, runOn(this, this.onInputChanging));
        }
    };
    ComboEditorView.prototype.onTargetChanged = function () {
        if (this.aa != null) {
            this.ad = true;
            if (this.aa.value == null && this.aa.text != "") {
                this.aa.text = "";
            }
            this.focus();
            this.ad = false;
        }
    };
    ComboEditorView.prototype.onEditStarted = function () {
        if (this.aa != null) {
            _super.prototype.onEditStarted.call(this);
            var a = this.container.getNativeElement();
            this.aa.defaultColumnWidth = (a.clientWidth - 2).toString();
            if (!this.a.isEditRefocusDesired) {
                this.focus();
            }
        }
        else {
            this.ac = true;
        }
    };
    ComboEditorView.prototype.onEditEnded = function () {
        _super.prototype.onEditEnded.call(this);
        if (this.a.isEditRefocusDesired) {
            var a = this.h.rootWrapper.getNativeElement();
            if (a == document.activeElement || a.contains(document.activeElement)) {
                this.focus();
            }
        }
        this.ac = false;
    };
    ComboEditorView.prototype.s = function () {
        if (this.aa != null) {
            this.ae.focus(true);
            this.aa.select();
        }
    };
    ComboEditorView.prototype.am = function () {
        if (this.aa != null) {
            this.aa.closeUp();
        }
    };
    ComboEditorView.prototype.u = function (a, b, c) {
        _super.prototype.u.call(this, a, b, c);
        switch (a) {
            case "DataSource":
            case "TextField":
            case "ValueField":
                this.ap();
                break;
        }
    };
    ComboEditorView.prototype.w = function () {
        this.ad = true;
        if (this.aa != null) {
            if (this.value == null) {
                this.aa.text = " ";
            }
            this.aa.value = this.value;
            this.s();
        }
        this.ad = false;
    };
    ComboEditorView.prototype.ap = function () {
        if (this.aa != null) {
            this.detachEvents();
            this.aa.dataSource = this.ag;
            this.aa.textField = this.aj;
            this.aa.valueField = this.z;
            if (this.aj != null) {
                this.aa.fields = [this.aj];
            }
            else if (this.z != null && this.z.length > 0) {
                this.aa.fields = [this.z[0]];
            }
            else {
                var a = typeCast(IDataSource_$type, this.ag);
                if (a != null && a.actualSchema != null) {
                    this.aa.fields = [a.actualSchema.propertyNames[0]];
                }
                else {
                    var b = (Array.isArray(this.ag));
                    if (b) {
                        var c = (this.ag.length);
                        if (c > 0) {
                            var d = (Object.keys(this.ag[0]));
                            if (d.length > 0) {
                                this.aa.fields = [d[0]];
                            }
                        }
                    }
                }
            }
            this.attachEvents();
        }
    };
    ComboEditorView.prototype.v = function () {
        _super.prototype.v.call(this);
        if (this.aa != null) {
            this.aa.textColor = this.textColor._fill;
        }
    };
    ComboEditorView.prototype.onComboValueChanged = function (a, b) {
        this.at();
    };
    ComboEditorView.prototype.onComboTextChanged = function (a, b) {
        this.at();
    };
    ComboEditorView.prototype.at = function () {
        if (this.ad) {
            return;
        }
        if (this.aa.value != null) {
            this.q(this.aa.value, false);
        }
        else if (this.aa.value == null && stringIsNullOrWhiteSpace(this.aa.text)) {
            this.q(null, false);
        }
        else {
            this.q(this.value, false);
        }
    };
    ComboEditorView.prototype.onInputChanging = function (a, b) {
        this.p();
    };
    ComboEditorView.prototype.onComboLostFocus = function (a) {
        this.o();
    };
    ComboEditorView.prototype.onComboGotFocus = function (a) {
        this.n();
    };
    ComboEditorView.$t = markType(ComboEditorView, 'ComboEditorView', BaseEditorView.$);
    return ComboEditorView;
}(BaseEditorView));
export { ComboEditorView };
