/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridStateBaseDirective } from "./GridStateBaseDirective";
import { Base, markType } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { ColumnState } from "./ColumnState";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { PagingState } from "./PagingState";
import { SortingExpression } from "./SortingExpression";
import { GroupingState } from "./GroupingState";
import { GridSelectionRange } from "./GridSelectionRange";
import { PinningConfig } from "./PinningConfig";
import { PivotConfiguration } from "./PivotConfiguration";
/**
 * @hidden
 */
var GridState = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridState, _super);
    function GridState() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.stateParsed = null;
        return _this;
    }
    GridState.prototype.stateParsedChanged = function () {
        var _this = this;
        if (this.stateParsed != null) {
            this.c.r("stateParsed", function (a) { return _this.stateParsed(_this, GridStateInfoEventArgs.b(a)); }, false);
        }
        else {
            this.c.u("stateParsed");
        }
    };
    GridState.prototype.k = function (a, b) {
        this.nativeElement.applyState(this.c.i(a), this.c.i(b));
    };
    GridState.prototype.l = function (a, b) {
        this.nativeElement.applyStateFromString(this.c.i(a), this.c.i(b));
    };
    GridState.prototype.h = function (a) {
        return this.c.g(this.nativeElement.getState(this.c.i(a)), function (b) { return new GridStateInfo(); });
    };
    GridState.prototype.j = function (a) {
        return (this.nativeElement.getStateAsString(this.c.i(a)));
    };
    GridState.$t = markType(GridState, 'GridState', GridStateBaseDirective.$);
    return GridState;
}(GridStateBaseDirective));
export { GridState };
/**
 * @hidden
 */
var GridStateCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridStateCollection, _super);
    function GridStateCollection() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = new WCNativeHelper();
        _this.d = null;
        return _this;
    }
    Object.defineProperty(GridStateCollection.prototype, "c", {
        get: function () {
            return this.b;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateCollection.prototype, "nativeElement", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
            this.b.o = this.d;
        },
        enumerable: false,
        configurable: true
    });
    GridStateCollection.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridStateCollection.prototype, "g", {
        get: function () {
            var ret_ = this.c.n("id");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("id", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateCollection.prototype, "f", {
        get: function () {
            var ret_ = this.c.n("parentRowID");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("parentRowID", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateCollection.prototype, "a", {
        get: function () {
            var ret_ = this.c.m("state", function (a) { return new GridState(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.c.v("state", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridStateCollection.$t = markType(GridStateCollection, 'GridStateCollection');
    return GridStateCollection;
}(Base));
export { GridStateCollection };
/**
 * @hidden
 */
var GridStateInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridStateInfo, _super);
    function GridStateInfo() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.o = new WCNativeHelper();
        _this.r = null;
        return _this;
    }
    Object.defineProperty(GridStateInfo.prototype, "p", {
        get: function () {
            return this.o;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "nativeElement", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            this.r = a;
            this.o.o = this.r;
        },
        enumerable: false,
        configurable: true
    });
    GridStateInfo.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(GridStateInfo.prototype, "b", {
        get: function () {
            var ret_ = this.p.m("columns", function (a) { return new ColumnState(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("columns", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "j", {
        get: function () {
            var ret_ = this.p.m("filtering", function (a) { return new FilteringExpressionsTree(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("filtering", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "i", {
        get: function () {
            var ret_ = this.p.m("advancedFiltering", function (a) { return new FilteringExpressionsTree(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("advancedFiltering", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "l", {
        get: function () {
            var ret_ = this.p.m("paging", function (a) { return new PagingState(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("paging", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "q", {
        get: function () {
            var ret_ = this.p.n("moving");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("moving", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "h", {
        get: function () {
            var ret_ = this.p.m("sorting", function (a) { return new SortingExpression(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("sorting", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "k", {
        get: function () {
            var ret_ = this.p.m("groupBy", function (a) { return new GroupingState(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("groupBy", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "a", {
        get: function () {
            var ret_ = this.p.m("cellSelection", function (a) { return new GridSelectionRange(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("cellSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "g", {
        get: function () {
            var ret_ = this.p.n("rowSelection");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("rowSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "c", {
        get: function () {
            var ret_ = this.p.n("columnSelection");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("columnSelection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "f", {
        get: function () {
            var ret_ = this.p.n("rowPinning");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("rowPinning", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "m", {
        get: function () {
            var ret_ = this.p.m("pinningConfig", function (a) { return new PinningConfig(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("pinningConfig", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "d", {
        get: function () {
            var ret_ = this.p.n("expansion");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("expansion", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "e", {
        get: function () {
            var ret_ = this.p.m("rowIslands", function (a) { return new GridStateCollection(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("rowIslands", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "t", {
        get: function () {
            var ret_ = this.p.n("id");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("id", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(GridStateInfo.prototype, "n", {
        get: function () {
            var ret_ = this.p.m("pivotConfiguration", function (a) { return new PivotConfiguration(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.p.v("pivotConfiguration", value_);
        },
        enumerable: false,
        configurable: true
    });
    GridStateInfo.$t = markType(GridStateInfo, 'GridStateInfo');
    return GridStateInfo;
}(Base));
export { GridStateInfo };
/**
 * @hidden
 */
var GridStateInfoEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GridStateInfoEventArgs, _super);
    function GridStateInfoEventArgs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        return _this;
    }
    GridStateInfoEventArgs.b = function (a) {
        return ((function () {
            var $ret = new GridStateInfoEventArgs();
            $ret.a = WCNativeHelper.h(a, function (b) { return new GridStateInfo(); });
            return $ret;
        })());
    };
    GridStateInfoEventArgs.$t = markType(GridStateInfoEventArgs, 'GridStateInfoEventArgs');
    return GridStateInfoEventArgs;
}(Base));
export { GridStateInfoEventArgs };
