/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GridBaseDirective } from "./GridBaseDirective";
import { SortingExpression } from "./SortingExpression";
import { typeGetValue, markType } from "igniteui-react-core";
import { PivotGridValueTemplateContext } from "./PivotGridValueTemplateContext";
import { PivotConfiguration } from "./PivotConfiguration";
import { PivotDimension } from "./PivotDimension";
import { DimensionsChangeEventArgs } from "./DimensionsChangeEventArgs";
import { PivotConfigurationChangedEventArgs } from "./PivotConfigurationChangedEventArgs";
import { PivotDimensionEventArgs } from "./PivotDimensionEventArgs";
import { PivotValueEventArgs } from "./PivotValueEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { ValuesChangeEventArgs } from "./ValuesChangeEventArgs";
import { PivotDimensionType_$type } from "./PivotDimensionType";
import { SortingDirection_$type } from "./SortingDirection";
/**
 * @hidden
 */
var PivotGrid = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(PivotGrid, _super);
    function PivotGrid() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.hb = null;
        _this.ha = null;
        _this.dimensionsChange = null;
        _this.pivotConfigurationChange = null;
        _this.dimensionInit = null;
        _this.valueInit = null;
        _this.dimensionsSortingExpressionsChange = null;
        _this.valuesChange = null;
        return _this;
    }
    Object.defineProperty(PivotGrid.prototype, "gy", {
        get: function () {
            var ret_ = this.d.m("dimensionsSortingExpressions", function (a) { return new SortingExpression(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotGrid.prototype, "hd", {
        get: function () {
            return this.hb;
        },
        set: function (a) {
            this.hb = a;
            this.d.s("valueChipTemplate", function (b) { return new PivotGridValueTemplateContext(); }, this.hb);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotGrid.prototype, "g0", {
        get: function () {
            var ret_ = this.d.m("pivotConfiguration", function (a) { return new PivotConfiguration(); });
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("pivotConfiguration", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotGrid.prototype, "g7", {
        get: function () {
            var ret_ = this.d.n("showPivotConfigurationUI");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("showPivotConfigurationUI", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotGrid.prototype, "g8", {
        get: function () {
            var ret_ = this.d.n("superCompactMode");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("superCompactMode", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotGrid.prototype, "g6", {
        get: function () {
            var ret_ = this.d.n("defaultExpandState");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("defaultExpandState", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotGrid.prototype, "gx", {
        get: function () {
            var ret_ = this.d.m("allDimensions", function (a) { return new PivotDimension(); });
            return ret_;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotGrid.prototype, "g9", {
        get: function () {
            var ret_ = this.d.n("data");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.d.v("data", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(PivotGrid.prototype, "hc", {
        get: function () {
            return this.ha;
        },
        set: function (a) {
            this.ha = a;
            this.d.s("emptyPivotGridTemplate", function (b) { return b; }, this.ha);
        },
        enumerable: false,
        configurable: true
    });
    PivotGrid.prototype.dimensionsChangeChanged = function () {
        var _this = this;
        if (this.dimensionsChange != null) {
            this.d.r("dimensionsChange", function (a) { return _this.dimensionsChange(_this, DimensionsChangeEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("dimensionsChange");
        }
    };
    PivotGrid.prototype.pivotConfigurationChangeChanged = function () {
        var _this = this;
        if (this.pivotConfigurationChange != null) {
            this.d.r("pivotConfigurationChange", function (a) { return _this.pivotConfigurationChange(_this, PivotConfigurationChangedEventArgs.a(a)); }, false);
        }
        else {
            this.d.u("pivotConfigurationChange");
        }
    };
    PivotGrid.prototype.dimensionInitChanged = function () {
        var _this = this;
        if (this.dimensionInit != null) {
            this.d.r("dimensionInit", function (a) { return _this.dimensionInit(_this, PivotDimensionEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("dimensionInit");
        }
    };
    PivotGrid.prototype.valueInitChanged = function () {
        var _this = this;
        if (this.valueInit != null) {
            this.d.r("valueInit", function (a) { return _this.valueInit(_this, PivotValueEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("valueInit");
        }
    };
    PivotGrid.prototype.dimensionsSortingExpressionsChangeChanged = function () {
        var _this = this;
        if (this.dimensionsSortingExpressionsChange != null) {
            this.d.r("dimensionsSortingExpressionsChange", function (a) { return _this.dimensionsSortingExpressionsChange(_this, SortingExpressionEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("dimensionsSortingExpressionsChange");
        }
    };
    PivotGrid.prototype.valuesChangeChanged = function () {
        var _this = this;
        if (this.valuesChange != null) {
            this.d.r("valuesChange", function (a) { return _this.valuesChange(_this, ValuesChangeEventArgs.b(a)); }, false);
        }
        else {
            this.d.u("valuesChange");
        }
    };
    PivotGrid.prototype.ho = function (a) {
        if (a === void 0) {
            a = false;
        }
        this.nativeElement.notifyDimensionChange(this.d.i(a));
    };
    PivotGrid.prototype.ht = function (a) {
        this.nativeElement.toggleColumn(this.d.i(a));
    };
    PivotGrid.prototype.hj = function (a) {
        this.nativeElement.getColumnGroupExpandState(this.d.i(a));
    };
    PivotGrid.prototype.hv = function (a, b) {
        this.nativeElement.toggleRowGroup(this.d.i(a), this.d.i(b));
    };
    PivotGrid.prototype.he = function (a) {
        this.nativeElement.autoSizeRowDimension(this.d.i(a));
    };
    PivotGrid.prototype.hk = function (a, b, c) {
        if (c === void 0) {
            c = -1;
        }
        this.nativeElement.insertDimensionAt(this.d.i(a), this.d.i(typeGetValue(this.d.f(PivotDimensionType_$type, b))), this.d.i(typeGetValue(this.d.f(PivotDimensionType_$type, c))));
    };
    PivotGrid.prototype.hm = function (a, b, c) {
        if (c === void 0) {
            c = -1;
        }
        this.nativeElement.moveDimension(this.d.i(a), this.d.i(typeGetValue(this.d.f(PivotDimensionType_$type, b))), this.d.i(typeGetValue(this.d.f(PivotDimensionType_$type, c))));
    };
    PivotGrid.prototype.hq = function (a) {
        this.nativeElement.removeDimension(this.d.i(a));
    };
    PivotGrid.prototype.hu = function (a) {
        this.nativeElement.toggleDimension(this.d.i(a));
    };
    PivotGrid.prototype.hl = function (a, b) {
        if (b === void 0) {
            b = -1;
        }
        this.nativeElement.insertValueAt(this.d.i(a), this.d.i(b));
    };
    PivotGrid.prototype.hn = function (a, b) {
        if (b === void 0) {
            b = -1;
        }
        this.nativeElement.moveValue(this.d.i(a), this.d.i(b));
    };
    PivotGrid.prototype.hr = function (a) {
        this.nativeElement.removeValue(this.d.i(a));
    };
    PivotGrid.prototype.hw = function (a) {
        this.nativeElement.toggleValue(this.d.i(a));
    };
    PivotGrid.prototype.hs = function (a, b) {
        this.nativeElement.sortDimension(this.d.i(a), this.d.i(typeGetValue(this.d.f(SortingDirection_$type, b))));
    };
    PivotGrid.prototype.hi = function (a, b, c) {
        this.nativeElement.filterDimension(this.d.i(a), this.d.i(b), this.d.i(c));
    };
    PivotGrid.$t = markType(PivotGrid, 'PivotGrid', GridBaseDirective.$);
    return PivotGrid;
}(GridBaseDirective));
export { PivotGrid };
