/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-react-core";
/**
 * Enumerates the different scope that summaries can apply to.
 */
export var SummaryScope = /*@__PURE__*/ (function (SummaryScope) {
    /**
     * Summaries are calculated for both the root and section level.
     */
    SummaryScope[SummaryScope["Both"] = 0] = "Both";
    /**
     * Summaries are only calculated at the root level.
     */
    SummaryScope[SummaryScope["Root"] = 1] = "Root";
    /**
     * Summaries are only calculated at the group level.
     */
    SummaryScope[SummaryScope["Groups"] = 2] = "Groups";
    /**
     * Summaries are not calculated at all.
     */
    SummaryScope[SummaryScope["None"] = 3] = "None";
    return SummaryScope;
})({});
/**
 * @hidden
 */
export var SummaryScope_$type = /*@__PURE__*/ markEnum('SummaryScope', 'Both,0|Root,1|Groups,2|None,3');
