import { CellRange as CellRange_internal } from "./CellRange";
/**
 * An indentifier for a specific cell in the grid.
*/
var IgrCellRange = /** @class */ /*@__PURE__*/ (function () {
    function IgrCellRange() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrCellRange.prototype.createImplementation = function () {
        return new CellRange_internal();
    };
    Object.defineProperty(IgrCellRange.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrCellRange.prototype.onImplementationCreated = function () {
    };
    IgrCellRange.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrCellRange.prototype, "startColumn", {
        /**
         * Gets or sets the start column of the range.
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellRange.prototype, "endColumn", {
        /**
         * Gets or sets the end column of the range.
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellRange.prototype, "startRow", {
        /**
         * Gets or sets the start row of the range.
        */
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellRange.prototype, "endRow", {
        /**
         * Gets or sets the end row of the range.
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrCellRange.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrCellRange;
}());
export { IgrCellRange };
