import { IgrColumn } from "./igr-column";
import { IgrRowType } from "./igr-row-type";
import { IgrGridCellIdentifier } from "./igr-grid-cell-identifier";
import { CellType as CellType_internal } from "./CellType";
import { ensureBool, interfaceToInternal } from "igniteui-react-core";
import { GridValidationState } from "./GridValidationState";
var IgrCellType = /** @class */ /*@__PURE__*/ (function () {
    function IgrCellType() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrCellType.prototype.createImplementation = function () {
        return new CellType_internal();
    };
    Object.defineProperty(IgrCellType.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrCellType.prototype.onImplementationCreated = function () {
    };
    IgrCellType.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrCellType.prototype, "value", {
        get: function () {
            return this.i.u;
        },
        set: function (v) {
            this.i.u = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "editValue", {
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "selected", {
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "active", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "editable", {
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "editMode", {
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "column", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "row", {
        get: function () {
            var r = this.i.f;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrRowType();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.f = null : this.i.f = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "grid", {
        get: function () {
            var r = this.i.c;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.c = null : this.i.c = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "id", {
        get: function () {
            var r = this.i.d;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGridCellIdentifier();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.d = null : this.i.d = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "cellID", {
        get: function () {
            return this.i.q;
        },
        set: function (v) {
            this.i.q = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "validation", {
        get: function () {
            return this.i.e.nativeElement;
        },
        set: function (v) {
            this.i.e = interfaceToInternal(v, function () { return new GridValidationState(); });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "readonly", {
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "title", {
        get: function () {
            return this.i.t;
        },
        set: function (v) {
            this.i.t = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "width", {
        get: function () {
            return this.i.v;
        },
        set: function (v) {
            this.i.v = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrCellType.prototype, "visibleColumnIndex", {
        get: function () {
            return this.i.o;
        },
        set: function (v) {
            this.i.o = +v;
        },
        enumerable: false,
        configurable: true
    });
    IgrCellType.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        if (this.row && this.row.name && this.row.name == name) {
            return this.row;
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        if (this.id && this.id.name && this.id.name == name) {
            return this.id;
        }
        if (this.validation && this.validation.name && this.validation.name == name) {
            return this.validation;
        }
        return null;
    };
    IgrCellType.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    IgrCellType.prototype.update = function (value) {
        this.i.y(value);
    };
    IgrCellType.prototype.setEditMode = function (value) {
        this.i.w(value);
    };
    IgrCellType.prototype.calculateSizeToFit = function (range) {
        var iv = this.i.n(range);
        return (iv);
    };
    return IgrCellType;
}());
export { IgrCellType };
