import { __extends } from "tslib";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnExportingEventArgsDetail as ColumnExportingEventArgsDetail_internal } from "./ColumnExportingEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
/**
 * columnExporting event arguments
 * ```typescript
 * this.exporterService.columnExporting.subscribe((args: IColumnExportingEventArgs) => {
 * // set args properties here
 * });
 * ```
*/
var IgrColumnExportingEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnExportingEventArgsDetail, _super);
    function IgrColumnExportingEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrColumnExportingEventArgsDetail.prototype.createImplementation = function () {
        return new ColumnExportingEventArgsDetail_internal();
    };
    Object.defineProperty(IgrColumnExportingEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnExportingEventArgsDetail.prototype, "header", {
        /**
         * Contains the exporting column header
        */
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnExportingEventArgsDetail.prototype, "field", {
        /**
         * Contains the exporting column field name
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnExportingEventArgsDetail.prototype, "columnIndex", {
        /**
         * Contains the exporting column index
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnExportingEventArgsDetail.prototype, "cancel", {
        /**
         * Skip the exporting column when set to true
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnExportingEventArgsDetail.prototype, "skipFormatter", {
        /**
         * Export the column's data without applying its formatter, when set to true
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnExportingEventArgsDetail.prototype, "grid", {
        /**
         * A reference to the grid owner.
        */
        get: function () {
            var r = this.i.g;
            if (r == null) {
                return null;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnExportingEventArgsDetail.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.grid && this.grid.name && this.grid.name == name) {
            return this.grid;
        }
        return null;
    };
    return IgrColumnExportingEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrColumnExportingEventArgsDetail };
