import { __extends } from "tslib";
import * as React from 'react';
import { IgrColumnGroup } from "./igr-column-group";
import { ColumnLayout } from "./ColumnLayout";
/**
 * Column layout for declaration of Multi-row Layout
 * @igxParent IgxGridComponent
*/
var IgrColumnLayout = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnLayout, _super);
    function IgrColumnLayout(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        return _this;
    }
    IgrColumnLayout.prototype.createImplementation = function () {
        var impl = new ColumnLayout();
        var nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-column-layout");
        }
        else {
            nat = {
                style: {}
            };
        }
        impl.setNativeElement(nat);
        return impl;
    };
    Object.defineProperty(IgrColumnLayout.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnLayout.prototype.render = function () {
        var children = this._contentChildrenManager.getChildren(this.props.children);
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrColumnLayout.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    return IgrColumnLayout;
}(IgrColumnGroup));
export { IgrColumnLayout };
