import { IgrDataGridColumn } from "./igr-data-grid-column";
import { PinnedPositions_$type } from "./PinnedPositions";
import { ColumnPinnedChangedEventArgs as ColumnPinnedChangedEventArgs_internal } from "./ColumnPinnedChangedEventArgs";
import { ensureEnum } from "igniteui-react-core";
/**
 * Event arguments for the ColumnPinnedChanged event.
*/
var IgrColumnPinnedChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrColumnPinnedChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrColumnPinnedChangedEventArgs.prototype.createImplementation = function () {
        return new ColumnPinnedChangedEventArgs_internal();
    };
    Object.defineProperty(IgrColumnPinnedChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnPinnedChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrColumnPinnedChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrColumnPinnedChangedEventArgs.prototype, "column", {
        /**
         * The column whose pinned state has changed.
        */
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrDataGridColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnPinnedChangedEventArgs.prototype, "pinned", {
        /**
         * The new pinned state for the column.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(PinnedPositions_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    return IgrColumnPinnedChangedEventArgs;
}());
export { IgrColumnPinnedChangedEventArgs };
