import { __extends } from "tslib";
import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnToggledEventArgsDetail as ColumnToggledEventArgsDetail_internal } from "./ColumnToggledEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
/**
 * Event emitted when a checkbox in the checkbox
 * list of an IgxColumnActions component is clicked.
*/
var IgrColumnToggledEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrColumnToggledEventArgsDetail, _super);
    function IgrColumnToggledEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrColumnToggledEventArgsDetail.prototype.createImplementation = function () {
        return new ColumnToggledEventArgsDetail_internal();
    };
    Object.defineProperty(IgrColumnToggledEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnToggledEventArgsDetail.prototype, "column", {
        /**
         * The column that is toggled.
        */
        get: function () {
            var r = this.i.g;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrColumnToggledEventArgsDetail.prototype, "checked", {
        /**
         * The checked state after the action.
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrColumnToggledEventArgsDetail.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        return null;
    };
    return IgrColumnToggledEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrColumnToggledEventArgsDetail };
