import { __extends } from "tslib";
import { IgrDataGridColumn } from "./igr-data-grid-column";
import { ComboBoxColumn } from "./ComboBoxColumn";
/**
 * A combobox column.
*/
var IgrComboBoxColumn = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrComboBoxColumn, _super);
    function IgrComboBoxColumn(props) {
        return _super.call(this, props) || this;
    }
    IgrComboBoxColumn.prototype.createImplementation = function () {
        return new ComboBoxColumn();
    };
    Object.defineProperty(IgrComboBoxColumn.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrComboBoxColumn.prototype, "actualDataSource", {
        /**
         * Gets the actual data source that is being used by the combo. If a collection was provided for the combobox data, an implicit LocalDataSource is created, and this is available via this property.
        */
        get: function () {
            return this.i.ln;
        },
        set: function (v) {
            this.i.ln = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrComboBoxColumn.prototype, "dataSource", {
        /**
         * Gets or sets the ComboBox data source.
        */
        get: function () {
            return this.i.lo;
        },
        set: function (v) {
            this.i.lo = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrComboBoxColumn.prototype, "textField", {
        /**
         * Gets or sets the ComboBox text field.
        */
        get: function () {
            return this.i.ls;
        },
        set: function (v) {
            this.i.ls = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrComboBoxColumn.prototype, "valueField", {
        /**
         * Gets or sets the ComboBox value field.
        */
        get: function () {
            return this.i.lt;
        },
        set: function (v) {
            this.i.lt = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrComboBoxColumn.prototype, "valueMultiField", {
        /**
         * Gets or sets the ComboBox value field.
        */
        get: function () {
            return this.i.ll;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.ll = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrComboBoxColumn;
}(IgrDataGridColumn));
export { IgrComboBoxColumn };
