import { __extends, __values } from "tslib";
import * as React from 'react';
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { DataSourceSchemaPropertyType_$type } from "igniteui-react-core";
import { IgrOperatorSelectorValueChangedEventArgs } from "./igr-operator-selector-value-changed-event-args";
import { IgrOperatorSelectorOpeningEventArgs } from "./igr-operator-selector-opening-event-args";
import { IgrOperatorSelectorClosingEventArgs } from "./igr-operator-selector-closing-event-args";
import { ComparisonOperatorSelector } from "./ComparisonOperatorSelector";
import { TypeRegistrar } from "igniteui-react-core";
import { NamePatcher, getModifiedProps, isValidProp, ensureEnum, brushToString, stringToBrush, toSpinal, initializePropertiesFromCss } from "igniteui-react-core";
/**
 * A dropdown selector for choosing which comparison operator to use.
*/
var IgrDataGridComparisonOperatorSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrDataGridComparisonOperatorSelector, _super);
    function IgrDataGridComparisonOperatorSelector(props) {
        var _this = _super.call(this, props) || this;
        _this.mounted = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._valueChanged = null;
        _this._valueChanged_wrapped = null;
        _this._opening = null;
        _this._opening_wrapped = null;
        _this._opened = null;
        _this._opened_wrapped = null;
        _this._closing = null;
        _this._closing_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        if (_this._initializeAdapters) {
            _this._initializeAdapters();
        }
        return _this;
    }
    IgrDataGridComparisonOperatorSelector.prototype.createImplementation = function () {
        return new ComparisonOperatorSelector();
    };
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: false,
        configurable: true
    });
    IgrDataGridComparisonOperatorSelector._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrDataGridComparisonOperatorSelector.prototype.onImplementationCreated = function () {
    };
    IgrDataGridComparisonOperatorSelector.prototype.componentDidMount = function () {
        var e_1, _a;
        this.mounted = true;
        try {
            for (var _b = __values(Object.keys(this.props)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = this.props[p];
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
    };
    IgrDataGridComparisonOperatorSelector.prototype.shouldComponentUpdate = function (nextProps, nextState) {
        var e_2, _a;
        var mod = getModifiedProps(this.props, nextProps);
        try {
            for (var _b = __values(Object.keys(mod)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var p = _c.value;
                if (isValidProp(this, p)) {
                    this[p] = mod[p];
                }
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return true;
    };
    IgrDataGridComparisonOperatorSelector.prototype.render = function () {
        return null;
    };
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "value", {
        /**
         * Gets or sets the value of the selector.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "customFilterID", {
        /**
         * Gets the ID for the custom filter that is selected. Value must be 'Custom' for this property to be valid.
        */
        get: function () {
            return this.i.ae;
        },
        set: function (v) {
            this.i.ae = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "customFilterIndex", {
        /**
         * Gets the index for the custom filter that is selected. Value must be 'Custom' for this property to be valid.
        */
        get: function () {
            return this.i.x;
        },
        set: function (v) {
            this.i.x = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "dataType", {
        /**
         * Gets or sets the data type. Used to determine what operators are available.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureEnum(DataSourceSchemaPropertyType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "maxHeight", {
        get: function () {
            return this.i.z;
        },
        set: function (v) {
            this.i.z = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "textColor", {
        /**
         * Gets or sets the text color.
        */
        get: function () {
            return brushToString(this.i.eq);
        },
        set: function (v) {
            this.i.eq = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "background", {
        /**
         * Gets or sets the background color.
        */
        get: function () {
            return brushToString(this.i.ep);
        },
        set: function (v) {
            this.i.ep = stringToBrush(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionTrue", {
        get: function () {
            return this.i.dd;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionFalse", {
        get: function () {
            return this.i.ck;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionEquals", {
        get: function () {
            return this.i.cj;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionNotEquals", {
        get: function () {
            return this.i.cz;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionLessThan", {
        get: function () {
            return this.i.cr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionLessThanOrEqual", {
        get: function () {
            return this.i.cs;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionGreaterThan", {
        get: function () {
            return this.i.cl;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionGreaterThanOrEqual", {
        get: function () {
            return this.i.cm;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionTop", {
        get: function () {
            return this.i.db;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionBottom", {
        get: function () {
            return this.i.cb;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionTopPercentile", {
        get: function () {
            return this.i.dc;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionBottomPercentile", {
        get: function () {
            return this.i.cc;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionToday", {
        get: function () {
            return this.i.c9;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionTomorrow", {
        get: function () {
            return this.i.da;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionYesterday", {
        get: function () {
            return this.i.dg;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionThisWeek", {
        get: function () {
            return this.i.c7;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionNextWeek", {
        get: function () {
            return this.i.cw;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionLastWeek", {
        get: function () {
            return this.i.cp;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionThisMonth", {
        get: function () {
            return this.i.c5;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionNextMonth", {
        get: function () {
            return this.i.cu;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionLastMonth", {
        get: function () {
            return this.i.cn;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionThisQuarter", {
        get: function () {
            return this.i.c6;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionNextQuarter", {
        get: function () {
            return this.i.cv;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionLastQuarter", {
        get: function () {
            return this.i.co;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionThisYear", {
        get: function () {
            return this.i.c8;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionNextYear", {
        get: function () {
            return this.i.cx;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionLastYear", {
        get: function () {
            return this.i.cq;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionYearToDate", {
        get: function () {
            return this.i.df;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionQ1", {
        get: function () {
            return this.i.c0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionQ2", {
        get: function () {
            return this.i.c1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionQ3", {
        get: function () {
            return this.i.c2;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionQ4", {
        get: function () {
            return this.i.c3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionMonth", {
        get: function () {
            return this.i.ct;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionYear", {
        get: function () {
            return this.i.de;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionStartsWith", {
        get: function () {
            return this.i.c4;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionDoesNotStartWith", {
        get: function () {
            return this.i.cg;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionEndsWith", {
        get: function () {
            return this.i.ci;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionDoesNotEndWith", {
        get: function () {
            return this.i.cf;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionContains", {
        get: function () {
            return this.i.cd;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionDoesNotContain", {
        get: function () {
            return this.i.ce;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionEmpty", {
        get: function () {
            return this.i.ch;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "operatorCaptionNotEmpty", {
        get: function () {
            return this.i.cy;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataGridComparisonOperatorSelector.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgrDataGridComparisonOperatorSelector.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgrDataGridComparisonOperatorSelector.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DataGridComparisonOperatorSelector");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgrDataGridComparisonOperatorSelector.prototype.provideContainer = function (container) {
        this.i.ej(container);
    };
    IgrDataGridComparisonOperatorSelector.prototype.dispose = function () {
        this.i.ea();
    };
    IgrDataGridComparisonOperatorSelector.prototype.getDropdownHeight = function () {
        var iv = this.i.y();
        return (iv);
    };
    IgrDataGridComparisonOperatorSelector.prototype.toggle = function () {
        this.i.em();
    };
    IgrDataGridComparisonOperatorSelector.prototype.close = function () {
        this.i.d8();
    };
    IgrDataGridComparisonOperatorSelector.prototype.addCustomOperator = function (name, icon, id, index) {
        this.i.d1(name, icon, id, index);
    };
    IgrDataGridComparisonOperatorSelector.prototype.clearCustomOperators = function () {
        this.i.d7();
    };
    IgrDataGridComparisonOperatorSelector.prototype.selectCustomFilter = function (id, index) {
        this.i.ek(id, index);
    };
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "valueChanged", {
        get: function () {
            return this._valueChanged;
        },
        set: function (ev) {
            var _this = this;
            if (this._valueChanged_wrapped !== null) {
                this.i.valueChanged = delegateRemove(this.i.valueChanged, this._valueChanged_wrapped);
                this._valueChanged_wrapped = null;
                this._valueChanged = null;
            }
            this._valueChanged = ev;
            this._valueChanged_wrapped = function (o, e) {
                var outerArgs = new IgrOperatorSelectorValueChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeValueChanged) {
                    _this.beforeValueChanged(_this, outerArgs);
                }
                if (_this._valueChanged) {
                    _this._valueChanged(_this, outerArgs);
                }
            };
            this.i.valueChanged = delegateCombine(this.i.valueChanged, this._valueChanged_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "opening", {
        get: function () {
            return this._opening;
        },
        set: function (ev) {
            var _this = this;
            if (this._opening_wrapped !== null) {
                this.i.opening = delegateRemove(this.i.opening, this._opening_wrapped);
                this._opening_wrapped = null;
                this._opening = null;
            }
            this._opening = ev;
            this._opening_wrapped = function (o, e) {
                var outerArgs = new IgrOperatorSelectorOpeningEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeOpening) {
                    _this.beforeOpening(_this, outerArgs);
                }
                if (_this._opening) {
                    _this._opening(_this, outerArgs);
                }
            };
            this.i.opening = delegateCombine(this.i.opening, this._opening_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "opened", {
        get: function () {
            return this._opened;
        },
        set: function (ev) {
            var _this = this;
            if (this._opened_wrapped !== null) {
                this.i.opened = delegateRemove(this.i.opened, this._opened_wrapped);
                this._opened_wrapped = null;
                this._opened = null;
            }
            this._opened = ev;
            this._opened_wrapped = function (o, e) {
                var outerArgs = new IgrOperatorSelectorOpeningEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeOpened) {
                    _this.beforeOpened(_this, outerArgs);
                }
                if (_this._opened) {
                    _this._opened(_this, outerArgs);
                }
            };
            this.i.opened = delegateCombine(this.i.opened, this._opened_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrDataGridComparisonOperatorSelector.prototype, "closing", {
        get: function () {
            return this._closing;
        },
        set: function (ev) {
            var _this = this;
            if (this._closing_wrapped !== null) {
                this.i.closing = delegateRemove(this.i.closing, this._closing_wrapped);
                this._closing_wrapped = null;
                this._closing = null;
            }
            this._closing = ev;
            this._closing_wrapped = function (o, e) {
                var outerArgs = new IgrOperatorSelectorClosingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeClosing) {
                    _this.beforeClosing(_this, outerArgs);
                }
                if (_this._closing) {
                    _this._closing(_this, outerArgs);
                }
            };
            this.i.closing = delegateCombine(this.i.closing, this._closing_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    return IgrDataGridComparisonOperatorSelector;
}(React.Component));
export { IgrDataGridComparisonOperatorSelector };
