import { TypeRegistrar } from "igniteui-react-core";
import { ensureBool } from "igniteui-react-core";
var IgrExporterOptionsBase = /** @class */ /*@__PURE__*/ (function () {
    function IgrExporterOptionsBase() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrExporterOptionsBase.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgrExporterOptionsBase.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: false,
        configurable: true
    });
    IgrExporterOptionsBase._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igr" + name;
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgrExporterOptionsBase.prototype.onImplementationCreated = function () {
    };
    IgrExporterOptionsBase.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrExporterOptionsBase.prototype, "ignoreColumnsVisibility", {
        /**
         * Specifies whether hidden columns should be exported.
         * ```typescript
         * let ignoreColumnsVisibility = this.exportOptions.ignoreColumnsVisibility;
         * this.exportOptions.ignoreColumnsVisibility = true;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "ignoreFiltering", {
        /**
         * Specifies whether filtered out rows should be exported.
         * ```typescript
         * let ignoreFiltering = this.exportOptions.ignoreFiltering;
         * this.exportOptions.ignoreFiltering = true;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "ignoreColumnsOrder", {
        /**
         * Specifies if the exporter should ignore the current column order in the IgxGrid.
         * ```typescript
         * let ignoreColumnsOrder = this.exportOptions.ignoreColumnsOrder;
         * this.exportOptions.ignoreColumnsOrder = true;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "ignoreSorting", {
        /**
         * Specifies whether the exported data should be sorted as in the provided IgxGrid.
         * When you export grouped data, setting ignoreSorting to true will cause
         * the grouping to fail because it relies on the sorting of the records.
         * ```typescript
         * let ignoreSorting = this.exportOptions.ignoreSorting;
         * this.exportOptions.ignoreSorting = true;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "ignoreGrouping", {
        /**
         * Specifies whether the exported data should be grouped as in the provided IgxGrid.
         * ```typescript
         * let ignoreGrouping = this.exportOptions.ignoreGrouping;
         * this.exportOptions.ignoreGrouping = true;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "ignoreMultiColumnHeaders", {
        /**
         * Specifies whether the exported data should include multi column headers as in the provided IgxGrid.
         * ```typescript
         * let ignoreMultiColumnHeaders = this.exportOptions.ignoreMultiColumnHeaders;
         * this.exportOptions.ignoreMultiColumnHeaders = true;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "exportSummaries", {
        /**
         * Specifies whether the exported data should include column summaries.
         * ```typescript
         * let exportSummaries = this.exportOptions.exportSummaries;
         * this.exportOptions.exportSummaries = true;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "freezeHeaders", {
        /**
         * Specifies whether the exported data should have frozen headers.
         * ```typescript
         * let freezeHeaders = this.exportOptions.freezeHeaders;
         * this.exportOptions.freezeHeaders = true;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "alwaysExportHeaders", {
        /**
         * Specifies whether the headers should be exported if there is no data.
         * ```typescript
         * let alwaysExportHeaders = this.exportOptions.alwaysExportHeaders;
         * this.exportOptions.alwaysExportHeaders = false;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrExporterOptionsBase.prototype, "fileName", {
        /**
         * Gets the file name which will be used for the exporting operation.
         * ```typescript
         * let fileName = this.exportOptions.fileName;
         * ```
         * @memberof IgxExporterOptionsBase
        */
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrExporterOptionsBase.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrExporterOptionsBase.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrExporterOptionsBase;
}());
export { IgrExporterOptionsBase };
