import { __extends } from "tslib";
import { IgrDefinitionBase } from "./igr-definition-base";
import { FilterRowDefinition } from "./FilterRowDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
var IgrFilterRowDefinition = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrFilterRowDefinition, _super);
    function IgrFilterRowDefinition(props) {
        return _super.call(this, props) || this;
    }
    IgrFilterRowDefinition.prototype.createImplementation = function () {
        return new FilterRowDefinition();
    };
    Object.defineProperty(IgrFilterRowDefinition.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrFilterRowDefinition.prototype, "paddingLeft", {
        /**
         * Gets or sets the amount of left padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrFilterRowDefinition.prototype, "paddingTop", {
        /**
         * Gets or sets the amount of top padding to use for the cell content for this column.
        */
        get: function () {
            return this.i.et;
        },
        set: function (v) {
            this.i.et = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrFilterRowDefinition.prototype, "paddingRight", {
        /**
         * Gets or sets the amount of right padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.es;
        },
        set: function (v) {
            this.i.es = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrFilterRowDefinition.prototype, "paddingBottom", {
        /**
         * Gets or sets the amount of bottom padding to use for the cell content of this column.
        */
        get: function () {
            return this.i.eq;
        },
        set: function (v) {
            this.i.eq = +v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrFilterRowDefinition;
}(IgrDefinitionBase));
export { IgrFilterRowDefinition };
