import { IgrGridCellPosition } from "./igr-grid-cell-position";
import { GridActiveCellChangedEventArgs as GridActiveCellChangedEventArgs_internal } from "./GridActiveCellChangedEventArgs";
/**
 * Information about the change to the selected cells in the grid.
*/
var IgrGridActiveCellChangedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridActiveCellChangedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridActiveCellChangedEventArgs.prototype.createImplementation = function () {
        return new GridActiveCellChangedEventArgs_internal();
    };
    Object.defineProperty(IgrGridActiveCellChangedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridActiveCellChangedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridActiveCellChangedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridActiveCellChangedEventArgs.prototype, "newActiveCell", {
        /**
         * The new active cell.
        */
        get: function () {
            var r = this.i.newActiveCell;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGridCellPosition();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.newActiveCell = null : this.i.newActiveCell = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridActiveCellChangedEventArgs.prototype, "oldActiveCell", {
        /**
         * The old active cell.
        */
        get: function () {
            var r = this.i.oldActiveCell;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrGridCellPosition();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.oldActiveCell = null : this.i.oldActiveCell = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridActiveCellChangedEventArgs;
}());
export { IgrGridActiveCellChangedEventArgs };
