import { GridAnimationSettings as GridAnimationSettings_internal } from "./GridAnimationSettings";
/**
 * Animation settings for the grid.
*/
var IgrGridAnimationSettings = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridAnimationSettings() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridAnimationSettings.prototype.createImplementation = function () {
        return new GridAnimationSettings_internal();
    };
    Object.defineProperty(IgrGridAnimationSettings.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridAnimationSettings.prototype.onImplementationCreated = function () {
    };
    IgrGridAnimationSettings.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrGridAnimationSettings.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrGridAnimationSettings;
}());
export { IgrGridAnimationSettings };
