import { IgrDataGridColumn } from "./igr-data-grid-column";
import { GridCellEditEndedEventArgs as GridCellEditEndedEventArgs_internal } from "./GridCellEditEndedEventArgs";
var IgrGridCellEditEndedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridCellEditEndedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridCellEditEndedEventArgs.prototype.createImplementation = function () {
        return new GridCellEditEndedEventArgs_internal();
    };
    Object.defineProperty(IgrGridCellEditEndedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridCellEditEndedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridCellEditEndedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridCellEditEndedEventArgs.prototype, "column", {
        /**
         * Gets the column of the cell that ended editing.
        */
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrDataGridColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCellEditEndedEventArgs.prototype, "row", {
        /**
         * Gets the row index of the cell that ended editing.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCellEditEndedEventArgs.prototype, "item", {
        /**
         * Gets the row item.
        */
        get: function () {
            return this.i.item;
        },
        set: function (v) {
            this.i.item = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridCellEditEndedEventArgs;
}());
export { IgrGridCellEditEndedEventArgs };
