import { GridClipboardEvent as GridClipboardEvent_internal } from "./GridClipboardEvent";
import { ensureBool } from "igniteui-react-core";
var IgrGridClipboardEvent = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridClipboardEvent() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridClipboardEvent.prototype.createImplementation = function () {
        return new GridClipboardEvent_internal();
    };
    Object.defineProperty(IgrGridClipboardEvent.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridClipboardEvent.prototype.onImplementationCreated = function () {
    };
    IgrGridClipboardEvent.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridClipboardEvent.prototype, "data", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            if (v && !Array.isArray(v) && typeof (v) == "string") {
                var re = /\s*(?:,|\s|$)\s*/gm;
                v = v.split(re);
            }
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridClipboardEvent.prototype, "cancel", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrGridClipboardEvent.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrGridClipboardEvent.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridClipboardEvent;
}());
export { IgrGridClipboardEvent };
