import { GridColumnAnimationSettings as GridColumnAnimationSettings_internal } from "./GridColumnAnimationSettings";
/**
 * Column animation settings for the grid.
*/
var IgrGridColumnAnimationSettings = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridColumnAnimationSettings() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridColumnAnimationSettings.prototype.createImplementation = function () {
        return new GridColumnAnimationSettings_internal();
    };
    Object.defineProperty(IgrGridColumnAnimationSettings.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridColumnAnimationSettings.prototype.onImplementationCreated = function () {
    };
    IgrGridColumnAnimationSettings.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrGridColumnAnimationSettings.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrGridColumnAnimationSettings;
}());
export { IgrGridColumnAnimationSettings };
