import { IgrDataGridColumn } from "./igr-data-grid-column";
import { IgrFilterOperand } from "./igr-filter-operand";
import { GridCustomFilterRequestedEventArgs as GridCustomFilterRequestedEventArgs_internal } from "./GridCustomFilterRequestedEventArgs";
var IgrGridCustomFilterRequestedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridCustomFilterRequestedEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridCustomFilterRequestedEventArgs.prototype.createImplementation = function () {
        return new GridCustomFilterRequestedEventArgs_internal();
    };
    Object.defineProperty(IgrGridCustomFilterRequestedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridCustomFilterRequestedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrGridCustomFilterRequestedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridCustomFilterRequestedEventArgs.prototype, "column", {
        /**
         * The column that requested the filter.
        */
        get: function () {
            var r = this.i.c;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrDataGridColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.c = null : this.i.c = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCustomFilterRequestedEventArgs.prototype, "filter", {
        /**
         * The custom filter that was chosen.
        */
        get: function () {
            var r = this.i.d;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrFilterOperand();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.d = null : this.i.d = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCustomFilterRequestedEventArgs.prototype, "value", {
        /**
         * The value that was provided in the editor for the filter.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCustomFilterRequestedEventArgs.prototype, "expression", {
        /**
         * Sets the filter expression to be used.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridCustomFilterRequestedEventArgs.prototype, "filterFactory", {
        /**
         * Gets the filter factory.
        */
        get: function () {
            return this.i.a;
        },
        enumerable: false,
        configurable: true
    });
    return IgrGridCustomFilterRequestedEventArgs;
}());
export { IgrGridCustomFilterRequestedEventArgs };
