import { __extends } from "tslib";
import * as React from 'react';
import { IgrGridActionsBaseDirective } from "./igr-grid-actions-base-directive";
import { GridPinningActions } from "./GridPinningActions";
/**
 * Grid Pinning Actions for the Action Strip
 * @igxParent IgxActionStripComponent
*/
var IgrGridPinningActions = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridPinningActions, _super);
    function IgrGridPinningActions(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        return _this;
    }
    IgrGridPinningActions.prototype.createImplementation = function () {
        var impl = new GridPinningActions();
        var nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-grid-pinning-actions");
        }
        else {
            nat = {
                style: {}
            };
        }
        impl.setNativeElement(nat);
        return impl;
    };
    Object.defineProperty(IgrGridPinningActions.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridPinningActions.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrGridPinningActions.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    /**
     * Pin the row according to the context.
     * @example
     * ```typescript
     * this.gridPinningActions.pin();
     * ```
    
    */
    IgrGridPinningActions.prototype.pin = function (evt) {
        this.i.h(evt);
    };
    /**
     * Unpin the row according to the context.
     * @example
     * ```typescript
     * this.gridPinningActions.unpin();
     * ```
    
    */
    IgrGridPinningActions.prototype.unpin = function (evt) {
        this.i.j(evt);
    };
    IgrGridPinningActions.prototype.scrollToRow = function (evt) {
        this.i.i(evt);
    };
    return IgrGridPinningActions;
}(IgrGridActionsBaseDirective));
export { IgrGridPinningActions };
