import { __extends } from "tslib";
import * as React from 'react';
import { IgrRowDirective } from "./igr-row-directive";
import { GridRow } from "./GridRow";
var IgrGridRow = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridRow, _super);
    function IgrGridRow(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        return _this;
    }
    IgrGridRow.prototype.createImplementation = function () {
        var impl = new GridRow();
        var nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-grid-row");
        }
        else {
            nat = {
                style: {}
            };
        }
        nat.style.width = "100%";
        nat.style.height = "100%";
        impl.setNativeElement(nat);
        return impl;
    };
    Object.defineProperty(IgrGridRow.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridRow.prototype.componentDidMount = function () {
        this.mounted = true;
        _super.prototype.componentDidMount.call(this);
    };
    IgrGridRow.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrGridRow.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    IgrGridRow.prototype.getContext = function (col, row) {
        this.i.q(col, row);
    };
    IgrGridRow.prototype.getContextMRL = function (pinnedCols, row) {
        this.i.r(pinnedCols, row);
    };
    return IgrGridRow;
}(IgrRowDirective));
export { IgrGridRow };
