import { IgrGridState } from "./igr-grid-state";
import { GridStateCollection as GridStateCollection_internal } from "./GridStateCollection";
var IgrGridStateCollection = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridStateCollection() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridStateCollection.prototype.createImplementation = function () {
        var impl = new GridStateCollection_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrGridStateCollection.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridStateCollection.prototype.onImplementationCreated = function () {
    };
    IgrGridStateCollection.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGridStateCollection.prototype, "id", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridStateCollection.prototype, "parentRowID", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridStateCollection.prototype, "state", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrGridState._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridStateCollection.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.state && this.state.name && this.state.name == name) {
            return this.state;
        }
        return null;
    };
    IgrGridStateCollection.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridStateCollection;
}());
export { IgrGridStateCollection };
