import { __extends } from "tslib";
import * as React from 'react';
import { IgrGridToolbarBaseAction } from "./igr-grid-toolbar-base-action";
import { GridToolbarAdvancedFiltering } from "./GridToolbarAdvancedFiltering";
import { interfaceToInternal } from "igniteui-react-core";
import { OverlaySettings } from "./OverlaySettings";
/**
 * Provides a pre-configured button to open the advanced filtering dialog of the grid.
 * @igxModule IgxGridToolbarModule
 * @igxParent IgxGridToolbarComponent
 * @example
 * ```html
 * Custom text
 * ```
*/
var IgrGridToolbarAdvancedFiltering = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridToolbarAdvancedFiltering, _super);
    function IgrGridToolbarAdvancedFiltering(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        return _this;
    }
    IgrGridToolbarAdvancedFiltering.prototype.createImplementation = function () {
        var impl = new GridToolbarAdvancedFiltering();
        var nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-grid-toolbar-advanced-filtering");
        }
        else {
            nat = {
                style: {}
            };
        }
        impl.setNativeElement(nat);
        return impl;
    };
    Object.defineProperty(IgrGridToolbarAdvancedFiltering.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridToolbarAdvancedFiltering.prototype.onImplementationCreated = function () {
        _super.prototype.onImplementationCreated.call(this);
        this._portalManager.getPortal(this._renderer.getWrapper(this._implementation.nativeElement), "ChildContent", function (p) { }, true);
    };
    IgrGridToolbarAdvancedFiltering.prototype.componentDidMount = function () {
        this.mounted = true;
        _super.prototype.componentDidMount.call(this);
    };
    IgrGridToolbarAdvancedFiltering.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrGridToolbarAdvancedFiltering.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    Object.defineProperty(IgrGridToolbarAdvancedFiltering.prototype, "overlaySettings", {
        get: function () {
            return this.i.b.nativeElement;
        },
        set: function (v) {
            this.i.b = interfaceToInternal(v, function () { return new OverlaySettings(); });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGridToolbarAdvancedFiltering.prototype, "name", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridToolbarAdvancedFiltering.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.overlaySettings && this.overlaySettings.name && this.overlaySettings.name == name) {
            return this.overlaySettings;
        }
        return null;
    };
    IgrGridToolbarAdvancedFiltering.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridToolbarAdvancedFiltering;
}(IgrGridToolbarBaseAction));
export { IgrGridToolbarAdvancedFiltering };
