import { __extends } from "tslib";
import * as React from 'react';
import { IgrBaseToolbarColumnActionsDirective } from "./igr-base-toolbar-column-actions-directive";
import { GridToolbarHiding } from "./GridToolbarHiding";
/**
 * Provides a pre-configured column hiding component for the grid.
 * @igxModule IgxGridToolbarModule
 * @igxParent IgxGridToolbarComponent
 * @example
 * ```html
 * ```
*/
var IgrGridToolbarHiding = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridToolbarHiding, _super);
    function IgrGridToolbarHiding(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        return _this;
    }
    IgrGridToolbarHiding.prototype.createImplementation = function () {
        var impl = new GridToolbarHiding();
        var nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-grid-toolbar-hiding");
        }
        else {
            nat = {
                style: {}
            };
        }
        impl.setNativeElement(nat);
        return impl;
    };
    Object.defineProperty(IgrGridToolbarHiding.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridToolbarHiding.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrGridToolbarHiding.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    return IgrGridToolbarHiding;
}(IgrBaseToolbarColumnActionsDirective));
export { IgrGridToolbarHiding };
