import { __extends } from "tslib";
import * as React from 'react';
import { IgrGridToolbarContent } from "./igr-grid-toolbar-content";
import { GridToolbarTitle } from "./GridToolbarTitle";
/**
 * Provides a way to template the title portion of the toolbar in the grid.
 * @igxModule IgxGridToolbarModule
 * @igxParent IgxGridToolbarComponent
 * @example
 * ```html
 * My custom title
 * ```
*/
var IgrGridToolbarTitle = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrGridToolbarTitle, _super);
    function IgrGridToolbarTitle(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        return _this;
    }
    IgrGridToolbarTitle.prototype.createImplementation = function () {
        var impl = new GridToolbarTitle();
        var nat;
        if (typeof document !== 'undefined') {
            nat = document.createElement("igc-grid-toolbar-title");
        }
        else {
            nat = {
                style: {}
            };
        }
        impl.setNativeElement(nat);
        return impl;
    };
    Object.defineProperty(IgrGridToolbarTitle.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridToolbarTitle.prototype.onImplementationCreated = function () {
        _super.prototype.onImplementationCreated.call(this);
        this._portalManager.getPortal(this._renderer.getWrapper(this._implementation.nativeElement), "ChildContent", function (p) { }, true);
    };
    IgrGridToolbarTitle.prototype.componentDidMount = function () {
        this.mounted = true;
        _super.prototype.componentDidMount.call(this);
    };
    IgrGridToolbarTitle.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("div", {
            ref: this._getMainRef,
            id: this.props.id,
            className: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrGridToolbarTitle.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    Object.defineProperty(IgrGridToolbarTitle.prototype, "name", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridToolbarTitle.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrGridToolbarTitle;
}(IgrGridToolbarContent));
export { IgrGridToolbarTitle };
