import { GridValidationService as GridValidationService_internal } from "./GridValidationService";
var IgrGridValidationService = /** @class */ /*@__PURE__*/ (function () {
    function IgrGridValidationService() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGridValidationService.prototype.createImplementation = function () {
        return new GridValidationService_internal();
    };
    Object.defineProperty(IgrGridValidationService.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGridValidationService.prototype.onImplementationCreated = function () {
    };
    IgrGridValidationService.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    IgrGridValidationService.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrGridValidationService.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    /**
     * Returns all invalid record states.
    
    */
    IgrGridValidationService.prototype.getInvalid = function () {
        var iv = this.i.a();
        var ret = [];
        for (var i = 0; i < iv.length; i++) {
            var impl = iv[i];
            if (!impl.externalObject) {
                var e = impl.nativeElement;
                impl.externalObject = e;
            }
            ret.push(impl.externalObject);
        }
        return ret;
    };
    IgrGridValidationService.prototype.markAsTouched = function (key, field) {
        this.i.g(key, field);
    };
    /**
     * Clears validation state by key or all states if none is provided.
     * key Optional. The key of the record for which to clear state.
    
    * @param key  * Optional. The key of the record for which to clear state.
    */
    IgrGridValidationService.prototype.clear = function (key) {
        this.i.f(key);
    };
    return IgrGridValidationService;
}());
export { IgrGridValidationService };
