import { GroupData as GroupData_internal } from "./GroupData";
/**
 * Object used to store group information for group headers.
*/
var IgrGroupData = /** @class */ /*@__PURE__*/ (function () {
    function IgrGroupData() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrGroupData.prototype.createImplementation = function () {
        return new GroupData_internal();
    };
    Object.defineProperty(IgrGroupData.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrGroupData.prototype.onImplementationCreated = function () {
    };
    IgrGroupData.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrGroupData.prototype, "groupName", {
        /**
         * The grouping key.
        */
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGroupData.prototype, "groupValue", {
        /**
         * The group value.
        */
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrGroupData.prototype, "formattedText", {
        /**
         * The value as formatted text.
        */
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrGroupData.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrGroupData;
}());
export { IgrGroupData };
