import { IgrColumn } from "./igr-column";
import { DisplayDensity_$type } from "./DisplayDensity";
import { SortingDirection_$type } from "./SortingDirection";
import { HeaderType as HeaderType_internal } from "./HeaderType";
import { ensureEnum, ensureBool } from "igniteui-react-core";
var IgrHeaderType = /** @class */ /*@__PURE__*/ (function () {
    function IgrHeaderType() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrHeaderType.prototype.createImplementation = function () {
        return new HeaderType_internal();
    };
    Object.defineProperty(IgrHeaderType.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrHeaderType.prototype.onImplementationCreated = function () {
    };
    IgrHeaderType.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrHeaderType.prototype, "column", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrHeaderType.prototype, "density", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = ensureEnum(DisplayDensity_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrHeaderType.prototype, "sorted", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrHeaderType.prototype, "selectable", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrHeaderType.prototype, "selected", {
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrHeaderType.prototype, "title", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrHeaderType.prototype, "sortDirection", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureEnum(SortingDirection_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    IgrHeaderType.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        return null;
    };
    IgrHeaderType.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrHeaderType;
}());
export { IgrHeaderType };
