import { __extends } from "tslib";
import { ImageStretchOptions_$type } from "./ImageStretchOptions";
import { EditorType_$type } from "./EditorType";
import { IgrDataGridColumn } from "./igr-data-grid-column";
import { ImageColumn } from "./ImageColumn";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents an Image grid column, used to allow the developer to display an image in a cell.
*/
var IgrImageColumn = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrImageColumn, _super);
    function IgrImageColumn(props) {
        return _super.call(this, props) || this;
    }
    IgrImageColumn.prototype.createImplementation = function () {
        return new ImageColumn();
    };
    Object.defineProperty(IgrImageColumn.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageColumn.prototype, "imageStretchOption", {
        /**
         * Gets or sets the stretch option to use when rendering images
        */
        get: function () {
            return this.i.lp;
        },
        set: function (v) {
            this.i.lp = ensureEnum(ImageStretchOptions_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageColumn.prototype, "editorType", {
        /**
         * Gets or sets the editor type used for editing cells in this column.
        */
        get: function () {
            return this.i.ll;
        },
        set: function (v) {
            this.i.ll = ensureEnum(EditorType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageColumn.prototype, "editorDataSource", {
        /**
         * Gets or sets the ComboBox data source.
        */
        get: function () {
            return this.i.lq;
        },
        set: function (v) {
            this.i.lq = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageColumn.prototype, "editorTextField", {
        /**
         * Gets or sets the ComboBox text field.
        */
        get: function () {
            return this.i.lr;
        },
        set: function (v) {
            this.i.lr = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrImageColumn.prototype, "editorValueField", {
        /**
         * Gets or sets the ComboBox value field.
        */
        get: function () {
            return this.i.ls;
        },
        set: function (v) {
            this.i.ls = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrImageColumn;
}(IgrDataGridColumn));
export { IgrImageColumn };
