import { IgrPinColumnCancellableEventArgsDetail } from "./igr-pin-column-cancellable-event-args-detail";
import { PinColumnCancellableEventArgs as PinColumnCancellableEventArgs_internal } from "./PinColumnCancellableEventArgs";
/**
 * The event arguments before a column's pin state is changed.
 * `insertAtIndex`specifies at which index in the pinned/unpinned area the column is inserted.
 * Can be changed in the `columnPin` event.
 * `isPinned` returns the actual pin state of the column. When pinning/unpinning is succesfull,
 * the value of `isPinned` will change accordingly when read in the "-ing" and "-ed" event.
*/
var IgrPinColumnCancellableEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrPinColumnCancellableEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPinColumnCancellableEventArgs.prototype.createImplementation = function () {
        return new PinColumnCancellableEventArgs_internal();
    };
    Object.defineProperty(IgrPinColumnCancellableEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPinColumnCancellableEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrPinColumnCancellableEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPinColumnCancellableEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPinColumnCancellableEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrPinColumnCancellableEventArgs;
}());
export { IgrPinColumnCancellableEventArgs };
