import { __extends } from "tslib";
import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { PinColumnEventArgsDetail as PinColumnEventArgsDetail_internal } from "./PinColumnEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
/**
 * The event arguments after a column's pin state is changed.
 * `insertAtIndex`specifies at which index in the pinned/unpinned area the column was inserted.
 * `isPinned` returns the actual pin state of the column after the operation completed.
*/
var IgrPinColumnEventArgsDetail = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrPinColumnEventArgsDetail, _super);
    function IgrPinColumnEventArgsDetail() {
        return _super.call(this) || this;
    }
    IgrPinColumnEventArgsDetail.prototype.createImplementation = function () {
        return new PinColumnEventArgsDetail_internal();
    };
    Object.defineProperty(IgrPinColumnEventArgsDetail.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPinColumnEventArgsDetail.prototype, "column", {
        get: function () {
            var r = this.i.g;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = IgrColumn._createFromInternal(r);
                if (e) {
                    e._implementation = r;
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.g = null : this.i.g = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPinColumnEventArgsDetail.prototype, "insertAtIndex", {
        /**
         * If pinned, specifies at which index in the pinned area the column is inserted.
         * If unpinned, specifies at which index in the unpinned area the column is inserted.
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPinColumnEventArgsDetail.prototype, "isPinned", {
        /**
         * Returns the actual pin state of the column.
         * If pinning/unpinning is succesfull, value of `isPinned` will change accordingly when read in the "-ing" and "-ed" event.
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrPinColumnEventArgsDetail.prototype.findByName = function (name) {
        var baseResult = _super.prototype.findByName.call(this, name);
        if (baseResult) {
            return baseResult;
        }
        if (this.column && this.column.name && this.column.name == name) {
            return this.column;
        }
        return null;
    };
    return IgrPinColumnEventArgsDetail;
}(IgrBaseEventArgsDetail));
export { IgrPinColumnEventArgsDetail };
