import { IgrPinColumnEventArgsDetail } from "./igr-pin-column-event-args-detail";
import { PinColumnEventArgs as PinColumnEventArgs_internal } from "./PinColumnEventArgs";
/**
 * The event arguments after a column's pin state is changed.
 * `insertAtIndex`specifies at which index in the pinned/unpinned area the column was inserted.
 * `isPinned` returns the actual pin state of the column after the operation completed.
*/
var IgrPinColumnEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrPinColumnEventArgs() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPinColumnEventArgs.prototype.createImplementation = function () {
        return new PinColumnEventArgs_internal();
    };
    Object.defineProperty(IgrPinColumnEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPinColumnEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrPinColumnEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPinColumnEventArgs.prototype, "detail", {
        get: function () {
            var r = this.i.b;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPinColumnEventArgsDetail();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.b = null : this.i.b = v.i;
        },
        enumerable: false,
        configurable: true
    });
    return IgrPinColumnEventArgs;
}());
export { IgrPinColumnEventArgs };
