import { IgrRowType } from "./igr-row-type";
import { PinRowEventArgsDetail as PinRowEventArgsDetail_internal } from "./PinRowEventArgsDetail";
import { ensureBool } from "igniteui-react-core";
/**
 * Event emitted when a row's pin state changes.
*/
var IgrPinRowEventArgsDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrPinRowEventArgsDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPinRowEventArgsDetail.prototype.createImplementation = function () {
        return new PinRowEventArgsDetail_internal();
    };
    Object.defineProperty(IgrPinRowEventArgsDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPinRowEventArgsDetail.prototype.onImplementationCreated = function () {
    };
    IgrPinRowEventArgsDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPinRowEventArgsDetail.prototype, "rowID", {
        /**
         * The ID of the row, that was pinned/unpinned.
         * ID is either the primaryKey value or the data record instance.
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPinRowEventArgsDetail.prototype, "row", {
        get: function () {
            var r = this.i.a;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrRowType();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.a = null : this.i.a = v.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPinRowEventArgsDetail.prototype, "insertAtIndex", {
        /**
         * The index at which to pin the row in the pinned rows collection.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = +v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPinRowEventArgsDetail.prototype, "isPinned", {
        /**
         * Whether or not the row is pinned or unpinned.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPinRowEventArgsDetail.prototype, "owner", {
        /**
         * Provides reference to the owner component.
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPinRowEventArgsDetail.prototype, "cancel", {
        /**
         * Provides the ability to cancel the event.
        */
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    IgrPinRowEventArgsDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.row && this.row.name && this.row.name == name) {
            return this.row;
        }
        return null;
    };
    IgrPinRowEventArgsDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrPinRowEventArgsDetail;
}());
export { IgrPinRowEventArgsDetail };
