import { IgrPivotDimensionCollection } from "./igr-pivot-dimension-collection";
import { IgrPivotValueCollection } from "./igr-pivot-value-collection";
import { IgrPivotKeys } from "./igr-pivot-keys";
import { PivotConfiguration as PivotConfiguration_internal } from "./PivotConfiguration";
import { interfaceToInternal } from "igniteui-react-core";
import { PivotDimensionStrategy } from "./PivotDimensionStrategy";
import { PivotDimensionCollection as PivotDimensionCollection_internal } from "./PivotDimensionCollection";
import { PivotDimension } from "./PivotDimension";
import { SyncableObservableCollection$1 } from "igniteui-react-core";
import { PivotValueCollection as PivotValueCollection_internal } from "./PivotValueCollection";
import { PivotValue } from "./PivotValue";
/**
 * Configuration of the pivot grid.
*/
var IgrPivotConfiguration = /** @class */ /*@__PURE__*/ (function () {
    function IgrPivotConfiguration() {
        this.mounted = false;
        this._rows = null;
        this._columns = null;
        this._values = null;
        this._filters = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPivotConfiguration.prototype.createImplementation = function () {
        var impl = new PivotConfiguration_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrPivotConfiguration.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotConfiguration.prototype.onImplementationCreated = function () {
    };
    IgrPivotConfiguration.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPivotConfiguration.prototype, "rowStrategy", {
        /**
         * A strategy to transform the rows.
        */
        get: function () {
            return this.i.e.nativeElement;
        },
        set: function (v) {
            this.i.e = interfaceToInternal(v, function () { return new PivotDimensionStrategy(); });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotConfiguration.prototype, "columnStrategy", {
        /**
         * A strategy to transform the columns.
        */
        get: function () {
            return this.i.d.nativeElement;
        },
        set: function (v) {
            this.i.d = interfaceToInternal(v, function () { return new PivotDimensionStrategy(); });
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotConfiguration.prototype, "rows", {
        /**
         * A list of the rows.
        */
        get: function () {
            if (this._rows === null) {
                var coll = new IgrPivotDimensionCollection();
                var innerColl = this.i.c;
                if (!innerColl) {
                    innerColl = new PivotDimensionCollection_internal();
                }
                this._rows = coll._fromInner(innerColl);
            }
            return this._rows;
        },
        set: function (v) {
            if (this._rows !== null) {
                this._rows._setSyncTarget(null);
                this._rows = null;
            }
            var coll = new IgrPivotDimensionCollection();
            this._rows = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PivotDimension.$type);
            var innerColl = this.i.c;
            if (!innerColl) {
                innerColl = new PivotDimensionCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._rows._setSyncTarget(syncColl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotConfiguration.prototype, "columns", {
        /**
         * A list of the columns.
        */
        get: function () {
            if (this._columns === null) {
                var coll = new IgrPivotDimensionCollection();
                var innerColl = this.i.a;
                if (!innerColl) {
                    innerColl = new PivotDimensionCollection_internal();
                }
                this._columns = coll._fromInner(innerColl);
            }
            return this._columns;
        },
        set: function (v) {
            if (this._columns !== null) {
                this._columns._setSyncTarget(null);
                this._columns = null;
            }
            var coll = new IgrPivotDimensionCollection();
            this._columns = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PivotDimension.$type);
            var innerColl = this.i.a;
            if (!innerColl) {
                innerColl = new PivotDimensionCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._columns._setSyncTarget(syncColl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotConfiguration.prototype, "values", {
        /**
         * A list of the values.
        */
        get: function () {
            if (this._values === null) {
                var coll = new IgrPivotValueCollection();
                var innerColl = this.i.g;
                if (!innerColl) {
                    innerColl = new PivotValueCollection_internal();
                }
                this._values = coll._fromInner(innerColl);
            }
            return this._values;
        },
        set: function (v) {
            if (this._values !== null) {
                this._values._setSyncTarget(null);
                this._values = null;
            }
            var coll = new IgrPivotValueCollection();
            this._values = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PivotValue.$type);
            var innerColl = this.i.g;
            if (!innerColl) {
                innerColl = new PivotValueCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._values._setSyncTarget(syncColl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotConfiguration.prototype, "filters", {
        /**
         * Dimensions to be displayed in the filter area.
        */
        get: function () {
            if (this._filters === null) {
                var coll = new IgrPivotDimensionCollection();
                var innerColl = this.i.b;
                if (!innerColl) {
                    innerColl = new PivotDimensionCollection_internal();
                }
                this._filters = coll._fromInner(innerColl);
            }
            return this._filters;
        },
        set: function (v) {
            if (this._filters !== null) {
                this._filters._setSyncTarget(null);
                this._filters = null;
            }
            var coll = new IgrPivotDimensionCollection();
            this._filters = coll._fromOuter(v);
            var syncColl = new SyncableObservableCollection$1(PivotDimension.$type);
            var innerColl = this.i.b;
            if (!innerColl) {
                innerColl = new PivotDimensionCollection_internal();
            }
            syncColl._inner = innerColl;
            syncColl.clear();
            this._filters._setSyncTarget(syncColl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotConfiguration.prototype, "pivotKeys", {
        /**
         * Pivot data keys used for data generation. Can be used for custom remote scenarios where the data is pre-populated.
        */
        get: function () {
            var r = this.i.f;
            if (r == null) {
                return null;
            }
            if (!r.externalObject) {
                var e = new IgrPivotKeys();
                if (r.$type) {
                    e._implementation = r;
                }
                else {
                    if (e.i.setNativeElement) {
                        e.i.setNativeElement(r);
                    }
                }
                r.externalObject = e;
            }
            return r.externalObject;
        },
        set: function (v) {
            v == null ? this.i.f = null : this.i.f = v.i;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotConfiguration.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        if (this.rowStrategy && this.rowStrategy.name && this.rowStrategy.name == name) {
            return this.rowStrategy;
        }
        if (this.columnStrategy && this.columnStrategy.name && this.columnStrategy.name == name) {
            return this.columnStrategy;
        }
        if (this.rows != null && this.rows.findByName && this.rows.findByName(name)) {
            return this.rows.findByName(name);
        }
        if (this.columns != null && this.columns.findByName && this.columns.findByName(name)) {
            return this.columns.findByName(name);
        }
        if (this.values != null && this.values.findByName && this.values.findByName(name)) {
            return this.values.findByName(name);
        }
        if (this.filters != null && this.filters.findByName && this.filters.findByName(name)) {
            return this.filters.findByName(name);
        }
        if (this.pivotKeys && this.pivotKeys.name && this.pivotKeys.name == name) {
            return this.pivotKeys;
        }
        return null;
    };
    IgrPivotConfiguration.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrPivotConfiguration;
}());
export { IgrPivotConfiguration };
