import { PivotKeys as PivotKeys_internal } from "./PivotKeys";
/**
 * Interface describing the Pivot data keys used for data generation.
 * Can be used for custom remote scenarios where the data is pre-populated.
*/
var IgrPivotKeys = /** @class */ /*@__PURE__*/ (function () {
    function IgrPivotKeys() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrPivotKeys.prototype.createImplementation = function () {
        var impl = new PivotKeys_internal();
        if (impl.setNativeElement) {
            impl.setNativeElement({});
        }
        return impl;
    };
    Object.defineProperty(IgrPivotKeys.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotKeys.prototype.onImplementationCreated = function () {
    };
    IgrPivotKeys.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrPivotKeys.prototype, "children", {
        /**
         * Field that stores children for hierarchy building.
        */
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotKeys.prototype, "records", {
        /**
         * Field that stores reference to the original data records.
        */
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotKeys.prototype, "aggregations", {
        /**
         * Field that stores aggregation values.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotKeys.prototype, "level", {
        /**
         * Field that stores dimension level based on its hierarchy.
        */
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotKeys.prototype, "columnDimensionSeparator", {
        /**
         * Separator used when generating the unique column field values.
        */
        get: function () {
            return this.i.g;
        },
        set: function (v) {
            this.i.g = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrPivotKeys.prototype, "rowDimensionSeparator", {
        /**
         * Separator used when generating the unique row field values.
        */
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrPivotKeys.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrPivotKeys.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrPivotKeys;
}());
export { IgrPivotKeys };
