import { DataSourceSummaryOperand_$type } from "igniteui-react-core";
import { SummaryData as SummaryData_internal } from "./SummaryData";
import { ensureEnum } from "igniteui-react-core";
/**
 * Object used to store summary information for group headers.
*/
var IgrSummaryData = /** @class */ /*@__PURE__*/ (function () {
    function IgrSummaryData() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrSummaryData.prototype.createImplementation = function () {
        return new SummaryData_internal();
    };
    Object.defineProperty(IgrSummaryData.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrSummaryData.prototype.onImplementationCreated = function () {
    };
    IgrSummaryData.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrSummaryData.prototype, "summaryName", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSummaryData.prototype, "summaryValue", {
        get: function () {
            return this.i.b;
        },
        set: function (v) {
            this.i.b = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSummaryData.prototype, "summaryOperand", {
        get: function () {
            return this.i.a;
        },
        set: function (v) {
            this.i.a = ensureEnum(DataSourceSummaryOperand_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSummaryData.prototype, "formattedText", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrSummaryData.prototype, "formattedValue", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = v;
        },
        enumerable: false,
        configurable: true
    });
    IgrSummaryData.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    return IgrSummaryData;
}());
export { IgrSummaryData };
