import { TemplateSectionHeaderCellUpdatingEventArgs as TemplateSectionHeaderCellUpdatingEventArgs_internal } from "./TemplateSectionHeaderCellUpdatingEventArgs";
import { IgrDateTimeCellInfo } from "./igr-date-time-cell-info";
import { IgrImageCellInfo } from "./igr-image-cell-info";
import { IgrNumericCellInfo } from "./igr-numeric-cell-info";
import { IgrRowSeparatorInfo } from "./igr-row-separator-info";
import { IgrSectionHeaderCellInfo } from "./igr-section-header-cell-info";
import { IgrTemplateCellInfo } from "./igr-template-cell-info";
import { IgrTemplateHeaderCellInfo } from "./igr-template-header-cell-info";
import { IgrTemplateSectionHeaderCellInfo } from "./igr-template-section-header-cell-info";
import { IgrTextCellInfo } from "./igr-text-cell-info";
import { IgrTextHeaderCellInfo } from "./igr-text-header-cell-info";
/**
 * Information about the cell that has content which is being created or updated.
*/
var IgrTemplateSectionHeaderCellUpdatingEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgrTemplateSectionHeaderCellUpdatingEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    IgrTemplateSectionHeaderCellUpdatingEventArgs.prototype.createImplementation = function () {
        return new TemplateSectionHeaderCellUpdatingEventArgs_internal();
    };
    Object.defineProperty(IgrTemplateSectionHeaderCellUpdatingEventArgs.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrTemplateSectionHeaderCellUpdatingEventArgs.prototype.onImplementationCreated = function () {
    };
    IgrTemplateSectionHeaderCellUpdatingEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    };
    Object.defineProperty(IgrTemplateSectionHeaderCellUpdatingEventArgs.prototype, "content", {
        /**
         * The host in which to add or update content.
        */
        get: function () {
            return this.i.content.element.getNativeElement();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTemplateSectionHeaderCellUpdatingEventArgs.prototype, "cellInfo", {
        /**
         * The backing information for the current cell.
        */
        get: function () {
            if (this.i.cellInfo == null) {
                return null;
            }
            if (!this.i.cellInfo.externalObject) {
                var ext = null;
                switch (this.i.cellInfo.$type.name) {
                    case "DateTimeCellModel":
                        ext = new IgrDateTimeCellInfo();
                        break;
                    case "ImageCellModel":
                        ext = new IgrImageCellInfo();
                        break;
                    case "NumericCellModel":
                        ext = new IgrNumericCellInfo();
                        break;
                    case "RowSeparatorModel":
                        ext = new IgrRowSeparatorInfo();
                        break;
                    case "SectionHeaderCellModel":
                        ext = new IgrSectionHeaderCellInfo();
                        break;
                    case "TemplateCellModel":
                        ext = new IgrTemplateCellInfo();
                        break;
                    case "TemplateHeaderCellModel":
                        ext = new IgrTemplateHeaderCellInfo();
                        break;
                    case "TemplateSectionHeaderCellModel":
                        ext = new IgrTemplateSectionHeaderCellInfo();
                        break;
                    case "TextCellModel":
                        ext = new IgrTextCellInfo();
                        break;
                    case "TextHeaderCellModel":
                        ext = new IgrTextHeaderCellInfo();
                        break;
                }
                ext._implementation = this.i.cellInfo;
                this.i.cellInfo.externalObject = ext;
            }
            return this.i.cellInfo.externalObject;
        },
        enumerable: false,
        configurable: true
    });
    return IgrTemplateSectionHeaderCellUpdatingEventArgs;
}());
export { IgrTemplateSectionHeaderCellUpdatingEventArgs };
