import { __extends } from "tslib";
import { delegateCombine, delegateRemove } from "igniteui-react-core";
import { IgrTemplateSectionHeaderCellUpdatingEventArgs } from "./igr-template-section-header-cell-updating-event-args";
import { IgrSectionHeader } from "./igr-section-header";
import { TemplateSectionHeader } from "./TemplateSectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
var IgrTemplateSectionHeader = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTemplateSectionHeader, _super);
    function IgrTemplateSectionHeader(props) {
        var _this = _super.call(this, props) || this;
        _this._cellUpdating = null;
        _this._cellUpdating_wrapped = null;
        return _this;
    }
    IgrTemplateSectionHeader.prototype.createImplementation = function () {
        return new TemplateSectionHeader();
    };
    Object.defineProperty(IgrTemplateSectionHeader.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTemplateSectionHeader.prototype, "cellUpdating", {
        /**
         * Called when the cell content is being created or updated.
        */
        get: function () {
            return this._cellUpdating;
        },
        set: function (ev) {
            var _this = this;
            if (this._cellUpdating_wrapped !== null) {
                this.i.cellUpdating = delegateRemove(this.i.cellUpdating, this._cellUpdating_wrapped);
                this._cellUpdating_wrapped = null;
                this._cellUpdating = null;
            }
            this._cellUpdating = ev;
            this._cellUpdating_wrapped = function (o, e) {
                var outerArgs = new IgrTemplateSectionHeaderCellUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeCellUpdating) {
                    _this.beforeCellUpdating(_this, outerArgs);
                }
                if (_this._cellUpdating) {
                    _this._cellUpdating(_this, outerArgs);
                }
            };
            this.i.cellUpdating = delegateCombine(this.i.cellUpdating, this._cellUpdating_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    return IgrTemplateSectionHeader;
}(IgrSectionHeader));
export { IgrTemplateSectionHeader };
