import { __extends } from "tslib";
import { EditorType_$type } from "./EditorType";
import { IgrDataGridColumn } from "./igr-data-grid-column";
import { TextColumn } from "./TextColumn";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
var IgrTextColumn = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrTextColumn, _super);
    function IgrTextColumn(props) {
        return _super.call(this, props) || this;
    }
    IgrTextColumn.prototype.createImplementation = function () {
        return new TextColumn();
    };
    Object.defineProperty(IgrTextColumn.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTextColumn.prototype, "editorType", {
        /**
         * Gets or sets the editor type used for editing cells in this column.
        */
        get: function () {
            return this.i.ll;
        },
        set: function (v) {
            this.i.ll = ensureEnum(EditorType_$type, v);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTextColumn.prototype, "editorDataSource", {
        /**
         * Gets or sets the ComboBox data source.
        */
        get: function () {
            return this.i.lm;
        },
        set: function (v) {
            this.i.lm = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTextColumn.prototype, "editorTextField", {
        /**
         * Gets or sets the ComboBox text field.
        */
        get: function () {
            return this.i.lo;
        },
        set: function (v) {
            this.i.lo = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgrTextColumn.prototype, "editorValueField", {
        /**
         * Gets or sets the ComboBox value field.
        */
        get: function () {
            return this.i.lp;
        },
        set: function (v) {
            this.i.lp = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgrTextColumn;
}(IgrDataGridColumn));
export { IgrTextColumn };
