import { ValuesChangeDetail as ValuesChangeDetail_internal } from "./ValuesChangeDetail";
import { IgrPivotValue } from "./igr-pivot-value";
/**
 * Event emitted when values list is changed.
*/
var IgrValuesChangeDetail = /** @class */ /*@__PURE__*/ (function () {
    function IgrValuesChangeDetail() {
        this.mounted = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgrValuesChangeDetail.prototype.createImplementation = function () {
        return new ValuesChangeDetail_internal();
    };
    Object.defineProperty(IgrValuesChangeDetail.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrValuesChangeDetail.prototype.onImplementationCreated = function () {
    };
    IgrValuesChangeDetail.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgrValuesChangeDetail.prototype, "values", {
        /**
         * The new list of values.
        */
        get: function () {
            if (!this.i.a) {
                return undefined;
            }
            var ret = [];
            for (var i = 0; i < this.i.a.length; i++) {
                var impl = this.i.a[i];
                if (!impl.externalObject) {
                    if (impl instanceof IgrPivotValue) {
                        ret.push(impl);
                        continue;
                    }
                    var e = new IgrPivotValue();
                    e._implementation = impl;
                    impl.externalObject = e;
                }
                ret.push(impl.externalObject);
            }
            return ret;
        },
        set: function (v) {
            var arr = [];
            for (var i = 0; i < v.length; i++) {
                arr.push(v[i].i);
            }
            this.i.a = arr;
        },
        enumerable: false,
        configurable: true
    });
    IgrValuesChangeDetail.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    IgrValuesChangeDetail.prototype.setNativeElement = function (element) {
        this.i.setNativeElement(element);
    };
    return IgrValuesChangeDetail;
}());
export { IgrValuesChangeDetail };
