
import { IgcColumnComponent } from './igc-column-component';
import { IgcColumnTemplateContext } from './igc-column-template-context';
import { IgcRenderFunction } from './common';




/* blazorElement */
/* omitModule */
/* wcElementTag: igc-column-group */
/* additionalIdentifier: Children.Field */
/* jsonAPIManageCollectionInMarkup */
/* blazorIndirectRender */
/**
 * **Ignite UI for Angular Column Group**
 *
 * @igxParent IgxGridComponent, IgxTreeGridComponent, IgxHierarchicalGridComponent, IgxColumnGroupComponent, IgxRowIslandComponent
 */

    export declare class IgcColumnGroupComponent extends IgcColumnComponent
    {

          

    /* blazorInclude */
    /* contentChildren */
    /* blazorTreatAsCollection */
    /* blazorCollectionName: ColumnCollection */
    /* blazorCollectionItemName: Column */
    /* alternateType: HTMLCollection */
    public set children(value: HTMLCollection);
          public get children(): HTMLCollection;
  
          

    /**
     * Set if the column group is collapsible.
     * Default value is `false`
     * ```html
     *  <igx-column-group [collapsible] = "true"></igx-column-group>
     * ```
     *
     * @memberof IgxColumnGroupComponent
     */
    public set collapsible(value: boolean);
          public get collapsible(): boolean;
  
                
    public get expanded(): boolean;
        
          

    /**
     * Allows you to define a custom template for expand/collapse indicator
     *
     * @memberof IgxColumnGroupComponent
     */
    public set collapsibleIndicatorTemplate(value: IgcRenderFunction<IgcColumnTemplateContext>);
          public get collapsibleIndicatorTemplate(): IgcRenderFunction<IgcColumnTemplateContext>;
  
                
    /**
     * Returns a boolean indicating if the column is a `ColumnGroup`.
     * ```typescript
     * let isColumnGroup =  this.columnGroup.columnGroup
     * ```
     *
     * @memberof IgxColumnGroupComponent
     */
    public get columnGroup(): boolean;
        
                
    /**
     * Returns a boolean indicating if the column is a `ColumnLayout` for multi-row layout.
     * ```typescript
     * let columnGroup =  this.column.columnGroup;
     * ```
     *
     * @memberof IgxColumnComponent
     */
    public get columnLayout(): boolean;
        
    }


        