
import { IgcDensityChangedEventArgs } from './igc-density-changed-event-args';
import { DisplayDensity } from './display-density';
import { EventEmitterMixin, LitElement, Constructor, AbstractConstructor } from './common';




/*  blazorInclude
    blazorComponent
    blazorIndirectRender
    omitModule  */
/**
 * @hidden
 * Base class containing all logic required for implementing DisplayDensity.
 */

    export declare class IgcDisplayDensityBase extends EventEmitterMixin<IgcDisplayDensityBaseEventMap, Constructor<LitElement>>(LitElement)

    {

          

    /**
     * Returns the theme of the component.
     * The default theme is `comfortable`.
     * Available options are `comfortable`, `cosy`, `compact`.
     * ```typescript
     * let componentTheme = this.component.displayDensity;
     * ```
     */
    public set displayDensity(value: DisplayDensity);
          public get displayDensity(): DisplayDensity;
  
    }

export declare interface IgcDisplayDensityBaseEventMap {
            
        densityChanged: CustomEvent<IgcDensityChangedEventArgs>;

}
        