
import { IgcFilteringExpressionsTree } from './igc-filtering-expressions-tree';
import { SortingDirection } from './sorting-direction';
import { GridColumnDataType } from './grid-column-data-type';


/* jsonAPIPlainObject */


/* blazorElement */
/* marshalByValue */
/**
* Configuration of a pivot dimension.
*/

    export declare class IgcPivotDimension
    {

          
    /** Allows defining a hierarchy when multiple sub groups need to be extracted from single member. */
    public childLevel?: IgcPivotDimension;
  
          
    /** Field name to use in order to extract value. */
    public set memberName(value: string);
          public get memberName(): string;
  
          

    /* csTreatAsEvent: MemberFunctionHandler */
    /* blazorOnlyScript */
    /** Function that extracts the value */
    public memberFunction?: any;
  
          
    /** Enables/Disables a particular dimension from pivot structure. */
    public set enabled(value: boolean);
          public get enabled(): boolean;
  
          
    /**
     * A predefined or defined via the `igxPivotSelector` filter expression tree for the current dimension to be applied in the filter pipe.
     * */
    public filter?: IgcFilteringExpressionsTree;
  
          
    /**
     * The sorting direction of the current dimension. Determines the order in which the values will appear in the related dimension.
     */
    public sortDirection?: SortingDirection;
  
          
    /**
     * The dataType of the related data field.
     */
    public dataType?: GridColumnDataType;
  
          
    /** The width of the dimension cells to be rendered.Can be pixel or %. */
    public width?: string;
  
          
    /** Level of the dimension. */
    public level?: number;
  
    }


        