import { BaseElement } from "igniteui-react";
import { WCNativeHelper } from "igniteui-react";
import { Base, Type } from "igniteui-react-core";
import { BaseEventArgs } from "./BaseEventArgs";
import { RowExportingEventArgs } from "./RowExportingEventArgs";
import { ExporterOptionsBase } from "./ExporterOptionsBase";
import { GridCellIdentifier } from "./GridCellIdentifier";
import { GridValidationState } from "./GridValidationState";
import { SummaryResult } from "./SummaryResult";
import { GridColumnDataType } from "./GridColumnDataType";
import { FilteringOperand } from "./FilteringOperand";
import { SortingStrategy } from "./SortingStrategy";
import { SummaryTemplateContext } from "./SummaryTemplateContext";
import { ColumnPipeArgs } from "./ColumnPipeArgs";
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { ObservableCollection$1 } from "igniteui-react-core";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { DisplayDensityBase } from "./DisplayDensityBase";
import { DataCloneStrategy } from "./DataCloneStrategy";
import { ClipboardOptions } from "./ClipboardOptions";
import { ActionStripCollection } from "./ActionStripCollection";
import { GridRowEditTextTemplateContext } from "./GridRowEditTextTemplateContext";
import { GridEmptyTemplateContext } from "./GridEmptyTemplateContext";
import { GridRowEditActionsTemplateContext } from "./GridRowEditActionsTemplateContext";
import { PaginatorCollection } from "./PaginatorCollection";
import { GridResourceStrings } from "./GridResourceStrings";
import { FilteringLogic } from "./FilteringLogic";
import { GridPagingMode } from "./GridPagingMode";
import { GridValidationTrigger } from "./GridValidationTrigger";
import { PinningConfig } from "./PinningConfig";
import { FilterMode } from "./FilterMode";
import { GridSummaryPosition } from "./GridSummaryPosition";
import { GridSummaryCalculationMode } from "./GridSummaryCalculationMode";
import { SortingOptions } from "./SortingOptions";
import { HeadSelectorTemplateContext } from "./HeadSelectorTemplateContext";
import { RowSelectorTemplateContext } from "./RowSelectorTemplateContext";
import { SortingExpression } from "./SortingExpression";
import { GridSelectionMode } from "./GridSelectionMode";
import { ForOfState } from "./ForOfState";
import { OverlayOutletDirective } from "./OverlayOutletDirective";
import { StateCollection } from "./StateCollection";
import { FilteringExpressionsTreeEventArgs } from "./FilteringExpressionsTreeEventArgs";
import { GridScrollEventArgs } from "./GridScrollEventArgs";
import { RowSelectionEventArgs } from "./RowSelectionEventArgs";
import { ColumnSelectionEventArgs } from "./ColumnSelectionEventArgs";
import { SortingEventArgs } from "./SortingEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { FilteringEventArgs } from "./FilteringEventArgs";
import { RowDataEventArgs } from "./RowDataEventArgs";
import { ColumnVisibilityChangingEventArgs } from "./ColumnVisibilityChangingEventArgs";
import { ColumnVisibilityChangedEventArgs } from "./ColumnVisibilityChangedEventArgs";
import { GridKeydownEventArgs } from "./GridKeydownEventArgs";
import { GridClipboardEventEventArgs } from "./GridClipboardEventEventArgs";
import { RowToggleEventArgs } from "./RowToggleEventArgs";
import { ActiveNodeChangeEventArgs } from "./ActiveNodeChangeEventArgs";
import { GridSelectionRangeEventArgs } from "./GridSelectionRangeEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { ForOfDataChangingEventArgs } from "./ForOfDataChangingEventArgs";
import { DropPosition } from "./DropPosition";
import { FilteringExpressionsTreeOrFilteringOperation } from "./FilteringExpressionsTreeOrFilteringOperation";
import { GridSelectionRange } from "./GridSelectionRange";
import { CellPosition } from "./CellPosition";
import { OverlaySettings } from "./OverlaySettings";
import { DisplayDensityBaseElement } from "./DisplayDensityBaseElement";
import { GridToolbarContentCollection } from "./GridToolbarContentCollection";
import { ValidationStatus } from "./ValidationStatus";
import { DisplayDensity } from "./DisplayDensity";
import { SortingDirection } from "./SortingDirection";
import { TreeGridRecord } from "./TreeGridRecord";
/**
 * @hidden
 */
export declare abstract class BaseExporter extends BaseElement {
    static $t: Type;
    private d;
    protected get e(): WCNativeHelper;
    private f;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    exportEnded: (sender: any, args: BaseEventArgs) => void;
    exportEndedChanged(): void;
    rowExporting: (sender: any, args: RowExportingEventArgs) => void;
    rowExportingChanged(): void;
    columnExporting: (sender: any, args: ColumnExportingEventArgs) => void;
    columnExportingChanged(): void;
    l(a: any, b: ExporterOptionsBase): void;
    j(a: any[], b: ExporterOptionsBase): void;
    h(a: any): void;
}
/**
 * @hidden
 */
export declare class CellTemplateContext extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get f(): any;
    set f(a: any);
    get e(): any;
    set e(a: any);
    get a(): CellType;
    set a(a: CellType);
}
/**
 * @hidden
 */
export declare class CellType extends Base {
    static $t: Type;
    private g;
    protected get h(): WCNativeHelper;
    private p;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get u(): any;
    set u(a: any);
    get r(): any;
    set r(a: any);
    get m(): boolean;
    set m(a: boolean);
    get i(): boolean;
    set i(a: boolean);
    get j(): boolean;
    set j(a: boolean);
    get k(): boolean;
    set k(a: boolean);
    get b(): Column;
    set b(a: Column);
    get f(): RowType;
    set f(a: RowType);
    get c(): GridBaseDirective;
    set c(a: GridBaseDirective);
    get d(): GridCellIdentifier;
    set d(a: GridCellIdentifier);
    get q(): any;
    set q(a: any);
    get e(): GridValidationState;
    set e(a: GridValidationState);
    get l(): boolean;
    set l(a: boolean);
    get t(): any;
    set t(a: any);
    get v(): string;
    set v(a: string);
    get o(): number;
    set o(a: number);
    private static __marshalByValueIgnore;
    y(a: any): void;
    w(a: boolean): void;
    n(a: any): number;
}
/**
 * @hidden
 */
export declare class Column extends BaseElement {
    static $t: Type;
    private h;
    protected get i(): WCNativeHelper;
    private ah;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a2(): string;
    set a2(a: string);
    get a3(): string;
    set a3(a: string);
    get a9(): string;
    set a9(a: string);
    get z(): boolean;
    set z(a: boolean);
    get x(): boolean;
    set x(a: boolean);
    get p(): boolean;
    set p(a: boolean);
    get m(): boolean;
    set m(a: boolean);
    get n(): boolean;
    set n(a: boolean);
    get v(): boolean;
    set v(a: boolean);
    get j(): boolean;
    set j(a: boolean);
    get q(): boolean;
    set q(a: boolean);
    get r(): boolean;
    set r(a: boolean);
    get y(): boolean;
    set y(a: boolean);
    get k(): boolean;
    set k(a: boolean);
    get l(): boolean;
    set l(a: boolean);
    get s(): boolean;
    set s(a: boolean);
    get ba(): string;
    set ba(a: string);
    get a6(): string;
    set a6(a: string);
    get a4(): string;
    set a4(a: string);
    get am(): any;
    set am(a: any);
    get a5(): string;
    set a5(a: string);
    get al(): any;
    set al(a: any);
    get aj(): any;
    set aj(a: any);
    get ak(): any;
    set ak(a: any);
    get b(): (value: any, rowData: any) => any;
    set b(a: (value: any, rowData: any) => any);
    get g(): (summary: SummaryResult, summaryOperand: SummaryOperand) => any;
    set g(a: (summary: SummaryResult, summaryOperand: SummaryOperand) => any);
    get o(): boolean;
    set o(a: boolean);
    get aa(): boolean;
    set aa(a: boolean);
    get w(): boolean;
    set w(a: boolean);
    get e(): GridColumnDataType;
    set e(a: GridColumnDataType);
    get af(): number;
    set af(a: number);
    get ad(): number;
    set ad(a: number);
    get ag(): number;
    set ag(a: number);
    get ae(): number;
    set ae(a: number);
    get ai(): any;
    set ai(a: any);
    get a7(): string;
    set a7(a: string);
    get u(): boolean;
    set u(a: boolean);
    get ap(): any;
    set ap(a: any);
    get d(): FilteringOperand;
    set d(a: FilteringOperand);
    get f(): SortingStrategy;
    set f(a: SortingStrategy);
    private av;
    get a1(): (arg: SummaryTemplateContext) => any;
    set a1(a: (arg: SummaryTemplateContext) => any);
    private aq;
    get aw(): (arg: CellTemplateContext) => any;
    set aw(a: (arg: CellTemplateContext) => any);
    private at;
    get az(): (arg: ColumnTemplateContext) => any;
    set az(a: (arg: ColumnTemplateContext) => any);
    private au;
    get a0(): (arg: CellTemplateContext) => any;
    set a0(a: (arg: CellTemplateContext) => any);
    private ar;
    get ax(): (arg: CellTemplateContext) => any;
    set ax(a: (arg: CellTemplateContext) => any);
    private as;
    get ay(): (arg: ColumnTemplateContext) => any;
    set ay(a: (arg: ColumnTemplateContext) => any);
    get ac(): boolean;
    set ac(a: boolean);
    get c(): ColumnPipeArgs;
    set c(a: ColumnPipeArgs);
    get ao(): any;
    set ao(a: any);
    get a(): Column[];
    set a(a: Column[]);
    t(a?: number): boolean;
    ab(a?: number): boolean;
    bc(a: number): void;
    bb(a?: boolean): void;
    get a8(): string;
    set a8(a: string);
}
/**
 * @hidden
 */
export declare class ColumnComponentEventArgs extends Base {
    static $t: Type;
    a: Column;
    static b(a: any): ColumnComponentEventArgs;
}
/**
 * @hidden
 */
export declare class ColumnExportingEventArgs extends Base {
    static $t: Type;
    b: ColumnExportingEventArgsDetail;
    static a(a: any): ColumnExportingEventArgs;
}
/**
 * @hidden
 */
export declare class ColumnExportingEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get l(): string;
    set l(a: string);
    get k(): string;
    set k(a: string);
    get j(): number;
    set j(a: number);
    get h(): boolean;
    set h(a: boolean);
    get i(): boolean;
    set i(a: boolean);
    get g(): GridBaseDirective;
    set g(a: GridBaseDirective);
}
/**
 * @hidden
 */
export declare class ColumnMovingEndEventArgs extends Base {
    static $t: Type;
    b: ColumnMovingEndEventArgsDetail;
    static a(a: any): ColumnMovingEndEventArgs;
}
/**
 * @hidden
 */
export declare class ColumnMovingEndEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get g(): Column;
    set g(a: Column);
    get h(): Column;
    set h(a: Column);
    get i(): boolean;
    set i(a: boolean);
}
/**
 * @hidden
 */
export declare class ColumnMovingEventArgs extends Base {
    static $t: Type;
    b: ColumnMovingEventArgsDetail;
    static a(a: any): ColumnMovingEventArgs;
}
/**
 * @hidden
 */
export declare class ColumnMovingEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get g(): Column;
    set g(a: Column);
    get h(): boolean;
    set h(a: boolean);
}
/**
 * @hidden
 */
export declare class ColumnMovingStartEventArgs extends Base {
    static $t: Type;
    b: ColumnMovingStartEventArgsDetail;
    static a(a: any): ColumnMovingStartEventArgs;
}
/**
 * @hidden
 */
export declare class ColumnMovingStartEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get g(): Column;
    set g(a: Column);
}
/**
 * @hidden
 */
export declare class ColumnResizeEventArgs extends Base {
    static $t: Type;
    b: ColumnResizeEventArgsDetail;
    static a(a: any): ColumnResizeEventArgs;
}
/**
 * @hidden
 */
export declare class ColumnResizeEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get g(): Column;
    set g(a: Column);
    get i(): string;
    set i(a: string);
    get h(): string;
    set h(a: string);
}
/**
 * @hidden
 */
export declare class ColumnsAutoGeneratedEventArgs extends Base {
    static $t: Type;
    b: ColumnsAutoGeneratedEventArgsDetail;
    static a(a: any): ColumnsAutoGeneratedEventArgs;
}
/**
 * @hidden
 */
export declare class ColumnsAutoGeneratedEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get g(): ColumnCollection;
}
/**
 * @hidden
 */
export declare class ColumnCollection extends ObservableCollection$1<Column> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ColumnTemplateContext extends Base {
    static $t: Type;
    private c;
    protected get d(): WCNativeHelper;
    private e;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get b(): Column;
    set b(a: Column);
    get a(): Column;
    set a(a: Column);
}
/**
 * @hidden
 */
export declare class SummaryOperand extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private e;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    d(a: any[]): number;
    a(a: any[], b: any[], c: string, d: GroupByRecord): SummaryResult[];
}
/**
 * @hidden
 */
export declare class FilteringStrategy extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    a(a: any[], b: FilteringExpressionsTree, c: FilteringExpressionsTree, d: GridBaseDirective): any[];
}
/**
 * @hidden
 */
export declare abstract class GridBaseDirective extends DisplayDensityBase {
    static $t: Type;
    get cy(): number;
    set cy(a: number);
    get ce(): boolean;
    set ce(a: boolean);
    get i(): string[];
    set i(a: string[]);
    get ci(): boolean;
    set ci(a: boolean);
    private c9;
    get ds(): (arg: any) => any;
    set ds(a: (arg: any) => any);
    private c6;
    get dp(): (arg: any) => any;
    set dp(a: (arg: any) => any);
    private de;
    get dx(): (arg: any) => any;
    set dx(a: (arg: any) => any);
    get cz(): number;
    set cz(a: number);
    get al(): DataCloneStrategy;
    set al(a: DataCloneStrategy);
    get w(): ClipboardOptions;
    set w(a: ClipboardOptions);
    get c4(): any;
    set c4(a: any);
    get c5(): any;
    set c5(a: any);
    get ed(): string;
    set ed(a: string);
    get s(): ActionStripCollection;
    private c7;
    get dq(): (arg: GridRowDragGhostContext) => any;
    set dq(a: (arg: GridRowDragGhostContext) => any);
    private di;
    get d1(): (arg: GridRowEditTextTemplateContext) => any;
    set d1(a: (arg: GridRowEditTextTemplateContext) => any);
    private df;
    get dy(): (arg: GridEmptyTemplateContext) => any;
    set dy(a: (arg: GridEmptyTemplateContext) => any);
    private dh;
    get d0(): (arg: GridRowEditActionsTemplateContext) => any;
    set d0(a: (arg: GridRowEditActionsTemplateContext) => any);
    private dj;
    get d2(): (arg: GridRowTemplateContext) => any;
    set d2(a: (arg: GridRowTemplateContext) => any);
    private dg;
    get dz(): (arg: GridRowTemplateContext) => any;
    set dz(a: (arg: GridRowTemplateContext) => any);
    private dc;
    get dv(): (arg: GridTemplateContext) => any;
    set dv(a: (arg: GridTemplateContext) => any);
    private db;
    get du(): (arg: GridTemplateContext) => any;
    set du(a: (arg: GridTemplateContext) => any);
    private da;
    get dt(): (arg: GridHeaderTemplateContext) => any;
    set dt(a: (arg: GridHeaderTemplateContext) => any);
    private dl;
    get d4(): (arg: GridHeaderTemplateContext) => any;
    set d4(a: (arg: GridHeaderTemplateContext) => any);
    private dm;
    get d5(): (arg: GridHeaderTemplateContext) => any;
    set d5(a: (arg: GridHeaderTemplateContext) => any);
    private dn;
    get d6(): (arg: GridHeaderTemplateContext) => any;
    set d6(a: (arg: GridHeaderTemplateContext) => any);
    get bo(): GridToolbarCollection;
    get bt(): PaginatorCollection;
    get bf(): GridResourceStrings;
    set bf(a: GridResourceStrings);
    get as(): FilteringLogic;
    set as(a: FilteringLogic);
    get ao(): FilteringExpressionsTree;
    set ao(a: FilteringExpressionsTree);
    get an(): FilteringExpressionsTree;
    set an(a: FilteringExpressionsTree);
    get ec(): string;
    set ec(a: string);
    get be(): GridPagingMode;
    set be(a: GridPagingMode);
    get cg(): boolean;
    set cg(a: boolean);
    get ck(): boolean;
    set ck(a: boolean);
    get br(): GridValidationTrigger;
    set br(a: GridValidationTrigger);
    get cl(): boolean;
    set cl(a: boolean);
    get eb(): string;
    set eb(a: string);
    get ee(): string;
    set ee(a: string);
    get cx(): number;
    set cx(a: number);
    get d7(): string;
    set d7(a: string);
    get d9(): string;
    set d9(a: string);
    get ch(): boolean;
    set ch(a: boolean);
    get cn(): boolean;
    set cn(a: boolean);
    get d8(): string;
    set d8(a: string);
    get bw(): PinningConfig;
    set bw(a: PinningConfig);
    get cd(): boolean;
    set cd(a: boolean);
    get cc(): boolean;
    set cc(a: boolean);
    get au(): FilterMode;
    set au(a: FilterMode);
    get bn(): GridSummaryPosition;
    set bn(a: GridSummaryPosition);
    get bm(): GridSummaryCalculationMode;
    set bm(a: GridSummaryCalculationMode);
    get co(): boolean;
    set co(a: boolean);
    get at(): FilteringStrategy;
    set at(a: FilteringStrategy);
    get bl(): GridSortingStrategy;
    set bl(a: GridSortingStrategy);
    get b8(): SortingOptions;
    set b8(a: SortingOptions);
    get o(): any[];
    set o(a: any[]);
    private dd;
    get dw(): (arg: HeadSelectorTemplateContext) => any;
    set dw(a: (arg: HeadSelectorTemplateContext) => any);
    private dk;
    get d3(): (arg: RowSelectorTemplateContext) => any;
    set d3(a: (arg: RowSelectorTemplateContext) => any);
    private c8;
    get dr(): (arg: GridEmptyTemplateContext) => any;
    set dr(a: (arg: GridEmptyTemplateContext) => any);
    get p(): SortingExpression[];
    set p(a: SortingExpression[]);
    get cu(): number;
    get cv(): number;
    get cf(): boolean;
    set cf(a: boolean);
    get bh(): GridSelectionMode;
    set bh(a: GridSelectionMode);
    get bj(): GridSelectionMode;
    set bj(a: GridSelectionMode);
    get bi(): GridSelectionMode;
    set bi(a: GridSelectionMode);
    get c2(): any;
    get k(): any[];
    get aw(): ForOfState;
    get bs(): OverlayOutletDirective;
    set bs(a: OverlayOutletDirective);
    get cr(): number;
    get cq(): number;
    get ab(): ColumnCollection;
    get m(): Column[];
    get q(): Column[];
    get r(): Column[];
    get c0(): number;
    set c0(a: number);
    get j(): any[];
    get cm(): boolean;
    set cm(a: boolean);
    filteringExpressionsTreeChange: (sender: any, args: FilteringExpressionsTreeEventArgs) => void;
    filteringExpressionsTreeChangeChanged(): void;
    advancedFilteringExpressionsTreeChange: (sender: any, args: FilteringExpressionsTreeEventArgs) => void;
    advancedFilteringExpressionsTreeChangeChanged(): void;
    gridScroll: (sender: any, args: GridScrollEventArgs) => void;
    gridScrollChanged(): void;
    cellClick: (sender: any, args: GridCellEventArgs) => void;
    cellClickChanged(): void;
    formGroupCreated: (sender: any, args: GridFormGroupCreatedEventArgs) => void;
    formGroupCreatedChanged(): void;
    validationStatusChange: (sender: any, args: GridValidationStatusEventArgs) => void;
    validationStatusChangeChanged(): void;
    selected: (sender: any, args: GridCellEventArgs) => void;
    selectedChanged(): void;
    rowSelectionChanging: (sender: any, args: RowSelectionEventArgs) => void;
    rowSelectionChangingChanged(): void;
    columnSelectionChanging: (sender: any, args: ColumnSelectionEventArgs) => void;
    columnSelectionChangingChanged(): void;
    columnPin: (sender: any, args: PinColumnCancellableEventArgs) => void;
    columnPinChanged(): void;
    columnPinned: (sender: any, args: PinColumnEventArgs) => void;
    columnPinnedChanged(): void;
    cellEditEnter: (sender: any, args: GridEditEventArgs) => void;
    cellEditEnterChanged(): void;
    cellEditExit: (sender: any, args: GridEditDoneEventArgs) => void;
    cellEditExitChanged(): void;
    cellEdit: (sender: any, args: GridEditEventArgs) => void;
    cellEditChanged(): void;
    cellEditDone: (sender: any, args: GridEditDoneEventArgs) => void;
    cellEditDoneChanged(): void;
    rowEditEnter: (sender: any, args: GridEditEventArgs) => void;
    rowEditEnterChanged(): void;
    rowEdit: (sender: any, args: GridEditEventArgs) => void;
    rowEditChanged(): void;
    rowEditDone: (sender: any, args: GridEditDoneEventArgs) => void;
    rowEditDoneChanged(): void;
    rowEditExit: (sender: any, args: GridEditDoneEventArgs) => void;
    rowEditExitChanged(): void;
    columnInit: (sender: any, args: ColumnComponentEventArgs) => void;
    columnInitChanged(): void;
    columnsAutogenerated: (sender: any, args: ColumnsAutoGeneratedEventArgs) => void;
    columnsAutogeneratedChanged(): void;
    sorting: (sender: any, args: SortingEventArgs) => void;
    sortingChanged(): void;
    sortingDone: (sender: any, args: SortingExpressionEventArgs) => void;
    sortingDoneChanged(): void;
    filtering: (sender: any, args: FilteringEventArgs) => void;
    filteringChanged(): void;
    filteringDone: (sender: any, args: FilteringExpressionsTreeEventArgs) => void;
    filteringDoneChanged(): void;
    rowAdded: (sender: any, args: RowDataEventArgs) => void;
    rowAddedChanged(): void;
    rowDeleted: (sender: any, args: RowDataEventArgs) => void;
    rowDeletedChanged(): void;
    rowDelete: (sender: any, args: GridEditEventArgs) => void;
    rowDeleteChanged(): void;
    rowAdd: (sender: any, args: GridEditEventArgs) => void;
    rowAddChanged(): void;
    columnResized: (sender: any, args: ColumnResizeEventArgs) => void;
    columnResizedChanged(): void;
    contextMenu: (sender: any, args: GridCellEventArgs) => void;
    contextMenuChanged(): void;
    doubleClick: (sender: any, args: GridCellEventArgs) => void;
    doubleClickChanged(): void;
    columnVisibilityChanging: (sender: any, args: ColumnVisibilityChangingEventArgs) => void;
    columnVisibilityChangingChanged(): void;
    columnVisibilityChanged: (sender: any, args: ColumnVisibilityChangedEventArgs) => void;
    columnVisibilityChangedChanged(): void;
    columnMovingStart: (sender: any, args: ColumnMovingStartEventArgs) => void;
    columnMovingStartChanged(): void;
    columnMoving: (sender: any, args: ColumnMovingEventArgs) => void;
    columnMovingChanged(): void;
    columnMovingEnd: (sender: any, args: ColumnMovingEndEventArgs) => void;
    columnMovingEndChanged(): void;
    gridKeydown: (sender: any, args: GridKeydownEventArgs) => void;
    gridKeydownChanged(): void;
    rowDragStart: (sender: any, args: RowDragStartEventArgs) => void;
    rowDragStartChanged(): void;
    rowDragEnd: (sender: any, args: RowDragEndEventArgs) => void;
    rowDragEndChanged(): void;
    gridCopy: (sender: any, args: GridClipboardEventEventArgs) => void;
    gridCopyChanged(): void;
    rowToggle: (sender: any, args: RowToggleEventArgs) => void;
    rowToggleChanged(): void;
    rowPinning: (sender: any, args: PinRowEventArgs) => void;
    rowPinningChanged(): void;
    rowPinned: (sender: any, args: PinRowEventArgs) => void;
    rowPinnedChanged(): void;
    activeNodeChange: (sender: any, args: ActiveNodeChangeEventArgs) => void;
    activeNodeChangeChanged(): void;
    sortingExpressionsChange: (sender: any, args: SortingExpressionEventArgs) => void;
    sortingExpressionsChangeChanged(): void;
    toolbarExporting: (sender: any, args: GridToolbarExportEventArgs) => void;
    toolbarExportingChanged(): void;
    rangeSelected: (sender: any, args: GridSelectionRangeEventArgs) => void;
    rangeSelectedChanged(): void;
    rendered: (sender: any, args: VoidEventArgs) => void;
    renderedChanged(): void;
    dataChanging: (sender: any, args: ForOfDataChangingEventArgs) => void;
    dataChangingChanged(): void;
    dataChanged: (sender: any, args: VoidEventArgs) => void;
    dataChangedChanged(): void;
    fu(a: number): void;
    gr(a: ColumnVisibilityChangedEventArgs): void;
    fg(): void;
    es(): void;
    fh(a: any): void;
    et(a: any): void;
    gs(a: any): void;
    ea(a: Column): string;
    x(a: string): Column;
    y(a: number): Column;
    f0(): void;
    fw(a: Column, b: Column, c: DropPosition): void;
    fv(): void;
    c1(a: any): any;
    gu(a: any, b: any, c: string): void;
    gv(a: any, b: any): void;
    c3(a: any): any;
    gn(a: SortingExpression[]): void;
    fi(a: string, b: any, c: FilteringExpressionsTreeOrFilteringOperation, d?: boolean): void;
    fj(a: any, b: any, c: any): void;
    fe(a: any[]): void;
    fc(a: any[]): void;
    eo(a: string): void;
    eq(a: string): void;
    cj(a: string, b: any): boolean;
    cp(a: string, b: any): boolean;
    f1(): void;
    cs(a: string, b?: boolean, c?: boolean): number;
    ct(a: string, b?: boolean, c?: boolean): number;
    cw(a?: boolean, b?: boolean): number;
    ep(): void;
    fo(a?: boolean): void;
    gm(a: any[], b?: boolean): void;
    fb(a: any[]): void;
    gi(a?: boolean): void;
    e9(a?: boolean): void;
    en(): void;
    gl(a: GridSelectionRange[]): void;
    l(): GridSelectionRange[];
    fq(a?: boolean, b?: boolean): void;
    n(): Column[];
    gj(a: string[], b?: boolean): void;
    fa(a: string[]): void;
    e8(): void;
    gh(): void;
    fp(a: boolean, b?: boolean): void;
    fx(a: number, b: number, c: any): void;
    u(a: number, b: number, c: any): CellPosition;
    v(a: number, b: number, c: any): CellPosition;
    fy(a: OverlaySettings): void;
    er(a: boolean): void;
    ff(a: boolean, b: any): void;
    eh(a: any, b?: boolean): void;
    private z;
    get aa(): ColumnCollection;
    get b9(): StateCollection;
}
/**
 * @hidden
 */
export declare class GridToolbar extends DisplayDensityBaseElement {
    static $t: Type;
    get l(): boolean;
    set l(a: boolean);
    get i(): GridBaseDirective;
    set i(a: GridBaseDirective);
    get m(): string;
    set m(a: string);
    private j;
    get k(): GridToolbarContentCollection;
}
/**
 * @hidden
 */
export declare class GridToolbarCollection extends ObservableCollection$1<GridToolbar> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class GridCellEventArgs extends Base {
    static $t: Type;
    b: GridCellEventArgsDetail;
    static a(a: any): GridCellEventArgs;
}
/**
 * @hidden
 */
export declare class GridCellEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get h(): CellType;
    set h(a: CellType);
    get i(): any;
    set i(a: any);
    private static __marshalByValueIgnore;
}
/**
 * @hidden
 */
export declare class GridEditDoneEventArgs extends Base {
    static $t: Type;
    b: GridEditDoneEventArgsDetail;
    static a(a: any): GridEditDoneEventArgs;
}
/**
 * @hidden
 */
export declare class GridEditDoneEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get p(): any;
    set p(a: any);
    get n(): any;
    set n(a: any);
    get i(): GridCellIdentifier;
    set i(a: GridCellIdentifier);
    get o(): any;
    set o(a: any);
    get m(): any;
    set m(a: any);
    get l(): any;
    set l(a: any);
    get g(): Column;
    set g(a: Column);
    get h(): GridBaseDirective;
    set h(a: GridBaseDirective);
    get j(): boolean;
    set j(a: boolean);
    get k(): boolean;
    set k(a: boolean);
}
/**
 * @hidden
 */
export declare class GridEditEventArgs extends Base {
    static $t: Type;
    b: GridEditEventArgsDetail;
    static a(a: any): GridEditEventArgs;
}
/**
 * @hidden
 */
export declare class GridEditEventArgsDetail extends Base {
    static $t: Type;
    private d;
    protected get e(): WCNativeHelper;
    private i;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get f(): boolean;
    set f(a: boolean);
    get o(): any;
    set o(a: any);
    get m(): any;
    set m(a: any);
    get c(): GridCellIdentifier;
    set c(a: GridCellIdentifier);
    get n(): any;
    set n(a: any);
    get l(): any;
    set l(a: any);
    get k(): any;
    set k(a: any);
    get a(): Column;
    set a(a: Column);
    get b(): GridBaseDirective;
    set b(a: GridBaseDirective);
    get g(): boolean;
    set g(a: boolean);
    get h(): boolean;
    set h(a: boolean);
}
/**
 * @hidden
 */
export declare class GridFormGroupCreatedEventArgs extends Base {
    static $t: Type;
    b: GridFormGroupCreatedEventArgsDetail;
    static a(a: any): GridFormGroupCreatedEventArgs;
}
/**
 * @hidden
 */
export declare class GridFormGroupCreatedEventArgsDetail extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a(): GridBaseDirective;
    set a(a: GridBaseDirective);
}
/**
 * @hidden
 */
export declare class GridSortingStrategy extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    a(a: any[], b: SortingExpression[], c: GridBaseDirective): any[];
}
/**
 * @hidden
 */
export declare class GridHeaderTemplateContext extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a(): HeaderType;
    set a(a: HeaderType);
}
/**
 * @hidden
 */
export declare class GridRowDragGhostContext extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get f(): any;
    set f(a: any);
    get e(): any;
    set e(a: any);
    get a(): GridBaseDirective;
    set a(a: GridBaseDirective);
}
/**
 * @hidden
 */
export declare class GridRowTemplateContext extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a(): RowType;
    set a(a: RowType);
}
/**
 * @hidden
 */
export declare class GridTemplateContext extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private d;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a(): GridBaseDirective;
    set a(a: GridBaseDirective);
}
/**
 * @hidden
 */
export declare class GridToolbarExportEventArgs extends Base {
    static $t: Type;
    b: GridToolbarExportEventArgsDetail;
    static a(a: any): GridToolbarExportEventArgs;
}
/**
 * @hidden
 */
export declare class GridToolbarExportEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get i(): GridBaseDirective;
    set i(a: GridBaseDirective);
    get g(): BaseExporter;
    set g(a: BaseExporter);
    get h(): ExporterOptionsBase;
    set h(a: ExporterOptionsBase);
    get j(): boolean;
    set j(a: boolean);
}
/**
 * @hidden
 */
export declare class GridValidationStatusEventArgs extends Base {
    static $t: Type;
    b: GridValidationStatusEventArgsDetail;
    static a(a: any): GridValidationStatusEventArgs;
}
/**
 * @hidden
 */
export declare class GridValidationStatusEventArgsDetail extends Base {
    static $t: Type;
    private c;
    protected get d(): WCNativeHelper;
    private e;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get b(): ValidationStatus;
    set b(a: ValidationStatus);
    get a(): GridBaseDirective;
    set a(a: GridBaseDirective);
}
/**
 * @hidden
 */
export declare class GroupByRecord extends Base {
    static $t: Type;
    private f;
    protected get g(): WCNativeHelper;
    private j;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get e(): SortingExpression;
    set e(a: SortingExpression);
    get i(): number;
    set i(a: number);
    get b(): any[];
    set b(a: any[]);
    get l(): any;
    set l(a: any);
    get d(): GroupByRecord;
    set d(a: GroupByRecord);
    get a(): GroupByRecord[];
    set a(a: GroupByRecord[]);
    get h(): number;
    set h(a: number);
    get c(): Column;
    set c(a: Column);
}
/**
 * @hidden
 */
export declare class HeaderType extends Base {
    static $t: Type;
    private d;
    protected get e(): WCNativeHelper;
    private j;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a(): Column;
    set a(a: Column);
    get b(): DisplayDensity;
    set b(a: DisplayDensity);
    get h(): boolean;
    set h(a: boolean);
    get f(): boolean;
    set f(a: boolean);
    get g(): boolean;
    set g(a: boolean);
    get i(): boolean;
    set i(a: boolean);
    get c(): SortingDirection;
    set c(a: SortingDirection);
}
/**
 * @hidden
 */
export declare class PinColumnCancellableEventArgs extends Base {
    static $t: Type;
    b: PinColumnCancellableEventArgsDetail;
    static a(a: any): PinColumnCancellableEventArgs;
}
/**
 * @hidden
 */
export declare class PinColumnCancellableEventArgsDetail extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private g;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get a(): Column;
    set a(a: Column);
    get f(): number;
    set f(a: number);
    get e(): boolean;
    set e(a: boolean);
    get d(): boolean;
    set d(a: boolean);
}
/**
 * @hidden
 */
export declare class PinColumnEventArgs extends Base {
    static $t: Type;
    b: PinColumnEventArgsDetail;
    static a(a: any): PinColumnEventArgs;
}
/**
 * @hidden
 */
export declare class PinColumnEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get g(): Column;
    set g(a: Column);
    get i(): number;
    set i(a: number);
    get h(): boolean;
    set h(a: boolean);
}
/**
 * @hidden
 */
export declare class PinRowEventArgs extends Base {
    static $t: Type;
    b: PinRowEventArgsDetail;
    static a(a: any): PinRowEventArgs;
}
/**
 * @hidden
 */
export declare class PinRowEventArgsDetail extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private g;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get j(): any;
    set j(a: any);
    get a(): RowType;
    set a(a: RowType);
    get f(): number;
    set f(a: number);
    get e(): boolean;
    set e(a: boolean);
    get i(): any;
    set i(a: any);
    get d(): boolean;
    set d(a: boolean);
}
/**
 * @hidden
 */
export declare class RowDragEndEventArgs extends Base {
    static $t: Type;
    b: RowDragEndEventArgsDetail;
    static a(a: any): RowDragEndEventArgs;
}
/**
 * @hidden
 */
export declare class RowDragEndEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get i(): any;
    set i(a: any);
    get g(): RowType;
    set g(a: RowType);
    get h(): boolean;
    set h(a: boolean);
}
/**
 * @hidden
 */
export declare class RowDragStartEventArgs extends Base {
    static $t: Type;
    b: RowDragStartEventArgsDetail;
    static a(a: any): RowDragStartEventArgs;
}
/**
 * @hidden
 */
export declare class RowDragStartEventArgsDetail extends Base {
    static $t: Type;
    private b;
    protected get c(): WCNativeHelper;
    private e;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get f(): any;
    set f(a: any);
    get a(): RowType;
    set a(a: RowType);
    get d(): boolean;
    set d(a: boolean);
    get h(): any;
    set h(a: any);
}
/**
 * @hidden
 */
export declare class RowType extends Base {
    static $t: Type;
    private h;
    protected get i(): WCNativeHelper;
    private w;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get u(): number;
    set u(a: number);
    get v(): number;
    set v(a: number);
    get q(): boolean;
    set q(a: boolean);
    get r(): boolean;
    set r(a: boolean);
    get e(): GroupByRecord;
    set e(a: GroupByRecord);
    get z(): any;
    set z(a: any);
    get d(): GridValidationState;
    set d(a: GridValidationState);
    get x(): any;
    set x(a: any);
    get a(): CellType[];
    set a(a: CellType[]);
    get l(): boolean;
    set l(a: boolean);
    get s(): boolean;
    set s(a: boolean);
    get t(): boolean;
    set t(a: boolean);
    get m(): boolean;
    set m(a: boolean);
    get k(): boolean;
    set k(a: boolean);
    get p(): boolean;
    set p(a: boolean);
    get b(): RowType[];
    set b(a: RowType[]);
    get f(): RowType;
    set f(a: RowType);
    get o(): boolean;
    set o(a: boolean);
    get g(): TreeGridRecord;
    set g(a: TreeGridRecord);
    get j(): boolean;
    set j(a: boolean);
    get n(): boolean;
    set n(a: boolean);
    get c(): GridBaseDirective;
    set c(a: GridBaseDirective);
    af(a: any): void;
    y(): any;
    ac(): void;
    ae(): void;
    get ab(): string;
}
