import { Type } from "igniteui-react-core";
/**
 * Enumerates the options for how cell property animates are applied.
 */
export declare enum CellPropertyAnimationType {
    /**
     * The property is animated as a double value.
     */
    DoubleValue = 0,
    /**
     * The property is animated as a number value.
     */
    NumberValue = 1,
    /**
     * The property is animated as a brush value.
     */
    BrushValue = 2,
    /**
     * The property is animated as a font value.
     */
    FontValue = 3,
    /**
     * The property is animated as a enum value.
     */
    EnumValue = 4,
    /**
     * The property is animated as a bool value.
     */
    BoolValue = 5,
    /**
     * The property is animated as an int value.
     */
    IntValue = 6,
    /**
     * The property is animated as a date value.
     */
    DateValue = 7,
    /**
     * The propety is animated as a string value.
     */
    StringValue = 8,
    /**
     * The property is animated as an object value.
     */
    ObjectValue = 9,
    /**
     * The property value is ignored and not propagated to live cells.
     */
    IgnoredValue = 10,
    /**
     * The property value is not animated.
     */
    None = 11
}
/**
 * @hidden
 */
export declare let CellPropertyAnimationType_$type: Type;
