import { Type } from "igniteui-react-core";
/**
 * Enumerates the options for how column exchanging is animated.
 */
export declare enum ColumnExchangingAnimationMode {
    /**
     * The correct animation mode is automatically selected.
     */
    Auto = 0,
    /**
     * No animation is performed.
     */
    None = 1,
    /**
     * The cells slide to the left.
     */
    SlideToLeft = 2,
    /**
     * The cells slide to the right.
     */
    SlideToRight = 3,
    /**
     * The cells slide to the top.
     */
    SlideToTop = 4,
    /**
     * The cells slide to the bottom.
     */
    SlideToBottom = 5,
    /**
     * The cells crossfade.
     */
    Crossfade = 6,
    /**
     * The cells slide to the left and crossfade.
     */
    SlideToLeftAndCrossfade = 7,
    /**
     * The cells slide to the right and crossfade.
     */
    SlideToRightAndCrossfade = 8,
    /**
     * The cells slide to the top and crossfade.
     */
    SlideToTopAndCrossfade = 9,
    /**
     * The cells slide to the bottom and crossfade.
     */
    SlideToBottomAndCrossfade = 10
}
/**
 * @hidden
 */
export declare let ColumnExchangingAnimationMode_$type: Type;
