import { Base, Type, Point, PropertyChangedEventArgs, INotifyPropertyChanged, IList$1, EventArgs, Nullable$1 } from "igniteui-react-core";
import { IFilterExpression } from "igniteui-react-core";
import { DataSourceSchemaPropertyType } from "igniteui-react-core";
import { ColumnComparisonConditionOperatorType } from "./ColumnComparisonConditionOperatorType";
import { List$1 } from "igniteui-react-core";
import { FilterFactory } from "igniteui-react-core";
import { ObservableCollection$1 } from "igniteui-react-core";
import { DomRenderer } from "igniteui-react-core";
import { IDataSource } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { ScrollbarStyle } from "igniteui-react-core";
import { MouseButton } from "igniteui-react-core";
import { RowPath } from "./RowPath";
import { IDragger } from "./IDragger";
import { GridCellPosition } from "./GridCellPosition";
import { EditModeType } from "./EditModeType";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { GridViewportChangedEventArgs } from "./GridViewportChangedEventArgs";
import { ICellModelExportUpdater } from "./ICellModelExportUpdater";
import { XButton } from "igniteui-react-inputs";
import { FontInfo } from "igniteui-react-core";
import { BrushAppearanceData } from "igniteui-react-core";
import { ModelStates } from "./ModelStates";
import { CellPath } from "./CellPath";
import { Rect } from "igniteui-react-core";
import { ModelTypes } from "./ModelTypes";
import { CellContentHorizontalAlignment } from "./CellContentHorizontalAlignment";
import { CellContentVerticalAlignment } from "./CellContentVerticalAlignment";
import { TextCellLineBreakMode } from "./TextCellLineBreakMode";
import { ColumnSortDirection } from "./ColumnSortDirection";
import { PinnedPositions } from "./PinnedPositions";
import { Dictionary$2 } from "igniteui-react-core";
import { CellModelExport } from "./CellModelExport";
import { DataSourceRowType } from "igniteui-react-core";
import { GroupSummaryDisplayMode } from "./GroupSummaryDisplayMode";
import { BindingFormatter } from "igniteui-react-core";
import { DateTimeFormats } from "./DateTimeFormats";
import { DateTimeColumnValueFormatter } from "./DateTimeColumnValueFormatter";
import { EditorType } from "./EditorType";
import { ImageStretchOptions } from "./ImageStretchOptions";
import { ImageResourceType } from "./ImageResourceType";
import { GroupData } from "./GroupData";
import { SummaryData } from "./SummaryData";
import { DataSourceSummaryOperand } from "igniteui-react-core";
import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { ColumnOptionsIconAlignment } from "./ColumnOptionsIconAlignment";
import { ColumnOptionsIconBehavior } from "./ColumnOptionsIconBehavior";
import { INativeCell } from "./INativeCell";
import { IExecutionContext } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { SummaryScope } from "./SummaryScope";
import { GroupHeaderDisplayMode } from "./GroupHeaderDisplayMode";
import { PageChangedEventArgs } from "./PageChangedEventArgs";
import { ColumnSummaryDescriptionCollection } from "./ColumnSummaryDescriptionCollection";
import { FilterExpressionCollection } from "igniteui-react-core";
import { GridFilterExpressionsEventArgs } from "./GridFilterExpressionsEventArgs";
import { GridSortDescriptionsChangedEventArgs } from "./GridSortDescriptionsChangedEventArgs";
import { GridGroupDescriptionsChangedEventArgs } from "./GridGroupDescriptionsChangedEventArgs";
import { GridSummaryDescriptionsChangedEventArgs } from "./GridSummaryDescriptionsChangedEventArgs";
import { IDataSourceUpdateNotifier } from "igniteui-react-core";
import { ColumnSortDescriptionCollection } from "./ColumnSortDescriptionCollection";
import { ColumnGroupDescription } from "./ColumnGroupDescription";
import { ColumnGroupDescriptionCollection } from "./ColumnGroupDescriptionCollection";
import { ColumnSummaryDescription } from "./ColumnSummaryDescription";
import { ISummaryResult } from "igniteui-react-core";
import { PagerVisualModelExport } from "./PagerVisualModelExport";
import { DataSourceLocalDataProvider } from "igniteui-react-core";
import { IDataSourceSchema } from "igniteui-react-core";
import { HashSet$1 } from "igniteui-react-core";
import { DefinitionPropertyUpdatedEventArgs } from "./DefinitionPropertyUpdatedEventArgs";
import { CellPropertyAnimationType } from "./CellPropertyAnimationType";
import { IPropertySetter } from "./IPropertySetter";
import { DragSelectEventArgs } from "./DragSelectEventArgs";
import { IColumnGrouping } from "./IColumnGrouping";
import { IDataGridComponent } from "./IDataGridComponent";
import { ColumnResizingMode } from "./ColumnResizingMode";
import { ColumnMovingMode } from "./ColumnMovingMode";
import { Thickness } from "igniteui-react-core";
import { IDelayedExecutionManager } from "./IDelayedExecutionManager";
import { ITickProvider } from "igniteui-react-core";
import { IViewportManager } from "./IViewportManager";
import { ColumnWidth } from "./ColumnWidth";
import { HeaderClickAction } from "./HeaderClickAction";
import { EditModeClickAction } from "./EditModeClickAction";
import { ColumnShowingAnimationMode } from "./ColumnShowingAnimationMode";
import { ColumnPropertyUpdatingAnimationMode } from "./ColumnPropertyUpdatingAnimationMode";
import { CellDataLoadedAnimationMode } from "./CellDataLoadedAnimationMode";
import { RowSelectionAnimationMode } from "./RowSelectionAnimationMode";
import { RowHoverAnimationMode } from "./RowHoverAnimationMode";
import { CellSelectionAnimationMode } from "./CellSelectionAnimationMode";
import { GridColumnAnimationSettings } from "./GridColumnAnimationSettings";
import { GridAnimationSettings } from "./GridAnimationSettings";
import { ColumnResizingAnimationMode } from "./ColumnResizingAnimationMode";
import { ColumnMovingAnimationMode } from "./ColumnMovingAnimationMode";
import { ColumnHidingAnimationMode } from "./ColumnHidingAnimationMode";
import { ColumnExchangingAnimationMode } from "./ColumnExchangingAnimationMode";
import { DataGridSelectionMode } from "./DataGridSelectionMode";
import { GridActivationMode } from "./GridActivationMode";
import { GridSelectionBehavior } from "./GridSelectionBehavior";
import { GridSelectedItemsCollection } from "./GridSelectedItemsCollection";
import { GridSelectedKeysCollection } from "./GridSelectedKeysCollection";
import { GridSelectedCellRangesCollection } from "./GridSelectedCellRangesCollection";
import { CornerRadius } from "igniteui-react-core";
import { IPlatformPixelConverter } from "./IPlatformPixelConverter";
import { IEditableDataSource } from "igniteui-react-core";
import { EnterKeyBehaviors } from "./EnterKeyBehaviors";
import { EnterKeyBehaviorAfterEdit } from "./EnterKeyBehaviorAfterEdit";
import { MergedCellMode } from "./MergedCellMode";
import { MergedCellEvaluationCriteria } from "./MergedCellEvaluationCriteria";
import { FilterUIType } from "./FilterUIType";
import { FilterLogicalOperator } from "./FilterLogicalOperator";
import { FilterComparisonType } from "./FilterComparisonType";
import { CellRange } from "./CellRange";
import { PrimaryKeyValue } from "./PrimaryKeyValue";
import { FastIterationDictionary$2 } from "igniteui-react-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-react-core";
import { GridSelectedItemsChangedEventArgs } from "./GridSelectedItemsChangedEventArgs";
import { GridSelectedKeysChangedEventArgs } from "./GridSelectedKeysChangedEventArgs";
import { GridSelectedCellRangesChangedEventArgs } from "./GridSelectedCellRangesChangedEventArgs";
import { GridDataCommittedEventArgs } from "./GridDataCommittedEventArgs";
import { GridDataCommittingEventArgs } from "./GridDataCommittingEventArgs";
import { GridSizeChangedEventArgs } from "./GridSizeChangedEventArgs";
import { ColumnStates } from "./ColumnStates";
import { IColumnGroupingVisualModelExport } from "./IColumnGroupingVisualModelExport";
import { IToolbarVisualModelExport } from "./IToolbarVisualModelExport";
import { VisualModelExport } from "./VisualModelExport";
import { GridActiveCellChangedEventArgs } from "./GridActiveCellChangedEventArgs";
import { GridSelectionChangedEventArgs } from "./GridSelectionChangedEventArgs";
import { GridRowEditStartedEventArgs } from "./GridRowEditStartedEventArgs";
import { GridRowEditEndedEventArgs } from "./GridRowEditEndedEventArgs";
import { Key } from "igniteui-react-core";
import { JsonDictionaryItem } from "igniteui-react-core";
import { GridCellType } from "./GridCellType";
import { GridAnimationPhaseSettings } from "./GridAnimationPhaseSettings";
import { GridAnimationManagerAnimationCreatedEventArgs } from "./GridAnimationManagerAnimationCreatedEventArgs";
import { GridAnimationManagerAnimationCompletedEventArgs } from "./GridAnimationManagerAnimationCompletedEventArgs";
import { GridAnimationManagerAnimationCanceledEventArgs } from "./GridAnimationManagerAnimationCanceledEventArgs";
import { GridColumnSpacer } from "./GridColumnSpacer";
import { GridColumnSpacerCollection } from "./GridColumnSpacerCollection";
import { GridEffectMainIntent } from "./GridEffectMainIntent";
import { FixedCellPositions } from "./FixedCellPositions";
import { GridEffectSubIntent } from "./GridEffectSubIntent";
import { CellStyleRequestedEventArgs } from "./CellStyleRequestedEventArgs";
import { LayoutAction } from "./LayoutAction";
import { JsonWriter } from "igniteui-react-core";
import { CalculationParameters } from "./CalculationParameters";
import { ColumnPropertySettersCollection } from "./ColumnPropertySettersCollection";
import { ColumnPropertySetter } from "./ColumnPropertySetter";
import { ResponsiveStateEnteringEventArgs } from "./ResponsiveStateEnteringEventArgs";
import { ResponsiveStateEnteredEventArgs } from "./ResponsiveStateEnteredEventArgs";
import { ResponsiveStateExitedEventArgs } from "./ResponsiveStateExitedEventArgs";
/**
 * @hidden
 */
export declare abstract class ColumnFilterCondition extends Base {
    static $t: Type;
    b: DataGridColumn;
    isGroup(): boolean;
    resolveFilter(a: string, b: DataSourceSchemaPropertyType): IFilterExpression;
}
/**
 * @hidden
 */
export declare class ColumnComparisonFilterCondition extends ColumnFilterCondition {
    static $t: Type;
    constructor();
    static getApplicableOperators(a: DataSourceSchemaPropertyType): ColumnComparisonConditionOperatorType[];
    equals(a: any): boolean;
    private _operator;
    get operator(): ColumnComparisonConditionOperatorType;
    set operator(a: ColumnComparisonConditionOperatorType);
    private _value;
    get value(): any;
    set value(a: any);
    private _isCaseSensitive;
    get isCaseSensitive(): boolean;
    set isCaseSensitive(a: boolean);
    resolveFilter(a: string, b: DataSourceSchemaPropertyType): IFilterExpression;
    private h;
    private static g;
    static getOperandNumber(a: ColumnComparisonConditionOperatorType): number;
    static getOperandNumbers(a: ColumnComparisonConditionOperatorType[]): number[];
    private k;
}
/**
 * @hidden
 */
export declare class ColumnCustomFilterCondition extends ColumnFilterCondition {
    static $t: Type;
    private _value;
    get value(): any;
    set value(a: any);
    private _id;
    get id(): string;
    set id(a: string);
    private _index;
    get index(): number;
    set index(a: number);
    resolveFilter(a: string, b: DataSourceSchemaPropertyType): IFilterExpression;
}
/**
 * @hidden
 */
export declare class ColumnFilterConditionCollection extends ObservableCollection$1<ColumnFilterCondition> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ColumnFilterConditionGroup extends ColumnFilterCondition {
    static $t: Type;
    isGroup(): boolean;
    constructor();
    equals(a: any): boolean;
    get count(): number;
    private _usesOrOperator;
    get usesOrOperator(): boolean;
    set usesOrOperator(a: boolean);
    private f;
    add(a: ColumnFilterCondition): void;
    remove(a: ColumnFilterCondition): void;
    removeAt(a: number): void;
    item(a: number, b?: ColumnFilterCondition): ColumnFilterCondition;
    clear(): void;
    toArray(): ColumnFilterCondition[];
    resolveFilter(a: string, b: DataSourceSchemaPropertyType): IFilterExpression;
}
/**
 * @hidden
 */
export interface IExternalGrid {
    readonly renderer: DomRenderer;
    insertExternalColumnAtIndex(a: number, b: any): void;
    removeExternalColumn(a: any): void;
    ensureColumnsAreManual(): void;
    onContentSizeChanged(): void;
    createLocalDataSource(a: any): IDataSource;
    createTextColumn(a: string): TextColumn;
    createNumericColumn(a: string): NumericColumn;
    createDateTimeColumn(a: string): DateTimeColumn;
    createImageColumn(a: string): ImageColumn;
    createTemplateColumn(a: string): TemplateColumn;
    createComboBoxColumn(a: string): ComboBoxColumn;
    focusScroller(): void;
    setHandCursor(): void;
    setResizeCursor(): void;
    setDefaultCursor(): void;
    setBorder(a: Brush, b: number, c: number, d: number, e: number, f: number, g: number, h: number, i: number): void;
    setScrollerVerticalTrackInset(a: number): void;
    setScrollbarStyle(a: ScrollbarStyle): void;
    setScrollbarColor(a: Brush): void;
    setClipboardText(a: string): void;
}
/**
 * @hidden
 */
export declare let IExternalGrid_$type: Type;
/**
 * @hidden
 */
export interface ICellActionManager {
    clickExpansionIndicator(): void;
    clickCell(a: MouseButton): void;
    dragStarted(): void;
    previewPointerDownCell(): void;
    previewPointerUpCell(): void;
    pointerDownCell(): void;
    pointerUpCell(): void;
    previewMouseDownCell(a: boolean, b: boolean, c: MouseButton): void;
    previewMouseUpCell(a: boolean, b: boolean, c: MouseButton): void;
    mouseDownCell(a: number, b: number): void;
    mouseUpCell(a: number, b: number): void;
    mouseLeaveCell(a: number, b: number): void;
    mouseEnterCell(a: number, b: number): void;
    mouseIsOver(a: number, b: number): void;
    doubleClicked(a: MouseButton): void;
    readonly isLeaveActionDesired: boolean;
    readonly isEnterActionDesired: boolean;
    readonly isClickActionDesired: boolean;
    readonly isHoverActionDesired: boolean;
    readonly isPreviewPointerDownActionDesired: boolean;
    readonly isPreviewPointerUpActionDesired: boolean;
    readonly isPointerDownActionDesired: boolean;
    readonly isPointerUpActionDesired: boolean;
    isControlPressed: boolean;
    isShiftPressed: boolean;
    readonly isDrag: boolean;
    readonly isMouseDown: boolean;
    readonly mousePosition: Point;
    isCellDown(): boolean;
    readonly isGridDragging: boolean;
    readonly isEditRefocusDesired: boolean;
    getColumnFilterCondition(): ColumnFilterCondition;
    getColumnPropertyType(): DataSourceSchemaPropertyType;
    columnFilterChanging(a: ColumnFilterCondition): void;
    columnFilterChanged(a: ColumnFilterCondition): void;
    updateCellEditValue(a: any): void;
    startEditMode(): void;
    editorCellLostFocus(): void;
    cancelEditMode(a: boolean): void;
    disableKeyInput(): void;
    enableKeyInput(): void;
    passCellClone(a: any): void;
    applyFilter(a: ColumnComparisonConditionOperatorType, b: any): void;
    applyCustomFilter(a: string, b: number, c: any): void;
    clearFilter(): void;
}
/**
 * @hidden
 */
export declare let ICellActionManager_$type: Type;
/**
 * @hidden
 */
export declare class DefaultCellActionManager extends Base implements ICellActionManager {
    static $t: Type;
    private b;
    private a;
    private c;
    private d;
    constructor(a: DataGrid, b: CellModel);
    clickExpansionIndicator(): void;
    clickCell(a: MouseButton): void;
    dragStarted(): void;
    previewPointerDownCell(): void;
    previewPointerUpCell(): void;
    pointerDownCell(): void;
    pointerUpCell(): void;
    previewMouseDownCell(a: boolean, b: boolean, c: MouseButton): void;
    previewMouseUpCell(a: boolean, b: boolean, c: MouseButton): void;
    mouseDownCell(a: number, b: number): void;
    mouseUpCell(a: number, b: number): void;
    mouseLeaveCell(a: number, b: number): void;
    mouseEnterCell(a: number, b: number): void;
    mouseIsOver(a: number, b: number): void;
    doubleClicked(a: MouseButton): void;
    getColumnFilterCondition(): ColumnFilterCondition;
    getColumnPropertyType(): DataSourceSchemaPropertyType;
    columnFilterChanging(a: ColumnFilterCondition): void;
    columnFilterChanged(a: ColumnFilterCondition): void;
    isCellDown(): boolean;
    get isLeaveActionDesired(): boolean;
    get isEnterActionDesired(): boolean;
    get isClickActionDesired(): boolean;
    get isHoverActionDesired(): boolean;
    get isPreviewPointerDownActionDesired(): boolean;
    get isPreviewPointerUpActionDesired(): boolean;
    get isPointerDownActionDesired(): boolean;
    get isPointerUpActionDesired(): boolean;
    get isControlPressed(): boolean;
    set isControlPressed(a: boolean);
    get isShiftPressed(): boolean;
    set isShiftPressed(a: boolean);
    get isDrag(): boolean;
    get isMouseDown(): boolean;
    get mousePosition(): Point;
    get isGridDragging(): boolean;
    get isEditRefocusDesired(): boolean;
    updateCellEditValue(a: any): void;
    startEditMode(): void;
    editorCellLostFocus(): void;
    cancelEditMode(a: boolean): void;
    disableKeyInput(): void;
    enableKeyInput(): void;
    passCellClone(a: any): void;
    applyFilter(a: ColumnComparisonConditionOperatorType, b: any): void;
    applyCustomFilter(a: string, b: number, c: any): void;
    clearFilter(): void;
}
/**
 * @hidden
 */
export interface IGridInfoRequestor {
    getColumn(): DataGridColumn;
    getDensity(): ControlDisplayDensity;
    getTheme(): BaseControlTheme;
    setViewportChangedHandler(a: (sender: any, e: GridViewportChangedEventArgs) => void): void;
    removeViewportChangedHandler(a: (sender: any, e: GridViewportChangedEventArgs) => void): void;
}
/**
 * @hidden
 */
export declare let IGridInfoRequestor_$type: Type;
/**
 * @hidden
 */
export declare class DefaultGridInfoRequestor extends Base implements IGridInfoRequestor {
    static $t: Type;
    private b;
    private a;
    constructor(a: DataGrid, b: CellModel);
    getColumn(): DataGridColumn;
    getDensity(): ControlDisplayDensity;
    getTheme(): BaseControlTheme;
    setViewportChangedHandler(a: (sender: any, e: GridViewportChangedEventArgs) => void): void;
    removeViewportChangedHandler(a: (sender: any, e: GridViewportChangedEventArgs) => void): void;
}
/**
 * @hidden
 */
export declare class DefaultCellModelExportUpdater extends Base implements ICellModelExportUpdater {
    static $t: Type;
    private a;
    constructor(a: CellModel);
    update(a: string, b: any): void;
}
/**
 * @hidden
 */
export declare class PagerView extends Base {
    static $t: Type;
    c: Pager;
    constructor(a: Pager);
    m: DomRenderer;
    private n;
    private d;
    private g;
    private f;
    private e;
    u(a: any): void;
    private h;
    private q;
    private t;
    private s;
    private r;
    v(): void;
    p(): void;
    a(): BrushAppearanceData;
    b(): BrushAppearanceData;
    o(): string;
    i(): XButton;
    l(): XButton;
    k(): XButton;
    j(): XButton;
}
/**
 * @hidden
 */
export declare abstract class CellModel extends Base {
    static $t: Type;
    private o;
    get p(): DataGrid;
    set p(a: DataGrid);
    constructor();
    private static dc;
    private static db;
    private static bo;
    static fb(a: string): number;
    s: ICellPresenter;
    static gn: number;
    private t;
    get u(): ModelStates;
    set u(a: ModelStates);
    jm: string;
    private k;
    static f9: number;
    get l(): CellPath;
    set l(a: CellPath);
    private ah;
    static ev: number;
    get au(): boolean;
    set au(a: boolean);
    et: number;
    be: boolean;
    bj: boolean;
    ay: boolean;
    aw: boolean;
    bc: boolean;
    bk: boolean;
    a0: boolean;
    bd: boolean;
    c: ICellActionManager;
    e: IGridInfoRequestor;
    d: ICellModelExportUpdater;
    private lh;
    static er: number;
    get li(): Rect;
    set li(a: Rect);
    static readonly fp: number;
    private ao;
    get a8(): boolean;
    set a8(a: boolean);
    private ar;
    static fr: number;
    get bf(): boolean;
    set bf(a: boolean);
    private as;
    static fs: number;
    get bg(): boolean;
    set bg(a: boolean);
    private aq;
    static fq: number;
    get bb(): boolean;
    set bb(a: boolean);
    private am;
    static fo: number;
    get a6(): boolean;
    set a6(a: boolean);
    private da;
    static fj: number;
    get fi(): number;
    set fi(a: number);
    private bl;
    az(a: string): boolean;
    a3(propertyId_: number): boolean;
    a2(a: string): boolean;
    private c3;
    private a;
    j0(propertyId_: number): void;
    jx(): void;
    j1(a: string): void;
    protected j8(a: string, b: number, c: any, d: any): void;
    protected kb(a: string, b: any, c: any): void;
    private j9;
    private j3;
    private j4;
    private j5;
    private j6;
    private ka;
    private j7;
    private k8;
    kd(): void;
    protected ke(): void;
    private bn;
    kg(a: string, b: any): void;
    av(a: string): boolean;
    kc(a: string): void;
    g1(a: string): any;
    private q;
    get r(): GridLayer;
    set r(a: GridLayer);
    static ge: number;
    private g0;
    get g4(): any;
    set g4(a: any);
    static readonly gw: number;
    private b5;
    get cl(): number;
    set cl(a: number);
    static readonly gx: number;
    private b6;
    get cm(): number;
    set cm(a: number);
    static readonly gi: number;
    private dh;
    get gh(): number;
    set gh(a: number);
    static readonly gk: number;
    private di;
    get gj(): number;
    set gj(a: number);
    static readonly ez: number;
    private bv;
    get cb(): number;
    set cb(a: number);
    static readonly es: number;
    private bu;
    get ca(): number;
    set ca(a: number);
    static readonly d5: number;
    private bs;
    get b8(): number;
    set b8(a: number);
    static readonly fz: number;
    private bz;
    get cf(): number;
    set cf(a: number);
    static readonly d7: number;
    private bt;
    get b9(): number;
    set b9(a: number);
    static readonly fv: number;
    j2(): void;
    private bx;
    get cd(): number;
    set cd(a: number);
    static readonly gq: number;
    private b2;
    get ci(): number;
    set ci(a: number);
    static readonly fw: number;
    private by;
    get ce(): number;
    set ce(a: number);
    static readonly gr: number;
    private b3;
    get cj(): number;
    set cj(a: number);
    static readonly fd: number;
    private c9;
    get fc(): number;
    set fc(a: number);
    static readonly gv: number;
    private dj;
    get gu(): number;
    set gu(a: number);
    static readonly ft: number;
    private at;
    get bi(): boolean;
    set bi(a: boolean);
    static readonly fy: number;
    private v;
    get w(): ModelTypes;
    set w(a: ModelTypes);
    static readonly gg: number;
    private b1;
    get ch(): number;
    set ch(a: number);
    static readonly du: number;
    private br;
    get b7(): number;
    set b7(a: number);
    static readonly fg: number;
    private bw;
    get cc(): number;
    set cc(a: number);
    private ap;
    get a9(): boolean;
    set a9(a: boolean);
    static readonly fe: number;
    private f;
    get g(): CellContentHorizontalAlignment;
    set g(a: CellContentHorizontalAlignment);
    static readonly gs: number;
    private h;
    get i(): CellContentVerticalAlignment;
    set i(a: CellContentVerticalAlignment);
    static readonly eh: number;
    private km;
    get k3(): Brush;
    set k3(a: Brush);
    static readonly em: number;
    private kn;
    get k4(): Brush;
    set k4(a: Brush);
    static readonly dv: number;
    private kj;
    get k0(): Brush;
    set k0(a: Brush);
    static readonly d0: number;
    private kk;
    get k1(): Brush;
    set k1(a: Brush);
    static readonly dp: number;
    private ki;
    get kz(): Brush;
    set kz(a: Brush);
    static readonly e4: number;
    private kp;
    get k6(): Brush;
    set k6(a: Brush);
    static readonly gf: number;
    private kv;
    get ld(): Brush;
    set ld(a: Brush);
    static readonly ff: number;
    private kr;
    get k9(): Brush;
    set k9(a: Brush);
    static readonly fh: number;
    private ks;
    get la(): Brush;
    set la(a: Brush);
    static readonly gm: number;
    private kw;
    get le(): Brush;
    set le(a: Brush);
    static readonly go: number;
    private kx;
    get lf(): Brush;
    set lf(a: Brush);
    static readonly gb: number;
    private ku;
    get lc(): Brush;
    set lc(a: Brush);
    private kt;
    static readonly fu: number;
    get lb(): Brush;
    set lb(a: Brush);
    private kq;
    static readonly e9: number;
    get k7(): Brush;
    set k7(a: Brush);
    static readonly gc: number;
    private b0;
    get cg(): number;
    set cg(a: number);
    static readonly f0: number;
    private gz;
    get g3(): any;
    set g3(a: any);
    static readonly gd: number;
    private g6;
    get jb(): string;
    set jb(a: string);
    static readonly gp: number;
    private ky;
    get lg(): Brush;
    set lg(a: Brush);
    static readonly eg: number;
    private kl;
    get k2(): Brush;
    set k2(a: Brush);
    static readonly eu: number;
    private ko;
    get k5(): Brush;
    set k5(a: Brush);
    static readonly fa: number;
    private ad;
    get ag(): FontInfo;
    set ag(a: FontInfo);
    static readonly d6: number;
    private ab;
    get ae(): FontInfo;
    set ae(a: FontInfo);
    static readonly fx: number;
    private z;
    get aa(): TextCellLineBreakMode;
    set aa(a: TextCellLineBreakMode);
    static readonly gt: number;
    private b4;
    get ck(): number;
    set ck(a: number);
    static readonly f4: number;
    private de;
    get f3(): number;
    set f3(a: number);
    static readonly f8: number;
    private dg;
    get f7(): number;
    set f7(a: number);
    static readonly f6: number;
    private df;
    get f5(): number;
    set f5(a: number);
    static readonly f2: number;
    private dd;
    get f1(): number;
    set f1(a: number);
    static readonly eb: number;
    private cw;
    get ea(): number;
    set ea(a: number);
    static readonly ef: number;
    private cy;
    get ee(): number;
    set ee(a: number);
    static readonly ed: number;
    private cx;
    get ec(): number;
    set ec(a: number);
    static readonly d9: number;
    private cv;
    get d8(): number;
    set d8(a: number);
    static readonly el: number;
    private c0;
    get ek(): number;
    set ek(a: number);
    static readonly eq: number;
    private c2;
    get ep(): number;
    set ep(a: number);
    static readonly eo: number;
    private c1;
    get en(): number;
    set en(a: number);
    static readonly ej: number;
    private cz;
    get ei(): number;
    set ei(a: number);
    static readonly dn: number;
    private co;
    get dm(): number;
    set dm(a: number);
    static readonly dt: number;
    private cq;
    get ds(): number;
    set ds(a: number);
    static readonly dr: number;
    private cp;
    get dq(): number;
    set dq(a: number);
    static readonly dl: number;
    private cn;
    get dk(): number;
    set dk(a: number);
    static readonly e3: number;
    private c6;
    get e2(): number;
    set e2(a: number);
    static readonly e8: number;
    private c8;
    get e7(): number;
    set e7(a: number);
    static readonly e6: number;
    private c7;
    get e5(): number;
    set e5(a: number);
    static readonly e1: number;
    private c5;
    get e0(): number;
    set e0(a: number);
    static readonly dz: number;
    private cs;
    get dy(): number;
    set dy(a: number);
    static readonly d4: number;
    private cu;
    get d3(): number;
    set d3(a: number);
    static readonly d2: number;
    private ct;
    get d1(): number;
    set d1(a: number);
    static readonly dx: number;
    private cr;
    get dw(): number;
    set dw(a: number);
    static readonly gl: number;
    private m;
    get n(): ColumnSortDirection;
    set n(a: ColumnSortDirection);
    static readonly fn: number;
    private al;
    get a5(): boolean;
    set a5(a: boolean);
    static readonly fk: number;
    private ai;
    get ax(): boolean;
    set ax(a: boolean);
    static readonly ga: number;
    private x;
    get y(): PinnedPositions;
    set y(a: PinnedPositions);
    static readonly ex: number;
    private ac;
    get af(): FontInfo;
    set af(a: FontInfo);
    static readonly fm: number;
    private ak;
    get a4(): boolean;
    set a4(a: boolean);
    static readonly fl: number;
    private aj;
    get a1(): boolean;
    set a1(a: boolean);
    static readonly ew: number;
    private g5;
    get h2(): string;
    set h2(a: string);
    ba: boolean;
    private c4;
    get ey(): number;
    set ey(a: number);
    private an;
    get a7(): boolean;
    set a7(a: boolean);
    gy: number;
    jv(): void;
    protected jw(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    b(a: CellModelExport): CellModelExport;
    private static bp;
    protected jz(): void;
    private static bm;
    protected jy(): void;
    kh(a: string, b: any): void;
    g2(a: string): any;
    kf(a: string, b: any): void;
    cellReconciling: (model: CellModel) => void;
    bh(a: DataSourceRowType): boolean;
    id(): string;
}
/**
 * @hidden
 */
export declare class DateTimeCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly lv: number;
    private ls;
    get lt(): Date;
    set lt(a: Date);
    static readonly ly: number;
    private l4;
    get ma(): string;
    set ma(a: string);
    static readonly lx: number;
    private lj;
    get lk(): any[];
    set lk(a: any[]);
    ll: BindingFormatter;
    private l2;
    static readonly lw: number;
    private _formatOverride;
    get l3(): any;
    set l3(a: any);
    static readonly lu: number;
    private lo;
    get lp(): DateTimeFormats;
    set lp(a: DateTimeFormats);
    l7(a: Date): string;
    id(): string;
    static readonly lz: number;
    private lm;
    get ln(): DateTimeColumnValueFormatter;
    set ln(a: DateTimeColumnValueFormatter);
    static readonly l0: number;
    private lq;
    get lr(): boolean;
    set lr(a: boolean);
    protected kb(a: string, b: any, c: any): void;
    kh(a: string, b: any): void;
    g2(a: string): any;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class EditorCellModel extends CellModel {
    static $t: Type;
    constructor();
    private ly;
    private lx;
    private ls;
    static l8: number;
    get lv(): boolean;
    private ln;
    static l5: number;
    get lo(): CellModel;
    set lo(a: CellModel);
    private ll;
    static lz: number;
    get lm(): DataSourceSchemaPropertyType;
    set lm(a: DataSourceSchemaPropertyType);
    private mh;
    static l6: number;
    get mr(): string;
    set mr(a: string);
    me: any;
    private lp;
    static l3: number;
    get lq(): EditorType;
    set lq(a: EditorType);
    private mc;
    static l1: number;
    get md(): any;
    set md(a: any);
    private mg;
    static l2: number;
    get mm(): string;
    set mm(a: string);
    private lj;
    static l4: number;
    get lk(): string[];
    set lk(a: string[]);
    static l7: number;
    private lr;
    get lu(): boolean;
    set lu(a: boolean);
    static l0: number;
    private mf;
    get mj(): string;
    set mj(a: string);
    static readonly l9: number;
    private lt;
    get lw(): boolean;
    set lw(a: boolean);
    get mb(): number;
    get ma(): number;
    protected ke(): void;
    protected kb(a: string, b: any, c: any): void;
    kh(a: string, b: any): void;
    g2(a: string): any;
    b(a: CellModelExport): CellModelExport;
    private mw;
}
/**
 * @hidden
 */
export declare class FilterCellModel extends CellModel {
    static $t: Type;
    static readonly l1: number;
    private ln;
    get lo(): DataSourceSchemaPropertyType;
    set lo(a: DataSourceSchemaPropertyType);
    static readonly l4: number;
    private ll;
    get lm(): ColumnFilterCondition;
    set lm(a: ColumnFilterCondition);
    static readonly l2: number;
    private lp;
    get lq(): IFilterExpression;
    set lq(a: IFilterExpression);
    static readonly l3: number;
    private lr;
    get ls(): GridFilterOperandsCollection;
    set ls(a: GridFilterOperandsCollection);
    static l5: number;
    private lt;
    get lu(): boolean;
    set lu(a: boolean);
    private lj;
    get lk(): ColumnComparisonConditionOperatorType;
    set lk(a: ColumnComparisonConditionOperatorType);
    l6: any;
    l0: number;
    lz: number;
    ly: number;
    lx: number;
    lw: number;
    lv: number;
    constructor();
    kh(a: string, b: any): void;
    g2(a: string): any;
    kf(a: string, b: any): void;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class EditorRowCellModel extends CellModel {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class SummaryCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly ll: number;
    private lp;
    get lr(): string;
    set lr(a: string);
    static readonly lm: number;
    private lq;
    get lt(): string;
    set lt(a: string);
    static readonly lo: number;
    private lx;
    get ly(): Brush;
    set ly(a: Brush);
    static readonly ln: number;
    private lj;
    get lk(): FontInfo;
    set lk(a: FontInfo);
    b(a: CellModelExport): CellModelExport;
    bh(a: DataSourceRowType): boolean;
}
/**
 * @hidden
 */
export declare class VerticalSeparatorCellModel extends CellModel {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ImageCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly ln: number;
    private lq;
    get lr(): string;
    set lr(a: string);
    static readonly lp: number;
    private ll;
    get lm(): ImageStretchOptions;
    set lm(a: ImageStretchOptions);
    static readonly lo: number;
    private lj;
    get lk(): ImageResourceType;
    set lk(a: ImageResourceType);
    b(a: CellModelExport): CellModelExport;
    kh(a: string, b: any): void;
    g2(a: string): any;
}
/**
 * @hidden
 */
export declare class NumericCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly l8: number;
    private lr;
    get ls(): number;
    set ls(a: number);
    static readonly lz: number;
    private lm;
    get lo(): boolean;
    set lo(a: boolean);
    static readonly ly: number;
    private mf;
    get mm(): string;
    set mm(a: string);
    static readonly lx: number;
    private lj;
    get lk(): any[];
    set lk(a: any[]);
    ll: BindingFormatter;
    private md;
    static readonly lw: number;
    private _formatOverride;
    get me(): any;
    set me(a: any);
    static readonly l6: number;
    private mg;
    get ms(): string;
    set ms(a: string);
    static readonly l9: number;
    private mi;
    get mx(): string;
    set mx(a: string);
    static readonly l7: number;
    private mh;
    get mu(): string;
    set mu(a: string);
    static readonly ma: number;
    private mj;
    get mz(): string;
    set mz(a: string);
    static readonly l1: number;
    private lt;
    get l0(): number;
    set l0(a: number);
    static readonly l3: number;
    private lu;
    get l2(): number;
    set l2(a: number);
    static readonly l5: number;
    private lv;
    get l4(): number;
    set l4(a: number);
    static readonly mb: number;
    private ln;
    get lq(): boolean;
    set lq(a: boolean);
    lp(): boolean;
    protected kb(a: string, b: any, c: any): void;
    kh(a: string, b: any): void;
    g2(a: string): any;
    b(a: CellModelExport): CellModelExport;
    id(): string;
}
/**
 * @hidden
 */
export declare class RowSeparatorModel extends CellModel {
    static $t: Type;
    constructor();
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class SectionHeaderCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly lp: number;
    private lj;
    get ll(): GroupData[];
    set ll(a: GroupData[]);
    static readonly ls: number;
    private lk;
    get lm(): SummaryData[];
    set lm(a: SummaryData[]);
    static readonly lr: number;
    private lv;
    get lz(): string;
    set lz(a: string);
    static readonly lq: number;
    private lu;
    get lx(): string;
    set lx(a: string);
    static readonly lt: number;
    private ln;
    get lo(): GroupSummaryDisplayMode;
    set lo(a: GroupSummaryDisplayMode);
    kh(a: string, b: any): void;
    g2(a: string): any;
    b(a: CellModelExport): CellModelExport;
    bh(a: DataSourceRowType): boolean;
}
/**
 * @hidden
 */
export declare class TemplateCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly lj: number;
    private lk;
    get ll(): any;
    set ll(a: any);
    kh(a: string, b: any): void;
    g2(a: string): any;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export declare class TextCellModel extends CellModel {
    static $t: Type;
    constructor();
    static readonly lj: number;
    private lk;
    get ll(): string;
    set ll(a: string);
    kh(a: string, b: any): void;
    g2(a: string): any;
    b(a: CellModelExport): CellModelExport;
    id(): string;
}
/**
 * @hidden
 */
export declare class TextHeaderCellModel extends TextCellModel {
    static $t: Type;
    constructor();
    static readonly ly: number;
    private lt;
    get lu(): boolean;
    set lu(a: boolean);
    static readonly lz: number;
    private lr;
    get ls(): SortIndicatorStyle;
    set ls(a: SortIndicatorStyle);
    static readonly lv: number;
    private ln;
    get lo(): ColumnOptionsIconAlignment;
    set lo(a: ColumnOptionsIconAlignment);
    static readonly lx: number;
    private l5;
    get l6(): Brush;
    set l6(a: Brush);
    static readonly lw: number;
    private lp;
    get lq(): ColumnOptionsIconBehavior;
    set lq(a: ColumnOptionsIconBehavior);
    kh(a: string, b: any): void;
    g2(a: string): any;
    b(a: CellModelExport): CellModelExport;
}
/**
 * @hidden
 */
export interface ICellPresenter {
    modelUpdated(a: CellModel): void;
    readonly isCanvasBased: boolean;
    readonly nativeCell: INativeCell;
}
/**
 * @hidden
 */
export declare let ICellPresenter_$type: Type;
/**
 * @hidden
 */
export declare class Pager extends Base implements INotifyPropertyChanged {
    static $t: Type;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected bu(a: string, b: any, c: any): void;
    protected bz(a: string, b: any, c: any): void;
    private br;
    static readonly a1: string;
    static readonly bd: string;
    static readonly a7: string;
    static readonly a6: string;
    protected n: PagerView;
    private _executionContext;
    get executionContext(): IExecutionContext;
    set executionContext(a: IExecutionContext);
    ac: ObservableCollection$1<any>;
    private d;
    private t;
    protected get u(): SRProvider;
    private au;
    get a9(): string;
    set a9(a: string);
    private g;
    get targetGrid(): DataGrid;
    set targetGrid(a: DataGrid);
    private b;
    get actualDataSource(): IDataSource;
    set actualDataSource(a: IDataSource);
    private ah;
    get ao(): number;
    set ao(a: number);
    private ag;
    get an(): number;
    set an(a: number);
    private ar;
    get itemsSource(): any;
    set itemsSource(a: any);
    private ad;
    get ak(): number;
    set ak(a: number);
    private r;
    get s(): FontInfo;
    set s(a: FontInfo);
    private b8;
    get ca(): Brush;
    set ca(a: Brush);
    private b9;
    get border(): Brush;
    set border(a: Brush);
    private k;
    private get l();
    private set l(value);
    private o;
    private get p();
    private set p(value);
    private i;
    private get j();
    private set j(value);
    private ai;
    private get ap();
    private set ap(value);
    private af;
    private get am();
    private set am(value);
    private ae;
    private get al();
    private set al(value);
    private aj;
    private get aq();
    private set aq(value);
    pageChanged: (sender: any, args: PageChangedEventArgs) => void;
    private bo;
    private aa;
    private v;
    private w;
    private ab;
    private z;
    constructor();
    private b2;
    b1(): void;
    private bl;
    private bt;
    private bj;
    private b7;
    private b6;
    b5(): void;
    bn(): void;
    by(): void;
    bk(): void;
    bm(): void;
    provideContainer(a: any): void;
    private bx;
    private y;
    private bq;
    private x;
    private bp;
    private bv;
    private bs;
    private f;
    private bw;
    private b4;
    b3(): void;
    a(a: IDataSource, b: any[]): ISummaryResult[][];
    as(): any;
    az(): string;
    e(): PagerVisualModelExport;
}
/**
 * @hidden
 */
export declare class PagerDataSourceNotificationBridge extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private a;
    constructor(a: Pager);
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
    notifySetItem(a: number, b: any, c: any): void;
    rangeActualized(a: number, b: number): void;
}
/**
 * @hidden
 */
export declare class PagerGridDataSourceNotificationBridge extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private b;
    private a;
    constructor(a: Pager, b: DataGrid);
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
    notifySetItem(a: number, b: any, c: any): void;
    rangeActualized(a: number, b: number): void;
}
/**
 * @hidden
 */
export declare class PagedDataProvider extends DataSourceLocalDataProvider {
    static $t: Type;
    private at;
    constructor(a: Pager);
    getItemValue(a: any, b: string): any;
}
/**
 * @hidden
 */
export declare class DataSourceNotificationBridge extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private a;
    constructor(a: DataGrid);
    rangeActualized(a: number, b: number): void;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
}
/**
 * @hidden
 */
export declare class ColumnController extends Base {
    static $t: Type;
    private i;
    private n;
    private c;
    private a;
    get p(): boolean;
    set p(a: boolean);
    get d(): IDataSourceSchema;
    set d(a: IDataSourceSchema);
    private v;
    get b(): string[];
    set b(a: string[]);
    get j(): GridColumnCollection;
    protected get o(): boolean;
    protected set o(a: boolean);
    private m;
    k: IExternalGrid;
    u(): boolean;
    private l;
    private q;
    private e;
    private t;
    constructor(a: GridColumnCollection, b: boolean, c: () => void);
    h(a: CellPath): DataGridColumn;
    f(a: number): DataGridColumn;
    g(a: string): DataGridColumn;
    r(a: DataGridColumn): boolean;
    s(a: DataGridColumn): boolean;
}
/**
 * @hidden
 */
export declare class EditingManager extends Base {
    static $t: Type;
    private g;
    private d;
    private n;
    private e;
    private a;
    private c;
    r: number;
    q: number;
    u: any;
    j: boolean;
    s: any;
    get o(): number;
    set o(a: number);
    get b(): CellModel;
    get p(): number;
    l: boolean;
    t: any;
    k: boolean;
    constructor(a: DataGrid, b: EditorDefinition);
    private y;
    ad(a: CellModel): void;
    ab(a: CellModel): void;
    v(): void;
    i(a: boolean, b: boolean): boolean;
    w(): void;
    aa(a: string): void;
    ac(a: CellModel): void;
    x(): void;
    private z;
    h(a: DataGridColumn, b: number): GridLayer;
    f(a: DataGridColumn): EditorType;
    m(a: CellModel): boolean;
}
/**
 * @hidden
 */
export declare class DataGrid extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private oi;
    get externalObject(): any;
    set externalObject(a: any);
    private _propertySetter;
    get propertySetter(): IPropertySetter;
    set propertySetter(a: IPropertySetter);
    private fb;
    get externalGrid(): IExternalGrid;
    set externalGrid(a: IExternalGrid);
    private e9;
    get dragger(): IDragger;
    set dragger(a: IDragger);
    private e3;
    get columnGrouping(): IColumnGrouping;
    set columnGrouping(a: IColumnGrouping);
    private _pager;
    get pager(): Pager;
    set pager(a: Pager);
    private _toolbar;
    get toolbar(): IDataGridComponent;
    set toolbar(a: IDataGridComponent);
    columnExchangingAnimationCompleted: (sender: any, e: EventArgs) => void;
    columnExchangingAnimationCanceled: (sender: any, e: EventArgs) => void;
    vq(a: DataGridColumn): void;
    vp(a: DataGridColumn): void;
    columnShowingAnimationCompleted: (sender: any, e: EventArgs) => void;
    columnShowingAnimationCanceled: (sender: any, e: EventArgs) => void;
    o(a: CellModel): ColumnFilterCondition;
    p(a: CellModel): DataSourceSchemaPropertyType;
    v0(a: DataGridColumn): void;
    filterExpressionsChanging: (sender: any, args: GridFilterExpressionsEventArgs) => void;
    filterExpressionsChanged: (sender: any, args: GridFilterExpressionsEventArgs) => void;
    t5(a: CellModel, b: ColumnFilterCondition): void;
    t4(a: CellModel, b: ColumnFilterCondition): void;
    vz(a: DataGridColumn): void;
    columnMovingAnimationCompleted: (sender: any, e: EventArgs) => void;
    columnMovingAnimationCanceled: (sender: any, e: EventArgs) => void;
    vw(a: DataGridColumn): void;
    vv(a: DataGridColumn): void;
    columnHidingAnimationCompleted: (sender: any, e: EventArgs) => void;
    columnHidingAnimationCanceled: (sender: any, e: EventArgs) => void;
    vs(a: DataGridColumn): void;
    vr(a: DataGridColumn): void;
    cellPreviewPointerDown: (sender: any, args: DataGridCellEventArgs) => void;
    vk(a: CellModel): void;
    cellPreviewPointerUp: (sender: any, args: DataGridCellEventArgs) => void;
    vl(a: CellModel): void;
    cellPointerDown: (sender: any, args: DataGridCellEventArgs) => void;
    vi(a: CellModel): void;
    cellPointerUp: (sender: any, args: DataGridCellEventArgs) => void;
    vj(a: CellModel): void;
    wr(a: number, b: string): void;
    cellClicked: (sender: any, args: DataGridCellEventArgs) => void;
    wf(a: CellModel): void;
    yg(a: number): void;
    private mu;
    we(a: EditorCellModel): void;
    vb(a: CellModel, b: MouseButton): void;
    u9(a: CellModel, b: boolean, c: boolean, d: MouseButton): void;
    private xa;
    private by;
    get columnResizingMode(): ColumnResizingMode;
    set columnResizingMode(a: ColumnResizingMode);
    private bk;
    get columnMovingMode(): ColumnMovingMode;
    set columnMovingMode(a: ColumnMovingMode);
    e0: HoverManager;
    private h4;
    get isRowHoverEnabled(): boolean;
    set isRowHoverEnabled(a: boolean);
    private y9;
    get rowHoverBackground(): Brush;
    set rowHoverBackground(a: Brush);
    private za;
    get rowHoverTextColor(): Brush;
    set rowHoverTextColor(a: Brush);
    private y1;
    get editRowBorder(): Brush;
    set editRowBorder(a: Brush);
    private aax;
    get editRowBorderWidth(): Thickness;
    set editRowBorderWidth(a: Thickness);
    aar: Point;
    ay: CellPath;
    av: CellPath;
    private ht;
    vg(a: CellModel, b: number, c: number): void;
    vh(a: CellModel, b: number, c: number): void;
    vf(a: CellModel, b: number, c: number): void;
    wk(a: CellModel, b: boolean, c: boolean, d: MouseButton): void;
    wl(a: CellModel, b: boolean, c: boolean, d: MouseButton): void;
    private jb;
    private my;
    private get n7();
    private set n7(value);
    ve(a: CellModel, b: number, c: number): void;
    wj(a: CellModel, b: number, c: number): void;
    private m6;
    private ia;
    private h9;
    private hi;
    private l1;
    private l8;
    private l6;
    private l7;
    private ln;
    private lw;
    private lx;
    private ly;
    private lz;
    private az;
    private nc;
    private nb;
    private iq;
    t0(): void;
    wd(a: CellPath, b: number, c: number, d: boolean): void;
    v9(a: any, b: DragSelectEventArgs): void;
    v7(a: any, b: DragSelectEventArgs): void;
    private m2;
    get n9(): number;
    set n9(a: number);
    private nd;
    private fm;
    private v8;
    private au;
    private aq;
    private ar;
    private ls;
    private l5;
    private l2;
    private l3;
    private wa;
    private wb;
    private xx;
    private wc;
    private lj;
    private lk;
    private x2;
    private aat;
    private ap;
    getHitCell(a: number, b: number): CellModel;
    private a1;
    private i0;
    private uc;
    private yl;
    constructor();
    xo(a: ColumnGroupDescription): void;
    xp(a: ColumnSummaryDescription): void;
    private x9;
    private uk;
    private j1;
    private uh;
    private x7;
    private yf;
    private cc;
    private it;
    private x0;
    private x1;
    private iv;
    private xz;
    private xy;
    private is;
    private w6;
    private w7;
    private db;
    get dc(): GridAnimationManager;
    set dc(a: GridAnimationManager);
    private _delayedExecutionManager;
    get delayedExecutionManager(): IDelayedExecutionManager;
    set delayedExecutionManager(a: IDelayedExecutionManager);
    private fn;
    get fo(): ResponsiveEngine;
    private e5;
    get e6(): IDataAdapter;
    set e6(a: IDataAdapter);
    private a4;
    get a5(): ColumnController;
    set a5(a: ColumnController);
    private d7;
    get d8(): GridLayerController;
    set d8(a: GridLayerController);
    private f9;
    get ga(): SpatialEngine;
    set ga(a: SpatialEngine);
    private d2;
    get d3(): GridEffectManager;
    set d3(a: GridEffectManager);
    private f3;
    get f4(): SelectionManager;
    set f4(a: SelectionManager);
    private aj;
    get ak(): ActivationManager;
    set ak(a: ActivationManager);
    private f7;
    get f8(): SortManager;
    set f8(a: SortManager);
    cq: EditingManager;
    private g7;
    get tickProvider(): ITickProvider;
    set tickProvider(a: ITickProvider);
    private f1;
    get sectionHeader(): SectionHeader;
    set sectionHeader(a: SectionHeader);
    private fz;
    get f0(): SectionFooter;
    set f0(a: SectionFooter);
    private gb;
    get summaryRowRoot(): SummaryRowRoot;
    set summaryRowRoot(a: SummaryRowRoot);
    private gd;
    get summaryRowSection(): SummaryRowSection;
    set summaryRowSection(a: SummaryRowSection);
    private fw;
    get rowSeparator(): RowSeparator;
    set rowSeparator(a: RowSeparator);
    private ew;
    get headerRowSeparator(): HeaderRowSeparator;
    set headerRowSeparator(a: HeaderRowSeparator);
    private ey;
    get headerSeparator(): HeaderSeparator;
    set headerSeparator(a: HeaderSeparator);
    private b0;
    get columnResizingSeparator(): ColumnResizingSeparator;
    set columnResizingSeparator(a: ColumnResizingSeparator);
    private bm;
    get columnMovingSeparator(): ColumnMovingSeparator;
    set columnMovingSeparator(a: ColumnMovingSeparator);
    private fk;
    get pinnedAreaSeparator(): PinnedAreaSeparator;
    set pinnedAreaSeparator(a: PinnedAreaSeparator);
    private cv;
    private cw;
    private c5;
    private b;
    get autoGenerateDesiredProperties(): string[];
    set autoGenerateDesiredProperties(a: string[]);
    private c;
    get dataSourceDesiredProperties(): string[];
    set dataSourceDesiredProperties(a: string[]);
    private gh;
    get gi(): VisibilityEngine;
    set gi(a: VisibilityEngine);
    private _viewportManager;
    get viewportManager(): IViewportManager;
    set viewportManager(a: IViewportManager);
    private lr;
    get ma(): number;
    set ma(a: number);
    private lq;
    get l9(): number;
    set l9(a: number);
    private gn;
    get density(): ControlDisplayDensity;
    set density(a: ControlDisplayDensity);
    private mq;
    get actualRowHeight(): number;
    set actualRowHeight(a: number);
    private m3;
    get rowHeight(): number;
    set rowHeight(a: number);
    private ch;
    get defaultColumnWidth(): ColumnWidth;
    set defaultColumnWidth(a: ColumnWidth);
    private lv;
    get defaultColumnMinWidth(): number;
    set defaultColumnMinWidth(a: number);
    private mp;
    get actualHeaderHeight(): number;
    set actualHeaderHeight(a: number);
    private mv;
    get headerHeight(): number;
    set headerHeight(a: number);
    private m8;
    get sectionHeaderHeight(): number;
    set sectionHeaderHeight(a: number);
    private oj;
    get itemsSource(): any;
    set itemsSource(a: any);
    private m7;
    get sectionFooterHeight(): number;
    set sectionFooterHeight(a: number);
    private m5;
    get rowSpacingHeight(): number;
    set rowSpacingHeight(a: number);
    private mt;
    get columnSpacingWidth(): number;
    set columnSpacingWidth(a: number);
    private eu;
    get headerClickAction(): HeaderClickAction;
    set headerClickAction(a: HeaderClickAction);
    private ct;
    get editMode(): EditModeType;
    set editMode(a: EditModeType);
    private cr;
    get editModeClickAction(): EditModeClickAction;
    set editModeClickAction(a: EditModeClickAction);
    private hj;
    get editOnKeyPress(): boolean;
    set editOnKeyPress(a: boolean);
    private hf;
    get autoGenerateColumns(): boolean;
    set autoGenerateColumns(a: boolean);
    private m4;
    get rowSeparatorHeight(): number;
    set rowSeparatorHeight(a: number);
    private h3;
    get isPlaceholderRenderingEnabled(): boolean;
    set isPlaceholderRenderingEnabled(a: boolean);
    private ji;
    private b6;
    private b2;
    get columnAddingAnimationMode(): ColumnShowingAnimationMode;
    set columnAddingAnimationMode(a: ColumnShowingAnimationMode);
    get jq(): boolean;
    private bt;
    get columnPropertyUpdatingAnimationMode(): ColumnPropertyUpdatingAnimationMode;
    set columnPropertyUpdatingAnimationMode(a: ColumnPropertyUpdatingAnimationMode);
    protected get jj(): boolean;
    get jf(): boolean;
    private an;
    get cellDataLoadedAnimationMode(): CellDataLoadedAnimationMode;
    set cellDataLoadedAnimationMode(a: CellDataLoadedAnimationMode);
    get kb(): boolean;
    private fu;
    get rowSelectionAnimationMode(): RowSelectionAnimationMode;
    set rowSelectionAnimationMode(a: RowSelectionAnimationMode);
    get j9(): boolean;
    private fr;
    get rowHoverAnimationMode(): RowHoverAnimationMode;
    set rowHoverAnimationMode(a: RowHoverAnimationMode);
    get jg(): boolean;
    private a2;
    get cellSelectionAnimationMode(): CellSelectionAnimationMode;
    set cellSelectionAnimationMode(a: CellSelectionAnimationMode);
    private dr;
    get columnAnimationSettings(): GridColumnAnimationSettings;
    set columnAnimationSettings(a: GridColumnAnimationSettings);
    private dd;
    get animationSettings(): GridAnimationSettings;
    set animationSettings(a: GridAnimationSettings);
    jr(a: DataGridColumn): boolean;
    private bx;
    private bv;
    get columnResizingAnimationMode(): ColumnResizingAnimationMode;
    set columnResizingAnimationMode(a: ColumnResizingAnimationMode);
    private js;
    private b7;
    private b3;
    get columnShowingAnimationMode(): ColumnShowingAnimationMode;
    set columnShowingAnimationMode(a: ColumnShowingAnimationMode);
    private jm;
    private bj;
    private bh;
    get columnMovingAnimationMode(): ColumnMovingAnimationMode;
    set columnMovingAnimationMode(a: ColumnMovingAnimationMode);
    private jl;
    private bg;
    private be;
    get columnHidingAnimationMode(): ColumnHidingAnimationMode;
    set columnHidingAnimationMode(a: ColumnHidingAnimationMode);
    private jk;
    private a8;
    private a6;
    get columnExchangingAnimationMode(): ColumnExchangingAnimationMode;
    set columnExchangingAnimationMode(a: ColumnExchangingAnimationMode);
    private aay;
    get inset(): Thickness;
    set inset(a: Thickness);
    private cn;
    get selectionMode(): DataGridSelectionMode;
    set selectionMode(a: DataGridSelectionMode);
    private c8;
    get activationMode(): GridActivationMode;
    set activationMode(a: GridActivationMode);
    private ej;
    get selectionBehavior(): GridSelectionBehavior;
    set selectionBehavior(a: GridSelectionBehavior);
    private h8;
    get mouseDragSelectionEnabled(): boolean;
    set mouseDragSelectionEnabled(a: boolean);
    private hn;
    get jd(): boolean;
    set jd(a: boolean);
    private ac;
    get selectedItems(): GridSelectedItemsCollection;
    private ag;
    get selectedKeys(): GridSelectedKeysCollection;
    private ef;
    get selectedCells(): GridSelectedCellsCollection;
    private ec;
    get selectedCellRanges(): GridSelectedCellRangesCollection;
    private hm;
    get jc(): boolean;
    set jc(a: boolean);
    private ab;
    get pinnedItems(): GridSelectedItemsCollection;
    private af;
    get pinnedKeys(): GridSelectedKeysCollection;
    private yb;
    private hq;
    get isColumnOptionsEnabled(): boolean;
    set isColumnOptionsEnabled(a: boolean);
    private hu;
    get isGroupByAreaVisible(): boolean;
    set isGroupByAreaVisible(a: boolean);
    private hz;
    get isGroupRowSticky(): boolean;
    set isGroupRowSticky(a: boolean);
    private h0;
    get isHeaderSeparatorVisible(): boolean;
    set isHeaderSeparatorVisible(a: boolean);
    private yv;
    get cellSelectedBackground(): Brush;
    set cellSelectedBackground(a: Brush);
    private zh;
    get sectionHeaderSelectedBackground(): Brush;
    set sectionHeaderSelectedBackground(a: Brush);
    private zk;
    get summaryRootBackground(): Brush;
    set summaryRootBackground(a: Brush);
    private zo;
    get summarySectionBackground(): Brush;
    set summarySectionBackground(a: Brush);
    private l4;
    get pinnedRowOpacity(): number;
    set pinnedRowOpacity(a: number);
    private gq;
    get editTextStyle(): FontInfo;
    set editTextStyle(a: FontInfo);
    private l0;
    get editOpacity(): number;
    set editOpacity(a: number);
    private y0;
    get deletedTextColor(): Brush;
    set deletedTextColor(a: Brush);
    private zj;
    get stickyRowBackground(): Brush;
    set stickyRowBackground(a: Brush);
    private y8;
    get pinnedRowBackground(): Brush;
    set pinnedRowBackground(a: Brush);
    private y7;
    get lastStickyRowBackground(): Brush;
    set lastStickyRowBackground(a: Brush);
    private dn;
    private dm;
    get activeCell(): GridCellPosition;
    set activeCell(a: GridCellPosition);
    private yu;
    get cellBackground(): Brush;
    set cellBackground(a: Brush);
    private yw;
    get cellTextColor(): Brush;
    set cellTextColor(a: Brush);
    private y5;
    get headerSortIndicatorColor(): Brush;
    set headerSortIndicatorColor(a: Brush);
    private f5;
    get headerSortIndicatorStyle(): SortIndicatorStyle;
    set headerSortIndicatorStyle(a: SortIndicatorStyle);
    private gp;
    get cellTextStyle(): FontInfo;
    set cellTextStyle(a: FontInfo);
    private zg;
    get sectionHeaderBackground(): Brush;
    set sectionHeaderBackground(a: Brush);
    private zi;
    get sectionHeaderTextColor(): Brush;
    set sectionHeaderTextColor(a: Brush);
    private gs;
    get sectionHeaderTextStyle(): FontInfo;
    set sectionHeaderTextStyle(a: FontInfo);
    private gt;
    get summaryRootLabelTextStyle(): FontInfo;
    set summaryRootLabelTextStyle(a: FontInfo);
    private gv;
    get summarySectionLabelTextStyle(): FontInfo;
    set summarySectionLabelTextStyle(a: FontInfo);
    private zn;
    get summaryRootValueTextColor(): Brush;
    set summaryRootValueTextColor(a: Brush);
    private gu;
    get summaryRootValueTextStyle(): FontInfo;
    set summaryRootValueTextStyle(a: FontInfo);
    private gw;
    get summarySectionValueTextStyle(): FontInfo;
    set summarySectionValueTextStyle(a: FontInfo);
    private zr;
    get summarySectionValueTextColor(): Brush;
    set summarySectionValueTextColor(a: Brush);
    private zl;
    get summaryRootLabelTextColor(): Brush;
    set summaryRootLabelTextColor(a: Brush);
    private zp;
    get summarySectionLabelTextColor(): Brush;
    set summarySectionLabelTextColor(a: Brush);
    private zm;
    get summaryRootSelectedBackground(): Brush;
    set summaryRootSelectedBackground(a: Brush);
    private zq;
    get summarySectionSelectedBackground(): Brush;
    set summarySectionSelectedBackground(a: Brush);
    private m1;
    get pinnedAreaSeparatorWidth(): number;
    set pinnedAreaSeparatorWidth(a: number);
    private mw;
    get headerSeparatorWidth(): number;
    set headerSeparatorWidth(a: number);
    ng(a: number): number;
    private y4;
    get headerSeparatorBackground(): Brush;
    set headerSeparatorBackground(a: Brush);
    private y2;
    get headerBackground(): Brush;
    set headerBackground(a: Brush);
    private y6;
    get headerTextColor(): Brush;
    set headerTextColor(a: Brush);
    private gr;
    get headerTextStyle(): FontInfo;
    set headerTextStyle(a: FontInfo);
    private zb;
    get rowSeparatorBackground(): Brush;
    set rowSeparatorBackground(a: Brush);
    private y3;
    get headerRowSeparatorBackground(): Brush;
    set headerRowSeparatorBackground(a: Brush);
    private ze;
    get rowSeparatorStickyRowBackground(): Brush;
    set rowSeparatorStickyRowBackground(a: Brush);
    private zc;
    get rowSeparatorLastStickyRowBackground(): Brush;
    set rowSeparatorLastStickyRowBackground(a: Brush);
    private zd;
    get rowSeparatorPinnedRowBackground(): Brush;
    set rowSeparatorPinnedRowBackground(a: Brush);
    private ms;
    get columnResizingSeparatorWidth(): number;
    set columnResizingSeparatorWidth(a: number);
    private lu;
    get columnResizingSeparatorOpacity(): number;
    set columnResizingSeparatorOpacity(a: number);
    private mr;
    get columnMovingSeparatorWidth(): number;
    set columnMovingSeparatorWidth(a: number);
    private lt;
    get columnMovingSeparatorOpacity(): number;
    set columnMovingSeparatorOpacity(a: number);
    private yz;
    get columnResizingSeparatorBackground(): Brush;
    set columnResizingSeparatorBackground(a: Brush);
    private yx;
    get columnMovingSeparatorBackground(): Brush;
    set columnMovingSeparatorBackground(a: Brush);
    private ik;
    get shiftSectionContent(): boolean;
    set shiftSectionContent(a: boolean);
    private bo;
    get columnOptionsIconAlignment(): ColumnOptionsIconAlignment;
    set columnOptionsIconAlignment(a: ColumnOptionsIconAlignment);
    private yy;
    get columnOptionsIconColor(): Brush;
    set columnOptionsIconColor(a: Brush);
    private bq;
    get columnOptionsIconBehavior(): ColumnOptionsIconBehavior;
    set columnOptionsIconBehavior(a: ColumnOptionsIconBehavior);
    private yt;
    get border(): Brush;
    set border(a: Brush);
    private aaw;
    get aa2(): Thickness;
    set aa2(a: Thickness);
    private aau;
    get actualBorderWidth(): Thickness;
    set actualBorderWidth(a: Thickness);
    private aav;
    get borderWidth(): Thickness;
    set borderWidth(a: Thickness);
    private ic;
    get notifyOnAllSelectionChanges(): boolean;
    set notifyOnAllSelectionChanges(a: boolean);
    private yo;
    get ys(): CornerRadius;
    set ys(a: CornerRadius);
    private yn;
    get cornerRadius(): CornerRadius;
    set cornerRadius(a: CornerRadius);
    private ym;
    get actualCornerRadius(): CornerRadius;
    set actualCornerRadius(a: CornerRadius);
    static readonly isActiveCellStyleEnabledPropertyName: string;
    private hp;
    get isActiveCellStyleEnabled(): boolean;
    set isActiveCellStyleEnabled(a: boolean);
    private g5;
    get platformPixelConverter(): IPlatformPixelConverter;
    set platformPixelConverter(a: IPlatformPixelConverter);
    private e1;
    get renderingEngine(): ICellRenderingEngine;
    set renderingEngine(a: ICellRenderingEngine);
    private wo;
    private fp;
    get responsiveStates(): ResponsiveStatesCollection;
    private gj;
    get model(): VisualModel;
    set model(a: VisualModel);
    get actualVisibleRegion(): Rect;
    private b9;
    private a9;
    private s;
    private ce;
    private z;
    private aa;
    private io;
    private im;
    private ip;
    private il;
    private b8;
    private ba;
    private t;
    private cd;
    get initialSortDescriptions(): ColumnSortDescriptionCollection;
    get initialGroupDescriptions(): ColumnGroupDescriptionCollection;
    get initialSummaryDescriptions(): ColumnSummaryDescriptionCollection;
    private or;
    get initialSorts(): string;
    set initialSorts(a: string);
    private oq;
    get initialGroups(): string;
    set initialGroups(a: string);
    private os;
    get initialSummaries(): string;
    set initialSummaries(a: string);
    private up;
    ja(a: any[], b: any[]): boolean;
    get sortDescriptions(): ColumnSortDescriptionCollection;
    get groupDescriptions(): ColumnGroupDescriptionCollection;
    sortDescriptionsChanged: (sender: any, args: GridSortDescriptionsChangedEventArgs) => void;
    groupDescriptionsChanged: (sender: any, args: GridGroupDescriptionsChangedEventArgs) => void;
    summaryDescriptionsChanged: (sender: any, args: GridSummaryDescriptionsChangedEventArgs) => void;
    columnHiddenChanged: (sender: any, args: ColumnHiddenChangedEventArgs) => void;
    columnPinnedChanged: (sender: any, args: ColumnPinnedChangedEventArgs) => void;
    private vx;
    cellValueChanging: (sender: any, args: GridCellValueChangingEventArgs) => void;
    dataCommitted: (sender: any, e: GridDataCommittedEventArgs) => void;
    dataCommitting: (sender: any, e: GridDataCommittingEventArgs) => void;
    get filterExpressions(): FilterExpressionCollection;
    get summaryDescriptions(): ColumnSummaryDescriptionCollection;
    private ir;
    private gf;
    get summaryScope(): SummaryScope;
    set summaryScope(a: SummaryScope);
    private hw;
    private hv;
    get isGroupCollapsable(): boolean;
    set isGroupCollapsable(a: boolean);
    private hk;
    private eq;
    get groupHeaderDisplayMode(): GroupHeaderDisplayMode;
    set groupHeaderDisplayMode(a: GroupHeaderDisplayMode);
    private hy;
    private hx;
    get isGroupExpandedDefault(): boolean;
    set isGroupExpandedDefault(a: boolean);
    private hl;
    private es;
    get groupSummaryDisplayMode(): GroupSummaryDisplayMode;
    set groupSummaryDisplayMode(a: GroupSummaryDisplayMode);
    private he;
    get autoAcceptEdits(): boolean;
    set autoAcceptEdits(a: boolean);
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    postPropertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected wm(a: string, b: any, c: any): void;
    xn(): void;
    xd(): void;
    xe(): void;
    calculateCompleted: (sender: any, e: any) => void;
    u6(): void;
    uj(): void;
    private ii;
    get kz(): boolean;
    set kz(a: boolean);
    refresh(): void;
    flush(): void;
    private x;
    private v;
    get actualDataSource(): IDataSource;
    set actualDataSource(a: IDataSource);
    private d;
    get primaryKey(): string[];
    set primaryKey(a: string[]);
    private a;
    get actualPrimaryKey(): string[];
    set actualPrimaryKey(a: string[]);
    private ha;
    get iw(): boolean;
    set iw(a: boolean);
    protected w8(a: string, b: any, c: any): void;
    private yd;
    private yq;
    private aa1;
    syncBorder(): void;
    private v6;
    private m;
    private n;
    private h;
    private t7;
    private xq;
    private ul;
    private um;
    private xr;
    private un;
    private ua;
    private t9;
    private v5;
    u0(): void;
    sizeChanged: (sender: any, e: GridSizeChangedEventArgs) => void;
    onSizeChanged(a: number, b: number): void;
    viewportChanged: (sender: any, e: GridViewportChangedEventArgs) => void;
    private mz;
    private m0;
    lb: boolean;
    notifyScrollStart(): void;
    notifyScrollStop(): void;
    setViewport(a: number, b: number, c: number, d: number): void;
    get actualColumns(): GridColumnCollection;
    actualColumnsChanged: (sender: any, args: GridColumnsChangedEventArgs) => void;
    private dt;
    get columns(): GridColumnCollection;
    wi(a: CellModel, b: any, c: any): void;
    wh(a: CellModel, b: any, c: any, d: string): void;
    cm(a: CellPath): DataGridColumn;
    hideThenRemoveColumn(a: DataGridColumn): void;
    exchangeColumn(a: DataGridColumn, b: DataGridColumn): void;
    private ts;
    private ib;
    private v1;
    private vy;
    private vt;
    private t3;
    private wu;
    private t6;
    pinColumn(a: DataGridColumn, b: PinnedPositions): void;
    private k9;
    private la;
    moveColumn(a: number, b: number): void;
    moveColumnLeft(a: number): void;
    moveColumnRight(a: number): void;
    canMoveColumnLeft(a: number): boolean;
    canMoveColumnRight(a: number): boolean;
    private kg;
    private ck;
    private cj;
    private vu;
    private t2;
    private ye;
    private cp;
    qp(a: CellPath, b: DataGrid, c: any, d: number): string;
    as(a: CellPath, b: string): CellModel;
    exportVisualModel(): any;
    exportSerializedVisualModel(): string;
    ft(a: number): RowPath;
    private g9;
    scrollToRowByIndex(a: number): void;
    scrollToLastRowByIndex(a: number): void;
    scrollToItem(a: any): boolean;
    scrollToPrimaryKey(a: any[]): boolean;
    scrollToColumnByIndex(a: number): void;
    private xt;
    k6(a: DataGridColumn): boolean;
    v4(a: number, b: number): void;
    private t1;
    private no;
    private k2;
    getLastVisibleIndex(): number;
    getFirstVisibleIndex(): number;
    nq(): number;
    nv(): number;
    w3(): void;
    jh: boolean;
    j0: boolean;
    get j7(): boolean;
    get j8(): boolean;
    get j5(): boolean;
    get j6(): boolean;
    private k0;
    private k1;
    private lf;
    private lg;
    private lh;
    private li;
    private hc;
    private hb;
    tx(a?: boolean): void;
    uf(): void;
    ws(a: any, b: PrimaryKeyValue): void;
    wt(a: any, b: PrimaryKeyValue): void;
    wz(a: number, b: any, c: PrimaryKeyValue): void;
    private iu;
    u7(a: number, b: number, c: string): void;
    va(a: number, b: string): void;
    private u8;
    private m9;
    private na;
    ki(a: boolean, b: boolean): boolean;
    kj(a: boolean, b: boolean): boolean;
    private nu;
    private np;
    private nz;
    private ny;
    private nn;
    ty(a: number, b: number, c: boolean, d?: boolean): void;
    kn(a: boolean, b: boolean): boolean;
    kp(a: boolean, b: boolean): boolean;
    kq(a: boolean, b: boolean): boolean;
    kr(a: boolean, b: boolean): boolean;
    ks(a: boolean, b: boolean): boolean;
    ku(a: boolean, b: boolean): boolean;
    w4(): void;
    kv(a: boolean, b: boolean): boolean;
    kk(a: boolean, b: boolean): boolean;
    kl(): boolean;
    km(): boolean;
    kt(a: boolean, b: boolean): boolean;
    aw: CellPath;
    ax: CellPath;
    ld(): boolean;
    k8(a: CellModel): boolean;
    i9(a: boolean, b?: boolean): boolean;
    ue(a: boolean): void;
    vm(a: PrimaryKeyValue, b: number): void;
    vn(a: PrimaryKeyValue, b: number): void;
    columnsAutoGenerated: (sender: any, args: GridColumnsAutoGeneratedEventArgs) => void;
    selectedItemsChanged: (sender: any, args: GridSelectedItemsChangedEventArgs) => void;
    selectedKeysChanged: (sender: any, args: GridSelectedKeysChangedEventArgs) => void;
    selectedCellsChanged: (sender: any, args: GridSelectedCellsChangedEventArgs) => void;
    selectionChanged: (sender: any, args: GridSelectionChangedEventArgs) => void;
    private ij;
    private w0;
    activeCellChanged: (sender: any, args: GridActiveCellChangedEventArgs) => void;
    selectedCellRangesChanged: (sender: any, args: GridSelectedCellRangesChangedEventArgs) => void;
    yj(a: List$1<any>, b: List$1<PrimaryKeyValue>, c: List$1<any>, d: List$1<PrimaryKeyValue>): void;
    tv(a: List$1<any>, b: List$1<PrimaryKeyValue>): void;
    tw(a: any, b: PrimaryKeyValue, c: boolean): void;
    yi(a: number, b: any, c: PrimaryKeyValue): void;
    xl(a: List$1<any>, b: List$1<PrimaryKeyValue>): void;
    xm(a: any, b: PrimaryKeyValue, c: boolean): void;
    private ww;
    private wx;
    private wv;
    private wy;
    private a0;
    tu(a: number, b: number, c: number, d: number): void;
    tt(a: CellRange): void;
    xi(a: CellRange): void;
    xh(): void;
    private uy;
    w1(a: number, b: any, c: any): void;
    private uq;
    vo(): void;
    invalidateVisibleRows(): void;
    private ur;
    private nr;
    private nw;
    private us;
    private ho;
    w9(): void;
    wg(a: number, b: any): void;
    wn(a: number, b: any): void;
    setActiveResponsiveState(a: string): void;
    x4(a: ResponsiveState): void;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
    dataIndexOfItem(a: any): number;
    dataIndexOfPrimaryKey(a: any[]): number;
    i(): string[];
    resolveCellValue(a: CellKey): any;
    resolveCellValueFromPosition(a: number, b: number): any;
    getColumnAtRenderedIndex(a: number): DataGridColumn;
    getRootSummaryResults(): ISummaryResult[];
    getSectionSummaryResults(a: number): ISummaryResult[][];
    private ih;
    get reactsToSortChanges(): boolean;
    set reactsToSortChanges(a: boolean);
    private ig;
    get reactsToGroupChanges(): boolean;
    set reactsToGroupChanges(a: boolean);
    private ie;
    get reactsToFilterChanges(): boolean;
    set reactsToFilterChanges(a: boolean);
    y(a: DataGridColumn): IFilterExpression;
    le(a: CellModel, b: number, c: any, d: any, e: any): boolean;
    private yk;
    private ok;
    columnWidthChanged: (sender: any, args: GridColumnWidthChangedEventArgs) => void;
    private v2;
    cellEditStarted: (sender: any, args: GridCellEditStartedEventArgs) => void;
    private vd;
    cellEditEnded: (sender: any, args: GridCellEditEndedEventArgs) => void;
    private vc;
    rowEditStarted: (sender: any, args: GridRowEditStartedEventArgs) => void;
    private wq;
    rowEditEnded: (sender: any, args: GridRowEditEndedEventArgs) => void;
    private wp;
    jt(): boolean;
    get canUndo(): boolean;
    get canRedo(): boolean;
    get canCommit(): boolean;
    commitEdits(): void;
    cancelEdits(): void;
    acceptCommit(a: number): void;
    rejectCommit(a: number): void;
    undo(): void;
    redo(): void;
    updatePropertyAtKey(a: any[], b: string, c: any): void;
    removeItemByKey(a: any[]): void;
    removeItem(a: any): void;
    private id;
    acceptEdit(a: number): void;
    rejectEdit(a: number): void;
    setEditError(a: number, b: string): void;
    startEditMode(): void;
    endEditMode(a: boolean): void;
    private cz;
    get enterBehavior(): EnterKeyBehaviors;
    set enterBehavior(a: EnterKeyBehaviors);
    private cx;
    get enterBehaviorAfterEdit(): EnterKeyBehaviorAfterEdit;
    set enterBehaviorAfterEdit(a: EnterKeyBehaviorAfterEdit);
    selectAllRows(): void;
    deselectAllRows(): void;
    private h1;
    get j2(): boolean;
    set j2(a: boolean);
    ko(a: Key, b: boolean, c: boolean): boolean;
    private lc;
    k7(): boolean;
    private hs;
    get isColumnOptionsSummariesEnabled(): boolean;
    set isColumnOptionsSummariesEnabled(a: boolean);
    private hr;
    get isColumnOptionsGroupingEnabled(): boolean;
    set isColumnOptionsGroupingEnabled(a: boolean);
    private fh;
    get mergedCellMode(): MergedCellMode;
    set mergedCellMode(a: MergedCellMode);
    private ff;
    get mergedCellEvaluationCriteria(): MergedCellEvaluationCriteria;
    set mergedCellEvaluationCriteria(a: MergedCellEvaluationCriteria);
    private al;
    get mergedCellVerticalAlignment(): CellContentVerticalAlignment;
    set mergedCellVerticalAlignment(a: CellContentVerticalAlignment);
    saveLayout(): string;
    private fy;
    private ll;
    loadLayout(a: string): void;
    private q;
    private r;
    nt(a: CellPath): number;
    private c6;
    get filterUIType(): FilterUIType;
    set filterUIType(a: FilterUIType);
    private c3;
    get filterLogicalOperator(): FilterLogicalOperator;
    set filterLogicalOperator(a: FilterLogicalOperator);
    private c1;
    get filterComparisonType(): FilterComparisonType;
    set filterComparisonType(a: FilterComparisonType);
    ju(): boolean;
    private lo;
    get todayOverride(): Date;
    set todayOverride(a: Date);
    private hg;
    get clearSelectionOnEscape(): boolean;
    set clearSelectionOnEscape(a: boolean);
    customFilterRequested: (sender: any, args: GridCustomFilterRequestedEventArgs) => void;
    v3(a: DataGridColumn, b: FilterOperand, c: any): void;
    private h2;
    get isPagerVisible(): boolean;
    set isPagerVisible(a: boolean);
    private mx;
    get pageSize(): number;
    set pageSize(a: number);
    private h7;
    get isToolbarVisible(): boolean;
    set isToolbarVisible(a: boolean);
    private h5;
    get isToolbarColumnChooserVisible(): boolean;
    set isToolbarColumnChooserVisible(a: boolean);
    private h6;
    get isToolbarColumnPinningVisible(): boolean;
    set isToolbarColumnPinningVisible(a: boolean);
    private ox;
    get toolbarTitle(): string;
    set toolbarTitle(a: string);
    private ot;
    get toolbarColumnChooserText(): string;
    set toolbarColumnChooserText(a: string);
    private ou;
    get toolbarColumnChooserTitle(): string;
    set toolbarColumnChooserTitle(a: string);
    private ov;
    get toolbarColumnPinningText(): string;
    set toolbarColumnPinningText(a: string);
    private ow;
    get toolbarColumnPinningTitle(): string;
    set toolbarColumnPinningTitle(a: string);
    private gl;
    get scrollbarStyle(): ScrollbarStyle;
    set scrollbarStyle(a: ScrollbarStyle);
    private zf;
    get scrollbarBackground(): Brush;
    set scrollbarBackground(a: Brush);
    private hd;
    get allowCopyOperation(): boolean;
    set allowCopyOperation(a: boolean);
    private hh;
    get deferEventForRowDragSelection(): boolean;
    set deferEventForRowDragSelection(a: boolean);
}
/**
 * @hidden
 */
export declare class GridColumnsAutoGeneratedEventArgs extends EventArgs {
    static $t: Type;
    private _columns;
    get columns(): GridColumnCollection;
    set columns(a: GridColumnCollection);
}
/**
 * @hidden
 */
export declare class GridColumnsChangedEventArgs extends EventArgs {
    static $t: Type;
    private _columns;
    get columns(): GridColumnCollection;
    set columns(a: GridColumnCollection);
}
/**
 * @hidden
 */
export declare class GridSelectedCellsChangedEventArgs extends EventArgs {
    static $t: Type;
    private _currentCells;
    get currentCells(): GridSelectedCellsCollection;
    set currentCells(a: GridSelectedCellsCollection);
    private _addedCells;
    get addedCells(): GridSelectedCellsCollection;
    set addedCells(a: GridSelectedCellsCollection);
    private _removedCells;
    get removedCells(): GridSelectedCellsCollection;
    set removedCells(a: GridSelectedCellsCollection);
}
/**
 * @hidden
 */
export declare class DataGridCellEventArgs extends EventArgs {
    static $t: Type;
    private _cellInfo;
    get cellInfo(): CellModel;
    set cellInfo(a: CellModel);
    private _grid;
    get grid(): DataGrid;
    set grid(a: DataGrid);
    private _button;
    get button(): MouseButton;
    set button(a: MouseButton);
    private _isDoubleClick;
    get isDoubleClick(): boolean;
    set isDoubleClick(a: boolean);
}
/**
 * @hidden
 */
export declare class ColumnHiddenChangedEventArgs extends Base {
    static $t: Type;
    a: DataGridColumn;
    b: boolean;
}
/**
 * @hidden
 */
export declare class ColumnPinnedChangedEventArgs extends Base {
    static $t: Type;
    a: DataGridColumn;
    b: PinnedPositions;
}
/**
 * @hidden
 */
export declare class GridCellValueChangingEventArgs extends Base {
    static $t: Type;
    c: number;
    private _cellInfo;
    get cellInfo(): CellModel;
    set cellInfo(a: CellModel);
    b: DataGridColumn;
    private _item;
    get item(): any;
    set item(a: any);
    f: any;
    e: any;
}
/**
 * @hidden
 */
export declare class GridCustomFilterRequestedEventArgs extends Base {
    static $t: Type;
    c: DataGridColumn;
    d: FilterOperand;
    e: any;
    b: IFilterExpression;
    get a(): FilterFactory;
}
/**
 * @hidden
 */
export declare class GridColumnWidthChangedEventArgs extends Base {
    static $t: Type;
    c: DataGridColumn;
    b: ColumnWidth;
    a: ColumnWidth;
}
/**
 * @hidden
 */
export declare class GridCellEditStartedEventArgs extends Base {
    static $t: Type;
    a: DataGridColumn;
    b: number;
    private _item;
    get item(): any;
    set item(a: any);
}
/**
 * @hidden
 */
export declare class GridCellEditEndedEventArgs extends Base {
    static $t: Type;
    a: DataGridColumn;
    b: number;
    private _item;
    get item(): any;
    set item(a: any);
}
/**
 * @hidden
 */
export declare class GridAnimationManager extends Base {
    static $t: Type;
    constructor();
    get h(): GridColumnAnimationSettings;
    private static o;
    protected p(): number;
    private l;
    private i;
    as(): void;
    m(): List$1<number>;
    animationCreated: (sender: any, args: GridAnimationManagerAnimationCreatedEventArgs) => void;
    animationCompleted: (sender: any, args: GridAnimationManagerAnimationCompletedEventArgs) => void;
    animationCanceled: (sender: any, args: GridAnimationManagerAnimationCanceledEventArgs) => void;
    protected x(a: number): void;
    protected v(a: number): void;
    protected w(a: number): void;
    private g;
    private f;
    ar(a: DataGrid, b: GridColumnAnimationSettings, c: ColumnInfo, d: boolean, e: ColumnStates): void;
    private k;
    aj(a: DataGrid, b: GridColumnAnimationSettings, c: ColumnInfo, d: ColumnInfo, e: ColumnStates): void;
    private y;
    private u;
    private t;
    private j;
    ah(a: DataGrid, b: GridColumnAnimationSettings, c: ColumnInfo, d: number): void;
    al(a: DataGrid, b: GridColumnAnimationSettings, c: ColumnInfo, d: ColumnStates): void;
    private static at;
    private q;
    private n;
    ak(a: DataGrid, b: GridColumnAnimationSettings, c: ColumnInfo, d: boolean, e: ColumnStates): void;
    r(a: DataGrid, b: ColumnInfo, c: string, d: CellPropertyAnimationType, e: any, f: any, g: ModelTypes): void;
    s(a: DataGrid, b: ColumnInfo, c: string, d: CellPropertyAnimationType, e: any, f: any, g: boolean, h: boolean, i: boolean, j: boolean): void;
    private e;
    am(a: DataGrid, b: number, c: number): void;
    private d;
    ai(a: DataGrid, b: ColumnInfo): void;
    z(a: DataGrid, b: number, c: number, d: boolean): void;
    ag(a: DataGrid, b: number, c: number, d: number, e: boolean): void;
    ao(a: DataGrid, b: number): void;
    aq(a: DataGrid, b: number): void;
    ae(a: DataGrid, b: number, c: number, d: number): void;
    aa(a: DataGrid, b: number, c: number, d: number): void;
    af(a: DataGrid, b: number, c: number, d: number): void;
    ab(a: DataGrid, b: number, c: number, d: number): void;
    ac(a: DataGrid, b: number, c: number): void;
    ad(a: DataGrid, b: number, c: number): void;
    an(a: DataGrid, b: number): void;
    ap(a: DataGrid, b: number): void;
}
/**
 * @hidden
 */
export declare class FilterOperand extends Base {
    static $t: Type;
    get a(): FilterFactory;
    g: string;
    e: string;
    f: string;
    d: boolean;
    b: EditorType;
    filterRequested: (sender: any, args: GridCustomFilterRequestedEventArgs) => void;
    h(a: GridCustomFilterRequestedEventArgs): void;
}
/**
 * @hidden
 */
export declare class GridFilterOperandsCollection extends ObservableCollection$1<FilterOperand> {
    static $t: Type;
    constructor();
    af(a: (sender: any, e: NotifyCollectionChangedEventArgs) => void): void;
    ag(a: (sender: any, e: NotifyCollectionChangedEventArgs) => void): void;
    get ae(): IList$1<FilterOperand>;
}
/**
 * @hidden
 */
export declare class CellKey extends Base {
    static $t: Type;
    private e;
    private g;
    private i;
    private a;
    private c;
    get primaryKey(): PrimaryKeyValue;
    set primaryKey(a: PrimaryKeyValue);
    get h(): any;
    set h(a: any);
    get j(): string;
    set j(a: string);
    get b(): DataGridColumn;
    get d(): DataGrid;
    set d(a: DataGrid);
}
/**
 * @hidden
 */
export declare class GridSelectedCellsCollection extends ObservableCollection$1<CellKey> {
    static $t: Type;
    constructor();
    an(a: (sender: any, e: NotifyCollectionChangedEventArgs) => void): void;
    ao(a: (sender: any, e: NotifyCollectionChangedEventArgs) => void): void;
    get am(): IList$1<CellKey>;
    ai(a: PrimaryKeyValue, b: number): CellKey;
    aj(a: PrimaryKeyValue, b: string): CellKey;
    ak(a: any, b: string): CellKey;
    ae(a: PrimaryKeyValue, b: DataGridColumn): CellKey;
    af(a: PrimaryKeyValue, b: string): CellKey;
    ag(a: any, b: DataGridColumn): CellKey;
    ah(a: any, b: string): CellKey;
    al(a: PrimaryKeyValue, b: number): CellKey;
}
/**
 * @hidden
 */
export declare abstract class DefinitionBase extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private bl;
    private t;
    get externalObject(): any;
    set externalObject(a: any);
    private ds;
    get d8(): Brush;
    set d8(a: Brush);
    private dt;
    get d9(): Brush;
    set d9(a: Brush);
    private di;
    get dz(): Brush;
    set dz(a: Brush);
    private du;
    get ea(): Brush;
    set ea(a: Brush);
    private dl;
    get d2(): Brush;
    set d2(a: Brush);
    private a2;
    get be(): number;
    set be(a: number);
    private a4;
    get bg(): number;
    set bg(a: number);
    private a3;
    get bf(): number;
    set bf(a: number);
    private a1;
    get bd(): number;
    set bd(a: number);
    private ay;
    get ba(): number;
    set ba(a: number);
    private a0;
    get bc(): number;
    set bc(a: number);
    private az;
    get bb(): number;
    set bb(a: number);
    private ax;
    get a9(): number;
    set a9(a: number);
    private a6;
    get bi(): number;
    set bi(a: number);
    private a8;
    get bk(): number;
    set bk(a: number);
    private a7;
    get bj(): number;
    set bj(a: number);
    private a5;
    get bh(): number;
    set bh(a: number);
    private r;
    get grid(): DataGrid;
    set grid(a: DataGrid);
    private c1;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    private dk;
    get d1(): Brush;
    set d1(a: Brush);
    private dj;
    get d0(): Brush;
    set d0(a: Brush);
    private dm;
    get d3(): Brush;
    set d3(a: Brush);
    private dx;
    get ek(): Brush;
    set ek(a: Brush);
    private dq;
    get d6(): Brush;
    set d6(a: Brush);
    private dw;
    get ej(): Brush;
    set ej(a: Brush);
    private dp;
    get d5(): Brush;
    set d5(a: Brush);
    private dv;
    get ei(): Brush;
    set ei(a: Brush);
    private dn;
    get d4(): Brush;
    set d4(a: Brush);
    private ar;
    get au(): number;
    set au(a: number);
    private b;
    get e(): CellContentHorizontalAlignment;
    set e(a: CellContentHorizontalAlignment);
    private g;
    get j(): CellContentVerticalAlignment;
    set j(a: CellContentVerticalAlignment);
    private a;
    get c(): CellContentHorizontalAlignment;
    set c(a: CellContentHorizontalAlignment);
    private f;
    get h(): CellContentVerticalAlignment;
    set h(a: CellContentVerticalAlignment);
    private w;
    get y(): TextCellLineBreakMode;
    set y(a: TextCellLineBreakMode);
    private v;
    get x(): TextCellLineBreakMode;
    set x(a: TextCellLineBreakMode);
    private dy;
    get el(): Brush;
    set el(a: Brush);
    private dr;
    get d7(): Brush;
    set d7(a: Brush);
    private as;
    get aw(): number;
    set aw(a: number);
    private aq;
    get at(): number;
    set at(a: number);
    private ac;
    get textStyle(): FontInfo;
    set textStyle(a: FontInfo);
    private ab;
    get ad(): FontInfo;
    set ad(a: FontInfo);
    k(a: CellPath, b: string): CellModel;
    protected abstract l(a: CellPath): CellModel;
    cm(a: CellPath, b: DataGrid, c: any, d: number): string;
    protected abstract cn(a: CellPath, b: DataGrid, c: any): string;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    cy(a: CellModel, b: DataGrid, c: any, d: any): void;
    private n;
    dataBinding: (sender: any, args: DataBindingEventArgs) => void;
    dataBound: (sender: any, args: DataBindingEventArgs) => void;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    ck(a: DataGrid, b: any, c: any): string;
    c6(): void;
    protected aj(a: string): boolean;
    protected ak(a: string): boolean;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected c3(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    protected c9(): void;
    protected dg(): void;
    protected dh(): void;
    protected de(): void;
    protected dd(): void;
    protected df(): void;
    protected dc(): void;
    protected c4(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    private ag;
    protected da(): void;
    private c8;
    private db;
    private am;
    private ao;
    private al;
    protected get an(): HashSet$1<string>;
    protected get ap(): List$1<string>;
    private cw;
    protected d(): CellContentHorizontalAlignment;
    protected i(): CellContentVerticalAlignment;
    protected eh(): Brush;
    protected eb(): Brush;
    protected af(): FontInfo;
    protected ec(): Brush;
    protected eg(): Brush;
    protected ee(): Brush;
    protected ed(): Brush;
    protected ef(): Brush;
    protected av(): number;
    definitionPropertyUpdated: (sender: any, args: DefinitionPropertyUpdatedEventArgs) => void;
    private z;
    c7(a: string, b: CellPropertyAnimationType, c: any): void;
    ai(): boolean;
    get aa(): FastIterationDictionary$2<string, any>;
    ah(a: string): boolean;
    c5(a: string): void;
    bn(a: string): any;
    cl(a: any, b: DataSourceSchemaPropertyType, c: any): string;
    u(a: ColumnSummaryDescription, b: ISummaryResult): SummaryData;
    cellStyleKeyRequested: (sender: any, args: CellStyleRequestedEventArgs) => void;
}
/**
 * @hidden
 */
export declare abstract class DataGridColumn extends DefinitionBase {
    static $t: Type;
    constructor();
    protected lh(): Brush;
    protected lg(): Brush;
    private static h5;
    h6: number;
    private fg;
    get fh(): ColumnStates;
    set fh(a: ColumnStates);
    private hr;
    get h2(): number;
    set h2(a: number);
    private ht;
    get h4(): number;
    set h4(a: number);
    private hs;
    get h3(): number;
    set h3(a: number);
    private hq;
    get h1(): number;
    set h1(a: number);
    private ie;
    get jz(): string;
    set jz(a: string);
    private ho;
    get hz(): number;
    set hz(a: number);
    private hn;
    get hy(): number;
    set hy(a: number);
    private hp;
    get h0(): number;
    set h0(a: number);
    private f3;
    get f5(): PinnedPositions;
    set f5(a: PinnedPositions);
    private ic;
    get i8(): string;
    set i8(a: string);
    private id;
    get jf(): string;
    set jf(a: string);
    private ia;
    get im(): string;
    set im(a: string);
    private k8;
    get lk(): Brush;
    set lk(a: Brush);
    private k3;
    get ld(): Brush;
    set ld(a: Brush);
    private k6;
    get li(): Brush;
    set li(a: Brush);
    private k1;
    get lb(): Brush;
    set lb(a: Brush);
    private k7;
    get lj(): Brush;
    set lj(a: Brush);
    private k2;
    get lc(): Brush;
    set lc(a: Brush);
    private fr;
    get fs(): GridColumnAnimationSettings;
    set fs(a: GridColumnAnimationSettings);
    private fi;
    get width(): ColumnWidth;
    set width(a: ColumnWidth);
    private hf;
    get hi(): number;
    set hi(a: number);
    private go;
    get g6(): boolean;
    set g6(a: boolean);
    private gi;
    get g0(): boolean;
    set g0(a: boolean);
    private gr;
    get g9(): boolean;
    set g9(a: boolean);
    private eo;
    get ep(): ColumnFilterCondition;
    set ep(a: ColumnFilterCondition);
    private eq;
    get er(): IFilterExpression;
    set er(a: IFilterExpression);
    private fv;
    get header(): Header;
    set header(a: Header);
    private gn;
    get g5(): boolean;
    set g5(a: boolean);
    private gq;
    get g8(): boolean;
    set g8(a: boolean);
    private gp;
    get g7(): boolean;
    set g7(a: boolean);
    private gs;
    get hb(): boolean;
    set hb(a: boolean);
    private fe;
    get ff(): ColumnSortDirection;
    set ff(a: ColumnSortDirection);
    private f4;
    get f6(): PinnedPositions;
    set f6(a: PinnedPositions);
    private gh;
    get gz(): boolean;
    set gz(a: boolean);
    get gw(): boolean;
    private e4;
    get e6(): ColumnOptionsIconAlignment;
    set e6(a: ColumnOptionsIconAlignment);
    private e5;
    get e7(): ColumnOptionsIconAlignment;
    set e7(a: ColumnOptionsIconAlignment);
    private kz;
    get k9(): Brush;
    set k9(a: Brush);
    private k4;
    get le(): Brush;
    set le(a: Brush);
    private e9;
    get fb(): ColumnOptionsIconBehavior;
    set fb(a: ColumnOptionsIconBehavior);
    private e8;
    get fa(): ColumnOptionsIconBehavior;
    set fa(a: ColumnOptionsIconBehavior);
    private gd;
    get gt(): boolean;
    set gt(a: boolean);
    private gj;
    get g1(): boolean;
    set g1(a: boolean);
    private gf;
    get gv(): boolean;
    set gv(a: boolean);
    private gl;
    get g3(): boolean;
    set g3(a: boolean);
    private ge;
    get gu(): boolean;
    set gu(a: boolean);
    private gk;
    get g2(): boolean;
    set g2(a: boolean);
    private gm;
    get g4(): boolean;
    set g4(a: boolean);
    private k5;
    get lf(): Brush;
    set lf(a: Brush);
    private k0;
    get la(): Brush;
    set la(a: Brush);
    private he;
    get hh(): number;
    set hh(a: number);
    private hd;
    get hg(): number;
    set hg(a: number);
    private ga;
    get textEditStyle(): FontInfo;
    set textEditStyle(a: FontInfo);
    private f9;
    get gb(): FontInfo;
    set gb(a: FontInfo);
    private fk;
    get fl(): EditorType;
    set fl(a: EditorType);
    private h7;
    get h8(): any;
    set h8(a: any);
    private ib;
    get i4(): string;
    set i4(a: string);
    private em;
    get en(): string[];
    set en(a: string[]);
    private f0;
    get f2(): MergedCellMode;
    set f2(a: MergedCellMode);
    private fx;
    get fz(): MergedCellEvaluationCriteria;
    set fz(a: MergedCellEvaluationCriteria);
    private ev;
    get ey(): CellContentVerticalAlignment;
    set ey(a: CellContentVerticalAlignment);
    private eu;
    get ew(): CellContentVerticalAlignment;
    set ew(a: CellContentVerticalAlignment);
    private hk;
    get hv(): number;
    set hv(a: number);
    private hm;
    get hx(): number;
    set hx(a: number);
    private hl;
    get hw(): number;
    set hw(a: number);
    private hj;
    get hu(): number;
    set hu(a: number);
    private fm;
    get fn(): FilterComparisonType;
    set fn(a: FilterComparisonType);
    fp(a: FilterComparisonType): FilterComparisonType;
    fo(): FilterComparisonType;
    private ft;
    get fu(): GridFilterOperandsCollection;
    private kd;
    f1(): MergedCellMode;
    fy(): MergedCellEvaluationCriteria;
    ha(): boolean;
    protected ee(): Brush;
    protected eg(): Brush;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    protected c4(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    protected ez(): CellContentVerticalAlignment;
    protected et(): CellContentHorizontalAlignment;
    protected ex(): CellContentVerticalAlignment;
    private kv;
    private kh;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    kw(): void;
    kx(): void;
    ky(): void;
    protected c9(): void;
    protected dg(): void;
    protected dh(): void;
    protected de(): void;
    protected ks(): void;
    protected ku(): void;
    protected kt(): void;
    protected dd(): void;
    protected df(): void;
    protected dc(): void;
    protected km(): void;
    protected kq(): void;
    protected kp(): void;
    protected kn(): void;
    protected kr(): void;
    protected ko(): void;
    columnCellsPropertyUpdating: (column: DataGridColumn, propertyName: string, propertyAnimationType: CellPropertyAnimationType, oldValue: any, newValue: any) => void;
    columnHeaderCellsPropertyUpdating: (column: DataGridColumn, propertyName: string, propertyAnimationType: CellPropertyAnimationType, oldValue: any, newValue: any) => void;
    protected kl(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    e3(): ColumnHidingAnimationMode;
    fd(): ColumnShowingAnimationMode;
    e2(): ColumnExchangingAnimationMode;
    fc(): ColumnResizingAnimationMode;
    jd(): string;
    private f7;
    private gg;
    kk(a: string, b: CellPropertyAnimationType, c: any): void;
    gy(): boolean;
    get f8(): FastIterationDictionary$2<string, any>;
    gx(a: string): boolean;
    kj(a: string): void;
    h9(a: string): any;
    hc: List$1<LayoutAction>;
    ki(a: string): void;
    kf(a: ColumnComparisonConditionOperatorType, b: any): void;
    ke(a: string, b: number, c: any): void;
    es(a: FilterOperand, b: any): IFilterExpression;
    fq(a: string, b: number): FilterOperand;
    kg(): void;
}
/**
 * @hidden
 */
export declare class GridColumnCollection extends ObservableCollection$1<DataGridColumn> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class GridEffectGroup extends Base {
    static $t: Type;
    private c;
    private f;
    private a;
    private b;
    effectsFinished: (sender: any, e: EventArgs) => void;
    effectsCanceled: (sender: any, e: EventArgs) => void;
    constructor(a: number, b: boolean);
    constructor(a: number);
    constructor(a: number, ..._rest: any[]);
    k(): void;
    g(a: GridEffect): void;
    private h;
    private i;
    protected j(): void;
}
/**
 * @hidden
 */
export declare class HoverManager extends Base {
    static $t: Type;
    private a;
    private b;
    private d;
    private e;
    constructor(a: DataGrid);
    f(a: number): void;
    c(a: number): boolean;
}
/**
 * @hidden
 */
export declare class RecyclingManager extends Base {
    static $t: Type;
    private b;
    constructor();
    a(a: string): CellModel;
    c(a: CellModel): void;
}
/**
 * @hidden
 */
export declare class ActivationManager extends Base {
    static $t: Type;
    private a;
    private b;
    private c;
    private e;
    private d;
    private f;
    private k;
    private l;
    private q;
    private t;
    private p;
    get v(): string;
    private get g();
    private get i();
    private get h();
    private get j();
    constructor(a: DataGrid, b: GridAnimationManager);
    al(a: CellModel): void;
    m(a: CellModel): boolean;
    private n;
    private o;
    ad(): void;
    private af;
    aa(a: CellModel): void;
    z(a: CellPath): void;
    ab(a: number, b: string, c: boolean): void;
    private r;
    private u;
    private y;
    private x;
    private ae;
    ah(): void;
    ai(a: number): void;
    aj(a: number): void;
    private w;
    ak(a: number): void;
    ag(): void;
    private ac;
    s(): number;
}
/**
 * @hidden
 */
export declare class SelectionManager extends Base {
    static $t: Type;
    private a;
    private b;
    private g;
    private f;
    private d;
    private e;
    private j;
    private get h();
    private get i();
    private t;
    private s;
    private k;
    constructor(a: DataGrid, b: GridAnimationManager);
    au(a: CellModel): void;
    at(a: CellModel): void;
    p(a: CellModel): boolean;
    n(a: PrimaryKeyValue): boolean;
    private l;
    private o;
    private m;
    private ax;
    private ap;
    private aq;
    private ar;
    private az;
    private ay;
    private ao;
    private an;
    private am;
    private aw;
    private av;
    private v;
    a2(): void;
    a1(): void;
    a0(): void;
    private x;
    private r;
    ad(): void;
    ah(a: number): void;
    private ak;
    ai(a: number, b: any): void;
    ag(a: number, b: DataGridColumn): void;
    ae(a: number, b: DataGridColumn): void;
    af(a: number, b: number, c: DataGridColumn): void;
    private w;
    aj(a: number): void;
    aa(): void;
    private y;
    private ac;
    private ab;
    private u;
    private c;
    private q;
    as(a: number): void;
    z(a: CellModel, b: boolean, c: boolean, d?: boolean): void;
    al(): void;
}
/**
 * @hidden
 */
export declare class SortManager extends Base {
    static $t: Type;
    private c;
    private e;
    constructor(a: DataGrid);
    d(a: DataGridColumn): boolean;
    f(a: DataGridColumn, b: ColumnSortDirection): boolean;
    private g;
    h(): void;
    private a;
    private b;
}
/**
 * @hidden
 */
export interface IDataAdapter {
    setDataSource(a: IDataSource): void;
    getItemForKey(a: PrimaryKeyValue): any;
    getItemKey(a: string[], b: any): PrimaryKeyValue;
    getRowKey(a: string[], b: number): PrimaryKeyValue;
    getRowCount(): number;
    getSectionCount(): number;
    getStickyRows(): number[];
    getStickyRowsInRange(a: number, b: number): number[];
    getStickRowPriority(a: number): number;
    isExclusivelySticky(a: number): boolean;
    pinRow(a: PrimaryKeyValue): void;
    unpinRow(a: PrimaryKeyValue): void;
    clearPinnedRows(): void;
    isRowPinned(a: number): boolean;
    firstVisibleIndexRequested: number;
    lastVisibleIndexRequested: number;
    indexOfKey(a: PrimaryKeyValue): number;
    fastGetItemIndexForKey(a: string[], b: PrimaryKeyValue, c: number, d: number): number;
    indexOfVisibleItemByKey(a: string[], b: PrimaryKeyValue, c: number, d: number): number;
    getDataRow(a: CellPath): number;
    resolveValue(a: number, b: string): any;
    resolveValueForPath(a: DataGrid, b: CellPath): any;
    resolveRow(a: number): any;
    resolveValueForDataRow(a: number): any;
    resolveValueForRow(a: CellPath): any;
    getSectionForRow(a: number): number;
    getRowPathForRow(a: number): RowPath;
    isPlaceholderValue(a: CellPath): boolean;
    isPlaceholderItem(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    isRowSpanning(a: DataSourceRowType): boolean;
    getRowIndent(a: number): number;
    getRootSummaryRowCount(): number;
    isEditedValue(a: any, b: string): boolean;
    isDeletedRow(a: any): boolean;
    getPendingEditID(a: any, b: string): number;
    getError(a: number): string;
}
/**
 * @hidden
 */
export declare let IDataAdapter_$type: Type;
/**
 * @hidden
 */
export declare class DataAdapter extends Base implements INotifyPropertyChanged, IDataAdapter {
    static $t: Type;
    private a;
    private h;
    private i;
    g: ColumnController;
    constructor(a: ColumnController);
    private b;
    get c(): IDataSource;
    set c(a: IDataSource);
    private d;
    get e(): IEditableDataSource;
    set e(a: IEditableDataSource);
    setDataSource(a: IDataSource): void;
    getItemForKey(a: PrimaryKeyValue): any;
    getItemKey(a: string[], item_: any): PrimaryKeyValue;
    getRowKey(a: string[], b: number): PrimaryKeyValue;
    private n;
    protected o(a: string, b: any, c: any): void;
    getRowCount(): number;
    m(a: PrimaryKeyValue, b: any): number;
    indexOfKey(a: PrimaryKeyValue): number;
    fastGetItemIndexForKey(a: string[], b: PrimaryKeyValue, c: number, d: number): number;
    indexOfVisibleItemByKey(a: string[], b: PrimaryKeyValue, c: number, d: number): number;
    l(a: number): number;
    getSectionCount(): number;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private f;
    getDataRow(a: CellPath): number;
    resolveValue(a: number, b: string): any;
    resolveValueForPath(a: DataGrid, b: CellPath): any;
    resolveRow(a: number): any;
    resolveValueForDataRow(a: number): any;
    resolveValueForRow(a: CellPath): any;
    getSectionForRow(a: number): number;
    getRowPathForRow(a: number): RowPath;
    private j;
    get firstVisibleIndexRequested(): number;
    set firstVisibleIndexRequested(a: number);
    private k;
    get lastVisibleIndexRequested(): number;
    set lastVisibleIndexRequested(a: number);
    isPlaceholderValue(a: CellPath): boolean;
    isPlaceholderItem(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    getStickyRows(): number[];
    getStickyRowsInRange(a: number, b: number): number[];
    getStickRowPriority(a: number): number;
    isExclusivelySticky(a: number): boolean;
    isRowSpanning(a: DataSourceRowType): boolean;
    pinRow(a: PrimaryKeyValue): void;
    unpinRow(a: PrimaryKeyValue): void;
    clearPinnedRows(): void;
    isRowPinned(a: number): boolean;
    getRowIndent(a: number): number;
    getRootSummaryRowCount(): number;
    isEditedValue(a: any, b: string): boolean;
    isDeletedRow(a: any): boolean;
    getPendingEditID(a: any, b: string): number;
    getError(a: number): string;
}
/**
 * @hidden
 */
export declare class ColumnMovingSeparator extends DefinitionBase {
    static $t: Type;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected ec(): Brush;
    private eq;
    get er(): number;
    set er(a: number);
    private em;
    get eo(): number;
    set eo(a: number);
    private en;
    get ep(): number;
    set ep(a: number);
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c9(): void;
    protected ev(): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class ComboBoxColumn extends DataGridColumn {
    static $t: Type;
    constructor();
    private lm;
    get ln(): IDataSource;
    set ln(a: IDataSource);
    get lo(): any;
    set lo(a: any);
    get ls(): string;
    set ls(a: string);
    get lt(): string;
    set lt(a: string);
    get ll(): string[];
    set ll(a: string[]);
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected c0(a: DataGrid, b: DataGrid): void;
    ck(a: DataGrid, b: any, c: any): string;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    protected c4(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    private lu;
    private lv;
    private lq;
    lr(a: any): string;
}
/**
 * @hidden
 */
export declare class DateTimeColumn extends DataGridColumn {
    static $t: Type;
    private lo;
    private lp;
    get lq(): DateTimeFormats;
    set lq(a: DateTimeFormats);
    private lz;
    get l8(): string;
    set l8(a: string);
    private ly;
    get l1(): string;
    set l1(a: string);
    private ll;
    get lm(): any[];
    set lm(a: any[]);
    private lv;
    get lx(): any;
    set lx(a: any);
    private ls;
    get lt(): boolean;
    set lt(a: boolean);
    get lr(): EditorType;
    set lr(a: EditorType);
    get lw(): any;
    set lw(a: any);
    get l3(): string;
    set l3(a: string);
    get l4(): string;
    set l4(a: string);
    protected c4(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    constructor();
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    ck(a: DataGrid, b: any, c: any): string;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    private lu;
    ln: BindingFormatter;
    private l5;
}
/**
 * @hidden
 */
export interface IExternalDefinitionBase {
    resolveStyleKey(a: string, b: CellPath, c: DataGrid, d: any): string;
}
/**
 * @hidden
 */
export declare let IExternalDefinitionBase_$type: Type;
/**
 * @hidden
 */
export declare class DataBindingEventArgs extends EventArgs {
    static $t: Type;
    private _resolvedValue;
    get resolvedValue(): any;
    set resolvedValue(a: any);
    private _rowObject;
    get rowObject(): any;
    set rowObject(a: any);
    private _cellInfo;
    get cellInfo(): CellModel;
    set cellInfo(a: CellModel);
}
/**
 * @hidden
 */
export declare class EditorDefinition extends DefinitionBase {
    static $t: Type;
    constructor();
    private et;
    get eu(): Rect;
    set eu(a: Rect);
    private eo;
    get er(): string;
    set er(a: string);
    private em;
    get en(): CellModel;
    set en(a: CellModel);
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class EditRowDefinition extends DefinitionBase {
    static $t: Type;
    constructor();
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class FilterRowDefinition extends DefinitionBase {
    static $t: Type;
    private en;
    get er(): number;
    set er(a: number);
    private ep;
    get et(): number;
    set et(a: number);
    private eo;
    get es(): number;
    set es(a: number);
    private em;
    get eq(): number;
    set eq(a: number);
    constructor();
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    protected dg(): void;
    protected c9(): void;
}
/**
 * @hidden
 */
export declare abstract class Header extends DefinitionBase {
    static $t: Type;
    constructor();
    protected eh(): Brush;
    protected ec(): Brush;
    protected fb(): Brush;
    protected af(): FontInfo;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c9(): void;
    protected dg(): void;
    protected dh(): void;
    protected e6(): void;
    protected e7(): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    private e9;
    get fc(): Brush;
    set fc(a: Brush);
    private e8;
    get fa(): Brush;
    set fa(a: Brush);
    private en;
    get ep(): SortIndicatorStyle;
    set ep(a: SortIndicatorStyle);
    private em;
    get eo(): SortIndicatorStyle;
    set eo(a: SortIndicatorStyle);
    private er;
    get ev(): number;
    set ev(a: number);
    private et;
    get ex(): number;
    set ex(a: number);
    private es;
    get ew(): number;
    set ew(a: number);
    private eq;
    get eu(): number;
    set eu(a: number);
    protected ak(a: string): boolean;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class ColumnResizingSeparator extends DefinitionBase {
    static $t: Type;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected ec(): Brush;
    private em;
    get eo(): number;
    set eo(a: number);
    private en;
    get ep(): number;
    set ep(a: number);
    protected c9(): void;
    protected et(): void;
    protected es(a: any, b: PropertyChangedEventArgs): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class HeaderSeparator extends DefinitionBase {
    static $t: Type;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected ec(): Brush;
    protected em(): number;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    protected c9(): void;
    private en;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class ImageColumn extends DataGridColumn {
    static $t: Type;
    private lo;
    get lp(): ImageStretchOptions;
    set lp(a: ImageStretchOptions);
    private lm;
    get ln(): ImageResourceType;
    set ln(a: ImageResourceType);
    get ll(): EditorType;
    set ll(a: EditorType);
    get lq(): any;
    set lq(a: any);
    get lr(): string;
    set lr(a: string);
    get ls(): string;
    set ls(a: string);
    constructor();
    protected i(): CellContentVerticalAlignment;
    protected et(): CellContentHorizontalAlignment;
    protected ez(): CellContentVerticalAlignment;
    protected d(): CellContentHorizontalAlignment;
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    private lt;
}
/**
 * @hidden
 */
export declare class NumericCellFormatter extends Base {
    static $t: Type;
    private static a;
    private static e;
    static b(a: BindingFormatter, b: number, c: number, d: number, e: boolean, f: string, g: string, h: string, i: string, j: number): string;
    static c(a: NumericCellModel): string;
    static d(a: NumericColumn, b: number): string;
}
/**
 * @hidden
 */
export declare class NumericColumn extends DataGridColumn {
    static $t: Type;
    constructor();
    protected d(): CellContentHorizontalAlignment;
    private l2;
    get mg(): string;
    set mg(a: string);
    private l4;
    get mk(): string;
    set mk(a: string);
    private l3;
    get mi(): string;
    set mi(a: string);
    private l5;
    get mm(): string;
    set mm(a: string);
    private ls;
    get lv(): number;
    set lv(a: number);
    private lt;
    get lw(): number;
    set lw(a: number);
    private lu;
    get lx(): number;
    set lx(a: number);
    private lp;
    get lq(): boolean;
    set lq(a: boolean);
    private l1;
    get mb(): string;
    set mb(a: string);
    private ll;
    get lm(): any[];
    set lm(a: any[]);
    private ly;
    get l0(): any;
    set l0(a: any);
    get lo(): EditorType;
    set lo(a: EditorType);
    get lz(): any;
    set lz(a: any);
    get l6(): string;
    set l6(a: string);
    get l7(): string;
    set l7(a: string);
    ln: BindingFormatter;
    protected c4(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    ck(a: DataGrid, b: any, c: any): string;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    private lr;
    private l8;
}
/**
 * @hidden
 */
export declare class PinnedAreaSeparator extends DefinitionBase {
    static $t: Type;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected ec(): Brush;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c9(): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
}
/**
 * @hidden
 */
export declare class SaveLayoutColumn extends JsonDictionaryItem {
    static $t: Type;
    o: string;
    e: ColumnWidth;
    i: Nullable$1<boolean>;
    j: Nullable$1<PinnedPositions>;
    m: string;
    n: string;
    k: Nullable$1<boolean>;
    g: List$1<DataSourceSummaryOperand>;
    h: Nullable$1<boolean>;
    l: Nullable$1<boolean>;
    f: List$1<ColumnFilterCondition>;
    p(a: JsonDictionaryItem): void;
    d(a: JsonWriter): void;
    constructor();
}
/**
 * @hidden
 */
export declare class SectionFooter extends DefinitionBase {
    static $t: Type;
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class SectionHeader extends DefinitionBase {
    static $t: Type;
    private fe;
    get fg(): Brush;
    set fg(a: Brush);
    private fd;
    get ff(): Brush;
    set ff(a: Brush);
    private eu;
    get ey(): number;
    set ey(a: number);
    private ew;
    get e0(): number;
    set e0(a: number);
    private ev;
    get ez(): number;
    set ez(a: number);
    private et;
    get ex(): number;
    set ex(a: number);
    private eq;
    get er(): boolean;
    set er(a: boolean);
    private en;
    get eo(): GroupSummaryDisplayMode;
    set eo(a: GroupSummaryDisplayMode);
    sectionHeaderPropertyUpdating: (sectionHeader: SectionHeader, propertyName: string, propertyAnimationType: CellPropertyAnimationType, oldValue: any, newValue: any) => void;
    constructor();
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected ec(): Brush;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    protected c0(a: DataGrid, b: DataGrid): void;
    private es;
    private fa;
    private e9;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    fc(): void;
    protected c9(): void;
    protected dg(): void;
    protected dh(): void;
    fb(): void;
    protected c4(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    private em;
}
/**
 * @hidden
 */
export declare class RowSeparator extends DefinitionBase {
    static $t: Type;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c9(): void;
    protected dd(): void;
    protected df(): void;
    protected dc(): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    protected l(a: CellPath): CellModel;
    protected ec(): Brush;
    protected eg(): Brush;
    protected ed(): Brush;
    protected ee(): Brush;
    protected av(): number;
}
/**
 * @hidden
 */
export declare class HeaderRowSeparator extends DefinitionBase {
    static $t: Type;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected l(a: CellPath): CellModel;
    protected ec(): Brush;
    protected c9(): void;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
}
/**
 * @hidden
 */
export declare abstract class SummaryRow extends DefinitionBase {
    static $t: Type;
    private fe;
    get fj(): Brush;
    set fj(a: Brush);
    private fc;
    get fg(): Brush;
    set fg(a: Brush);
    private ff;
    get fk(): Brush;
    set fk(a: Brush);
    private fd;
    get fh(): Brush;
    set fh(a: Brush);
    private en;
    get summaryNameTextStyle(): FontInfo;
    set summaryNameTextStyle(a: FontInfo);
    private em;
    get eo(): FontInfo;
    set eo(a: FontInfo);
    private es;
    get ew(): number;
    set ew(a: number);
    private eu;
    get ey(): number;
    set ey(a: number);
    private et;
    get ex(): number;
    set ex(a: number);
    private er;
    get ev(): number;
    set ev(a: number);
    constructor();
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected l(a: CellPath): CellModel;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    protected c0(a: DataGrid, b: DataGrid): void;
    protected fi(): Brush;
    protected eh(): Brush;
    protected c2(a: any, b: PropertyChangedEventArgs): void;
    protected e9(): void;
    protected fa(): void;
    protected dh(): void;
    protected fb(): void;
    protected c4(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
    protected af(): FontInfo;
    protected ep(): FontInfo;
}
/**
 * @hidden
 */
export declare class SummaryRowRoot extends SummaryRow {
    static $t: Type;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected ec(): Brush;
    protected c9(): void;
    protected e9(): void;
    protected fa(): void;
    protected dg(): void;
    protected fb(): void;
}
/**
 * @hidden
 */
export declare class SummaryRowSection extends SummaryRow {
    static $t: Type;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    protected ec(): Brush;
    protected c9(): void;
    protected e9(): void;
    protected fa(): void;
    protected dg(): void;
    protected fb(): void;
}
/**
 * @hidden
 */
export declare class TemplateColumn extends DataGridColumn {
    static $t: Type;
    constructor();
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    lm(a: TemplateCellModel, b: any): void;
    cellUpdating: (sender: any, args: TemplateCellUpdatingEventArgs) => void;
    protected c4(a: string, b: CellPropertyAnimationType, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare class TemplateCellUpdatingEventArgs extends EventArgs {
    static $t: Type;
    private _cellInfo;
    get cellInfo(): TemplateCellModel;
    set cellInfo(a: TemplateCellModel);
    private _content;
    get content(): any;
    set content(a: any);
}
/**
 * @hidden
 */
export declare class TextColumn extends DataGridColumn {
    static $t: Type;
    private ln;
    get lr(): string;
    set lr(a: string);
    get ll(): EditorType;
    set ll(a: EditorType);
    get lm(): any;
    set lm(a: any);
    get lo(): string;
    set lo(a: string);
    get lp(): string;
    set lp(a: string);
    protected l(a: CellPath): CellModel;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    ck(a: DataGrid, b: any, c: any): string;
    private lq;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
}
/**
 * @hidden
 */
export declare class TextHeader extends Header {
    static $t: Type;
    constructor();
    protected l(a: CellPath): CellModel;
    protected cn(a: CellPath, b: DataGrid, c: any): string;
    cx(a: CellModel, b: DataGrid, c: any, d: any): void;
    cz(a: CellModel, b: DataGrid, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class GridEffect extends Base {
    static $t: Type;
    constructor();
    bu(): void;
    bt(a: GridEffect): void;
    private s;
    get t(): GridEffectMainIntent;
    set t(a: GridEffectMainIntent);
    am(a: GridEffect): boolean;
    private u;
    get v(): GridEffectSubIntent;
    set v(a: GridEffectSubIntent);
    private br;
    get bs(): string;
    set bs(a: string);
    private af;
    get as(): boolean;
    set as(a: boolean);
    private ac;
    get ap(): boolean;
    set ap(a: boolean);
    onFinished: (target: any) => void;
    onCanceled: (target: any, canceledBy: GridEffect) => void;
    private a3;
    private a1;
    get ba(): number;
    set ba(a: number);
    private h;
    get i(): (startItem: CellPath, numberOfItems: number, item: CellPath) => number;
    set i(a: (startItem: CellPath, numberOfItems: number, item: CellPath) => number);
    private a7;
    get bi(): number;
    set bi(a: number);
    private a8;
    get bj(): number;
    set bj(a: number);
    private a2;
    get a9(): number;
    set a9(a: number);
    private j;
    get k(): (startItem: CellPath, numberOfItems: number, item: CellPath) => number;
    set k(a: (startItem: CellPath, numberOfItems: number, item: CellPath) => number);
    private a4;
    get bg(): number;
    set bg(a: number);
    private c;
    get g(): CellPath;
    set g(a: CellPath);
    private a;
    get e(): CellPath;
    set e(a: CellPath);
    private a6;
    get bh(): number;
    set bh(a: number);
    private ad;
    get aq(): boolean;
    set aq(a: boolean);
    private ab;
    get ao(): boolean;
    set ao(a: boolean);
    private bk;
    get bl(): number;
    set bl(a: number);
    private bm;
    get bo(): any;
    set bo(a: any);
    private bn;
    get bq(): any;
    set bq(a: any);
    private w;
    get x(): (progress: number, fromValue: any, toValue: any, target: any, model: VisualModel) => void;
    set x(a: (progress: number, fromValue: any, toValue: any, target: any, model: VisualModel) => void);
    private p;
    get q(): (progress: number) => number;
    set q(a: (progress: number) => number);
    private aa;
    get al(): boolean;
    set al(a: boolean);
    private n;
    get o(): (target: any, model: VisualModel) => any;
    set o(a: (target: any, model: VisualModel) => any);
    private ae;
    get ar(): boolean;
    set ar(a: boolean);
    bx(a: GridAnimationPhaseSettings): void;
    private r;
    private ay;
    au(a: ColumnInfo, b: VisualModel, c: GridLayerController, d: number): boolean;
    av(a: any, b: VisualModel, c: GridLayerController, d: number): boolean;
    private a0;
    private an;
    bz(a: CellPath, b: VisualModel, c: GridLayerController, d: number): void;
    at(a: CellModel, b: VisualModel, c: GridLayerController, d: number): boolean;
    private az;
    by(a: any, b: VisualModel, c: any): void;
    private bp;
    aw(a: SectionInfo, b: VisualModel, c: GridLayerController, d: number): boolean;
    ag(a: CellPath, b: VisualModel): boolean;
    ah(a: ColumnInfo, b: VisualModel): boolean;
    ai(a: RowPath, b: VisualModel): boolean;
    aj(a: GridColumnSpacer, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
    private a5;
    private b;
    protected get f(): CellPath;
    bf(a: VisualModel, b: GridLayerController, c: CellPath, d: number): number;
    private ax;
    private bd;
    private bb;
    be(a: VisualModel, b: CellPath): number;
    bc(a: VisualModel, b: GridLayerController, c: CellPath, d: number): number;
    protected d(a: VisualModel): CellPath;
    protected y(a: RowPath, b: RowPath): RowPath;
    protected z(a: RowPath, b: RowPath): RowPath;
    ak(a: VisualModel, b: GridLayerController, c: number): boolean;
}
/**
 * @hidden
 */
export declare class ColumnEffect extends GridEffect {
    static $t: Type;
    b0: number;
    ah(a: ColumnInfo, b: VisualModel): boolean;
}
/**
 * @hidden
 */
export declare class SpacerEffect extends GridEffect {
    static $t: Type;
    b0: number;
    aj(a: GridColumnSpacer, b: VisualModel): boolean;
}
/**
 * @hidden
 */
export declare class ColumnCellsEffect extends GridEffect {
    static $t: Type;
    b2: number;
    b1: number;
    b0: FixedCellPositions;
    ag(a: CellPath, b: VisualModel): boolean;
    protected d(a: VisualModel): CellPath;
    be(a: VisualModel, b: CellPath): number;
}
/**
 * @hidden
 */
export declare class CellEffect extends GridEffect {
    static $t: Type;
    b4: number;
    b3: number;
    b1: FixedCellPositions;
    b0: CellPath;
    b2: boolean;
    ag(a: CellPath, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
}
/**
 * @hidden
 */
export declare class CellPositionEffect extends CellEffect {
    static $t: Type;
    ag(a: CellPath, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
}
/**
 * @hidden
 */
export declare class RowEffect extends GridEffect {
    static $t: Type;
    b0: RowPath;
    ai(a: RowPath, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
}
/**
 * @hidden
 */
export declare class RowCellsEffect extends GridEffect {
    static $t: Type;
    b0: RowPath;
    ag(a: CellPath, b: VisualModel): boolean;
    bv(a: RowPath): void;
    bw(a: RowPath): void;
    be(a: VisualModel, b: CellPath): number;
}
/**
 * @hidden
 */
export declare class GridEffectManager extends Base {
    static $t: Type;
    private b;
    protected get c(): ITickProvider;
    constructor(a: ITickProvider, b: DataGrid);
    ae(a: RowPath): void;
    af(a: RowPath): void;
    private k;
    private j;
    private m;
    private l;
    private i;
    private n;
    private q;
    private o;
    a: DataGrid;
    private ad;
    d(): boolean;
    ac(): void;
    ab(): void;
    an(a: boolean): void;
    private p;
    private am;
    private aa;
    u(a: ColumnInfo, b: ColumnEffect): void;
    ai(a: number, b: boolean, c: GridEffect): void;
    z(a: GridColumnSpacer, b: SpacerEffect): void;
    al(a: GridColumnSpacer, b: boolean, c: GridEffect): void;
    t(a: ColumnInfo, b: ColumnCellsEffect): void;
    x(a: ColumnCellsEffect): void;
    y(a: ColumnCellsEffect): void;
    ah(a: number, b: boolean, c: GridEffect): void;
    w(a: RowPath, b: RowEffect): void;
    ak(a: RowPath, b: boolean, c: GridEffect): void;
    v(a: RowPath, b: RowCellsEffect): void;
    aj(a: RowPath, b: boolean, c: GridEffect): void;
    r(a: CellPath, b: CellEffect, c: number): void;
    s(a: CellPath, b: CellPositionEffect): void;
    ag(a: CellPath, b: boolean, c: GridEffect): void;
    f(a: number, b: VisualModel, c: GridLayerController): boolean;
    h(a: number, b: VisualModel, c: GridLayerController): boolean;
    g(a: number, b: VisualModel, c: GridLayerController): boolean;
    e(a: number, b: VisualModel, c: GridLayerController): boolean;
}
/**
 * @hidden
 */
export declare class GridLayerController extends Base {
    static $t: Type;
    private e;
    a(a: CellPath, b: VisualModel): CellModel;
    b(a: CellPath, b: DataGrid, c: VisualModel, d: GridLayer, e: ModelTypes, f: boolean, g: boolean, h: boolean): CellModel;
    private d;
    private g;
    private f;
    i(a: CellPath, b: VisualModel): void;
    j(a: CellPath, b: GridLayer, c: VisualModel): void;
    c(a: CellPath, b: VisualModel): CellModel;
    h(a: CellModel, b: VisualModel, c: number, d: number, e: number, f: number): void;
}
/**
 * @hidden
 */
export declare class VisibilityEngine extends Base {
    static $t: Type;
    private o;
    private f;
    private d;
    private c;
    private k;
    private e;
    private l;
    i: boolean;
    private q;
    get r(): number;
    set r(a: number);
    constructor();
    private g;
    ah(): void;
    t(a: DataGrid): void;
    u(a: DataGrid, b: VisualModel, c: SpatialEngine, d: boolean): void;
    a(a: DataGrid, b: VisualModel, c: SpatialEngine, d: Rect): CalculationParameters;
    private ag;
    private af;
    private ae;
    private ab;
    n(a: DataGrid, b: VisualModel, c: Rect): List$1<PinnedRowInfo>;
    m(a: DataGrid, b: VisualModel, c: Rect, d: CalculationParameters, e: boolean): List$1<PinnedRowInfo>;
    private am;
    private b;
    private j;
    private aa;
    private ac;
    private ad;
    private x;
    private z;
    p(a: ColumnInfo, b: DataGrid): number;
    private v;
    private ap;
    private ao;
    private y;
    private as;
    private h;
    private w;
    private aq;
    private aj;
    private ak;
    private al;
    private s;
    private ai;
    private an;
    private ar;
    private aw;
    private at;
    private au;
    private av;
}
/**
 * @hidden
 */
export declare class PinnedRowInfo extends Base {
    static $t: Type;
    m: number;
    o: string;
    l: number;
    get j(): number;
    k: number;
    i: number;
    e: boolean;
    private c;
    get h(): boolean;
    set h(a: boolean);
    a: DataSourceRowType;
    f: boolean;
    n: number;
    g: boolean;
    d: boolean;
    b: VisualModel;
    toString(): string;
}
/**
 * @hidden
 */
export declare class PushRowSettings extends Base {
    static $t: Type;
    a: number[];
    d: Dictionary$2<number, PinnedRowInfo>;
    b: boolean;
    c: boolean;
    e: number;
}
/**
 * @hidden
 */
export declare class PushRowResult extends Base {
    static $t: Type;
    b: boolean;
    a: PinnedRowInfo;
}
/**
 * @hidden
 */
export interface ICellRenderingEngine {
    refresh(a: VisualModel, b: boolean): void;
    viewportChanged(): void;
    invalidateVisibility(a: () => void): void;
    detach(): void;
    attach(): void;
    readonly initialRefreshFinished: boolean;
}
/**
 * @hidden
 */
export declare let ICellRenderingEngine_$type: Type;
/**
 * @hidden
 */
export declare class SpatialEngine extends Base {
    static $t: Type;
    private f;
    private c;
    private d;
    private e;
    r(a: DataGrid, b: VisualModel, c: number): void;
    s(a: VisualModel): void;
    q(a: DataGrid, b: VisualModel, c: number): void;
    g(a: ColumnInfo): number;
    private static p;
    k(a: number, b: DataGrid, c: VisualModel): number;
    l(a: number, b: VisualModel, c: boolean): number;
    private h;
    m(a: PinnedPositions, b: number, c: VisualModel): number;
    j(a: number, b: VisualModel): number;
    n(a: number, b: DataGrid, c: VisualModel): number;
    o(a: number, b: DataGrid, c: VisualModel): number;
    b(a: number, b: VisualModel): RowPath;
    v(a: GridLayerController, b: number, c: DataGridColumn, d: VisualModel): void;
    t(a: number, b: DataGridColumn, c: VisualModel): void;
    x(a: RowPath, b: VisualModel): void;
    y(a: GridLayerController, b: RowPath, c: VisualModel): void;
    private aa;
    private a;
    private ab;
    private z;
    w(a: GridLayerController, b: VisualModel): void;
    u(a: GridLayerController, b: VisualModel, c: number, d: number, e: number): void;
    i(a: VisualModel, b: RowPath): number;
}
/**
 * @hidden
 */
export declare class ColumnExchanger extends Base {
    static $t: Type;
    c: any;
    a: DataGridColumn;
    b: number;
    constructor(a: number);
    constructor(a: number, b: DataGridColumn, c: number);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class ColumnExchangersCollection extends ObservableCollection$1<ColumnExchanger> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ResponsiveEngine extends Base {
    static $t: Type;
    private c;
    private l;
    private m;
    private k;
    private h;
    private i;
    private j;
    private a;
    private f;
    get g(): ResponsiveStatesCollection;
    set g(a: ResponsiveStatesCollection);
    private b;
    private d;
    constructor(a: DataGrid);
    x(a: ResponsiveState): void;
    y(a: number, b: number): void;
    private w;
    private q;
    private t;
    private u;
    private o;
    private p;
    private r;
    private v;
    private s;
    private e;
    private n;
}
/**
 * @hidden
 */
export declare class ResponsivePhase extends Base {
    static $t: Type;
    j: any;
    k: string;
    i: number;
    private d;
    get e(): ColumnPropertySettersCollection;
    private a;
    get b(): ColumnExchangersCollection;
    g(a: ColumnPropertySetter): ResponsivePhase;
    c(): ColumnPropertySetter;
    f(a: ColumnExchanger): ResponsivePhase;
    h(): ResponsivePhase;
}
/**
 * @hidden
 */
export declare class ResponsivePhasesCollection extends ObservableCollection$1<ResponsivePhase> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class ResponsiveState extends Base {
    static $t: Type;
    m: any;
    n: string;
    k: number;
    j: number;
    stateEntering: (sender: any, eventArgs: ResponsiveStateEnteringEventArgs) => void;
    stateEntered: (sender: any, eventArgs: ResponsiveStateEnteredEventArgs) => void;
    stateExited: (sender: any, eventArgs: ResponsiveStateExitedEventArgs) => void;
    private h;
    get i(): boolean;
    set i(a: boolean);
    l: number;
    private b;
    get c(): ResponsivePhasesCollection;
    d(a: ResponsivePhase): ResponsiveState;
    a(): ResponsivePhase;
    p(): void;
    o(): void;
    q(): void;
}
/**
 * @hidden
 */
export declare class ResponsiveStatesCollection extends ObservableCollection$1<ResponsiveState> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class GridLayer extends FastIterationDictionary$2<CellPath, CellModel> {
    static $t: Type;
    v: string;
    constructor(a: string);
}
/**
 * @hidden
 */
export declare class ColumnInfo extends Base {
    static $t: Type;
    constructor();
    m: number;
    n: number;
    b: ColumnWidth;
    i: number;
    k: number;
    l: number;
    p: string;
    o: number;
    c: FixedCellPositions;
    g: number;
    j: number;
    h: number;
    e(a: VisualModel): number;
    f(a: VisualModel): number;
    a: ColumnStates;
    d: PinnedPositions;
}
/**
 * @hidden
 */
export declare class SectionInfo extends Base {
    static $t: Type;
    h: number;
    m: number;
    q: number;
    o: number;
    g: number;
    d: number;
    n: number;
    p: number;
    i: number;
    b: List$1<number>;
    c: List$1<number>;
    l(): number;
    e(a: number): number;
    f(a: number): number;
    k(): number;
    j(a: number): number;
    a(a: number): RowPath;
}
/**
 * @hidden
 */
export declare class VisualModel extends Base {
    static $t: Type;
    private _actualVisibleRegion;
    get actualVisibleRegion(): Rect;
    set actualVisibleRegion(a: Rect);
    private _absoluteWidth;
    get absoluteWidth(): number;
    set absoluteWidth(a: number);
    private _absoluteHeight;
    get absoluteHeight(): number;
    set absoluteHeight(a: number);
    c3: number;
    c6: number;
    c7: number;
    c1: number;
    cz: number;
    c0: number;
    cv: number;
    dd: number;
    de: number;
    cn: number;
    co: number;
    cx: number;
    cy: number;
    c4: number;
    da: number;
    cq: number;
    get cr(): number;
    get cm(): number;
    get cp(): number;
    get ch(): number;
    get cs(): number;
    cj: number;
    ck: number;
    cl: number;
    ci: number;
    c2: number;
    cw: number;
    private am;
    get bm(): GridLayer;
    set bm(a: GridLayer);
    private r;
    get a1(): GridLayer;
    set a1(a: GridLayer);
    private j;
    get at(): GridLayer;
    set at(a: GridLayer);
    private ag;
    get bg(): GridLayer;
    set bg(a: GridLayer);
    private l;
    get av(): GridLayer;
    set av(a: GridLayer);
    private ap;
    get bp(): GridLayer;
    set bp(a: GridLayer);
    private u;
    get a4(): GridLayer;
    set a4(a: GridLayer);
    private o;
    get ay(): GridLayer;
    set ay(a: GridLayer);
    private aa;
    get ba(): GridLayer;
    set ba(a: GridLayer);
    private q;
    get a0(): GridLayer;
    set a0(a: GridLayer);
    private k;
    get au(): GridLayer;
    set au(a: GridLayer);
    private ao;
    get bo(): GridLayer;
    set bo(a: GridLayer);
    private t;
    get a3(): GridLayer;
    set a3(a: GridLayer);
    private s;
    get a2(): GridLayer;
    set a2(a: GridLayer);
    private an;
    get bn(): GridLayer;
    set bn(a: GridLayer);
    private y;
    get a8(): GridLayer;
    set a8(a: GridLayer);
    private x;
    get a7(): GridLayer;
    set a7(a: GridLayer);
    private m;
    get aw(): GridLayer;
    set aw(a: GridLayer);
    private ar;
    get br(): GridLayer;
    set br(a: GridLayer);
    private w;
    get a6(): GridLayer;
    set a6(a: GridLayer);
    private v;
    get a5(): GridLayer;
    set a5(a: GridLayer);
    private aq;
    get bq(): GridLayer;
    set bq(a: GridLayer);
    private n;
    get ax(): GridLayer;
    set ax(a: GridLayer);
    private z;
    get a9(): GridLayer;
    set a9(a: GridLayer);
    private p;
    get az(): GridLayer;
    set az(a: GridLayer);
    private ah;
    get bh(): GridLayer;
    set bh(a: GridLayer);
    private ab;
    get bb(): GridLayer;
    set bb(a: GridLayer);
    private ac;
    get bc(): GridLayer;
    set bc(a: GridLayer);
    private ad;
    get bd(): GridLayer;
    set bd(a: GridLayer);
    private ai;
    get bi(): GridLayer;
    set bi(a: GridLayer);
    private ae;
    get be(): GridLayer;
    set be(a: GridLayer);
    private af;
    get bf(): GridLayer;
    set bf(a: GridLayer);
    private aj;
    get bj(): GridLayer;
    set bj(a: GridLayer);
    private al;
    get bl(): GridLayer;
    set bl(a: GridLayer);
    private ak;
    get bk(): GridLayer;
    set bk(a: GridLayer);
    private as;
    get bs(): GridLayer;
    set bs(a: GridLayer);
    private bt;
    get bu(): IColumnGroupingVisualModelExport;
    set bu(a: IColumnGroupingVisualModelExport);
    b: PagerVisualModelExport;
    bv: IToolbarVisualModelExport;
    private d;
    f(a: number, b: number): CellModel;
    private by;
    get bz(): FastIterationDictionary$2<CellPath, List$1<CellModel>>;
    set bz(a: FastIterationDictionary$2<CellPath, List$1<CellModel>>);
    ce: List$1<SectionInfo>;
    b9: List$1<ColumnInfo>;
    cd: List$1<ColumnInfo>;
    b3: boolean;
    b5: boolean;
    b2: boolean;
    private b8;
    get cf(): List$1<GridColumnSpacerCollection>;
    set cf(a: List$1<GridColumnSpacerCollection>);
    b6: Dictionary$2<number, number>;
    bx: RowPath;
    bw: RowPath;
    b4(): boolean;
    private di;
    private g;
    h(a: number): ColumnInfo;
    dj(a: ColumnInfo): void;
    constructor();
    private dn;
    private b7;
    get cc(): List$1<GridLayer>;
    b0(): boolean;
    dm(): void;
    dl(): void;
    c(): VisualModelExport;
    private a;
    cg: List$1<number>;
    c8: number;
    db: number;
    c9: number;
    dc: number;
    b1: boolean;
    dg: number;
    dh: number;
    df: number;
    i(a: number, b: ColumnInfo, c: number, d: boolean, e: boolean): GridColumnSpacer;
    dk(a: GridColumnSpacer): void;
    cb(a: ColumnInfo): List$1<GridColumnSpacer>;
    ca(a: ColumnInfo): List$1<CellModel>;
    e(a: number, b: number, c?: GridCellType): CellModel;
    c5(): number;
}
