import { Type } from "igniteui-react-core";
/**
 * Enumerates the options for how column hiding is animated.
 */
export declare enum ColumnHidingAnimationMode {
    /**
     * The correct animation mode is automatically selected.
     */
    Auto = 0,
    /**
     * No animation is performed.
     */
    None = 1,
    /**
     * The cells slide to the left.
     */
    SlideToLeft = 2,
    /**
     * The cells slide to the right.
     */
    SlideToRight = 3,
    /**
     * The cells slide to the top.
     */
    SlideToTop = 4,
    /**
     * The cells slide to the bottom.
     */
    SlideToBottom = 5,
    /**
     * The cells fade out.
     */
    FadeOut = 6,
    /**
     * The cells slide to the left and fade out.
     */
    SlideToLeftAndFadeOut = 7,
    /**
     * The cells slide to the right and fade out.
     */
    SlideToRightAndFadeOut = 8,
    /**
     * The cells slide to the top and fade out.
     */
    SlideToTopAndFadeOut = 9,
    /**
     * The cells slide to the bottom and fade out.
     */
    SlideToBottomAndFadeOut = 10
}
/**
 * @hidden
 */
export declare let ColumnHidingAnimationMode_$type: Type;
