import { Type } from "igniteui-react-core";
/**
 * Indicates what type of alignment to use for the column options icon.
 */
export declare enum ColumnOptionsIconAlignment {
    /**
     * Use the default alignment.
     */
    Unset = 0,
    /**
     * The icon is not aligned so it will appear alongside the header text.
     */
    None = 1,
    /**
     * The icon is aligned with the edge of the column but opposite the alignment of the header text.
     */
    Opposite = 2
}
/**
 * @hidden
 */
export declare let ColumnOptionsIconAlignment_$type: Type;
