import { Type } from "igniteui-react-core";
/**
 * Indicates how the column options icon will behave in the column header cell.
 */
export declare enum ColumnOptionsIconBehavior {
    /**
     * Use the default behavior which is AppearOnHoverAnimate.
     */
    Unset = 0,
    /**
     * The column options icon is always visible.
     */
    AlwaysVisible = 1,
    /**
     * The column options icon will appear when the header cell is hovered.
     */
    AppearOnHover = 2,
    /**
     * The column options icon will animate into view when the header cell is hovered.
     */
    AppearOnHoverAnimate = 3
}
/**
 * @hidden
 */
export declare let ColumnOptionsIconBehavior_$type: Type;
