import { Type } from "igniteui-react-core";
/**
 * Enumerates the options for how changes to column properties are animated.
 */
export declare enum ColumnPropertyUpdatingAnimationMode {
    /**
     * Automatically decides on the animation mode to use.
     */
    Auto = 0,
    /**
     * No animation is performed.
     */
    None = 1,
    /**
     * The previous value and the next value are interpolated between.
     */
    Interpolate = 2,
    /**
     * Deep values within the previous and next value are interpolated between.
     */
    InterpolateDeep = 3
}
/**
 * @hidden
 */
export declare let ColumnPropertyUpdatingAnimationMode_$type: Type;
