import { Type } from "igniteui-react-core";
/**
 * Enumerates the options for how columns animate into view.
 */
export declare enum ColumnShowingAnimationMode {
    /**
     * Automatically selects the correct animation mode.
     */
    Auto = 0,
    /**
     * No animation should be performed.
     */
    None = 1,
    /**
     * Cells slide in from the left.
     */
    SlideFromLeft = 2,
    /**
     * Cells slide in from the right.
     */
    SlideFromRight = 3,
    /**
     * Cells slide in from the top.
     */
    SlideFromTop = 4,
    /**
     * Cells slide in from the bottom.
     */
    SlideFromBottom = 5,
    /**
     * Cells fade in.
     */
    FadeIn = 6,
    /**
     * Cells slide in from the left and fade in.
     */
    SlideFromLeftAndFadeIn = 7,
    /**
     * Cells slide in from the right and fade in.
     */
    SlideFromRightAndFadeIn = 8,
    /**
     * Cells slide in from the top and fade in.
     */
    SlideFromTopAndFadeIn = 9,
    /**
     * Cells slide in from the bottom and fade in.
     */
    SlideFromBottomAndFadeIn = 10
}
/**
 * @hidden
 */
export declare let ColumnShowingAnimationMode_$type: Type;
