import { Type } from "igniteui-react-core";
/**
 * Indicates the selection mode to use for the grid.
 */
export declare enum DataGridSelectionMode {
    /**
     * No selection should be peformed based on interaction.
     */
    None = 0,
    /**
     * A single row is permitted to be selected at a time from interaction.
     */
    SingleRow = 1,
    /**
     * Multiple rows are permitted to be selected at a time from interaction.
     */
    MultipleRow = 2,
    /**
     * A single cell is permitted to be selected at a time from interaction.
     */
    SingleCell = 3,
    /**
     * Multiple cells are permitted to be selected at a time from interaction.
     */
    MultipleCell = 4,
    /**
     * Multiple cells are allowed to be selected however they are stored as ranges not individual cells.
     */
    RangeCell = 5
}
/**
 * @hidden
 */
export declare let DataGridSelectionMode_$type: Type;
