import { Type } from "igniteui-react-core";
/**
 * Indicates some simple date formats to be used.
 */
export declare enum DateTimeFormats {
    /**
     * A standard short date format is used.
     */
    DateShort = 0,
    /**
     * A standard long date format is used.
     */
    DateLong = 1,
    /**
     * A standard short time format is used.
     */
    TimeShort = 2,
    /**
     * A standard long time format is used.
     */
    TimeLong = 3,
    /**
     * A standard short date/time format is used.
     */
    DateTimeShort = 4,
    /**
     * A standard long date/time format is used.
     */
    DateTimeLong = 5
}
/**
 * @hidden
 */
export declare let DateTimeFormats_$type: Type;
