import { Type } from "igniteui-react-core";
/**
 * Indicates what type of click action will activate edit mode.
 */
export declare enum EditModeClickAction {
    /**
     * Mouse clicks will be ignored for edit mode activation.
     */
    None = 0,
    /**
     * A single click is required to enter edit mode.
     */
    SingleClick = 1,
    /**
     * A double click is required to enter edit mode.
     */
    DoubleClick = 2
}
/**
 * @hidden
 */
export declare let EditModeClickAction_$type: Type;
