import { Type } from "igniteui-react-core";
/**
 * Indicates what should occur when entering edit mode.
 */
export declare enum EditModeType {
    /**
     * Edit mode is disabled.
     */
    None = 0,
    /**
     * Allow cells to enter edit mode and commit the value on exit.
     */
    Cell = 1,
    /**
     * Allows cells to enter edit mode but changes will be cached for later commit.
     */
    CellBatch = 2,
    /**
     * Allow rows to enter edit mode and commit the value on exit.
     */
    Row = 3
}
/**
 * @hidden
 */
export declare let EditModeType_$type: Type;
