import { Type } from "igniteui-react-core";
/**
 * Indicates what editor type to use for cell editing.
 */
export declare enum EditorType {
    /**
     * Default edit type used in cell editing.
     */
    Default = 0,
    /**
     * Use a text editor for cell editing.
     */
    Text = 1,
    /**
     * Use a numeric editor for cell editing.
     */
    Numeric = 2,
    /**
     * Use a date editor for cell editing.
     */
    Date = 3,
    /**
     * Use a combo editor for cell editing.
     */
    Combo = 4
}
/**
 * @hidden
 */
export declare let EditorType_$type: Type;
