import { Type } from "igniteui-react-core";
/**
 * Indicates the action to take after the Enter key is pressed to complete edit mode.
 */
export declare enum EnterKeyBehaviorAfterEdit {
    /**
     * The Enter key does nothing.
     */
    None = 0,
    /**
     * Moves the active cell down after the Enter key is pressed.
     */
    MoveDown = 1,
    /**
     * Moves the active cell to the right after the Enter key is pressed.
     */
    MoveRight = 2,
    /**
     * Moves the active cell up after the Enter key is pressed.
     */
    MoveUp = 3,
    /**
     * Moves the active cell to the left after the Enter key is pressed.
     */
    MoveLeft = 4
}
/**
 * @hidden
 */
export declare let EnterKeyBehaviorAfterEdit_$type: Type;
