import { Type } from "igniteui-react-core";
/**
 * Indicates the action the enter key should take when the Enter key is pressed.
 */
export declare enum EnterKeyBehaviors {
    /**
     * The Enter key does nothing.
     */
    None = 0,
    /**
     * Place the active cell into edit mode when the Enter key is pressed if edit mode is enabled.
     */
    Edit = 1,
    /**
     * Moves the active cell down after the Enter key is pressed.
     */
    MoveDown = 2,
    /**
     * Moves the active cell to the right after the Enter key is pressed.
     */
    MoveRight = 3,
    /**
     * Moves the active cell up after the Enter key is pressed.
     */
    MoveUp = 4,
    /**
     * Moves the active cell to the left after the Enter key is pressed.
     */
    MoveLeft = 5
}
/**
 * @hidden
 */
export declare let EnterKeyBehaviors_$type: Type;
