import { Type } from "igniteui-react-core";
/**
 * Indicates which type of filter UI to use.
 */
export declare enum FilterUIType {
    /**
     * Filtering is displayed within the column options menu.
     */
    ColumnOptions = 0,
    /**
     * A filter row is displayed. Each filter cell in the row will let you select filter operator as well as filter
     * condition for the associated field.
     */
    FilterRow = 1,
    /**
     * No filter UI is used.
     */
    None = 2
}
/**
 * @hidden
 */
export declare let FilterUIType_$type: Type;
