import { Base, Type } from "igniteui-react-core";
import { WCNativeHelper } from "igniteui-react";
import { BaseEventArgsDetail } from "./BaseEventArgsDetail";
import { HierarchicalGridBaseDirective } from "./HierarchicalGridBaseDirective";
import { CellType } from "./CellType";
import { RowType } from "./RowType";
import { BaseElement } from "igniteui-react";
import { DataCloneStrategy } from "./DataCloneStrategy";
import { ClipboardOptions } from "./ClipboardOptions";
import { ActionStripCollection } from "./ActionStripCollection";
import { GridRowDragGhostContext } from "./GridRowDragGhostContext";
import { GridRowEditTextTemplateContext } from "./GridRowEditTextTemplateContext";
import { GridEmptyTemplateContext } from "./GridEmptyTemplateContext";
import { GridRowEditActionsTemplateContext } from "./GridRowEditActionsTemplateContext";
import { GridRowTemplateContext } from "./GridRowTemplateContext";
import { GridTemplateContext } from "./GridTemplateContext";
import { GridHeaderTemplateContext } from "./GridHeaderTemplateContext";
import { GridToolbarCollection } from "./GridToolbarCollection";
import { PaginatorCollection } from "./PaginatorCollection";
import { GridResourceStrings } from "./GridResourceStrings";
import { FilteringLogic } from "./FilteringLogic";
import { FilteringExpressionsTree } from "./FilteringExpressionsTree";
import { GridPagingMode } from "./GridPagingMode";
import { GridValidationTrigger } from "./GridValidationTrigger";
import { PinningConfig } from "./PinningConfig";
import { FilterMode } from "./FilterMode";
import { GridSummaryPosition } from "./GridSummaryPosition";
import { GridSummaryCalculationMode } from "./GridSummaryCalculationMode";
import { FilteringStrategy } from "./FilteringStrategy";
import { GridSortingStrategy } from "./GridSortingStrategy";
import { SortingOptions } from "./SortingOptions";
import { HeadSelectorTemplateContext } from "./HeadSelectorTemplateContext";
import { RowSelectorTemplateContext } from "./RowSelectorTemplateContext";
import { SortingExpression } from "./SortingExpression";
import { GridSelectionMode } from "./GridSelectionMode";
import { ColumnCollection } from "./ColumnCollection";
import { ForOfStateEventArgs } from "./ForOfStateEventArgs";
import { FilteringExpressionsTreeEventArgs } from "./FilteringExpressionsTreeEventArgs";
import { GridScrollEventArgs } from "./GridScrollEventArgs";
import { GridCellEventArgs } from "./GridCellEventArgs";
import { GridFormGroupCreatedEventArgs } from "./GridFormGroupCreatedEventArgs";
import { GridValidationStatusEventArgs } from "./GridValidationStatusEventArgs";
import { RowSelectionEventArgs } from "./RowSelectionEventArgs";
import { ColumnSelectionEventArgs } from "./ColumnSelectionEventArgs";
import { PinColumnCancellableEventArgs } from "./PinColumnCancellableEventArgs";
import { PinColumnEventArgs } from "./PinColumnEventArgs";
import { GridEditEventArgs } from "./GridEditEventArgs";
import { GridEditDoneEventArgs } from "./GridEditDoneEventArgs";
import { ColumnComponentEventArgs } from "./ColumnComponentEventArgs";
import { ColumnsAutoGeneratedEventArgs } from "./ColumnsAutoGeneratedEventArgs";
import { SortingEventArgs } from "./SortingEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { FilteringEventArgs } from "./FilteringEventArgs";
import { RowDataEventArgs } from "./RowDataEventArgs";
import { ColumnResizeEventArgs } from "./ColumnResizeEventArgs";
import { ColumnVisibilityChangingEventArgs } from "./ColumnVisibilityChangingEventArgs";
import { ColumnVisibilityChangedEventArgs } from "./ColumnVisibilityChangedEventArgs";
import { ColumnMovingStartEventArgs } from "./ColumnMovingStartEventArgs";
import { ColumnMovingEventArgs } from "./ColumnMovingEventArgs";
import { ColumnMovingEndEventArgs } from "./ColumnMovingEndEventArgs";
import { GridKeydownEventArgs } from "./GridKeydownEventArgs";
import { RowDragStartEventArgs } from "./RowDragStartEventArgs";
import { RowDragEndEventArgs } from "./RowDragEndEventArgs";
import { GridClipboardEventEventArgs } from "./GridClipboardEventEventArgs";
import { RowToggleEventArgs } from "./RowToggleEventArgs";
import { PinRowEventArgs } from "./PinRowEventArgs";
import { ActiveNodeChangeEventArgs } from "./ActiveNodeChangeEventArgs";
import { GridToolbarExportEventArgs } from "./GridToolbarExportEventArgs";
import { GridSelectionRangeEventArgs } from "./GridSelectionRangeEventArgs";
import { VoidEventArgs } from "igniteui-react";
import { ForOfDataChangingEventArgs } from "./ForOfDataChangingEventArgs";
import { Column } from "./Column";
import { DropPosition } from "./DropPosition";
import { FilteringExpressionsTreeOrFilteringOperation } from "./FilteringExpressionsTreeOrFilteringOperation";
import { GridSelectionRange } from "./GridSelectionRange";
import { CellPosition } from "./CellPosition";
import { OverlaySettings } from "./OverlaySettings";
import { ObservableCollection$1 } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class GridCreatedEventArgs extends Base {
    static $t: Type;
    b: GridCreatedEventArgsDetail;
    static a(a: any): GridCreatedEventArgs;
}
/**
 * @hidden
 */
export declare class GridCreatedEventArgsDetail extends BaseEventArgsDetail {
    static $t: Type;
    get h(): RowIsland;
    set h(a: RowIsland);
    get i(): any;
    set i(a: any);
    get g(): HierarchicalGrid;
    set g(a: HierarchicalGrid);
}
/**
 * @hidden
 */
export declare class HierarchicalGrid extends HierarchicalGridBaseDirective {
    static $t: Type;
    get g6(): RowIslandCollection;
    get he(): string;
    set he(a: string);
    get g2(): any[];
    set g2(a: any[]);
    get hc(): number;
    set hc(a: number);
    get g9(): boolean;
    set g9(a: boolean);
    get hd(): any;
    get g3(): CellType[];
    g7(a: number): RowType;
    g8(a: any): RowType;
    g4(a: number, b: string): CellType;
    g5(a: any, b: string): CellType;
    ha(a: any, b?: number): boolean;
    hb(a: any): boolean;
    hf(a: any): void;
}
/**
 * @hidden
 */
export declare class RowIsland extends BaseElement {
    static $t: Type;
    private bz;
    protected get b0(): WCNativeHelper;
    private co;
    protected get nativeElement(): any;
    protected set nativeElement(a: any);
    setNativeElement(a: any): void;
    get dv(): string;
    set dv(a: string);
    get bq(): RowIslandCollection;
    get b(): any[];
    set b(a: any[]);
    get b5(): boolean;
    set b5(a: boolean);
    get d0(): string;
    set d0(a: string);
    get ce(): boolean;
    set ce(a: boolean);
    get b4(): boolean;
    set b4(a: boolean);
    get cl(): number;
    set cl(a: number);
    get b3(): boolean;
    set b3(a: boolean);
    get a(): string[];
    set a(a: string[]);
    get b8(): boolean;
    set b8(a: boolean);
    private cx;
    get df(): (arg: any) => any;
    set df(a: (arg: any) => any);
    private cu;
    get dc(): (arg: any) => any;
    set dc(a: (arg: any) => any);
    private c2;
    get dk(): (arg: any) => any;
    set dk(a: (arg: any) => any);
    get cm(): number;
    set cm(a: number);
    get x(): DataCloneStrategy;
    set x(a: DataCloneStrategy);
    get k(): ClipboardOptions;
    set k(a: ClipboardOptions);
    get cs(): any;
    set cs(a: any);
    get ct(): any;
    set ct(a: any);
    get d3(): string;
    set d3(a: string);
    get g(): ActionStripCollection;
    private cv;
    get dd(): (arg: GridRowDragGhostContext) => any;
    set dd(a: (arg: GridRowDragGhostContext) => any);
    private c6;
    get dp(): (arg: GridRowEditTextTemplateContext) => any;
    set dp(a: (arg: GridRowEditTextTemplateContext) => any);
    private c3;
    get dl(): (arg: GridEmptyTemplateContext) => any;
    set dl(a: (arg: GridEmptyTemplateContext) => any);
    private c5;
    get dn(): (arg: GridRowEditActionsTemplateContext) => any;
    set dn(a: (arg: GridRowEditActionsTemplateContext) => any);
    private c7;
    get dq(): (arg: GridRowTemplateContext) => any;
    set dq(a: (arg: GridRowTemplateContext) => any);
    private c4;
    get dm(): (arg: GridRowTemplateContext) => any;
    set dm(a: (arg: GridRowTemplateContext) => any);
    private c0;
    get di(): (arg: GridTemplateContext) => any;
    set di(a: (arg: GridTemplateContext) => any);
    private cz;
    get dh(): (arg: GridTemplateContext) => any;
    set dh(a: (arg: GridTemplateContext) => any);
    private cy;
    get dg(): (arg: GridHeaderTemplateContext) => any;
    set dg(a: (arg: GridHeaderTemplateContext) => any);
    private c9;
    get ds(): (arg: GridHeaderTemplateContext) => any;
    set ds(a: (arg: GridHeaderTemplateContext) => any);
    private da;
    get dt(): (arg: GridHeaderTemplateContext) => any;
    set dt(a: (arg: GridHeaderTemplateContext) => any);
    private db;
    get du(): (arg: GridHeaderTemplateContext) => any;
    set du(a: (arg: GridHeaderTemplateContext) => any);
    get bc(): GridToolbarCollection;
    get bg(): PaginatorCollection;
    get a3(): GridResourceStrings;
    set a3(a: GridResourceStrings);
    get ae(): FilteringLogic;
    set ae(a: FilteringLogic);
    get aa(): FilteringExpressionsTree;
    set aa(a: FilteringExpressionsTree);
    get z(): FilteringExpressionsTree;
    set z(a: FilteringExpressionsTree);
    get d1(): string;
    set d1(a: string);
    get a2(): GridPagingMode;
    set a2(a: GridPagingMode);
    get b6(): boolean;
    set b6(a: boolean);
    get ca(): boolean;
    set ca(a: boolean);
    get bf(): GridValidationTrigger;
    set bf(a: GridValidationTrigger);
    get cb(): boolean;
    set cb(a: boolean);
    get ck(): number;
    set ck(a: number);
    get dw(): string;
    set dw(a: string);
    get dy(): string;
    set dy(a: string);
    get b7(): boolean;
    set b7(a: boolean);
    get cd(): boolean;
    set cd(a: boolean);
    get dx(): string;
    set dx(a: string);
    get bj(): PinningConfig;
    set bj(a: PinningConfig);
    get b2(): boolean;
    set b2(a: boolean);
    get b1(): boolean;
    set b1(a: boolean);
    get ag(): FilterMode;
    set ag(a: FilterMode);
    get bb(): GridSummaryPosition;
    set bb(a: GridSummaryPosition);
    get ba(): GridSummaryCalculationMode;
    set ba(a: GridSummaryCalculationMode);
    get cf(): boolean;
    set cf(a: boolean);
    get af(): FilteringStrategy;
    set af(a: FilteringStrategy);
    get a9(): GridSortingStrategy;
    set a9(a: GridSortingStrategy);
    get bw(): SortingOptions;
    set bw(a: SortingOptions);
    get e(): any[];
    set e(a: any[]);
    private c1;
    get dj(): (arg: HeadSelectorTemplateContext) => any;
    set dj(a: (arg: HeadSelectorTemplateContext) => any);
    private c8;
    get dr(): (arg: RowSelectorTemplateContext) => any;
    set dr(a: (arg: RowSelectorTemplateContext) => any);
    private cw;
    get de(): (arg: GridEmptyTemplateContext) => any;
    set de(a: (arg: GridEmptyTemplateContext) => any);
    get f(): SortingExpression[];
    set f(a: SortingExpression[]);
    get a5(): GridSelectionMode;
    set a5(a: GridSelectionMode);
    get a7(): GridSelectionMode;
    set a7(a: GridSelectionMode);
    get a6(): GridSelectionMode;
    set a6(a: GridSelectionMode);
    get n(): ColumnCollection;
    get cn(): number;
    set cn(a: number);
    get cc(): boolean;
    set cc(a: boolean);
    gridCreated: (sender: any, args: GridCreatedEventArgs) => void;
    gridCreatedChanged(): void;
    gridInitialized: (sender: any, args: GridCreatedEventArgs) => void;
    gridInitializedChanged(): void;
    dataPreLoad: (sender: any, args: ForOfStateEventArgs) => void;
    dataPreLoadChanged(): void;
    filteringExpressionsTreeChange: (sender: any, args: FilteringExpressionsTreeEventArgs) => void;
    filteringExpressionsTreeChangeChanged(): void;
    advancedFilteringExpressionsTreeChange: (sender: any, args: FilteringExpressionsTreeEventArgs) => void;
    advancedFilteringExpressionsTreeChangeChanged(): void;
    gridScroll: (sender: any, args: GridScrollEventArgs) => void;
    gridScrollChanged(): void;
    cellClick: (sender: any, args: GridCellEventArgs) => void;
    cellClickChanged(): void;
    formGroupCreated: (sender: any, args: GridFormGroupCreatedEventArgs) => void;
    formGroupCreatedChanged(): void;
    validationStatusChange: (sender: any, args: GridValidationStatusEventArgs) => void;
    validationStatusChangeChanged(): void;
    selected: (sender: any, args: GridCellEventArgs) => void;
    selectedChanged(): void;
    rowSelectionChanging: (sender: any, args: RowSelectionEventArgs) => void;
    rowSelectionChangingChanged(): void;
    columnSelectionChanging: (sender: any, args: ColumnSelectionEventArgs) => void;
    columnSelectionChangingChanged(): void;
    columnPin: (sender: any, args: PinColumnCancellableEventArgs) => void;
    columnPinChanged(): void;
    columnPinned: (sender: any, args: PinColumnEventArgs) => void;
    columnPinnedChanged(): void;
    cellEditEnter: (sender: any, args: GridEditEventArgs) => void;
    cellEditEnterChanged(): void;
    cellEditExit: (sender: any, args: GridEditDoneEventArgs) => void;
    cellEditExitChanged(): void;
    cellEdit: (sender: any, args: GridEditEventArgs) => void;
    cellEditChanged(): void;
    cellEditDone: (sender: any, args: GridEditDoneEventArgs) => void;
    cellEditDoneChanged(): void;
    rowEditEnter: (sender: any, args: GridEditEventArgs) => void;
    rowEditEnterChanged(): void;
    rowEdit: (sender: any, args: GridEditEventArgs) => void;
    rowEditChanged(): void;
    rowEditDone: (sender: any, args: GridEditDoneEventArgs) => void;
    rowEditDoneChanged(): void;
    rowEditExit: (sender: any, args: GridEditDoneEventArgs) => void;
    rowEditExitChanged(): void;
    columnInit: (sender: any, args: ColumnComponentEventArgs) => void;
    columnInitChanged(): void;
    columnsAutogenerated: (sender: any, args: ColumnsAutoGeneratedEventArgs) => void;
    columnsAutogeneratedChanged(): void;
    sorting: (sender: any, args: SortingEventArgs) => void;
    sortingChanged(): void;
    sortingDone: (sender: any, args: SortingExpressionEventArgs) => void;
    sortingDoneChanged(): void;
    filtering: (sender: any, args: FilteringEventArgs) => void;
    filteringChanged(): void;
    filteringDone: (sender: any, args: FilteringExpressionsTreeEventArgs) => void;
    filteringDoneChanged(): void;
    rowAdded: (sender: any, args: RowDataEventArgs) => void;
    rowAddedChanged(): void;
    rowDeleted: (sender: any, args: RowDataEventArgs) => void;
    rowDeletedChanged(): void;
    rowDelete: (sender: any, args: GridEditEventArgs) => void;
    rowDeleteChanged(): void;
    rowAdd: (sender: any, args: GridEditEventArgs) => void;
    rowAddChanged(): void;
    columnResized: (sender: any, args: ColumnResizeEventArgs) => void;
    columnResizedChanged(): void;
    contextMenu: (sender: any, args: GridCellEventArgs) => void;
    contextMenuChanged(): void;
    doubleClick: (sender: any, args: GridCellEventArgs) => void;
    doubleClickChanged(): void;
    columnVisibilityChanging: (sender: any, args: ColumnVisibilityChangingEventArgs) => void;
    columnVisibilityChangingChanged(): void;
    columnVisibilityChanged: (sender: any, args: ColumnVisibilityChangedEventArgs) => void;
    columnVisibilityChangedChanged(): void;
    columnMovingStart: (sender: any, args: ColumnMovingStartEventArgs) => void;
    columnMovingStartChanged(): void;
    columnMoving: (sender: any, args: ColumnMovingEventArgs) => void;
    columnMovingChanged(): void;
    columnMovingEnd: (sender: any, args: ColumnMovingEndEventArgs) => void;
    columnMovingEndChanged(): void;
    gridKeydown: (sender: any, args: GridKeydownEventArgs) => void;
    gridKeydownChanged(): void;
    rowDragStart: (sender: any, args: RowDragStartEventArgs) => void;
    rowDragStartChanged(): void;
    rowDragEnd: (sender: any, args: RowDragEndEventArgs) => void;
    rowDragEndChanged(): void;
    gridCopy: (sender: any, args: GridClipboardEventEventArgs) => void;
    gridCopyChanged(): void;
    rowToggle: (sender: any, args: RowToggleEventArgs) => void;
    rowToggleChanged(): void;
    rowPinning: (sender: any, args: PinRowEventArgs) => void;
    rowPinningChanged(): void;
    rowPinned: (sender: any, args: PinRowEventArgs) => void;
    rowPinnedChanged(): void;
    activeNodeChange: (sender: any, args: ActiveNodeChangeEventArgs) => void;
    activeNodeChangeChanged(): void;
    sortingExpressionsChange: (sender: any, args: SortingExpressionEventArgs) => void;
    sortingExpressionsChangeChanged(): void;
    toolbarExporting: (sender: any, args: GridToolbarExportEventArgs) => void;
    toolbarExportingChanged(): void;
    rangeSelected: (sender: any, args: GridSelectionRangeEventArgs) => void;
    rangeSelectedChanged(): void;
    rendered: (sender: any, args: VoidEventArgs) => void;
    renderedChanged(): void;
    dataChanging: (sender: any, args: ForOfDataChangingEventArgs) => void;
    dataChangingChanged(): void;
    dataChanged: (sender: any, args: VoidEventArgs) => void;
    dataChangedChanged(): void;
    fm(a: number): void;
    gj(a: ColumnVisibilityChangedEventArgs): void;
    e6(): void;
    eh(): void;
    e7(a: any): void;
    ei(a: any): void;
    gk(a: any): void;
    dz(a: Column): string;
    l(a: string): Column;
    m(a: number): Column;
    fs(): void;
    fo(a: Column, b: Column, c: DropPosition): void;
    fn(): void;
    cp(a: any): any;
    gm(a: any, b: any, c: string): void;
    gn(a: any, b: any): void;
    cq(a: any): any;
    gf(a: SortingExpression[]): void;
    e8(a: string, b: any, c: FilteringExpressionsTreeOrFilteringOperation, d?: boolean): void;
    e9(a: any, b: any, c: any): void;
    e4(a: any[]): void;
    e2(a: any[]): void;
    ed(a: string): void;
    ef(a: string): void;
    b9(a: string, b: any): boolean;
    cg(a: string, b: any): boolean;
    ch(a: string, b?: boolean, c?: boolean): number;
    ci(a: string, b?: boolean, c?: boolean): number;
    cj(a?: boolean, b?: boolean): number;
    ee(): void;
    fe(a?: boolean): void;
    gd(a: any[], b?: boolean): void;
    e1(a: any[]): void;
    f9(a?: boolean): void;
    ez(a?: boolean): void;
    ec(): void;
    gc(a: GridSelectionRange[]): void;
    c(): GridSelectionRange[];
    fg(a?: boolean, b?: boolean): void;
    d(): Column[];
    ga(a: string[], b?: boolean): void;
    e0(a: string[]): void;
    ey(): void;
    f8(): void;
    ff(a?: boolean, b?: boolean): void;
    fp(a: number, b: number, c: any): void;
    i(a: number, b: number, c: any): CellPosition;
    j(a: number, b: number, c: any): CellPosition;
    fq(a: OverlaySettings): void;
    eg(a: boolean): void;
    e5(a: boolean, b: any): void;
    d6(a: any, b?: boolean): void;
    get d2(): string;
    set d2(a: string);
}
/**
 * @hidden
 */
export declare class RowIslandCollection extends ObservableCollection$1<RowIsland> {
    static $t: Type;
    constructor();
}
