import { Type } from "igniteui-react-core";
/**
 * Indicates the selection mode to use for the grid.
 */
export declare enum GridSelectionBehavior {
    /**
     * Rows and cells are selected using a toggleable behavior. Modifier selection is ignored (CTRL and SHIFT).
     */
    Toggle = 0,
    /**
     * Only one row or cell is selected at a time and modifier keys are required to multi-select them.
     */
    ModifierBased = 1
}
/**
 * @hidden
 */
export declare let GridSelectionBehavior_$type: Type;
