import { Type } from "igniteui-react-core";
/**
 * Indicates how summaries are displayed inside groups.
 */
export declare enum GroupSummaryDisplayMode {
    /**
     * Group summaries are displayed in a flat list in the spanning group header.
     */
    List = 0,
    /**
     * The group header is rendered as cells and summary values are rendered inside the cells
     * aligned with their column.
     */
    Cells = 1,
    /**
     * Group summaries are displayed as summary rows at the top of the group.
     */
    RowTop = 2,
    /**
     * Group summaries are displayed as summary rows at the bottom of the group.
     */
    RowBottom = 3,
    /**
     * No summaries are displayed in the group.
     */
    None = 4
}
/**
 * @hidden
 */
export declare let GroupSummaryDisplayMode_$type: Type;
