import { Type } from "igniteui-react-core";
/**
 * Indicates what should occur on a header click event.
 */
export declare enum HeaderClickAction {
    /**
     * Sorting by one column is permitted and toggles between ascending and descending.
     */
    SortByOneColumnOnly = 0,
    /**
     * Sorting by multiple columns is permitted and each toggle between ascending and descending.
     */
    SortByMultipleColumns = 1,
    /**
     * Sorting by one column is permitted and toggles between ascending, descending and unsorted.
     */
    SortByOneColumnOnlyTriState = 2,
    /**
     * Sorting by multiple columns is permitted and toggles between ascending, descending and unsorted.
     */
    SortByMultipleColumnsTriState = 3,
    /**
     * No action is triggered.
     */
    None = 4
}
/**
 * @hidden
 */
export declare let HeaderClickAction_$type: Type;
