import { Type } from "igniteui-react-core";
/**
 * Indicates the image resource type to use.
 */
export declare enum ImageResourceType {
    /**
     * Image resource type will attempt to be determined from any scheme specifiers on the paths.
     */
    Unspecified = 0,
    /**
     * Images are a local platform specific resource in the application.
     */
    LocalResource = 1,
    /**
     * Images are a local platform specific asset in the application. For platforms that don't support assets, this will fall back on local resource.
     */
    LocalAsset = 2,
    /**
     * Images are a .NET embedded resource in the application. Path needs to be a valid embedded resource identifier.
     */
    EmbeddedResource = 3,
    /**
     * Images are a remote URL resource.
     */
    RemoteResource = 4
}
/**
 * @hidden
 */
export declare let ImageResourceType_$type: Type;
