import { Type } from "igniteui-react-core";
/**
 * Indicates when the grid should merge cells with same values.
 */
export declare enum MergedCellMode {
    /**
     * At the grid level it defaults to Never. At the column level it defers
     * to the grid level.
     */
    Default = 0,
    /**
     * The grid will never merge cells.
     */
    Never = 1,
    /**
     * The grid will always merge cells.
     */
    Always = 2,
    /**
     * The grid will only merge cells after a sort occurs.
     */
    OnlyWhenSorted = 3
}
/**
 * @hidden
 */
export declare let MergedCellMode_$type: Type;
