import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DataGrid } from "./DataGrid";
import { DomWrapper, DomRenderer } from "igniteui-react-core";
import { DataGridColumn } from "./DataGridColumn";
import { InputChangeEventArgs } from "igniteui-react-inputs";
import { KeyEventArgs } from "igniteui-react-core";
import { IDataSource } from "igniteui-react-core";
import { GotFocusEventArgs } from "./GotFocusEventArgs";
import { LostFocusEventArgs } from "./LostFocusEventArgs";
import { FontInfo } from "igniteui-react-core";
import { ColumnWidth } from "./ColumnWidth";
import { SortMode } from "./SortMode";
import { IDataSourceUpdateNotifier } from "igniteui-react-core";
import { CornerRadius } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { InputGroupDisplayType } from "igniteui-react-inputs";
import { MultiColumnComboBoxTextChangedEventArgs } from "./MultiColumnComboBoxTextChangedEventArgs";
import { MultiColumnComboBoxValueChangedEventArgs } from "./MultiColumnComboBoxValueChangedEventArgs";
import { MultiColumnComboVisualModelExport } from "./MultiColumnComboVisualModelExport";
/**
 * @hidden
 */
export declare class MultiColumnComboBoxView extends Base {
    static $t: Type;
    private ac;
    private ak;
    private f;
    private ai;
    private k;
    private ah;
    private j;
    private aj;
    private l;
    private h;
    private ae;
    private i;
    private af;
    private m;
    private ag;
    private d;
    private aq;
    private static readonly ar;
    private static readonly at;
    private static readonly as;
    private ab;
    private au;
    private aa;
    private ap;
    private x;
    private a;
    private c;
    private w;
    private s;
    private r;
    private p;
    private an;
    private am;
    get e(): DataGrid;
    private get y();
    private get n();
    protected bg(a: DomWrapper): void;
    bh(a: MultiColumnComboBox): void;
    bq(): void;
    protected b2(): void;
    private aw;
    ay(): void;
    az(): void;
    private u;
    private a0;
    private a1;
    bu(a: number, b: number): void;
    bx(a: number, b: any, c: any): void;
    bt(): void;
    bv(a: number, b: any): void;
    bw(a: number, b: any): void;
    b0(a: number, b: number): void;
    b5(a: number, b: any, c: any): void;
    bs(): void;
    b1(a: number, b: any): void;
    b3(a: number, b: any): void;
    private o;
    a3(): void;
    private c4;
    b(): IDataSource;
    private q;
    private a8;
    private bc;
    private bp;
    private br;
    private by;
    private bz;
    b4(a: DomRenderer): void;
    private b6;
    private b7;
    private b8;
    private b9;
    private ca;
    cj(): void;
    a5(a: boolean): void;
    v: boolean;
    private cb;
    private cc;
    private cd;
    cf(a: number): void;
    private ao;
    private ch;
    cl(a: string): void;
    ck(a: any): void;
    cm(): void;
    cu(): void;
    private co;
    private ct;
    private cv;
    private cw;
    private cx;
    cn(a: ColumnWidth): void;
    cr(): void;
    private cy;
    cz(): void;
    private av;
    c0(): void;
    cg(a: boolean): void;
    private z;
    private c1;
    a6(a: boolean): void;
    ce(): void;
    ci(a: string): void;
    protected get al(): DomWrapper;
    protected get g(): MultiColumnComboBox;
    get ad(): DomRenderer;
    c2(): void;
    private a2;
    private ax;
    private a4;
    private a7;
    private a9;
    private ba;
    private bb;
    private bd;
    private t;
    private be;
    private bf;
    private bi;
    private bj;
    private bk;
    private bl;
    private bm;
    private bn;
    private bo;
    private c3;
    cq(): void;
    cp(): void;
    cs(): void;
}
/**
 * @hidden
 */
export declare class MultiColumnComboBox extends Base implements INotifyPropertyChanged {
    static $t: Type;
    static ag: BaseControlTheme;
    dd: any;
    h1: Brush;
    h2: Brush;
    co: number;
    io: Thickness;
    gy: CornerRadius;
    h3: Brush;
    cp: number;
    h4: Brush;
    cq: number;
    cr: number;
    h5: Brush;
    cs: number;
    ct: number;
    h6: Brush;
    cu: number;
    h7: Brush;
    cv: number;
    cw: number;
    cx: number;
    static hy: Brush;
    static h0: Brush;
    static hz: Brush;
    constructor();
    private a5;
    private get a6();
    protected u(): MultiColumnComboBoxView;
    protected gm(a: string, b: any, c: any): void;
    private gt;
    private a0;
    private get a1();
    v: MultiColumnComboBoxView;
    focus(a: boolean): void;
    setName(a: string): void;
    private a8;
    get disallowTabFocus(): boolean;
    set disallowTabFocus(a: boolean);
    private bc;
    get bq(): boolean;
    set bq(a: boolean);
    private c;
    get g(): string[];
    set g(a: string[]);
    private m;
    get defaultColumnWidth(): ColumnWidth;
    set defaultColumnWidth(a: ColumnWidth);
    private ha;
    get hw(): Brush;
    set hw(a: Brush);
    private gz;
    get hl(): Brush;
    set hl(a: Brush);
    private af;
    get ai(): BaseControlTheme;
    set ai(a: BaseControlTheme);
    private ae;
    get ah(): BaseControlTheme;
    set ah(a: BaseControlTheme);
    private hb;
    get hx(): Brush;
    set hx(a: Brush);
    private g0;
    get hm(): Brush;
    set hm(a: Brush);
    private b2;
    get cm(): number;
    set cm(a: number);
    private bs;
    get cc(): number;
    set cc(a: number);
    private bh;
    get columnHeadersVisible(): boolean;
    set columnHeadersVisible(a: boolean);
    private ik;
    get im(): Thickness;
    set im(a: Thickness);
    private ij;
    get il(): Thickness;
    set il(a: Thickness);
    private gv;
    get gx(): CornerRadius;
    set gx(a: CornerRadius);
    private gu;
    get gw(): CornerRadius;
    set gw(a: CornerRadius);
    private b;
    get f(): string[];
    set f(a: string[]);
    private al;
    get density(): ControlDisplayDensity;
    set density(a: ControlDisplayDensity);
    private ak;
    get am(): ControlDisplayDensity;
    set am(a: ControlDisplayDensity);
    private bk;
    get dropDownButtonVisible(): boolean;
    set dropDownButtonVisible(a: boolean);
    private hc;
    get h9(): Brush;
    set h9(a: Brush);
    private g1;
    get hn(): Brush;
    set hn(a: Brush);
    private b3;
    get cy(): number;
    set cy(a: number);
    private bt;
    get cd(): number;
    set cd(a: number);
    private hd;
    get ia(): Brush;
    set ia(a: Brush);
    private g2;
    get ho(): Brush;
    set ho(a: Brush);
    private b4;
    get cz(): number;
    set cz(a: number);
    private bu;
    get ce(): number;
    set ce(a: number);
    private b5;
    get c0(): number;
    set c0(a: number);
    private bv;
    get cf(): number;
    set cf(a: number);
    private he;
    get ib(): Brush;
    set ib(a: Brush);
    private g3;
    get hp(): Brush;
    set hp(a: Brush);
    private b6;
    get c1(): number;
    set c1(a: number);
    private bw;
    get cg(): number;
    set cg(a: number);
    private b7;
    get c2(): number;
    set c2(a: number);
    private bx;
    get ch(): number;
    set ch(a: number);
    private c7;
    get itemsSource(): any;
    set itemsSource(a: any);
    get actualDataSource(): IDataSource;
    private fd;
    get fb(): string;
    set fb(a: string);
    private hf;
    get ic(): Brush;
    set ic(a: Brush);
    private g4;
    get hq(): Brush;
    set hq(a: Brush);
    static ay: FontInfo;
    private as;
    get a2(): FontInfo;
    set a2(a: FontInfo);
    private ap;
    get av(): FontInfo;
    set av(a: FontInfo);
    private be;
    get actualLabelVisible(): boolean;
    set actualLabelVisible(a: boolean);
    private fg;
    get fh(): string;
    set fh(a: string);
    private d1;
    get actualNoMatchesFoundLabel(): string;
    set actualNoMatchesFoundLabel(a: string);
    private hg;
    get id(): Brush;
    set id(a: Brush);
    static readonly d3: string;
    private g5;
    get hr(): Brush;
    set hr(a: Brush);
    private hh;
    get ie(): Brush;
    set ie(a: Brush);
    private g6;
    get hs(): Brush;
    set hs(a: Brush);
    static az: FontInfo;
    private at;
    get a3(): FontInfo;
    set a3(a: FontInfo);
    private aq;
    get aw(): FontInfo;
    set aw(a: FontInfo);
    private fo;
    get fn(): string;
    set fn(a: string);
    private bb;
    get rowSeparatorsVisible(): boolean;
    set rowSeparatorsVisible(a: boolean);
    static h8: Brush;
    private hi;
    get ig(): Brush;
    set ig(a: Brush);
    private g7;
    get ht(): Brush;
    set ht(a: Brush);
    private au;
    get a4(): FontInfo;
    set a4(a: FontInfo);
    private ar;
    get ax(): FontInfo;
    set ax(a: FontInfo);
    private hj;
    get ih(): Brush;
    set ih(a: Brush);
    private g8;
    get hu(): Brush;
    set hu(a: Brush);
    private b8;
    get c3(): number;
    set c3(a: number);
    private by;
    get ci(): number;
    set ci(a: number);
    private hk;
    get ii(): Brush;
    set ii(a: Brush);
    private g9;
    get hv(): Brush;
    set hv(a: Brush);
    private b9;
    get c4(): number;
    set c4(a: number);
    private bz;
    get cj(): number;
    set cj(a: number);
    private ca;
    get c5(): number;
    set c5(a: number);
    private b0;
    get ck(): number;
    set ck(a: number);
    private cb;
    get c6(): number;
    set c6(a: number);
    private b1;
    get cl(): number;
    set cl(a: number);
    private a7;
    get bg(): boolean;
    set bg(a: boolean);
    private w;
    get x(): SortMode;
    set x(a: SortMode);
    private dg;
    get fv(): string;
    set fv(a: string);
    private df;
    get text(): string;
    set text(a: string);
    private d;
    get j(): string[];
    set j(a: string[]);
    private a;
    get e(): string[];
    set e(a: string[]);
    private c8;
    get value(): any;
    set value(a: any);
    private aa;
    get ac(): InputGroupDisplayType;
    set ac(a: InputGroupDisplayType);
    private da;
    p(): DataGridColumn;
    e5(): string;
    private db;
    private e3;
    private o;
    private e4;
    private h;
    i(): string[];
    gi(a: any): void;
    private bm;
    private gl;
    gq(a: string): void;
    gs(): void;
    private gr;
    closeUp(): void;
    destroy(): void;
    dropDown(): void;
    select(): void;
    notifySizeChanged(): void;
    provideRenderer(a: DomRenderer): void;
    c9(): any;
    ew(): string;
    l(): MultiColumnComboVisualModelExport;
    private a9;
    get bn(): boolean;
    set bn(a: boolean);
    private ba;
    get bo(): boolean;
    set bo(a: boolean);
    private bd;
    get br(): boolean;
    set br(a: boolean);
    gotFocus: (sender: any, args: GotFocusEventArgs) => void;
    lostFocus: (sender: any, args: LostFocusEventArgs) => void;
    textValueChanged: (sender: any, args: MultiColumnComboBoxTextChangedEventArgs) => void;
    selectedValueChanged: (sender: any, args: MultiColumnComboBoxValueChangedEventArgs) => void;
    keyDown: (sender: any, args: KeyEventArgs) => void;
    change: (sender: any, args: InputChangeEventArgs) => void;
    changing: (sender: any, args: InputChangeEventArgs) => void;
    ge(a: GotFocusEventArgs): void;
    gg(a: LostFocusEventArgs): void;
    gk(a: MultiColumnComboBoxTextChangedEventArgs): void;
    private gj;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected gh(a: string, b: any, c: any): void;
    gf(a: KeyEventArgs): void;
    gd(a: InputChangeEventArgs): void;
}
/**
 * @hidden
 */
export declare class MultiColumnComboBoxDataSourceNotificationHandler extends Base implements IDataSourceUpdateNotifier {
    static $t: Type;
    private a;
    private b;
    constructor(a: MultiColumnComboBoxView, b: boolean);
    rangeActualized(a: number, b: number): void;
    notifySetItem(a: number, b: any, c: any): void;
    notifyClearItems(): void;
    notifyInsertItem(a: number, b: any): void;
    notifyRemoveItem(a: number, b: any): void;
}
