import { GridBaseDirective } from "./GridBaseDirective";
import { SortingExpression } from "./SortingExpression";
import { Type } from "igniteui-react-core";
import { PivotGridValueTemplateContext } from "./PivotGridValueTemplateContext";
import { PivotConfiguration } from "./PivotConfiguration";
import { PivotDimension } from "./PivotDimension";
import { DimensionsChangeEventArgs } from "./DimensionsChangeEventArgs";
import { PivotConfigurationChangedEventArgs } from "./PivotConfigurationChangedEventArgs";
import { PivotDimensionEventArgs } from "./PivotDimensionEventArgs";
import { PivotValueEventArgs } from "./PivotValueEventArgs";
import { SortingExpressionEventArgs } from "./SortingExpressionEventArgs";
import { ValuesChangeEventArgs } from "./ValuesChangeEventArgs";
import { Column } from "./Column";
import { PivotDimensionType } from "./PivotDimensionType";
import { PivotValue } from "./PivotValue";
import { SortingDirection } from "./SortingDirection";
import { FilteringExpressionsTreeOrFilteringOperation } from "./FilteringExpressionsTreeOrFilteringOperation";
/**
 * @hidden
 */
export declare class PivotGrid extends GridBaseDirective {
    static $t: Type;
    get gy(): SortingExpression[];
    private hb;
    get hd(): (arg: PivotGridValueTemplateContext) => any;
    set hd(a: (arg: PivotGridValueTemplateContext) => any);
    get g0(): PivotConfiguration;
    set g0(a: PivotConfiguration);
    get g7(): boolean;
    set g7(a: boolean);
    get g8(): boolean;
    set g8(a: boolean);
    get g6(): boolean;
    set g6(a: boolean);
    get gx(): PivotDimension[];
    get g9(): any;
    set g9(a: any);
    private ha;
    get hc(): (arg: any) => any;
    set hc(a: (arg: any) => any);
    dimensionsChange: (sender: any, args: DimensionsChangeEventArgs) => void;
    dimensionsChangeChanged(): void;
    pivotConfigurationChange: (sender: any, args: PivotConfigurationChangedEventArgs) => void;
    pivotConfigurationChangeChanged(): void;
    dimensionInit: (sender: any, args: PivotDimensionEventArgs) => void;
    dimensionInitChanged(): void;
    valueInit: (sender: any, args: PivotValueEventArgs) => void;
    valueInitChanged(): void;
    dimensionsSortingExpressionsChange: (sender: any, args: SortingExpressionEventArgs) => void;
    dimensionsSortingExpressionsChangeChanged(): void;
    valuesChange: (sender: any, args: ValuesChangeEventArgs) => void;
    valuesChangeChanged(): void;
    ho(a?: boolean): void;
    ht(a: Column): void;
    hj(a: Column): void;
    hv(a: Column, b: boolean): void;
    he(a: PivotDimension): void;
    hk(a: PivotDimension, b: PivotDimensionType, c?: number): void;
    hm(a: PivotDimension, b: PivotDimensionType, c?: number): void;
    hq(a: PivotDimension): void;
    hu(a: PivotDimension): void;
    hl(a: PivotValue, b?: number): void;
    hn(a: PivotValue, b?: number): void;
    hr(a: PivotValue): void;
    hw(a: PivotValue): void;
    hs(a: PivotDimension, b: SortingDirection): void;
    hi(a: PivotDimension, b: any, c: FilteringExpressionsTreeOrFilteringOperation): void;
}
