import { Type } from "igniteui-react-core";
export declare enum SortIndicatorStyle {
    /**
     * The sort indicator is rendered as a single arrow that points in the direction of the sort.
     */
    Default = 0,
    /**
     * The sort indicator is rendered as two arrows pointing opposite of each other.  The direction of the sort determines which arrow
     * is faded and which is fully opaque.
     */
    FadingUpDownArrows = 1,
    /**
     * The sort indicator is rendered as two arrows without the stem, one ontop of the other.  The direction of the sort determines which arrow
     * is faded and which is fully opaque.
     */
    FadingSimpleUpDownArrows = 2,
    /**
     * No style is set.
     */
    Unset = 3
}
/**
 * @hidden
 */
export declare let SortIndicatorStyle_$type: Type;
