import { Type } from "igniteui-react-core";
/**
 * Enumerates the different scope that summaries can apply to.
 */
export declare enum SummaryScope {
    /**
     * Summaries are calculated for both the root and section level.
     */
    Both = 0,
    /**
     * Summaries are only calculated at the root level.
     */
    Root = 1,
    /**
     * Summaries are only calculated at the group level.
     */
    Groups = 2,
    /**
     * Summaries are not calculated at all.
     */
    None = 3
}
/**
 * @hidden
 */
export declare let SummaryScope_$type: Type;
