import { Type } from "igniteui-react-core";
/**
 * Indicates how to break lines of text for a cell.
 */
export declare enum TextCellLineBreakMode {
    /**
     * Truncates the text content at the end and displays an ellipsis character if it can't fit on a line.
     */
    Ellipsis = 0,
    /**
     * Keeps the text on a single line, but does not attempt to insert an ellipsis character.
     */
    NoWrap = 1,
    /**
     * If possible for the current platform, wraps to a new line on a word break, if necessary.
     */
    WordWrap = 2,
    /**
     * If possible for the current platform, wraps to a new line whenever necessary.
     */
    CharacterWrap = 3
}
/**
 * @hidden
 */
export declare let TextCellLineBreakMode_$type: Type;
