import * as React from 'react';
import { IgrGridActionsBaseDirectiveCollection } from "./igr-grid-actions-base-directive-collection";
import { IgrActionStripResourceStrings } from "./igr-action-strip-resource-strings";
import { IgrDisplayDensityBaseElement, IIgrDisplayDensityBaseElementProps } from "./igr-display-density-base-element";
import { ActionStrip } from "./ActionStrip";
import { IgrGridActionsBaseDirective } from "./igr-grid-actions-base-directive";
export declare class IgrActionStrip extends IgrDisplayDensityBaseElement<IIgrActionStripProps> {
    protected createImplementation(): ActionStrip;
    /**
                                 * @hidden
                                 */
    get i(): ActionStrip;
    protected onImplementationCreated(): void;
    protected _initializeAdapters(): void;
    protected _updateAdapters(): void;
    constructor(props: IIgrActionStripProps);
    componentDidMount(): void;
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    private _actionButtons;
    private _actualActionButtons;
    get actualActionButtons(): IgrGridActionsBaseDirective[];
    private _contentActionButtons;
    get contentActionButtons(): IgrGridActionsBaseDirective[];
    private _actionButtonsAdapter;
    /**
     * ActionButton as ContentChildren inside the Action Strip
     * @hidden
     * @internal
    */
    get actionButtons(): IgrGridActionsBaseDirectiveCollection;
    get hidden(): boolean;
    set hidden(v: boolean);
    /**
     * Gets/Sets the resource strings.
     * @remarks
     * By default it uses EN resources.
    */
    get resourceStrings(): IgrActionStripResourceStrings;
    set resourceStrings(v: IgrActionStripResourceStrings);
    get name(): string;
    set name(v: string);
    findByName(name: string): any;
    /**
     * Showing the Action Strip and appending it the specified context element.
     * context
     * @example
     * ```typescript
     * this.actionStrip.show(row);
     * ```
    
    * @param   * context
    */
    show(context: any): void;
    /**
     * Hiding the Action Strip and removing it from its current context element.
     * @example
     * ```typescript
     * this.actionStrip.hide();
     * ```
    
    */
    hide(): void;
}
export interface IIgrActionStripProps extends IIgrDisplayDensityBaseElementProps {
    hidden?: boolean | string;
    /**
     * Gets/Sets the resource strings.
     * @remarks
     * By default it uses EN resources.
    */
    resourceStrings?: IgrActionStripResourceStrings;
    name?: string;
}
