/**
 * An interface describing settings for clipboard options
*/
export interface IgrClipboardOptions {
    /**
     * Enables/disables the copy behavior
    */
    enabled?: boolean | string;
    /**
     * Include the columns headers in the clipboard output.
    */
    copyHeaders?: boolean | string;
    /**
     * Apply the columns formatters (if any) on the data in the clipboard output.
    */
    copyFormatters?: boolean | string;
    /**
     * The separator used for formatting the copy output. Defaults to `\t`.
    */
    separator?: string;
}
