import { IgrGridBaseDirective } from "./igr-grid-base-directive";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { ColumnExportingEventArgsDetail as ColumnExportingEventArgsDetail_internal } from "./ColumnExportingEventArgsDetail";
/**
 * columnExporting event arguments
 * ```typescript
 * this.exporterService.columnExporting.subscribe((args: IColumnExportingEventArgs) => {
 * // set args properties here
 * });
 * ```
*/
export declare class IgrColumnExportingEventArgsDetail extends IgrBaseEventArgsDetail {
    protected createImplementation(): ColumnExportingEventArgsDetail_internal;
    /**
                                 * @hidden
                                 */
    get i(): ColumnExportingEventArgsDetail_internal;
    constructor();
    /**
     * Contains the exporting column header
    */
    get header(): string;
    set header(v: string);
    /**
     * Contains the exporting column field name
    */
    get field(): string;
    set field(v: string);
    /**
     * Contains the exporting column index
    */
    get columnIndex(): number;
    set columnIndex(v: number);
    /**
     * Skip the exporting column when set to true
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    /**
     * Export the column's data without applying its formatter, when set to true
    */
    get skipFormatter(): boolean;
    set skipFormatter(v: boolean);
    /**
     * A reference to the grid owner.
    */
    get grid(): IgrGridBaseDirective;
    set grid(v: IgrGridBaseDirective);
    findByName(name: string): any;
}
