import { IgrFormatGroupTextEventArgs } from "./igr-format-group-text-event-args";
import { IgrColumnSortDescription } from "./igr-column-sort-description";
import { ColumnGroupDescription as ColumnGroupDescription_internal } from "./ColumnGroupDescription";
/**
 * Represents an element in the current grouping applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class IgrColumnGroupDescription extends IgrColumnSortDescription {
    protected createImplementation(): ColumnGroupDescription_internal;
    /**
                                 * @hidden
                                 */
    get i(): ColumnGroupDescription_internal;
    constructor();
    /**
     * Gets or sets the format string for the group value.
    */
    get valueFormat(): string;
    set valueFormat(v: string);
    /**
     * Gets or sets the format specifiers to use with the ValueFormat string.
    */
    get valueFormatSpecifiers(): any[];
    set valueFormatSpecifiers(v: any[]);
    /**
     * Gets or sets the display format for the group text in the group header.
    */
    get displayFormat(): string;
    set displayFormat(v: string);
    /**
     * Gets or sets the format specifiers to use with the DisplayFormat string.
    */
    get displayFormatSpecifiers(): any[];
    set displayFormatSpecifiers(v: any[]);
    /**
     * Gets or sets an INTL.DateTimeFormat or INTL.NumericFormat to use to format the value.
    */
    get formatOverride(): any;
    set formatOverride(v: any);
    /**
     * Gets or sets the display text for the group name.
    */
    get displayName(): string;
    set displayName(v: string);
    findByName(name: string): any;
    private _formatText;
    private _formatText_wrapped;
    /**
     * Called when the value is being formatted.
    */
    get formatText(): (s: IgrColumnGroupDescription, e: IgrFormatGroupTextEventArgs) => void;
    set formatText(ev: (s: IgrColumnGroupDescription, e: IgrFormatGroupTextEventArgs) => void);
}
