import * as React from 'react';
import { IgrColumnCollection } from "./igr-column-collection";
import { IgrColumn, IIgrColumnProps } from "./igr-column";
import { ColumnGroup } from "./ColumnGroup";
import { IgrColumnTemplateContext } from "./igr-column-template-context";
/**
 * **Ignite UI for Angular Column Group**
 * @igxParent IgxGridComponent, IgxTreeGridComponent, IgxHierarchicalGridComponent, IgxColumnGroupComponent, IgxRowIslandComponent
*/
export declare class IgrColumnGroup<P extends IIgrColumnGroupProps = IIgrColumnGroupProps> extends IgrColumn<P> {
    protected createImplementation(): ColumnGroup;
    /**
                                 * @hidden
                                 */
    get i(): ColumnGroup;
    protected _initializeAdapters(): void;
    protected _updateAdapters(): void;
    constructor(props: P);
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    private _children;
    private _actualChildren;
    get actualChildren(): IgrColumn[];
    private _contentChildren;
    get contentChildren(): IgrColumn[];
    private _childrenAdapter;
    get children(): IgrColumnCollection;
    get collapsible(): boolean;
    set collapsible(v: boolean);
    private _collapsibleIndicatorTemplate;
    private _collapsibleIndicatorTemplateAdapter;
    /**
     * Allows you to define a custom template for expand/collapse indicator
     * @memberof IgxColumnGroupComponent
    */
    get collapsibleIndicatorTemplate(): React.FunctionComponent<{
        dataContext: IgrColumnTemplateContext;
    }> | React.Component<{
        dataContext: IgrColumnTemplateContext;
    }>;
    set collapsibleIndicatorTemplate(v: React.FunctionComponent<{
        dataContext: IgrColumnTemplateContext;
    }> | React.Component<{
        dataContext: IgrColumnTemplateContext;
    }>);
    findByName(name: string): any;
}
export interface IIgrColumnGroupProps extends IIgrColumnProps {
    collapsible?: boolean | string;
    /**
     * Allows you to define a custom template for expand/collapse indicator
     * @memberof IgxColumnGroupComponent
    */
    collapsibleIndicatorTemplate?: React.FunctionComponent<{
        dataContext: IgrColumnTemplateContext;
    }> | React.Component<{
        dataContext: IgrColumnTemplateContext;
    }>;
}
