import { ColumnPropertySetter as ColumnPropertySetter_internal } from "./ColumnPropertySetter";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Indicates that a specified column should have a specified property set to a value.
*/
export declare class IgrColumnPropertySetter {
    protected createImplementation(): ColumnPropertySetter_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnPropertySetter_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The name or key of the column to change the property of
    */
    get columnName(): string;
    set columnName(v: string);
    /**
     * The name of the property to change
    */
    get propertyName(): string;
    set propertyName(v: string);
    /**
     * The new value of the property
    */
    get value(): any;
    set value(v: any);
    findByName(name: string): any;
}
