import { IgrColumnSortDescription } from "./igr-column-sort-description";
import { ColumnSortDescriptionCollection as ColumnSortDescriptionCollection_internal } from "./ColumnSortDescriptionCollection";
/**
 * Represents a collection of sort elements that are applied to a data source or provider.
*/
export declare class IgrColumnSortDescriptionCollection {
    protected createImplementation(): ColumnSortDescriptionCollection_internal;
    protected _implementation: any;
    get i(): ColumnSortDescriptionCollection_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    item(index: number, value?: IgrColumnSortDescription): IgrColumnSortDescription;
    get count(): number;
    toArray(): IgrColumnSortDescription[];
    [Symbol.iterator](): Generator<any, void, unknown>;
    /**
 * Gets or sets whether this collection should detach the sync when the target collection changes.
*/
    get shouldDetachOnTargetChange(): boolean;
    set shouldDetachOnTargetChange(v: boolean);
    findByName(name: string): any;
    add(item: IgrColumnSortDescription): boolean;
    insert(index: number, item: IgrColumnSortDescription): void;
    clear(): void;
    indexOf(item: IgrColumnSortDescription): number;
    remove(item: IgrColumnSortDescription): boolean;
    removeAt(index: number): IgrColumnSortDescription;
}
