import { ListSortDirection } from "igniteui-react-core";
import { ColumnSortDescription as ColumnSortDescription_internal } from "./ColumnSortDescription";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Represents an element in the current sort applied to a data source or provider. Changes to this object are not observed or expected after it is initially assigned to a collection.
*/
export declare class IgrColumnSortDescription {
    protected createImplementation(): ColumnSortDescription_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnSortDescription_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets the property being sorted.
    */
    get field(): string;
    set field(v: string);
    /**
     * Gets or sets the direction to sort based on the property.
    */
    get sortDirection(): ListSortDirection;
    set sortDirection(v: ListSortDirection);
    findByName(name: string): any;
    /**
     * Returns if the SortDescription is equal to another.
    
    * @param other  * The SortDescription to compare to.
    */
    equals(other: any): boolean;
}
