import { ColumnWidth as ColumnWidth_internal } from "./ColumnWidth";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Represents a width of a column.
*/
export declare class IgrColumnWidth {
    protected createImplementation(): ColumnWidth_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ColumnWidth_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Gets or sets whether to use star sizing for the column's width
    */
    get isStarSized(): boolean;
    set isStarSized(v: boolean);
    /**
     * Gets or sets the fixed width or the proportional width of the column, depending on whether this width is a star width.
    */
    get value(): number;
    set value(v: number);
    /**
     * Gets or sets a minimum width to use when star sizing.
    */
    get minimumWidth(): number;
    set minimumWidth(v: number);
    findByName(name: string): any;
}
