import { IDataSource } from "igniteui-react-core";
import { IgrDataGridColumn, IIgrDataGridColumnProps } from "./igr-data-grid-column";
import { ComboBoxColumn } from "./ComboBoxColumn";
/**
 * A combobox column.
*/
export declare class IgrComboBoxColumn extends IgrDataGridColumn<IIgrComboBoxColumnProps> {
    protected createImplementation(): ComboBoxColumn;
    /**
                                 * @hidden
                                 */
    get i(): ComboBoxColumn;
    constructor(props: IIgrComboBoxColumnProps);
    /**
     * Gets the actual data source that is being used by the combo. If a collection was provided for the combobox data, an implicit LocalDataSource is created, and this is available via this property.
    */
    get actualDataSource(): IDataSource;
    set actualDataSource(v: IDataSource);
    /**
     * Gets or sets the ComboBox data source.
    */
    get dataSource(): any;
    set dataSource(v: any);
    /**
     * Gets or sets the ComboBox text field.
    */
    get textField(): string;
    set textField(v: string);
    /**
     * Gets or sets the ComboBox value field.
    */
    get valueField(): string;
    set valueField(v: string);
    /**
     * Gets or sets the ComboBox value field.
    */
    get valueMultiField(): string[];
    set valueMultiField(v: string[]);
}
export interface IIgrComboBoxColumnProps extends IIgrDataGridColumnProps {
    /**
     * Gets the actual data source that is being used by the combo. If a collection was provided for the combobox data, an implicit LocalDataSource is created, and this is available via this property.
    */
    actualDataSource?: IDataSource;
    /**
     * Gets or sets the ComboBox data source.
    */
    dataSource?: any;
    /**
     * Gets or sets the ComboBox text field.
    */
    textField?: string;
    /**
     * Gets or sets the ComboBox value field.
    */
    valueField?: string;
    /**
     * Gets or sets the ComboBox value field.
    */
    valueMultiField?: string[];
}
