import * as React from 'react';
import { GridExpansionIndicator } from "./GridExpansionIndicator";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrDataGridExpansionIndicator<P extends IIgrDataGridExpansionIndicatorProps = IIgrDataGridExpansionIndicatorProps> extends React.Component<P, {}> {
    protected createImplementation(): GridExpansionIndicator;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridExpansionIndicator; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrDataGridExpansionIndicator;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    /**
     * Gets or sets the expansion state of the indicator.
    */
    get isExpanded(): boolean;
    set isExpanded(v: boolean);
    /**
     * Gets or sets the color of the indicator.
    */
    get iconColor(): string;
    set iconColor(v: string);
    /**
     * Gets or sets whether animations are enabled.
    */
    get isAnimationEnabled(): boolean;
    set isAnimationEnabled(v: boolean);
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio(): number;
    set pixelScalingRatio(v: number);
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get actualPixelScalingRatio(): number;
    set actualPixelScalingRatio(v: number);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    notifySizeChanged(width: number, height: number): void;
}
export interface IIgrDataGridExpansionIndicatorProps {
    children?: React.ReactNode;
    /**
     * Gets or sets the expansion state of the indicator.
    */
    isExpanded?: boolean | string;
    /**
     * Gets or sets the color of the indicator.
    */
    iconColor?: string;
    /**
     * Gets or sets whether animations are enabled.
    */
    isAnimationEnabled?: boolean | string;
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    pixelScalingRatio?: number | string;
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    actualPixelScalingRatio?: number | string;
}
