import * as React from 'react';
import { IgrGridFilterDialogOpeningEventArgs } from "./igr-grid-filter-dialog-opening-event-args";
import { IgrGridFilterDialogFilterChangeEventArgs } from "./igr-grid-filter-dialog-filter-change-event-args";
import { IgrFilterDialogRenderCompletedEventArgs } from "./igr-filter-dialog-render-completed-event-args";
import { GridFilterDialog } from "./GridFilterDialog";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * An advanced grid for displaying data.
*/
export declare class IgrDataGridFilterDialog<P extends IIgrDataGridFilterDialogProps = IIgrDataGridFilterDialogProps> extends React.Component<P, {}> {
    protected createImplementation(): GridFilterDialog;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridFilterDialog; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrDataGridFilterDialog;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    get isAnimationEnabled(): boolean;
    set isAnimationEnabled(v: boolean);
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio(): number;
    set pixelScalingRatio(v: number);
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get actualPixelScalingRatio(): number;
    set actualPixelScalingRatio(v: number);
    get iconColor(): string;
    set iconColor(v: string);
    get viewSize(): number;
    set viewSize(v: number);
    get isOpen(): boolean;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    notifySizeChanged(width: number, height: number): void;
    notifyCellSizeChanged(): void;
    showIcon(): void;
    hideIcon(): void;
    private _dialogOpening;
    private _dialogOpening_wrapped;
    get dialogOpening(): (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogOpeningEventArgs) => void;
    set dialogOpening(ev: (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogOpeningEventArgs) => void);
    private _filterChanging;
    private _filterChanging_wrapped;
    get filterChanging(): (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogFilterChangeEventArgs) => void;
    set filterChanging(ev: (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogFilterChangeEventArgs) => void);
    private _filterChanged;
    private _filterChanged_wrapped;
    get filterChanged(): (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogFilterChangeEventArgs) => void;
    set filterChanged(ev: (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogFilterChangeEventArgs) => void);
    private _renderCompleted;
    private _renderCompleted_wrapped;
    get renderCompleted(): (s: IgrDataGridFilterDialog, e: IgrFilterDialogRenderCompletedEventArgs) => void;
    set renderCompleted(ev: (s: IgrDataGridFilterDialog, e: IgrFilterDialogRenderCompletedEventArgs) => void);
}
export interface IIgrDataGridFilterDialogProps {
    children?: React.ReactNode;
    isAnimationEnabled?: boolean | string;
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    pixelScalingRatio?: number | string;
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    actualPixelScalingRatio?: number | string;
    iconColor?: string;
    viewSize?: number | string;
    dialogOpening?: (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogOpeningEventArgs) => void;
    filterChanging?: (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogFilterChangeEventArgs) => void;
    filterChanged?: (s: IgrDataGridFilterDialog, e: IgrGridFilterDialogFilterChangeEventArgs) => void;
    renderCompleted?: (s: IgrDataGridFilterDialog, e: IgrFilterDialogRenderCompletedEventArgs) => void;
}
