import * as React from 'react';
import { ColumnSortDirection } from "./ColumnSortDirection";
import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { IgrSortIndicatorRenderCompletedEventArgs } from "./igr-sort-indicator-render-completed-event-args";
import { GridSortIndicator } from "./GridSortIndicator";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * An advanced grid for displaying data.
*/
export declare class IgrDataGridSortIndicator<P extends IIgrDataGridSortIndicatorProps = IIgrDataGridSortIndicatorProps> extends React.Component<P, {}> {
    protected createImplementation(): GridSortIndicator;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridSortIndicator; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrDataGridSortIndicator;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    get sortDirection(): ColumnSortDirection;
    set sortDirection(v: ColumnSortDirection);
    get iconColor(): string;
    set iconColor(v: string);
    get isAnimationEnabled(): boolean;
    set isAnimationEnabled(v: boolean);
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio(): number;
    set pixelScalingRatio(v: number);
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get actualPixelScalingRatio(): number;
    set actualPixelScalingRatio(v: number);
    get sortIndicatorStyle(): SortIndicatorStyle;
    set sortIndicatorStyle(v: SortIndicatorStyle);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    getDesiredScale(): number;
    notifySizeChanged(width: number, height: number): void;
    notifyCellSizeChanged(): void;
    private _renderCompleted;
    private _renderCompleted_wrapped;
    get renderCompleted(): (s: IgrDataGridSortIndicator, e: IgrSortIndicatorRenderCompletedEventArgs) => void;
    set renderCompleted(ev: (s: IgrDataGridSortIndicator, e: IgrSortIndicatorRenderCompletedEventArgs) => void);
}
export interface IIgrDataGridSortIndicatorProps {
    children?: React.ReactNode;
    sortDirection?: ColumnSortDirection | string;
    iconColor?: string;
    isAnimationEnabled?: boolean | string;
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    pixelScalingRatio?: number | string;
    /**
     * Gets the actual pixel scaling ratio used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    actualPixelScalingRatio?: number | string;
    sortIndicatorStyle?: SortIndicatorStyle | string;
    renderCompleted?: (s: IgrDataGridSortIndicator, e: IgrSortIndicatorRenderCompletedEventArgs) => void;
}
