import * as React from 'react';
import { IgRect } from "igniteui-react-core";
import { IgrSectionHeader } from './igr-section-header';
import { IgrSummaryRowRoot } from './igr-summary-row-root';
import { IgrSummaryRowSection } from './igr-summary-row-section';
import { IgrColumnWidth } from './igr-column-width';
import { HeaderClickAction } from './HeaderClickAction';
import { ColumnShowingAnimationMode } from './ColumnShowingAnimationMode';
import { ColumnPropertyUpdatingAnimationMode } from './ColumnPropertyUpdatingAnimationMode';
import { CellDataLoadedAnimationMode } from './CellDataLoadedAnimationMode';
import { RowSelectionAnimationMode } from './RowSelectionAnimationMode';
import { ColumnMovingAnimationMode } from './ColumnMovingAnimationMode';
import { ColumnHidingAnimationMode } from './ColumnHidingAnimationMode';
import { CellSelectionAnimationMode } from './CellSelectionAnimationMode';
import { ColumnExchangingAnimationMode } from './ColumnExchangingAnimationMode';
import { RowHoverAnimationMode } from './RowHoverAnimationMode';
import { DataGridSelectionMode } from './DataGridSelectionMode';
import { GridActivationMode } from './GridActivationMode';
import { GridSelectionBehavior } from './GridSelectionBehavior';
import { IgrDataGridCellEventArgs } from './igr-data-grid-cell-event-args';
import { IgrGridColumnsAutoGeneratedEventArgs } from './igr-grid-columns-auto-generated-event-args';
import { IgrGridColumnsChangedEventArgs } from './igr-grid-columns-changed-event-args';
import { IgrGridSelectedItemsChangedEventArgs } from './igr-grid-selected-items-changed-event-args';
import { IgrGridSelectedKeysChangedEventArgs } from './igr-grid-selected-keys-changed-event-args';
import { IgrGridSelectedCellsChangedEventArgs } from './igr-grid-selected-cells-changed-event-args';
import { IgrGridSelectedCellRangesChangedEventArgs } from './igr-grid-selected-cell-ranges-changed-event-args';
import { IgrGridSortDescriptionsChangedEventArgs } from './igr-grid-sort-descriptions-changed-event-args';
import { IgrGridGroupDescriptionsChangedEventArgs } from './igr-grid-group-descriptions-changed-event-args';
import { IgrGridSummaryDescriptionsChangedEventArgs } from './igr-grid-summary-descriptions-changed-event-args';
import { DataGrid } from "./DataGrid";
import { Thickness } from "igniteui-react-core";
import { IgrDataGridColumn } from './igr-data-grid-column';
import { IgrGridColumnCollection } from './igr-grid-column-collection';
import { ScrollbarStyle } from "igniteui-react-core";
import { IgrColumnSortDescriptionCollection } from './igr-column-sort-description-collection';
import { IgrColumnGroupDescriptionCollection } from './igr-column-group-description-collection';
import { IgrColumnSummaryDescriptionCollection } from './igr-column-summary-description-collection';
import { IgrFilterExpressionCollection } from "igniteui-react-core";
import { IgrGridSelectedItemsCollection } from "./igr-grid-selected-items-collection";
import { IgrGridSelectedKeysCollection } from "./igr-grid-selected-keys-collection";
import { IgrGridSelectedCellsCollection } from "./igr-grid-selected-cells-collection";
import { IgrGridSelectedCellRangesCollection } from "./igr-grid-selected-cell-ranges-collection";
import { IgrColumnHiddenChangedEventArgs } from "./igr-column-hidden-changed-event-args";
import { IgrCellKey } from "./igr-cell-key";
import { IDataSource } from "igniteui-react-core";
import { IgrGridFilterExpressionsEventArgs } from './igr-grid-filter-expressions-event-args';
import { IgrResponsiveStatesCollection } from './igr-responsive-states-collection';
import { IgrGridAnimationSettings } from './igr-grid-animation-settings';
import { IgrRowSeparator } from './igr-row-separator';
import { IgrHeaderRowSeparator } from './igr-header-row-separator';
import { IgrGridCellPosition } from "./igr-grid-cell-position";
import { IgrGridActiveCellChangedEventArgs } from "./igr-grid-active-cell-changed-event-args";
import { IgrCellInfo } from "./igr-cell-info";
import { IgrHeaderSeparator } from "./igr-header-separator";
import { IgrColumnResizingSeparator } from "./igr-column-resizing-separator";
import { ColumnResizingMode } from "./ColumnResizingMode";
import { ColumnResizingAnimationMode } from "./ColumnResizingAnimationMode";
import { ColumnMovingMode } from "./ColumnMovingMode";
import { IgrColumnMovingSeparator } from "./igr-column-moving-separator";
import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { GroupHeaderDisplayMode } from "./GroupHeaderDisplayMode";
import { SummaryScope } from "./SummaryScope";
import { GroupSummaryDisplayMode } from "./GroupSummaryDisplayMode";
import { ISummaryResult } from "igniteui-react-core";
import { IgrPinnedAreaSeparator } from "./igr-pinned-area-separator";
import { PinnedPositions } from "./PinnedPositions";
import { ColumnOptionsIconAlignment } from "./ColumnOptionsIconAlignment";
import { ColumnOptionsIconBehavior } from "./ColumnOptionsIconBehavior";
import { IgrColumnPinnedChangedEventArgs } from "./igr-column-pinned-changed-event-args";
import { ControlDisplayDensity } from "igniteui-react-core";
import { EditModeType } from "./EditModeType";
import { EditModeClickAction } from "./EditModeClickAction";
import { IgrGridCellValueChangingEventArgs } from "./igr-grid-cell-value-changing-event-args";
import { IgrGridDataCommittingEventArgs } from "./igr-grid-data-committing-event-args";
import { IgrGridDataCommittedEventArgs } from "./igr-grid-data-committed-event-args";
import { IgrGridSizeChangedEventArgs } from "./igr-grid-size-changed-event-args";
import { IgrGridColumnWidthChangedEventArgs } from "./igr-grid-column-width-changed-event-args";
import { IgrGridCellEditStartedEventArgs } from "./igr-grid-cell-edit-started-event-args";
import { IgrGridCellEditEndedEventArgs } from "./igr-grid-cell-edit-ended-event-args";
import { IgrGridRowEditStartedEventArgs } from "./igr-grid-row-edit-started-event-args";
import { IgrGridRowEditEndedEventArgs } from "./igr-grid-row-edit-ended-event-args";
import { IgrGridSelectionChangedEventArgs } from "./igr-grid-selection-changed-event-args";
import { EnterKeyBehaviors } from "./EnterKeyBehaviors";
import { EnterKeyBehaviorAfterEdit } from "./EnterKeyBehaviorAfterEdit";
import { MergedCellMode } from "./MergedCellMode";
import { MergedCellEvaluationCriteria } from "./MergedCellEvaluationCriteria";
import { FilterUIType } from "./FilterUIType";
import { FilterLogicalOperator } from "./FilterLogicalOperator";
import { FilterComparisonType } from "./FilterComparisonType";
import { IgrGridCustomFilterRequestedEventArgs } from "./igr-grid-custom-filter-requested-event-args";
import { CellContentVerticalAlignment } from "./CellContentVerticalAlignment";
export declare class IgrDataGrid extends React.Component<IIgrDataGridProps> {
    private _portalManager;
    contentColumns: IgrDataGridColumn[];
    /**
     * The columns actually present in the grid. Do not directly modify this array.
     * This array's contents can be modified by causing React to reproject the child content.
     * Or adding and removing columns from the manual columns collection on the columns property.
     */
    combinedColumns: IgrDataGridColumn[];
    private _container;
    private _columns;
    private _insertExternalColumnAtIndex;
    private _removeExternalColumn;
    private _contentChildrenManager;
    private _updateContentChildren;
    get actualDataSource(): IDataSource;
    private _getMainRef;
    private _contentAreaRef;
    private _getContentAreaRef;
    private _getFilterDialog;
    private _getColumnGroupingRef;
    private _pagerRef;
    private _getPagerRef;
    private _getToolbarRef;
    private _disableManualColumnSync;
    private _ensureColumnsAreManual;
    /**
     * A collection or manually added columns for the grid.
    */
    get columns(): IgrGridColumnCollection;
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _isGroupByAreaVisible;
    /**
     * Gets or sets if the Column Grouping Area should be shown and enabled
    */
    get isGroupByAreaVisible(): boolean;
    set isGroupByAreaVisible(value: boolean);
    private _useCanvas;
    set useCanvas(value: boolean);
    get useCanvas(): boolean;
    private _useAccessibility;
    set useAccessibility(value: boolean);
    get useAccessibility(): boolean;
    private _setScrollbarStyle;
    private _setScrollbarColor;
    private _filterDialogRef;
    private _columnGroupingRef;
    private _elRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        style: {
            boxSizing: "border-box";
            overflow: "hidden";
            display: "flex";
            flexDirection: "column";
        };
        children: any[];
    }, any>;
    private _mounted;
    destroy(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    private _columnsAdapter;
    protected createImplementation(): DataGrid;
    ngOnInit(): void;
    protected _implementation: any;
    get i(): DataGrid;
    private onImplementationCreated;
    private _renderer;
    constructor(props: IIgrDataGridProps);
    private requestRender;
    private _focusScroller;
    private _setDefaultCursor;
    private _setResizeCursor;
    private _setHandCursor;
    private _setBorder;
    private _setScrollerVerticalTrackInset;
    initializeContent(): void;
    notifyDOMInsertion(): void;
    protected initializeProperties(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    private _scroller;
    private _dragger;
    private _wrapper;
    private _grid;
    private containerResized;
    private _contentLayout;
    private _contentDiv;
    private _useNativeScroll;
    private _content;
    private refreshContentSize;
    onScroll(): void;
    onScrollStart(): void;
    onScrollStop(): void;
    scrollTo(x: number, y: number): void;
    private _dataSource;
    set dataSource(value: any);
    get dataSource(): any;
    forColumnsWithPropertyPath(propertyPath: string, callback: (column: IgrDataGridColumn) => void): void;
    /**
     * Gets or sets the default column width to use if a column as no local width.
     * */
    get defaultColumnWidth(): IgrColumnWidth;
    set defaultColumnWidth(value: IgrColumnWidth);
    private _insetLeft;
    /**
     * Gets or sets the amount of left inset space to use around the grid content.
    */
    get insetLeft(): number;
    set insetLeft(v: number);
    private _insetTop;
    /**
     * Gets or sets the amount of top inset space to use around the grid content.
    */
    get insetTop(): number;
    set insetTop(v: number);
    private _insetRight;
    /**
     * Gets or sets the amount of right inset space to use around the grid content.
    */
    get insetRight(): number;
    set insetRight(v: number);
    private _insetBottom;
    /**
     * Gets or sets the amount of bottom inset space to use around the grid content.
    */
    get insetBottom(): number;
    set insetBottom(v: number);
    private _isPagerVisible;
    /**
     * Gets or sets whether to show the pager or not.
    */
    get isPagerVisible(): boolean | string;
    set isPagerVisible(value: boolean | string);
    /**
     * Gets or sets whether to show the toolbar.
    */
    get isToolbarVisible(): boolean | string;
    set isToolbarVisible(value: boolean | string);
    /**
     * Get the cell that contains the provided coordinates.
     */
    getHitCell(x: number, y: number): IgrCellInfo;
    /**
 * Gets or sets the type of column resizing to use.
*/
    get columnResizingMode(): ColumnResizingMode;
    set columnResizingMode(v: ColumnResizingMode);
    /**
     * Gets or sets the type column moving to use.
    */
    get columnMovingMode(): ColumnMovingMode;
    set columnMovingMode(v: ColumnMovingMode);
    /**
     * Gets or sets whether the row will highlight when hovered.
    */
    get isRowHoverEnabled(): boolean;
    set isRowHoverEnabled(v: boolean);
    /**
     * Gets or sets the background color for rows when hovered.
    */
    get rowHoverBackground(): string;
    set rowHoverBackground(v: string);
    /**
     * Gets or sets the text color for rows when hovered.
    */
    get rowHoverTextColor(): string;
    set rowHoverTextColor(v: string);
    /**
     * Gets or sets the border color for rows being edited.
    */
    get editRowBorder(): string;
    set editRowBorder(v: string);
    get editRowBorderWidthBottom(): number;
    set editRowBorderWidthBottom(v: number);
    get editRowBorderWidthLeft(): number;
    set editRowBorderWidthLeft(v: number);
    get editRowBorderWidthRight(): number;
    set editRowBorderWidthRight(v: number);
    get editRowBorderWidthTop(): number;
    set editRowBorderWidthTop(v: number);
    ensureEditRowBorderWidth(): void;
    /**
     * Gets or sets the header type used for sectioning off groups of rows.
    */
    get sectionHeader(): IgrSectionHeader;
    set sectionHeader(v: IgrSectionHeader);
    /**
     * Gets or sets the cell definition used for summary rows at the root level.
    */
    get summaryRowRoot(): IgrSummaryRowRoot;
    set summaryRowRoot(v: IgrSummaryRowRoot);
    /**
     * Gets or sets the cell definition used for summary rows at the section level.
    */
    get summaryRowSection(): IgrSummaryRowSection;
    set summaryRowSection(v: IgrSummaryRowSection);
    /**
     * Gets or sets the row seperator settings.
    */
    get rowSeparator(): IgrRowSeparator;
    set rowSeparator(v: IgrRowSeparator);
    /**
     * Gets or sets the header row seperator settings.
    */
    get headerRowSeparator(): IgrHeaderRowSeparator;
    set headerRowSeparator(v: IgrHeaderRowSeparator);
    /**
     * Gets or sets the header seperator settings.
    */
    get headerSeparator(): IgrHeaderSeparator;
    set headerSeparator(v: IgrHeaderSeparator);
    /**
     * Gets or sets the column resizing seperator settings.
    */
    get columnResizingSeparator(): IgrColumnResizingSeparator;
    set columnResizingSeparator(v: IgrColumnResizingSeparator);
    /**
     * Gets or sets the column resizing seperator settings.
    */
    get columnMovingSeparator(): IgrColumnMovingSeparator;
    set columnMovingSeparator(v: IgrColumnMovingSeparator);
    /**
     * Gets or sets the pinned area separator settings.
    */
    get pinnedAreaSeparator(): IgrPinnedAreaSeparator;
    set pinnedAreaSeparator(v: IgrPinnedAreaSeparator);
    /**
     * Gets or sets the desired properties the grid will automatically generate columns for.
    */
    get autoGenerateDesiredProperties(): string[];
    set autoGenerateDesiredProperties(v: string[]);
    /**
     * Gets or sets the desired properties for the data source to load. If specified the data source may decide to constrain the properties it fetches to these properties and must make sure that at least those properties are loaded, rather than the default behavior for that data source.
    */
    get dataSourceDesiredProperties(): string[];
    set dataSourceDesiredProperties(v: string[]);
    /**
     * Gets or sets the display density to use for the grid.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets the actual height for the rows in the grid.
    */
    get actualRowHeight(): number;
    set actualRowHeight(v: number);
    /**
     * Gets or sets the height to use for the rows in the grid. If not set the grid will
     * use the default value for the set display density.
    */
    get rowHeight(): number;
    set rowHeight(v: number);
    /**
     * Gets or sets the default minimum width to use on all columns. Ignored if NaN.
    */
    get defaultColumnMinWidth(): number;
    set defaultColumnMinWidth(v: number);
    /**
     * Gets the height used for the header row.
    */
    get actualHeaderHeight(): number;
    set actualHeaderHeight(v: number);
    /**
     * Gets or sets the height to use for the header row.
    */
    get headerHeight(): number;
    set headerHeight(v: number);
    /**
     * Returns/sets the action to take when a column header is clicked.
    */
    get headerClickAction(): HeaderClickAction;
    set headerClickAction(v: HeaderClickAction);
    /**
     * Gets or sets the type of edit mode
    */
    get editMode(): EditModeType;
    set editMode(v: EditModeType);
    /**
     * Gets or sets the type of click action required to enter edit mode.
    */
    get editModeClickAction(): EditModeClickAction;
    set editModeClickAction(v: EditModeClickAction);
    /**
     * Gets or sets whether edit mode will begin as soon as you start typing while a cell is active.
    */
    get editOnKeyPress(): boolean;
    set editOnKeyPress(v: boolean);
    /**
     * Configures whether or not the grid will autogenerate columns when the data source is set.
    */
    get autoGenerateColumns(): boolean;
    set autoGenerateColumns(v: boolean);
    /**
     * Sets or gets the height to use for the row separators.
    */
    get rowSeparatorHeight(): number;
    set rowSeparatorHeight(v: number);
    /**
     * Configures whether or not place holders are used for cells who do not have their data yet.
    */
    get isPlaceholderRenderingEnabled(): boolean;
    set isPlaceholderRenderingEnabled(v: boolean);
    /**
     * Sets or gets the Column Adding Animation mode to use.
    */
    get columnAddingAnimationMode(): ColumnShowingAnimationMode;
    set columnAddingAnimationMode(v: ColumnShowingAnimationMode);
    /**
     * Sets or gets the Column Property Updating Animation mode to use.
    */
    get columnPropertyUpdatingAnimationMode(): ColumnPropertyUpdatingAnimationMode;
    set columnPropertyUpdatingAnimationMode(v: ColumnPropertyUpdatingAnimationMode);
    /**
     * Sets or gets the cell data loaded animation mode to use.
    */
    get cellDataLoadedAnimationMode(): CellDataLoadedAnimationMode;
    set cellDataLoadedAnimationMode(v: CellDataLoadedAnimationMode);
    /**
     * Sets or gets the row selection animation mode to use.
    */
    get rowSelectionAnimationMode(): RowSelectionAnimationMode;
    set rowSelectionAnimationMode(v: RowSelectionAnimationMode);
    /**
     * Sets or gets the row hover animation mode to use.
    */
    get rowHoverAnimationMode(): RowHoverAnimationMode;
    set rowHoverAnimationMode(v: RowHoverAnimationMode);
    /**
     * Sets or gets the cell selection animation mode to use.
    */
    get cellSelectionAnimationMode(): CellSelectionAnimationMode;
    set cellSelectionAnimationMode(v: CellSelectionAnimationMode);
    /**
     * Sets or gets the default animation settings for the grid.
    */
    get animationSettings(): IgrGridAnimationSettings;
    set animationSettings(v: IgrGridAnimationSettings);
    /**
     * Sets or gets the column resizing animation mode to use. Only applies when resizing in Deferred mode.
    */
    get columnResizingAnimationMode(): ColumnResizingAnimationMode;
    set columnResizingAnimationMode(v: ColumnResizingAnimationMode);
    /**
     * Sets or gets the column showing animation mode to use.
    */
    get columnShowingAnimationMode(): ColumnShowingAnimationMode;
    set columnShowingAnimationMode(v: ColumnShowingAnimationMode);
    /**
     * Sets or gets the column moving animation mode to use.
    */
    get columnMovingAnimationMode(): ColumnMovingAnimationMode;
    set columnMovingAnimationMode(v: ColumnMovingAnimationMode);
    /**
     * Sets or gets the column hiding animation mode to use.
    */
    get columnHidingAnimationMode(): ColumnHidingAnimationMode;
    set columnHidingAnimationMode(v: ColumnHidingAnimationMode);
    /**
     * Sets or gets the column exchanging animation mode to use.
    */
    get columnExchangingAnimationMode(): ColumnExchangingAnimationMode;
    set columnExchangingAnimationMode(v: ColumnExchangingAnimationMode);
    /**
     * Sets or gets the grid selection mode.
    */
    get selectionMode(): DataGridSelectionMode;
    set selectionMode(v: DataGridSelectionMode);
    /**
     * Sets or gets the grid selection mode.
    */
    get activationMode(): GridActivationMode;
    set activationMode(v: GridActivationMode);
    /**
     * Sets or gets how selection behaves in the grid.
    */
    get selectionBehavior(): GridSelectionBehavior;
    set selectionBehavior(v: GridSelectionBehavior);
    /**
     * Gets or sets the ability to select rows or cells via mouse dragging. Currently only applies when SelectionMode is MultipleRow or RangeCell.
    */
    get mouseDragSelectionEnabled(): boolean;
    set mouseDragSelectionEnabled(v: boolean);
    private _selectedItems;
    /**
     * Gets which items are currently selected in the grid. Collection can be updated to programatically select items.
    */
    get selectedItems(): IgrGridSelectedItemsCollection;
    set selectedItems(v: IgrGridSelectedItemsCollection);
    private _selectedKeys;
    /**
     * Gets which primary key values are currently selected in the grid. Collection can be updated to programatically select items.
    */
    get selectedKeys(): IgrGridSelectedKeysCollection;
    set selectedKeys(v: IgrGridSelectedKeysCollection);
    private _selectedCells;
    /**
     * Gets which cells are currently selected in the grid. Collection can be updated to programatically select cells.
    */
    get selectedCells(): IgrGridSelectedCellsCollection;
    set selectedCells(v: IgrGridSelectedCellsCollection);
    private _selectedCellRanges;
    /**
     * Gets which cell ranges are currently selected in the grid. Collection can be updated to programatically select cells.
    */
    get selectedCellRanges(): IgrGridSelectedCellRangesCollection;
    set selectedCellRanges(v: IgrGridSelectedCellRangesCollection);
    private _pinnedItems;
    /**
     * Gets which items are currently pinned in the grid. Collection can be updated to programatically pin items.
    */
    get pinnedItems(): IgrGridSelectedItemsCollection;
    set pinnedItems(v: IgrGridSelectedItemsCollection);
    private _pinnedKeys;
    /**
     * Gets which primary keys are currently pinned in the grid. Collection can be updated to programatically pin items.
    */
    get pinnedKeys(): IgrGridSelectedKeysCollection;
    set pinnedKeys(v: IgrGridSelectedKeysCollection);
    /**
     * Gets or sets whether to show the column options UI in the headers for columns.
    */
    get isColumnOptionsEnabled(): boolean;
    set isColumnOptionsEnabled(v: boolean);
    /**
     * Gets or sets if group rows will stick to the top of the grid.
    */
    get isGroupRowSticky(): boolean;
    set isGroupRowSticky(v: boolean);
    /**
     * Gets or sets if header separators are rendered.
    */
    get isHeaderSeparatorVisible(): boolean;
    set isHeaderSeparatorVisible(v: boolean);
    /**
     * Gets or sets the default background color to use for content cells when a row is in a selected state
    */
    get cellSelectedBackground(): string;
    set cellSelectedBackground(v: string);
    /**
     * Gets or sets the default background color to use for section header cells when a row is in a selected state
    */
    get sectionHeaderSelectedBackground(): string;
    set sectionHeaderSelectedBackground(v: string);
    /**
     * Gets or sets the default background color to use for summary cells at the root level.
    */
    get summaryRootBackground(): string;
    set summaryRootBackground(v: string);
    /**
     * Gets or sets the default background color to use for summary cells at the section level.
    */
    get summarySectionBackground(): string;
    set summarySectionBackground(v: string);
    /**
     * Gets or sets the default opacity to use for pinned rows
    */
    get pinnedRowOpacity(): number;
    set pinnedRowOpacity(v: number);
    /**
     * Gets or sets the font to use for cells that have been edited.
    */
    get editTextStyle(): string;
    set editTextStyle(v: string);
    /**
     * Gets or sets the default opacity for unsaved cell edits.
    */
    get editOpacity(): number;
    set editOpacity(v: number);
    /**
     * Gets or sets the text color for unsaved deleted rows.
    */
    get deletedTextColor(): string;
    set deletedTextColor(v: string);
    /**
     * Gets or sets the default color to use for sticky rows
    */
    get stickyRowBackground(): string;
    set stickyRowBackground(v: string);
    /**
     * Gets or sets the default color to use for pinned rows
    */
    get pinnedRowBackground(): string;
    set pinnedRowBackground(v: string);
    /**
     * Gets or sets the default color to use for the last sticky row
    */
    get lastStickyRowBackground(): string;
    set lastStickyRowBackground(v: string);
    /**
     * Gets or sets the position of the active cell.
    */
    get activeCell(): IgrGridCellPosition;
    set activeCell(v: IgrGridCellPosition);
    /**
     * Gets or sets the default background color to use for content cells
    */
    get cellBackground(): string;
    set cellBackground(v: string);
    /**
     * Gets or sets the default text color to use for content cells
    */
    get cellTextColor(): string;
    set cellTextColor(v: string);
    /**
     * Gets or sets the default text color to use for content cells
    */
    get headerSortIndicatorColor(): string;
    set headerSortIndicatorColor(v: string);
    /**
     * Gets or sets the default render style for sort indicators in header cells.
    */
    get headerSortIndicatorStyle(): SortIndicatorStyle;
    set headerSortIndicatorStyle(v: SortIndicatorStyle);
    /**
     * Gets or sets the font to use for content cells
    */
    get cellTextStyle(): string;
    set cellTextStyle(v: string);
    /**
     * Gets or sets the default background color to use for section header cells
    */
    get sectionHeaderBackground(): string;
    set sectionHeaderBackground(v: string);
    /**
     * Gets or sets the default text color to use for section header cells
    */
    get sectionHeaderTextColor(): string;
    set sectionHeaderTextColor(v: string);
    /**
     * Gets or sets the font to use for section header cells
    */
    get sectionHeaderTextStyle(): string;
    set sectionHeaderTextStyle(v: string);
    /**
     * Gets or sets the font to use for summary labels at the root level.
    */
    get summaryRootLabelTextStyle(): string;
    set summaryRootLabelTextStyle(v: string);
    /**
     * Gets or sets the font to use for summary labels at the section level.
    */
    get summarySectionLabelTextStyle(): string;
    set summarySectionLabelTextStyle(v: string);
    /**
     * Gets or sets the default text color to use for summary cells at the root level.
    */
    get summaryRootValueTextColor(): string;
    set summaryRootValueTextColor(v: string);
    /**
     * Gets or sets the font to use for summary values at the root level.
    */
    get summaryRootValueTextStyle(): string;
    set summaryRootValueTextStyle(v: string);
    /**
     * Gets or sets the font to use for summary values at the section level.
    */
    get summarySectionValueTextStyle(): string;
    set summarySectionValueTextStyle(v: string);
    /**
     * Gets or sets the default text color to use for summary cells at the section level.
    */
    get summarySectionValueTextColor(): string;
    set summarySectionValueTextColor(v: string);
    /**
     * Gets or sets the default text color to use for summary labels in summary cells at the root level.
    */
    get summaryRootLabelTextColor(): string;
    set summaryRootLabelTextColor(v: string);
    /**
     * Gets or sets the default text color to use for summary labels in summary cells at the section level.
    */
    get summarySectionLabelTextColor(): string;
    set summarySectionLabelTextColor(v: string);
    /**
     * Gets or sets the default background color to use for summary cells at the root level.
    */
    get summaryRootSelectedBackground(): string;
    set summaryRootSelectedBackground(v: string);
    /**
     * Gets or sets the default background color to use for summary cells at the section level.
    */
    get summarySectionSelectedBackground(): string;
    set summarySectionSelectedBackground(v: string);
    /**
     * Gets or sets the width of the pinned area separators.
    */
    get pinnedAreaSeparatorWidth(): number;
    set pinnedAreaSeparatorWidth(v: number);
    /**
     * Gets or sets the width of the header separators.
    */
    get headerSeparatorWidth(): number;
    set headerSeparatorWidth(v: number);
    /**
     * Gets or sets the default background color to use for header separators.
    */
    get headerSeparatorBackground(): string;
    set headerSeparatorBackground(v: string);
    /**
     * Gets or sets the default background color to use for header cells
    */
    get headerBackground(): string;
    set headerBackground(v: string);
    /**
     * Gets or sets the default text color to use for header cells
    */
    get headerTextColor(): string;
    set headerTextColor(v: string);
    /**
     * Gets or sets the font to use for header cells
    */
    get headerTextStyle(): string;
    set headerTextStyle(v: string);
    /**
     * Gets or sets the default background color to use for row separators
    */
    get rowSeparatorBackground(): string;
    set rowSeparatorBackground(v: string);
    get headerRowSeparatorBackground(): string;
    set headerRowSeparatorBackground(v: string);
    /**
     * Gets or sets the default sticky row background color to use for row separators
    */
    get rowSeparatorStickyRowBackground(): string;
    set rowSeparatorStickyRowBackground(v: string);
    /**
     * Gets or sets the default last sticky row background color to use for row separators
    */
    get rowSeparatorLastStickyRowBackground(): string;
    set rowSeparatorLastStickyRowBackground(v: string);
    /**
     * Gets or sets the pinned row background color to use for row separators
    */
    get rowSeparatorPinnedRowBackground(): string;
    set rowSeparatorPinnedRowBackground(v: string);
    /**
     * Sets or gets the width to use for the column resizing separator.
    */
    get columnResizingSeparatorWidth(): number;
    set columnResizingSeparatorWidth(v: number);
    /**
     * Gets or sets the opacity of the column Resizing separator.
    */
    get columnResizingSeparatorOpacity(): number;
    set columnResizingSeparatorOpacity(v: number);
    /**
     * Sets or gets the width to use for the column resizing separator.
    */
    get columnMovingSeparatorWidth(): number;
    set columnMovingSeparatorWidth(v: number);
    /**
     * Gets or sets the opacity of the column moving separator.
    */
    get columnMovingSeparatorOpacity(): number;
    set columnMovingSeparatorOpacity(v: number);
    /**
     * Gets or sets the default background color to use for column resizing separator.
    */
    get columnResizingSeparatorBackground(): string;
    set columnResizingSeparatorBackground(v: string);
    /**
     * Gets or sets the default background color to use for column moving separator.
    */
    get columnMovingSeparatorBackground(): string;
    set columnMovingSeparatorBackground(v: string);
    /**
     * Gets or sets if the section header content should be shifted into the normal column scrollable area when there are pinned columns
    */
    get shiftSectionContent(): boolean;
    set shiftSectionContent(v: boolean);
    /**
     * Gets or sets the column options icon alignment in header cells.
    */
    get columnOptionsIconAlignment(): ColumnOptionsIconAlignment;
    set columnOptionsIconAlignment(v: ColumnOptionsIconAlignment);
    /**
     * Gets or sets the column options icon color in header cells.
    */
    get columnOptionsIconColor(): string;
    set columnOptionsIconColor(v: string);
    /**
     * Gets or sets how the column options icon will behave inside header cells.
    */
    get columnOptionsIconBehavior(): ColumnOptionsIconBehavior;
    set columnOptionsIconBehavior(v: ColumnOptionsIconBehavior);
    /**
     * Gets or sets the border color around the grid.
    */
    get border(): string;
    set border(v: string);
    /**
     * Gets the actual border width.
    */
    get actualBorderWidth(): Thickness;
    set actualBorderWidth(v: Thickness);
    get borderWidthBottom(): number;
    set borderWidthBottom(v: number);
    get borderWidthLeft(): number;
    set borderWidthLeft(v: number);
    get borderWidthRight(): number;
    set borderWidthRight(v: number);
    get borderWidthTop(): number;
    set borderWidthTop(v: number);
    ensureBorderWidth(): void;
    /**
     * Gets or sets if the grid should notify on programmatic selection changes as well as changes from the UI.
    */
    get notifyOnAllSelectionChanges(): boolean;
    set notifyOnAllSelectionChanges(v: boolean);
    get cornerRadiusBottomRight(): number;
    set cornerRadiusBottomRight(v: number);
    get cornerRadiusBottomLeft(): number;
    set cornerRadiusBottomLeft(v: number);
    get cornerRadiusTopLeft(): number;
    set cornerRadiusTopLeft(v: number);
    get cornerRadiusTopRight(): number;
    set cornerRadiusTopRight(v: number);
    ensureCornerRadius(): void;
    get actualCornerRadiusBottomRight(): number;
    set actualCornerRadiusBottomRight(v: number);
    get actualCornerRadiusBottomLeft(): number;
    set actualCornerRadiusBottomLeft(v: number);
    get actualCornerRadiusTopLeft(): number;
    set actualCornerRadiusTopLeft(v: number);
    get actualCornerRadiusTopRight(): number;
    set actualCornerRadiusTopRight(v: number);
    ensureActualCornerRadius(): void;
    /**
     * Gets or sets whether the active cell style will be applied to cells when made active.
    */
    get isActiveCellStyleEnabled(): boolean;
    set isActiveCellStyleEnabled(v: boolean);
    private _responsiveStates;
    /**
     * A set of states that can be applied to the columns of the grid based on available space.
    */
    get responsiveStates(): IgrResponsiveStatesCollection;
    set responsiveStates(v: IgrResponsiveStatesCollection);
    /**
     * Gets the region of the grid that is visible.
    */
    get actualVisibleRegion(): IgRect;
    /**
     * Gets the current sort that is applied to the grid. Collection can be updated to modify the sort for the grid. Once sort descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get initialSortDescriptions(): IgrColumnSortDescriptionCollection;
    /**
     * Gets the current sort that is applied to the grid. Collection can be updated to modify the sort for the grid. Once sort descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get initialGroupDescriptions(): IgrColumnGroupDescriptionCollection;
    /**
     * Gets the current summaries that are applied to the grid.
    */
    get initialSummaryDescriptions(): IgrColumnSummaryDescriptionCollection;
    get initialSorts(): string;
    set initialSorts(v: string);
    get initialGroups(): string;
    set initialGroups(v: string);
    get initialSummaries(): string;
    set initialSummaries(v: string);
    /**
     * Gets the current sort that is applied to the grid. Collection can be updated to modify the sort for the grid. Once sort descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get sortDescriptions(): IgrColumnSortDescriptionCollection;
    /**
     * Gets the current grouping that is applied to the grid. Collection can be updated to modify the grouping for the grid. Once grouping descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get groupDescriptions(): IgrColumnGroupDescriptionCollection;
    /**
     * Gets the current filter that is applied to the grid. Collection can be updated to modify the filter for the grid. Once filter expresisons are in this collection, the grid will no longer listen for changes on their properties.
    */
    get filterExpressions(): IgrFilterExpressionCollection;
    /**
     * Gets the current summaries that are applied to the grid.
    */
    get summaryDescriptions(): IgrColumnSummaryDescriptionCollection;
    /**
     * Gets or sets the scope which summaries are calculated for.
    */
    get summaryScope(): SummaryScope;
    set summaryScope(v: SummaryScope);
    /**
     * Gets or sets whether group headers are collapsable.
    */
    get isGroupCollapsable(): boolean;
    set isGroupCollapsable(v: boolean);
    /**
     * Gets or sets how group headers are displayed when there are multiple groups defined in the grid.
    */
    get groupHeaderDisplayMode(): GroupHeaderDisplayMode;
    set groupHeaderDisplayMode(v: GroupHeaderDisplayMode);
    /**
     * Gets or sets whether groups are expanded or collapsed by default.
    */
    get isGroupExpandedDefault(): boolean;
    set isGroupExpandedDefault(v: boolean);
    /**
     * Gets or sets the display mode summaries will use inside groups.
    */
    get groupSummaryDisplayMode(): GroupSummaryDisplayMode;
    set groupSummaryDisplayMode(v: GroupSummaryDisplayMode);
    /**
     * Gets or sets whether to automatically accept edits or require explicit acceptance or rejections of edits
     * when handling the CellValueChanging or DataCommitting events.
     * When True, nothing is required on the part of the developer in order for edits to be accepted. In
     * order to validate and reject a user cell edit you must explicitly handle the CellValueChanging event
     * and call the RejectEdit method using the edit ID provided by the event. In order to reject a whole
     * commit you need to handle the DataComitting event and explicitly call the RejectCommit method using
     * the commit ID provided by the event.
     * When False, cell edits are not immediately accepted until you explicitly call the AcceptEdit method
     * using the edit ID provided by the CellValueChanging event. If you do not handle this event then edits
     * will be auto accepted.
    */
    get autoAcceptEdits(): boolean;
    set autoAcceptEdits(v: boolean);
    /**
     * Sets or gets the user provided primary key to assume for the data. Certain functionality of the grid requires a way to uniquely identify items in order to work correctly.
     * If a primary key cannot be inferred from the data source, you may need to provide one here.
    */
    get primaryKey(): string[];
    set primaryKey(v: string[]);
    /**
     * Gets either the inferred primary key from the data source, or the user provided primary key, if present. Represents the actual primary key that the grid will use in operations that require it.
    */
    get actualPrimaryKey(): string[];
    set actualPrimaryKey(v: string[]);
    private _actualColumns;
    get actualColumns(): IgrGridColumnCollection;
    set actualColumns(v: IgrGridColumnCollection);
    /**
     * Sets or gets whether the grid will react to sort changes.
    */
    get reactsToSortChanges(): boolean;
    set reactsToSortChanges(v: boolean);
    /**
     * Sets or gets whether the grid will react to group changes.
    */
    get reactsToGroupChanges(): boolean;
    set reactsToGroupChanges(v: boolean);
    /**
     * Sets or gets whether the grid will react to filter changes.
    */
    get reactsToFilterChanges(): boolean;
    set reactsToFilterChanges(v: boolean);
    /**
     * Gets whether an undo can be performed.
    */
    get canUndo(): boolean;
    /**
     * Gets whether a redo can be performed.
    */
    get canRedo(): boolean;
    /**
     * Gets whether a commit can be performed. False if there are any errors present
     * on any pending transactions.
    */
    get canCommit(): boolean;
    /**
     * Gets or sets the behavior of the Enter key.
    */
    get enterBehavior(): EnterKeyBehaviors;
    set enterBehavior(v: EnterKeyBehaviors);
    /**
     * Gets or sets the behavior of the enter key when exiting edit mode.
    */
    get enterBehaviorAfterEdit(): EnterKeyBehaviorAfterEdit;
    set enterBehaviorAfterEdit(v: EnterKeyBehaviorAfterEdit);
    /**
     * Gets or sets whether to show the summaries option in the column options menu.
    */
    get isColumnOptionsSummariesEnabled(): boolean;
    set isColumnOptionsSummariesEnabled(v: boolean);
    /**
     * Gets or sets whether to show the grouping option in the column options menu.
    */
    get isColumnOptionsGroupingEnabled(): boolean;
    set isColumnOptionsGroupingEnabled(v: boolean);
    /**
     * Gets or sets if and how cell merging is performed for all fields.
    */
    get mergedCellMode(): MergedCellMode;
    set mergedCellMode(v: MergedCellMode);
    /**
     * Gets or sets how cells are evaluated for merging.
    */
    get mergedCellEvaluationCriteria(): MergedCellEvaluationCriteria;
    set mergedCellEvaluationCriteria(v: MergedCellEvaluationCriteria);
    /**
     * Gets or sets the vertical alignment to use for the merged cell content.
    */
    get mergedCellVerticalAlignment(): CellContentVerticalAlignment;
    set mergedCellVerticalAlignment(v: CellContentVerticalAlignment);
    /**
     * Gets or sets which filter UI type to use.
    */
    get filterUIType(): FilterUIType;
    set filterUIType(v: FilterUIType);
    /**
     * Gets or sets how filters set through the filter UI are combined.
    */
    get filterLogicalOperator(): FilterLogicalOperator;
    set filterLogicalOperator(v: FilterLogicalOperator);
    /**
     * Gets or sets whether UI filters are case sensitive or not.
    */
    get filterComparisonType(): FilterComparisonType;
    set filterComparisonType(v: FilterComparisonType);
    get todayOverride(): Date;
    set todayOverride(v: Date);
    /**
     * Gets or sets whether selection is cleared when pressing the Escape key.
    */
    get clearSelectionOnEscape(): boolean;
    set clearSelectionOnEscape(v: boolean);
    /**
     * Gets or sets the size of each page when the pager is visible.
    */
    get pageSize(): number;
    set pageSize(v: number);
    /**
     * Gets or sets whether to show the column chooser button in the toolbar.
    */
    get isToolbarColumnChooserVisible(): boolean;
    set isToolbarColumnChooserVisible(v: boolean);
    /**
     * Gets or sets whether to show the column pinning button in the toolbar.
    */
    get isToolbarColumnPinningVisible(): boolean;
    set isToolbarColumnPinningVisible(v: boolean);
    /**
     * Gets or sets the title text to use in the toolbar.
    */
    get toolbarTitle(): string;
    set toolbarTitle(v: string);
    /**
     * Gets or sets the column chooser button text to use in the toolbar.
    */
    get toolbarColumnChooserText(): string;
    set toolbarColumnChooserText(v: string);
    /**
     * Gets or sets the column chooser title text to use in the toolbar.
    */
    get toolbarColumnChooserTitle(): string;
    set toolbarColumnChooserTitle(v: string);
    /**
     * Gets or sets the column pinning button text to use in the toolbar.
    */
    get toolbarColumnPinningText(): string;
    set toolbarColumnPinningText(v: string);
    /**
     * Gets or sets the column pinning title text to use in the toolbar.
    */
    get toolbarColumnPinningTitle(): string;
    set toolbarColumnPinningTitle(v: string);
    /**
     * Gets or sets the style of scrollbar.
    */
    get scrollbarStyle(): ScrollbarStyle;
    set scrollbarStyle(v: ScrollbarStyle);
    /**
     * Gets or sets the scrollbar background color.
    */
    get scrollbarBackground(): string;
    set scrollbarBackground(v: string);
    get allowCopyOperation(): boolean;
    set allowCopyOperation(v: boolean);
    /**
     * Gets or sets whether to defer the SelectedItemsChanged and SelectedKeysChanged events till after the drag selection has completed.
    */
    get deferEventForRowDragSelection(): boolean;
    set deferEventForRowDragSelection(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    /**
 * Forces a refresh of the grid content.

*/
    refresh(): void;
    /**
     * Makes sure pending work has completed if the grid need to be synchronously examined.
    
    */
    flush(): void;
    notifyScrollStart(): void;
    notifyScrollStop(): void;
    exchangeColumn(newColumn: IgrDataGridColumn, oldColumn: IgrDataGridColumn): void;
    pinColumn(column: IgrDataGridColumn, position: PinnedPositions): void;
    moveColumn(oldIndex: number, newIndex: number): void;
    /**
     * Moves a column to the left, if possible.
    
    * @param columnIndex  * The index of the column to move.
    */
    moveColumnLeft(columnIndex: number): void;
    /**
     * Moves a column to the right, if possible.
    
    * @param columnIndex  * The index of the column to move.
    */
    moveColumnRight(columnIndex: number): void;
    /**
     * Returns true if a column can be moved to the left of it's current position; otherwise false.
    
    * @param columnIndex  * The index of the column.
    */
    canMoveColumnLeft(columnIndex: number): boolean;
    /**
     * Returns true if a column can be moved to the right of it's current position; otherwise false.
    
    * @param columnIndex  * The index of the column.
    */
    canMoveColumnRight(columnIndex: number): boolean;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
    /**
     * Scrolls the grid to given row, by index
    
    * @param rowNumber  * The row index to scroll to.
    */
    scrollToRowByIndex(rowNumber: number): void;
    /**
     * Scrolls the grid so that a row is the last visible, by index.
    
    * @param rowNumber  * The row index to scroll to.
    */
    scrollToLastRowByIndex(rowNumber: number): void;
    /**
     * Scrolls to an item, if found.
    
    * @param item  * The item to scroll to.
    */
    scrollToItem(item: any): boolean;
    scrollToPrimaryKey(key: any[]): boolean;
    /**
     * Scrolls the grid to given column, by index
    
    * @param columnNumber  * The column number to scroll to.
    */
    scrollToColumnByIndex(columnNumber: number): void;
    /**
     * Gets the last visible index in the grid.
    
    */
    getLastVisibleIndex(): number;
    /**
     * Gets the first visible index in the grid.
    
    */
    getFirstVisibleIndex(): number;
    /**
     * Invalidates the bound data for the rows currently visible.
    
    */
    invalidateVisibleRows(): void;
    /**
     * Manually set the active responsive state of the grid.
    
    * @param name
    */
    setActiveResponsiveState(name: string): void;
    notifySetItem(index: number, oldItem: any, newItem: any): void;
    /**
     * Manually notifies the grid's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the grid is bound to is already observable.
    
    */
    notifyClearItems(): void;
    notifyInsertItem(index: number, newItem: any): void;
    notifyRemoveItem(index: number, oldItem: any): void;
    /**
     * Returns the data index of an item within the bound data source.
    
    * @param item  * The item from which to get the index.
    */
    dataIndexOfItem(item: any): number;
    dataIndexOfPrimaryKey(key: any[]): number;
    /**
     * Resolves the value of a specific cell.
    
    * @param cellKey  * The cell to resolve.
    */
    resolveCellValue(cellKey: IgrCellKey): any;
    resolveCellValueFromPosition(row: number, column: number): any;
    /**
     * Gets the column that appears at the index specified. This is not the columns actual index in the
     * column's collection but the index for how it appears visually in the grid.
    
    * @param index  * The rendered index of the column.
    */
    getColumnAtRenderedIndex(index: number): IgrDataGridColumn;
    /**
     * Gets the summary results for root level.
    
    */
    getRootSummaryResults(): ISummaryResult[];
    /**
     * Gets the summary results for a specific section.
    
    */
    getSectionSummaryResults(sectionIndex: number): ISummaryResult[][];
    /**
     * Commits any edits that may exist in the datasource.
    
    */
    commitEdits(): void;
    /**
     * Cancels any edits that may exist in the datasource.
    
    */
    cancelEdits(): void;
    /**
     * Accepts a specific commit to the datasource.
    
    * @param commitID  * The ID of the commit provided by the Committing event.
    */
    acceptCommit(commitID: number): void;
    /**
     * Rejects a specific commit.
    
    * @param commitID  * The ID of the commit provided by the Committing event.
    */
    rejectCommit(commitID: number): void;
    /**
     * Undo the last edit.
    
    */
    undo(): void;
    /**
     * Redo the last edit.
    
    */
    redo(): void;
    updatePropertyAtKey(key: any[], propertyPath: string, value: any): void;
    removeItemByKey(key: any[]): void;
    /**
     * Removes an item by its instance.
    
    * @param item  * The item instance to remove.
    */
    removeItem(item: any): void;
    /**
     * Accept a pending edit turning it into a real edit.
    
    * @param editID  * The ID of the edit. Provided by the CellValueChanging event.
    */
    acceptEdit(editID: number): void;
    /**
     * Reject a pending edit.
    
    * @param editID  * The ID of the edit. Provided by the CellValueChanging event.
    */
    rejectEdit(editID: number): void;
    setEditError(editID: number, errorMessage: string): void;
    /**
     * Start edit mode on the active cell.
    
    */
    startEditMode(): void;
    endEditMode(commit: boolean): void;
    /**
     * Selects all of the rows in the grid.
    
    */
    selectAllRows(): void;
    /**
     * Deselects all currently selected rows.
    
    */
    deselectAllRows(): void;
    /**
     * Saves the layout chnages that have been made to the grid
    
    */
    saveLayout(): string;
    /**
     * Loads the layout chnages that have been made to the grid
    
    */
    loadLayout(json: string): void;
    private _filterExpressionsChanging;
    private _filterExpressionsChanging_wrapped;
    get filterExpressionsChanging(): (s: IgrDataGrid, e: IgrGridFilterExpressionsEventArgs) => void;
    set filterExpressionsChanging(ev: (s: IgrDataGrid, e: IgrGridFilterExpressionsEventArgs) => void);
    private _filterExpressionsChanged;
    private _filterExpressionsChanged_wrapped;
    get filterExpressionsChanged(): (s: IgrDataGrid, e: IgrGridFilterExpressionsEventArgs) => void;
    set filterExpressionsChanged(ev: (s: IgrDataGrid, e: IgrGridFilterExpressionsEventArgs) => void);
    private _cellPreviewPointerDown;
    private _cellPreviewPointerDown_wrapped;
    /**
     * Previews that a pointer is down on a cell.
    */
    get cellPreviewPointerDown(): (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    set cellPreviewPointerDown(ev: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void);
    private _cellPreviewPointerUp;
    private _cellPreviewPointerUp_wrapped;
    /**
     * Previews that a pointer is up on a cell.
    */
    get cellPreviewPointerUp(): (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    set cellPreviewPointerUp(ev: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void);
    private _cellPointerDown;
    private _cellPointerDown_wrapped;
    /**
     * Indicates a pointer is down on a cell.
    */
    get cellPointerDown(): (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    set cellPointerDown(ev: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void);
    private _cellPointerUp;
    private _cellPointerUp_wrapped;
    /**
     * Indicates a pointer is up on a cell.
    */
    get cellPointerUp(): (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    set cellPointerUp(ev: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void);
    private _cellClicked;
    private _cellClicked_wrapped;
    /**
     * Called when a cell is clicked.
    */
    get cellClicked(): (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    set cellClicked(ev: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void);
    private _sortDescriptionsChanged;
    private _sortDescriptionsChanged_wrapped;
    /**
     * Called when sorting has changed.
    */
    get sortDescriptionsChanged(): (s: IgrDataGrid, e: IgrGridSortDescriptionsChangedEventArgs) => void;
    set sortDescriptionsChanged(ev: (s: IgrDataGrid, e: IgrGridSortDescriptionsChangedEventArgs) => void);
    private _groupDescriptionsChanged;
    private _groupDescriptionsChanged_wrapped;
    /**
     * Called when grouping has changed.
    */
    get groupDescriptionsChanged(): (s: IgrDataGrid, e: IgrGridGroupDescriptionsChangedEventArgs) => void;
    set groupDescriptionsChanged(ev: (s: IgrDataGrid, e: IgrGridGroupDescriptionsChangedEventArgs) => void);
    private _summaryDescriptionsChanged;
    private _summaryDescriptionsChanged_wrapped;
    /**
     * Called when summaries have changed.
    */
    get summaryDescriptionsChanged(): (s: IgrDataGrid, e: IgrGridSummaryDescriptionsChangedEventArgs) => void;
    set summaryDescriptionsChanged(ev: (s: IgrDataGrid, e: IgrGridSummaryDescriptionsChangedEventArgs) => void);
    private _columnHiddenChanged;
    private _columnHiddenChanged_wrapped;
    /**
     * Called when a column is hidden or unhidden.
    */
    get columnHiddenChanged(): (s: IgrDataGrid, e: IgrColumnHiddenChangedEventArgs) => void;
    set columnHiddenChanged(ev: (s: IgrDataGrid, e: IgrColumnHiddenChangedEventArgs) => void);
    private _columnPinnedChanged;
    private _columnPinnedChanged_wrapped;
    /**
     * Called when a column is pinned or unpinned.
    */
    get columnPinnedChanged(): (s: IgrDataGrid, e: IgrColumnPinnedChangedEventArgs) => void;
    set columnPinnedChanged(ev: (s: IgrDataGrid, e: IgrColumnPinnedChangedEventArgs) => void);
    private _cellValueChanging;
    private _cellValueChanging_wrapped;
    /**
     * Called when a cell has been edited.
    */
    get cellValueChanging(): (s: IgrDataGrid, e: IgrGridCellValueChangingEventArgs) => void;
    set cellValueChanging(ev: (s: IgrDataGrid, e: IgrGridCellValueChangingEventArgs) => void);
    private _dataCommitted;
    private _dataCommitted_wrapped;
    /**
     * Called when edits have been committed to the datasource.
    */
    get dataCommitted(): (s: IgrDataGrid, e: IgrGridDataCommittedEventArgs) => void;
    set dataCommitted(ev: (s: IgrDataGrid, e: IgrGridDataCommittedEventArgs) => void);
    private _dataCommitting;
    private _dataCommitting_wrapped;
    /**
     * Called when edits are about to be committed to the datasource.
    */
    get dataCommitting(): (s: IgrDataGrid, e: IgrGridDataCommittingEventArgs) => void;
    set dataCommitting(ev: (s: IgrDataGrid, e: IgrGridDataCommittingEventArgs) => void);
    private _sizeChanged;
    private _sizeChanged_wrapped;
    /**
     * Called when the grids size has changed.
    */
    get sizeChanged(): (s: IgrDataGrid, e: IgrGridSizeChangedEventArgs) => void;
    set sizeChanged(ev: (s: IgrDataGrid, e: IgrGridSizeChangedEventArgs) => void);
    private _actualColumnsChanged;
    private _actualColumnsChanged_wrapped;
    get actualColumnsChanged(): (s: IgrDataGrid, e: IgrGridColumnsChangedEventArgs) => void;
    set actualColumnsChanged(ev: (s: IgrDataGrid, e: IgrGridColumnsChangedEventArgs) => void);
    private _columnsAutoGenerated;
    private _columnsAutoGenerated_wrapped;
    /**
     * Called when the columns are autogenerated.
    */
    get columnsAutoGenerated(): (s: IgrDataGrid, e: IgrGridColumnsAutoGeneratedEventArgs) => void;
    set columnsAutoGenerated(ev: (s: IgrDataGrid, e: IgrGridColumnsAutoGeneratedEventArgs) => void);
    private _selectedItemsChanged;
    private _selectedItemsChanged_wrapped;
    /**
     * Called when the selected items change.
    */
    get selectedItemsChanged(): (s: IgrDataGrid, e: IgrGridSelectedItemsChangedEventArgs) => void;
    set selectedItemsChanged(ev: (s: IgrDataGrid, e: IgrGridSelectedItemsChangedEventArgs) => void);
    private _selectedKeysChanged;
    private _selectedKeysChanged_wrapped;
    /**
     * Called when the selected keys change.
    */
    get selectedKeysChanged(): (s: IgrDataGrid, e: IgrGridSelectedKeysChangedEventArgs) => void;
    set selectedKeysChanged(ev: (s: IgrDataGrid, e: IgrGridSelectedKeysChangedEventArgs) => void);
    private _selectedCellsChanged;
    private _selectedCellsChanged_wrapped;
    /**
     * Called when the selected cells change.
    */
    get selectedCellsChanged(): (s: IgrDataGrid, e: IgrGridSelectedCellsChangedEventArgs) => void;
    set selectedCellsChanged(ev: (s: IgrDataGrid, e: IgrGridSelectedCellsChangedEventArgs) => void);
    private _selectionChanged;
    private _selectionChanged_wrapped;
    /**
     * Called when an individual selection operation has been made.
    */
    get selectionChanged(): (s: IgrDataGrid, e: IgrGridSelectionChangedEventArgs) => void;
    set selectionChanged(ev: (s: IgrDataGrid, e: IgrGridSelectionChangedEventArgs) => void);
    private _activeCellChanged;
    private _activeCellChanged_wrapped;
    /**
     * Called when the active cell changes.
    */
    get activeCellChanged(): (s: IgrDataGrid, e: IgrGridActiveCellChangedEventArgs) => void;
    set activeCellChanged(ev: (s: IgrDataGrid, e: IgrGridActiveCellChangedEventArgs) => void);
    private _selectedCellRangesChanged;
    private _selectedCellRangesChanged_wrapped;
    /**
     * Called when the selected cell ranges changed.
    */
    get selectedCellRangesChanged(): (s: IgrDataGrid, e: IgrGridSelectedCellRangesChangedEventArgs) => void;
    set selectedCellRangesChanged(ev: (s: IgrDataGrid, e: IgrGridSelectedCellRangesChangedEventArgs) => void);
    private _columnWidthChanged;
    private _columnWidthChanged_wrapped;
    /**
     * Called when a column's Width property has changed.
    */
    get columnWidthChanged(): (s: IgrDataGrid, e: IgrGridColumnWidthChangedEventArgs) => void;
    set columnWidthChanged(ev: (s: IgrDataGrid, e: IgrGridColumnWidthChangedEventArgs) => void);
    private _cellEditStarted;
    private _cellEditStarted_wrapped;
    /**
     * Called when a cell has started editing.
    */
    get cellEditStarted(): (s: IgrDataGrid, e: IgrGridCellEditStartedEventArgs) => void;
    set cellEditStarted(ev: (s: IgrDataGrid, e: IgrGridCellEditStartedEventArgs) => void);
    private _cellEditEnded;
    private _cellEditEnded_wrapped;
    /**
     * Called when a cell has finished editing.
    */
    get cellEditEnded(): (s: IgrDataGrid, e: IgrGridCellEditEndedEventArgs) => void;
    set cellEditEnded(ev: (s: IgrDataGrid, e: IgrGridCellEditEndedEventArgs) => void);
    private _rowEditStarted;
    private _rowEditStarted_wrapped;
    /**
     * Called when a row has started editing.
    */
    get rowEditStarted(): (s: IgrDataGrid, e: IgrGridRowEditStartedEventArgs) => void;
    set rowEditStarted(ev: (s: IgrDataGrid, e: IgrGridRowEditStartedEventArgs) => void);
    private _rowEditEnded;
    private _rowEditEnded_wrapped;
    /**
     * Called when a row has finished editing.
    */
    get rowEditEnded(): (s: IgrDataGrid, e: IgrGridRowEditEndedEventArgs) => void;
    set rowEditEnded(ev: (s: IgrDataGrid, e: IgrGridRowEditEndedEventArgs) => void);
    private _customFilterRequested;
    private _customFilterRequested_wrapped;
    get customFilterRequested(): (s: IgrDataGrid, e: IgrGridCustomFilterRequestedEventArgs) => void;
    set customFilterRequested(ev: (s: IgrDataGrid, e: IgrGridCustomFilterRequestedEventArgs) => void);
    private _actualPrimaryKeyChange;
    private _actualPrimaryKeyChange_wrapped;
    get actualPrimaryKeyChange(): (s: IgrDataGrid, e: string[]) => void;
    set actualPrimaryKeyChange(ev: (s: IgrDataGrid, e: string[]) => void);
}
export interface IIgrDataGridProps {
    width?: string;
    height?: string;
    useCanvas?: boolean | string;
    useAccessibility?: boolean | string;
    /**
     * Gets or sets the default column width to use if a column as no local width.
     * */
    defaultColumnWidth?: IgrColumnWidth | string;
    /**
  * Gets or sets the data for the grid to use.
  */
    dataSource?: any;
    /**
     * Gets or sets the amount of left inset space to use around the grid content.
    */
    insetLeft?: number;
    /**
     * Gets or sets the amount of top inset space to use around the grid content.
    */
    insetTop?: number;
    /**
     * Gets or sets the amount of right inset space to use around the grid content.
    */
    insetRight?: number;
    /**
     * Gets or sets the amount of bottom inset space to use around the grid content.
    */
    insetBottom?: number;
    /**
     * Gets or sets if the Column Grouping Area should be shown and enabled
    */
    isGroupByAreaVisible?: boolean | string;
    /**
     * Gets or sets whether to show the pager or not.
    */
    isPagerVisible?: boolean | string;
    /**
     * Gets or sets whether to show the toolbar.
    */
    isToolbarVisible?: boolean | string;
    children?: React.ReactNode;
    /**
 * Gets or sets the type of column resizing to use.
*/
    columnResizingMode?: ColumnResizingMode | string;
    /**
     * Gets or sets the type column moving to use.
    */
    columnMovingMode?: ColumnMovingMode | string;
    /**
     * Gets or sets whether the row will highlight when hovered.
    */
    isRowHoverEnabled?: boolean | string;
    /**
     * Gets or sets the background color for rows when hovered.
    */
    rowHoverBackground?: string;
    /**
     * Gets or sets the text color for rows when hovered.
    */
    rowHoverTextColor?: string;
    /**
     * Gets or sets the border color for rows being edited.
    */
    editRowBorder?: string;
    editRowBorderWidthBottom?: number | string;
    editRowBorderWidthLeft?: number | string;
    editRowBorderWidthRight?: number | string;
    editRowBorderWidthTop?: number | string;
    /**
     * Gets or sets the header type used for sectioning off groups of rows.
    */
    sectionHeader?: IgrSectionHeader;
    /**
     * Gets or sets the cell definition used for summary rows at the root level.
    */
    summaryRowRoot?: IgrSummaryRowRoot;
    /**
     * Gets or sets the cell definition used for summary rows at the section level.
    */
    summaryRowSection?: IgrSummaryRowSection;
    /**
     * Gets or sets the row seperator settings.
    */
    rowSeparator?: IgrRowSeparator;
    /**
     * Gets or sets the header row seperator settings.
    */
    headerRowSeparator?: IgrHeaderRowSeparator;
    /**
     * Gets or sets the header seperator settings.
    */
    headerSeparator?: IgrHeaderSeparator;
    /**
     * Gets or sets the column resizing seperator settings.
    */
    columnResizingSeparator?: IgrColumnResizingSeparator;
    /**
     * Gets or sets the column resizing seperator settings.
    */
    columnMovingSeparator?: IgrColumnMovingSeparator;
    /**
     * Gets or sets the pinned area separator settings.
    */
    pinnedAreaSeparator?: IgrPinnedAreaSeparator;
    /**
     * Gets or sets the desired properties the grid will automatically generate columns for.
    */
    autoGenerateDesiredProperties?: string[];
    /**
     * Gets or sets the desired properties for the data source to load. If specified the data source may decide to constrain the properties it fetches to these properties and must make sure that at least those properties are loaded, rather than the default behavior for that data source.
    */
    dataSourceDesiredProperties?: string[];
    /**
     * Gets or sets the display density to use for the grid.
    */
    density?: ControlDisplayDensity | string;
    /**
     * Gets the actual height for the rows in the grid.
    */
    actualRowHeight?: number | string;
    /**
     * Gets or sets the height to use for the rows in the grid. If not set the grid will
     * use the default value for the set display density.
    */
    rowHeight?: number | string;
    /**
     * Gets or sets the default minimum width to use on all columns. Ignored if NaN.
    */
    defaultColumnMinWidth?: number | string;
    /**
     * Gets the height used for the header row.
    */
    actualHeaderHeight?: number | string;
    /**
     * Gets or sets the height to use for the header row.
    */
    headerHeight?: number | string;
    /**
     * Returns/sets the action to take when a column header is clicked.
    */
    headerClickAction?: HeaderClickAction | string;
    /**
     * Gets or sets the type of edit mode
    */
    editMode?: EditModeType | string;
    /**
     * Gets or sets the type of click action required to enter edit mode.
    */
    editModeClickAction?: EditModeClickAction | string;
    /**
     * Gets or sets whether edit mode will begin as soon as you start typing while a cell is active.
    */
    editOnKeyPress?: boolean | string;
    /**
     * Configures whether or not the grid will autogenerate columns when the data source is set.
    */
    autoGenerateColumns?: boolean | string;
    /**
     * Sets or gets the height to use for the row separators.
    */
    rowSeparatorHeight?: number | string;
    /**
     * Configures whether or not place holders are used for cells who do not have their data yet.
    */
    isPlaceholderRenderingEnabled?: boolean | string;
    /**
     * Sets or gets the Column Adding Animation mode to use.
    */
    columnAddingAnimationMode?: ColumnShowingAnimationMode | string;
    /**
     * Sets or gets the Column Property Updating Animation mode to use.
    */
    columnPropertyUpdatingAnimationMode?: ColumnPropertyUpdatingAnimationMode | string;
    /**
     * Sets or gets the cell data loaded animation mode to use.
    */
    cellDataLoadedAnimationMode?: CellDataLoadedAnimationMode | string;
    /**
     * Sets or gets the row selection animation mode to use.
    */
    rowSelectionAnimationMode?: RowSelectionAnimationMode | string;
    /**
     * Sets or gets the row hover animation mode to use.
    */
    rowHoverAnimationMode?: RowHoverAnimationMode | string;
    /**
     * Sets or gets the cell selection animation mode to use.
    */
    cellSelectionAnimationMode?: CellSelectionAnimationMode | string;
    /**
     * Sets or gets the default animation settings for the grid.
    */
    animationSettings?: IgrGridAnimationSettings;
    /**
     * Sets or gets the column resizing animation mode to use. Only applies when resizing in Deferred mode.
    */
    columnResizingAnimationMode?: ColumnResizingAnimationMode | string;
    /**
     * Sets or gets the column showing animation mode to use.
    */
    columnShowingAnimationMode?: ColumnShowingAnimationMode | string;
    /**
     * Sets or gets the column moving animation mode to use.
    */
    columnMovingAnimationMode?: ColumnMovingAnimationMode | string;
    /**
     * Sets or gets the column hiding animation mode to use.
    */
    columnHidingAnimationMode?: ColumnHidingAnimationMode | string;
    /**
     * Sets or gets the column exchanging animation mode to use.
    */
    columnExchangingAnimationMode?: ColumnExchangingAnimationMode | string;
    /**
     * Sets or gets the grid selection mode.
    */
    selectionMode?: DataGridSelectionMode | string;
    /**
     * Sets or gets the grid selection mode.
    */
    activationMode?: GridActivationMode | string;
    /**
     * Sets or gets how selection behaves in the grid.
    */
    selectionBehavior?: GridSelectionBehavior | string;
    /**
     * Gets or sets the ability to select rows or cells via mouse dragging. Currently only applies when SelectionMode is MultipleRow or RangeCell.
    */
    mouseDragSelectionEnabled?: boolean | string;
    /**
     * Gets or sets whether to show the column options UI in the headers for columns.
    */
    isColumnOptionsEnabled?: boolean | string;
    /**
     * Gets or sets if group rows will stick to the top of the grid.
    */
    isGroupRowSticky?: boolean | string;
    /**
     * Gets or sets if header separators are rendered.
    */
    isHeaderSeparatorVisible?: boolean | string;
    /**
     * Gets or sets the default background color to use for content cells when a row is in a selected state
    */
    cellSelectedBackground?: string;
    /**
     * Gets or sets the default background color to use for section header cells when a row is in a selected state
    */
    sectionHeaderSelectedBackground?: string;
    /**
     * Gets or sets the default background color to use for summary cells at the root level.
    */
    summaryRootBackground?: string;
    /**
     * Gets or sets the default background color to use for summary cells at the section level.
    */
    summarySectionBackground?: string;
    /**
     * Gets or sets the default opacity to use for pinned rows
    */
    pinnedRowOpacity?: number | string;
    /**
     * Gets or sets the font to use for cells that have been edited.
    */
    editTextStyle?: string;
    /**
     * Gets or sets the default opacity for unsaved cell edits.
    */
    editOpacity?: number | string;
    /**
     * Gets or sets the text color for unsaved deleted rows.
    */
    deletedTextColor?: string;
    /**
     * Gets or sets the default color to use for sticky rows
    */
    stickyRowBackground?: string;
    /**
     * Gets or sets the default color to use for pinned rows
    */
    pinnedRowBackground?: string;
    /**
     * Gets or sets the default color to use for the last sticky row
    */
    lastStickyRowBackground?: string;
    /**
     * Gets or sets the position of the active cell.
    */
    activeCell?: IgrGridCellPosition;
    /**
     * Gets or sets the default background color to use for content cells
    */
    cellBackground?: string;
    /**
     * Gets or sets the default text color to use for content cells
    */
    cellTextColor?: string;
    /**
     * Gets or sets the default text color to use for content cells
    */
    headerSortIndicatorColor?: string;
    /**
     * Gets or sets the default render style for sort indicators in header cells.
    */
    headerSortIndicatorStyle?: SortIndicatorStyle | string;
    /**
     * Gets or sets the font to use for content cells
    */
    cellTextStyle?: string;
    /**
     * Gets or sets the default background color to use for section header cells
    */
    sectionHeaderBackground?: string;
    /**
     * Gets or sets the default text color to use for section header cells
    */
    sectionHeaderTextColor?: string;
    /**
     * Gets or sets the font to use for section header cells
    */
    sectionHeaderTextStyle?: string;
    /**
     * Gets or sets the font to use for summary labels at the root level.
    */
    summaryRootLabelTextStyle?: string;
    /**
     * Gets or sets the font to use for summary labels at the section level.
    */
    summarySectionLabelTextStyle?: string;
    /**
     * Gets or sets the default text color to use for summary cells at the root level.
    */
    summaryRootValueTextColor?: string;
    /**
     * Gets or sets the font to use for summary values at the root level.
    */
    summaryRootValueTextStyle?: string;
    /**
     * Gets or sets the font to use for summary values at the section level.
    */
    summarySectionValueTextStyle?: string;
    /**
     * Gets or sets the default text color to use for summary cells at the section level.
    */
    summarySectionValueTextColor?: string;
    /**
     * Gets or sets the default text color to use for summary labels in summary cells at the root level.
    */
    summaryRootLabelTextColor?: string;
    /**
     * Gets or sets the default text color to use for summary labels in summary cells at the section level.
    */
    summarySectionLabelTextColor?: string;
    /**
     * Gets or sets the default background color to use for summary cells at the root level.
    */
    summaryRootSelectedBackground?: string;
    /**
     * Gets or sets the default background color to use for summary cells at the section level.
    */
    summarySectionSelectedBackground?: string;
    /**
     * Gets or sets the width of the pinned area separators.
    */
    pinnedAreaSeparatorWidth?: number | string;
    /**
     * Gets or sets the width of the header separators.
    */
    headerSeparatorWidth?: number | string;
    /**
     * Gets or sets the default background color to use for header separators.
    */
    headerSeparatorBackground?: string;
    /**
     * Gets or sets the default background color to use for header cells
    */
    headerBackground?: string;
    /**
     * Gets or sets the default text color to use for header cells
    */
    headerTextColor?: string;
    /**
     * Gets or sets the font to use for header cells
    */
    headerTextStyle?: string;
    /**
     * Gets or sets the default background color to use for row separators
    */
    rowSeparatorBackground?: string;
    headerRowSeparatorBackground?: string;
    /**
     * Gets or sets the default sticky row background color to use for row separators
    */
    rowSeparatorStickyRowBackground?: string;
    /**
     * Gets or sets the default last sticky row background color to use for row separators
    */
    rowSeparatorLastStickyRowBackground?: string;
    /**
     * Gets or sets the pinned row background color to use for row separators
    */
    rowSeparatorPinnedRowBackground?: string;
    /**
     * Sets or gets the width to use for the column resizing separator.
    */
    columnResizingSeparatorWidth?: number | string;
    /**
     * Gets or sets the opacity of the column Resizing separator.
    */
    columnResizingSeparatorOpacity?: number | string;
    /**
     * Sets or gets the width to use for the column resizing separator.
    */
    columnMovingSeparatorWidth?: number | string;
    /**
     * Gets or sets the opacity of the column moving separator.
    */
    columnMovingSeparatorOpacity?: number | string;
    /**
     * Gets or sets the default background color to use for column resizing separator.
    */
    columnResizingSeparatorBackground?: string;
    /**
     * Gets or sets the default background color to use for column moving separator.
    */
    columnMovingSeparatorBackground?: string;
    /**
     * Gets or sets if the section header content should be shifted into the normal column scrollable area when there are pinned columns
    */
    shiftSectionContent?: boolean | string;
    /**
     * Gets or sets the column options icon alignment in header cells.
    */
    columnOptionsIconAlignment?: ColumnOptionsIconAlignment | string;
    /**
     * Gets or sets the column options icon color in header cells.
    */
    columnOptionsIconColor?: string;
    /**
     * Gets or sets how the column options icon will behave inside header cells.
    */
    columnOptionsIconBehavior?: ColumnOptionsIconBehavior | string;
    /**
     * Gets or sets the border color around the grid.
    */
    border?: string;
    /**
     * Gets the actual border width.
    */
    actualBorderWidth?: Thickness;
    borderWidthBottom?: number | string;
    borderWidthLeft?: number | string;
    borderWidthRight?: number | string;
    borderWidthTop?: number | string;
    /**
     * Gets or sets if the grid should notify on programmatic selection changes as well as changes from the UI.
    */
    notifyOnAllSelectionChanges?: boolean | string;
    cornerRadiusBottomRight?: number | string;
    cornerRadiusBottomLeft?: number | string;
    cornerRadiusTopLeft?: number | string;
    cornerRadiusTopRight?: number | string;
    actualCornerRadiusBottomRight?: number | string;
    actualCornerRadiusBottomLeft?: number | string;
    actualCornerRadiusTopLeft?: number | string;
    actualCornerRadiusTopRight?: number | string;
    /**
     * Gets or sets whether the active cell style will be applied to cells when made active.
    */
    isActiveCellStyleEnabled?: boolean | string;
    initialSorts?: string;
    initialGroups?: string;
    initialSummaries?: string;
    /**
     * Gets or sets the scope which summaries are calculated for.
    */
    summaryScope?: SummaryScope | string;
    /**
     * Gets or sets whether group headers are collapsable.
    */
    isGroupCollapsable?: boolean | string;
    /**
     * Gets or sets how group headers are displayed when there are multiple groups defined in the grid.
    */
    groupHeaderDisplayMode?: GroupHeaderDisplayMode | string;
    /**
     * Gets or sets whether groups are expanded or collapsed by default.
    */
    isGroupExpandedDefault?: boolean | string;
    /**
     * Gets or sets the display mode summaries will use inside groups.
    */
    groupSummaryDisplayMode?: GroupSummaryDisplayMode | string;
    /**
     * Gets or sets whether to automatically accept edits or require explicit acceptance or rejections of edits
     * when handling the CellValueChanging or DataCommitting events.
     * When True, nothing is required on the part of the developer in order for edits to be accepted. In
     * order to validate and reject a user cell edit you must explicitly handle the CellValueChanging event
     * and call the RejectEdit method using the edit ID provided by the event. In order to reject a whole
     * commit you need to handle the DataComitting event and explicitly call the RejectCommit method using
     * the commit ID provided by the event.
     * When False, cell edits are not immediately accepted until you explicitly call the AcceptEdit method
     * using the edit ID provided by the CellValueChanging event. If you do not handle this event then edits
     * will be auto accepted.
    */
    autoAcceptEdits?: boolean | string;
    /**
     * Sets or gets the user provided primary key to assume for the data. Certain functionality of the grid requires a way to uniquely identify items in order to work correctly.
     * If a primary key cannot be inferred from the data source, you may need to provide one here.
    */
    primaryKey?: string[];
    /**
     * Gets either the inferred primary key from the data source, or the user provided primary key, if present. Represents the actual primary key that the grid will use in operations that require it.
    */
    actualPrimaryKey?: string[];
    /**
     * Sets or gets whether the grid will react to sort changes.
    */
    reactsToSortChanges?: boolean | string;
    /**
     * Sets or gets whether the grid will react to group changes.
    */
    reactsToGroupChanges?: boolean | string;
    /**
     * Sets or gets whether the grid will react to filter changes.
    */
    reactsToFilterChanges?: boolean | string;
    /**
     * Gets or sets the behavior of the Enter key.
    */
    enterBehavior?: EnterKeyBehaviors | string;
    /**
     * Gets or sets the behavior of the enter key when exiting edit mode.
    */
    enterBehaviorAfterEdit?: EnterKeyBehaviorAfterEdit | string;
    /**
     * Gets or sets whether to show the summaries option in the column options menu.
    */
    isColumnOptionsSummariesEnabled?: boolean | string;
    /**
     * Gets or sets whether to show the grouping option in the column options menu.
    */
    isColumnOptionsGroupingEnabled?: boolean | string;
    /**
     * Gets or sets if and how cell merging is performed for all fields.
    */
    mergedCellMode?: MergedCellMode | string;
    /**
     * Gets or sets how cells are evaluated for merging.
    */
    mergedCellEvaluationCriteria?: MergedCellEvaluationCriteria | string;
    /**
     * Gets or sets the vertical alignment to use for the merged cell content.
    */
    mergedCellVerticalAlignment?: CellContentVerticalAlignment | string;
    /**
     * Gets or sets which filter UI type to use.
    */
    filterUIType?: FilterUIType | string;
    /**
     * Gets or sets how filters set through the filter UI are combined.
    */
    filterLogicalOperator?: FilterLogicalOperator | string;
    /**
     * Gets or sets whether UI filters are case sensitive or not.
    */
    filterComparisonType?: FilterComparisonType | string;
    todayOverride?: Date;
    /**
     * Gets or sets whether selection is cleared when pressing the Escape key.
    */
    clearSelectionOnEscape?: boolean | string;
    /**
     * Gets or sets the size of each page when the pager is visible.
    */
    pageSize?: number | string;
    /**
     * Gets or sets whether to show the column chooser button in the toolbar.
    */
    isToolbarColumnChooserVisible?: boolean | string;
    /**
     * Gets or sets whether to show the column pinning button in the toolbar.
    */
    isToolbarColumnPinningVisible?: boolean | string;
    /**
     * Gets or sets the title text to use in the toolbar.
    */
    toolbarTitle?: string;
    /**
     * Gets or sets the column chooser button text to use in the toolbar.
    */
    toolbarColumnChooserText?: string;
    /**
     * Gets or sets the column chooser title text to use in the toolbar.
    */
    toolbarColumnChooserTitle?: string;
    /**
     * Gets or sets the column pinning button text to use in the toolbar.
    */
    toolbarColumnPinningText?: string;
    /**
     * Gets or sets the column pinning title text to use in the toolbar.
    */
    toolbarColumnPinningTitle?: string;
    /**
     * Gets or sets the style of scrollbar.
    */
    scrollbarStyle?: ScrollbarStyle | string;
    /**
     * Gets or sets the scrollbar background color.
    */
    scrollbarBackground?: string;
    allowCopyOperation?: boolean | string;
    /**
     * Gets or sets whether to defer the SelectedItemsChanged and SelectedKeysChanged events till after the drag selection has completed.
    */
    deferEventForRowDragSelection?: boolean | string;
    filterExpressionsChanging?: (s: IgrDataGrid, e: IgrGridFilterExpressionsEventArgs) => void;
    filterExpressionsChanged?: (s: IgrDataGrid, e: IgrGridFilterExpressionsEventArgs) => void;
    /**
     * Previews that a pointer is down on a cell.
    */
    cellPreviewPointerDown?: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    /**
     * Previews that a pointer is up on a cell.
    */
    cellPreviewPointerUp?: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    /**
     * Indicates a pointer is down on a cell.
    */
    cellPointerDown?: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    /**
     * Indicates a pointer is up on a cell.
    */
    cellPointerUp?: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    /**
     * Called when a cell is clicked.
    */
    cellClicked?: (s: IgrDataGrid, e: IgrDataGridCellEventArgs) => void;
    /**
     * Called when sorting has changed.
    */
    sortDescriptionsChanged?: (s: IgrDataGrid, e: IgrGridSortDescriptionsChangedEventArgs) => void;
    /**
     * Called when grouping has changed.
    */
    groupDescriptionsChanged?: (s: IgrDataGrid, e: IgrGridGroupDescriptionsChangedEventArgs) => void;
    /**
     * Called when summaries have changed.
    */
    summaryDescriptionsChanged?: (s: IgrDataGrid, e: IgrGridSummaryDescriptionsChangedEventArgs) => void;
    /**
     * Called when a column is hidden or unhidden.
    */
    columnHiddenChanged?: (s: IgrDataGrid, e: IgrColumnHiddenChangedEventArgs) => void;
    /**
     * Called when a column is pinned or unpinned.
    */
    columnPinnedChanged?: (s: IgrDataGrid, e: IgrColumnPinnedChangedEventArgs) => void;
    /**
     * Called when a cell has been edited.
    */
    cellValueChanging?: (s: IgrDataGrid, e: IgrGridCellValueChangingEventArgs) => void;
    /**
     * Called when edits have been committed to the datasource.
    */
    dataCommitted?: (s: IgrDataGrid, e: IgrGridDataCommittedEventArgs) => void;
    /**
     * Called when edits are about to be committed to the datasource.
    */
    dataCommitting?: (s: IgrDataGrid, e: IgrGridDataCommittingEventArgs) => void;
    /**
     * Called when the grids size has changed.
    */
    sizeChanged?: (s: IgrDataGrid, e: IgrGridSizeChangedEventArgs) => void;
    actualColumnsChanged?: (s: IgrDataGrid, e: IgrGridColumnsChangedEventArgs) => void;
    /**
     * Called when the columns are autogenerated.
    */
    columnsAutoGenerated?: (s: IgrDataGrid, e: IgrGridColumnsAutoGeneratedEventArgs) => void;
    /**
     * Called when the selected items change.
    */
    selectedItemsChanged?: (s: IgrDataGrid, e: IgrGridSelectedItemsChangedEventArgs) => void;
    /**
     * Called when the selected keys change.
    */
    selectedKeysChanged?: (s: IgrDataGrid, e: IgrGridSelectedKeysChangedEventArgs) => void;
    /**
     * Called when the selected cells change.
    */
    selectedCellsChanged?: (s: IgrDataGrid, e: IgrGridSelectedCellsChangedEventArgs) => void;
    /**
     * Called when an individual selection operation has been made.
    */
    selectionChanged?: (s: IgrDataGrid, e: IgrGridSelectionChangedEventArgs) => void;
    /**
     * Called when the active cell changes.
    */
    activeCellChanged?: (s: IgrDataGrid, e: IgrGridActiveCellChangedEventArgs) => void;
    /**
     * Called when the selected cell ranges changed.
    */
    selectedCellRangesChanged?: (s: IgrDataGrid, e: IgrGridSelectedCellRangesChangedEventArgs) => void;
    /**
     * Called when a column's Width property has changed.
    */
    columnWidthChanged?: (s: IgrDataGrid, e: IgrGridColumnWidthChangedEventArgs) => void;
    /**
     * Called when a cell has started editing.
    */
    cellEditStarted?: (s: IgrDataGrid, e: IgrGridCellEditStartedEventArgs) => void;
    /**
     * Called when a cell has finished editing.
    */
    cellEditEnded?: (s: IgrDataGrid, e: IgrGridCellEditEndedEventArgs) => void;
    /**
     * Called when a row has started editing.
    */
    rowEditStarted?: (s: IgrDataGrid, e: IgrGridRowEditStartedEventArgs) => void;
    /**
     * Called when a row has finished editing.
    */
    rowEditEnded?: (s: IgrDataGrid, e: IgrGridRowEditEndedEventArgs) => void;
    customFilterRequested?: (s: IgrDataGrid, e: IgrGridCustomFilterRequestedEventArgs) => void;
}
