import { DateTimeFormats } from "./DateTimeFormats";
import { IgrCellInfo } from "./igr-cell-info";
import { DateTimeCellModel as DateTimeCellModel_internal } from "./DateTimeCellModel";
/**
 * Backing information about a date time cell for the grid.
*/
export declare class IgrDateTimeCellInfo extends IgrCellInfo {
    protected createImplementation(): DateTimeCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): DateTimeCellModel_internal;
    constructor();
    /**
     * Sets or gets the DateTime value for the cell.
    */
    get dateTimeValue(): Date;
    set dateTimeValue(v: Date);
    /**
     * The format string to apply to the value
    */
    get formatStringOverride(): string;
    set formatStringOverride(v: string);
    get formatSpecifiers(): any[];
    set formatSpecifiers(v: any[]);
    /**
     * The format options to apply to the value
    */
    get formatOverride(): any;
    set formatOverride(v: any);
    /**
     * Sets or gets the simple DateTimeFormat to use for the cell.
    */
    get dateTimeFormat(): DateTimeFormats;
    set dateTimeFormat(v: DateTimeFormats);
    /**
     * Sets or gets whether the value to use is a DateTimeOffset value.
    */
    get isOffsetValue(): boolean;
    set isOffsetValue(v: boolean);
    findByName(name: string): any;
}
