import { PivotDimensionType } from "./PivotDimensionType";
import { DimensionsChangeDetail as DimensionsChangeDetail_internal } from "./DimensionsChangeDetail";
import { ContentChildrenManager } from "igniteui-react-core";
import { IgrPivotDimension } from "./igr-pivot-dimension";
/**
 * Event emitted when dimension collection for rows, columns of filters is changed.
*/
export declare class IgrDimensionsChangeDetail {
    protected createImplementation(): DimensionsChangeDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): DimensionsChangeDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The new list of dimensions.
    */
    get dimensions(): IgrPivotDimension[];
    set dimensions(v: IgrPivotDimension[]);
    /**
     * The dimension list type - Row, Column or Filter.
    */
    get dimensionCollectionType(): PivotDimensionType;
    set dimensionCollectionType(v: PivotDimensionType);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
