import * as React from 'react';
import { DisplayDensity } from "./DisplayDensity";
import { IgrDensityChangedEventArgs } from "./igr-density-changed-event-args";
import { DisplayDensityBase } from "./DisplayDensityBase";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * @hidden
 * Base class containing all logic required for implementing DisplayDensity.
*/
export declare class IgrDisplayDensityBase<P extends IIgrDisplayDensityBaseProps = IIgrDisplayDensityBaseProps> extends React.Component<P, {}> {
    protected createImplementation(): DisplayDensityBase;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): DisplayDensityBase; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrDisplayDensityBase;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: P["id"];
        class: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Returns the theme of the component.
     * The default theme is `comfortable`.
     * Available options are `comfortable`, `cosy`, `compact`.
     * ```typescript
     * let componentTheme = this.component.displayDensity;
     * ```
    */
    get displayDensity(): DisplayDensity;
    set displayDensity(v: DisplayDensity);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
    private _densityChanged;
    private _densityChanged_wrapped;
    get densityChanged(): (s: IgrDisplayDensityBase, e: IgrDensityChangedEventArgs) => void;
    set densityChanged(ev: (s: IgrDisplayDensityBase, e: IgrDensityChangedEventArgs) => void);
}
export interface IIgrDisplayDensityBaseProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Returns the theme of the component.
     * The default theme is `comfortable`.
     * Available options are `comfortable`, `cosy`, `compact`.
     * ```typescript
     * let componentTheme = this.component.displayDensity;
     * ```
    */
    displayDensity?: DisplayDensity | string;
    densityChanged?: (s: IgrDisplayDensityBase, e: IgrDensityChangedEventArgs) => void;
}
