import { IgrCellInfo } from "./igr-cell-info";
import { DataSourceSchemaPropertyType } from "igniteui-react-core";
import { EditorType } from "./EditorType";
import { EditorCellModel as EditorCellModel_internal } from "./EditorCellModel";
/**
 * Represents info about the current cell.
*/
export declare class IgrEditorCellInfo extends IgrCellInfo {
    protected createImplementation(): EditorCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): EditorCellModel_internal;
    constructor();
    /**
     * Gets whether the editor cell is hidden or not.
    */
    get isHidden(): boolean;
    /**
     * Gets or sets the edit target for this cell.
    */
    get editTarget(): IgrCellInfo;
    set editTarget(v: IgrCellInfo);
    /**
     * Gets or sets the data type associated with the cell being edited.
    */
    get dataType(): DataSourceSchemaPropertyType;
    set dataType(v: DataSourceSchemaPropertyType);
    /**
     * Gets or sets the error message to display in the editor cell.
    */
    get errorMessage(): string;
    set errorMessage(v: string);
    /**
     * Gets or sets the user selected value.
    */
    get editValue(): any;
    set editValue(v: any);
    /**
     * Gets or sets the type of editor to use while cell editing.
    */
    get editorType(): EditorType;
    set editorType(v: EditorType);
    /**
     * Gets or sets the data source to use for the editor where it makes sense.
    */
    get editorDataSource(): any;
    set editorDataSource(v: any);
    /**
     * Gets or sets the editors display member.
    */
    get editorTextField(): string;
    set editorTextField(v: string);
    /**
     * Gets or sets the editors value member.
    */
    get editorValueField(): string[];
    set editorValueField(v: string[]);
    get dateFormatString(): string;
    set dateFormatString(v: string);
    get showTodayButton(): boolean;
    set showTodayButton(v: boolean);
    /**
     * Gets the row index that the editor cell is targeting for edit.
    */
    get targetRow(): number;
    /**
     * Gets the column index that the editor cell is targeting for edit.
    */
    get targetColumn(): number;
    findByName(name: string): any;
}
