import { DataSourceSchemaPropertyType } from "igniteui-react-core";
import { IgrGridFilterOperandsCollection } from "./igr-grid-filter-operands-collection";
import { IgrCellInfo } from "./igr-cell-info";
import { FilterCellModel as FilterCellModel_internal } from "./FilterCellModel";
import { ColumnFilterCondition } from "./ColumnFilterCondition";
import { IFilterExpression } from "igniteui-react-core";
import { ColumnComparisonConditionOperatorType } from "./ColumnComparisonConditionOperatorType";
/**
 * Represents info about the current cell.
*/
export declare class IgrFilterCellInfo extends IgrCellInfo {
    protected createImplementation(): FilterCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): FilterCellModel_internal;
    constructor();
    /**
     * Gets or sets whether the cell is hit test visible.
    */
    get dataType(): DataSourceSchemaPropertyType;
    set dataType(v: DataSourceSchemaPropertyType);
    /**
     * Gets or sets the current filter to display in the cell.
    */
    get filter(): ColumnFilterCondition;
    set filter(v: ColumnFilterCondition);
    /**
     * Gets or sets the current filter expression applied to the column.
    */
    get filterExpression(): IFilterExpression;
    set filterExpression(v: IFilterExpression);
    private _filterOperands;
    get filterOperands(): IgrGridFilterOperandsCollection;
    set filterOperands(v: IgrGridFilterOperandsCollection);
    get operatorType(): ColumnComparisonConditionOperatorType;
    set operatorType(v: ColumnComparisonConditionOperatorType);
    get filterValue(): any;
    set filterValue(v: any);
    get selectorTop(): number;
    set selectorTop(v: number);
    get selectorLeft(): number;
    set selectorLeft(v: number);
    get editorTop(): number;
    set editorTop(v: number);
    get editorLeft(): number;
    set editorLeft(v: number);
    get clearIconTop(): number;
    set clearIconTop(v: number);
    get clearIconLeft(): number;
    set clearIconLeft(v: number);
    findByName(name: string): any;
}
