import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { FilterRowDefinition } from "./FilterRowDefinition";
/**
 * Represents a base class used to configure the appearance of the column header cells.
*/
export declare class IgrFilterRowDefinition extends IgrDefinitionBase<IIgrFilterRowDefinitionProps> {
    protected createImplementation(): FilterRowDefinition;
    /**
                                 * @hidden
                                 */
    get i(): FilterRowDefinition;
    constructor(props: IIgrFilterRowDefinitionProps);
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    get paddingLeft(): number;
    set paddingLeft(v: number);
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    get paddingTop(): number;
    set paddingTop(v: number);
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    get paddingRight(): number;
    set paddingRight(v: number);
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    get paddingBottom(): number;
    set paddingBottom(v: number);
}
export interface IIgrFilterRowDefinitionProps extends IIgrDefinitionBaseProps {
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    paddingLeft?: number | string;
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    paddingTop?: number | string;
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    paddingRight?: number | string;
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    paddingBottom?: number | string;
}
