import { IgrFilteringOperation } from "./igr-filtering-operation";
import { FilteringOperand as FilteringOperand_internal } from "./FilteringOperand";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Provides base filtering operations
 * Implementations should be Singleton
 * @export
*/
export declare class IgrFilteringOperand {
    protected createImplementation(): FilteringOperand_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): FilteringOperand_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get operations(): IgrFilteringOperation[];
    set operations(v: IgrFilteringOperation[]);
    findByName(name: string): any;
    setNativeElement(element: any): void;
    instance(): IgrFilteringOperand;
    /**
     * Returns an array of names of the conditions which are visible in the UI
    
    */
    conditionList(): string[];
    /**
     * Returns an instance of the condition with the specified name.
     * name The name of the condition.
    
    * @param name  * The name of the condition.
    */
    condition(name: string): IgrFilteringOperation;
    /**
     * Adds a new condition to the filtering operations.
     * operation The filtering operation.
    
    * @param operation  * The filtering operation.
    */
    append(operation: IgrFilteringOperation): void;
}
