import * as React from 'react';
import { GridActionButton } from "./GridActionButton";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrGridActionButton<P extends IIgrGridActionButtonProps = IIgrGridActionButtonProps> extends React.Component<P, {}> {
    protected createImplementation(): GridActionButton;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridActionButton; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrGridActionButton;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DetailedReactHTMLElement<{
        ref: (ref: any) => void;
        className: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Whether button action is rendered in menu and should container text label.
    */
    get asMenuItem(): boolean;
    set asMenuItem(v: boolean);
    /**
     * Name of the icon to display in the button.
    */
    get iconName(): string;
    set iconName(v: string);
    /**
     * Additional Menu item container element classes.
    */
    get classNames(): string;
    set classNames(v: string);
    /**
     * The name of the icon set. Used in case the icon is from a different icon set.
    */
    get iconSet(): string;
    set iconSet(v: string);
    /**
     * The text of the label.
    */
    get labelText(): string;
    set labelText(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrGridActionButtonProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Whether button action is rendered in menu and should container text label.
    */
    asMenuItem?: boolean | string;
    /**
     * Name of the icon to display in the button.
    */
    iconName?: string;
    /**
     * Additional Menu item container element classes.
    */
    classNames?: string;
    /**
     * The name of the icon set. Used in case the icon is from a different icon set.
    */
    iconSet?: string;
    /**
     * The text of the label.
    */
    labelText?: string;
}
