import { IgrCellInfo } from './igr-cell-info';
import { IgrDataGridColumn } from './igr-data-grid-column';
import { GridCellValueChangingEventArgs as GridCellValueChangingEventArgs_internal } from "./GridCellValueChangingEventArgs";
/**
 * Event arguments for the CellValueChanging event
*/
export declare class IgrGridCellValueChangingEventArgs {
    protected createImplementation(): GridCellValueChangingEventArgs_internal;
    protected _implementation: any;
    get i(): GridCellValueChangingEventArgs_internal;
    private onImplementationCreated;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The backing information for the current cell.
    */
    get cellInfo(): IgrCellInfo;
    /**
 * Gets the edit ID for this value change.
*/
    get editID(): number;
    set editID(v: number);
    /**
     * Gets the column the cell belongs to.
    */
    get column(): IgrDataGridColumn;
    set column(v: IgrDataGridColumn);
    /**
     * Gets the row item associated with the change.
    */
    get item(): any;
    set item(v: any);
    /**
     * Gets the old cell value.
    */
    get oldValue(): any;
    set oldValue(v: any);
    /**
     * Gets the new cell value.
    */
    get newValue(): any;
    set newValue(v: any);
}
