import { GridColumnFilterOptions } from './GridColumnFilterOptions';
import { IgrGridColumnOptionsSectionBase } from "./igr-grid-column-options-section-base";
import { IIgrGridColumnOptionsSectionBaseProps } from "./igr-grid-column-options-section-base";
import { ControlDisplayDensity } from "igniteui-react-core";
export declare class IgrGridColumnFilterOptions extends IgrGridColumnOptionsSectionBase<IIgrGridColumnOptionsSectionBaseProps> {
    private _mainDiv;
    private _initialized;
    private _elRef;
    private _clearFiltersSectionRef;
    private _filterSectionRef;
    private _filterCheckboxListSectionRef;
    private _filterButtonsSectionRef;
    private _reactRenderer;
    private _getMainRef;
    private _getClearFiltersSectionRef;
    private _getFilterSectionRef;
    private _getFilterCheckboxListSectionRef;
    private _getFilterButtonsSectionRef;
    private verifyReferences;
    render(): JSX.Element;
    constructor(props: IIgrGridColumnFilterOptionsProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): GridColumnFilterOptions;
    get i(): GridColumnFilterOptions;
    get clearColumnFiltersCaption(): string;
    set clearColumnFiltersCaption(v: string);
    get filterListPlaceholderText(): string;
    set filterListPlaceholderText(v: string);
    /**
     * Gets or sets the display Density to use for the buttons in the component.
    */
    get filterListDensity(): ControlDisplayDensity;
    set filterListDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual display filterListDensity to use for the component.
    */
    get actualFilterListDensity(): ControlDisplayDensity;
    set actualFilterListDensity(v: ControlDisplayDensity);
    get textFilterCaption(): string;
    set textFilterCaption(v: string);
    onApply(): void;
}
export interface IIgrGridColumnFilterOptionsProps extends IIgrGridColumnOptionsSectionBaseProps {
    clearColumnFiltersCaption?: string;
    filterListPlaceholderText?: string;
    /**
     * Gets or sets the display Density to use for the buttons in the component.
    */
    filterListDensity?: ControlDisplayDensity | string;
    /**
     * Gets the actual display filterListDensity to use for the component.
    */
    actualFilterListDensity?: ControlDisplayDensity | string;
    textFilterCaption?: string;
}
