import * as React from 'react';
import { BaseControlTheme } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { IgrDataGridColumn } from "./igr-data-grid-column";
import { GridColumnOptionsBase } from "./GridColumnOptionsBase";
import { ContentChildrenManager } from "igniteui-react-core";
export declare abstract class IgrGridColumnOptionsBase<P extends IIgrGridColumnOptionsBaseProps = IIgrGridColumnOptionsBaseProps> extends React.Component<P, {}> {
    protected createImplementation(): GridColumnOptionsBase;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridColumnOptionsBase; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrGridColumnOptionsBase;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    /**
     * Gets or sets the autoSize for which this AutoSizeOptions will apply.
    */
    get autoSize(): boolean;
    set autoSize(v: boolean);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    /**
     * Gets or sets the base built in theme to use for the component.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets the actual display baseTheme to use for the component.
    */
    get actualBaseTheme(): BaseControlTheme;
    set actualBaseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the display Density to use for the buttons in the component.
    */
    get buttonDensity(): ControlDisplayDensity;
    set buttonDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual display buttonDensity to use for the component.
    */
    get actualButtonDensity(): ControlDisplayDensity;
    set actualButtonDensity(v: ControlDisplayDensity);
    /**
     * Gets or sets the font to use for buttons.
    */
    get buttonTextStyle(): string;
    set buttonTextStyle(v: string);
    /**
     * Gets or sets the column for which this ColumnOptions will apply.
    */
    get column(): IgrDataGridColumn;
    set column(v: IgrDataGridColumn);
    /**
     * Gets or sets the display density to use for the component.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets the actual display density to use for the component.
    */
    get actualDensity(): ControlDisplayDensity;
    set actualDensity(v: ControlDisplayDensity);
    /**
     * Gets or sets the font to use for labels.
    */
    get labelTextStyle(): string;
    set labelTextStyle(v: string);
    /**
     * Gets or sets the color to use for the text of the component.
    */
    get textColor(): string;
    set textColor(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
}
export interface IIgrGridColumnOptionsBaseProps {
    children?: React.ReactNode;
    /**
     * Gets or sets the autoSize for which this AutoSizeOptions will apply.
    */
    autoSize?: boolean | string;
    /**
     * Gets or sets the color to use for the background of the component.
    */
    backgroundColor?: string;
    /**
     * Gets or sets the base built in theme to use for the component.
    */
    baseTheme?: BaseControlTheme | string;
    /**
     * Gets the actual display baseTheme to use for the component.
    */
    actualBaseTheme?: BaseControlTheme | string;
    /**
     * Gets or sets the display Density to use for the buttons in the component.
    */
    buttonDensity?: ControlDisplayDensity | string;
    /**
     * Gets the actual display buttonDensity to use for the component.
    */
    actualButtonDensity?: ControlDisplayDensity | string;
    /**
     * Gets or sets the font to use for buttons.
    */
    buttonTextStyle?: string;
    /**
     * Gets or sets the column for which this ColumnOptions will apply.
    */
    column?: IgrDataGridColumn;
    /**
     * Gets or sets the display density to use for the component.
    */
    density?: ControlDisplayDensity | string;
    /**
     * Gets the actual display density to use for the component.
    */
    actualDensity?: ControlDisplayDensity | string;
    /**
     * Gets or sets the font to use for labels.
    */
    labelTextStyle?: string;
    /**
     * Gets or sets the color to use for the text of the component.
    */
    textColor?: string;
}
