import { GridColumnOptions } from './GridColumnOptions';
import { IgrGridColumnOptionsBase } from "./igr-grid-column-options-base";
import { IIgrGridColumnOptionsBaseProps } from "./igr-grid-column-options-base";
import { IgrApplyButtonClickEventArgs } from './igr-apply-button-click-event-args';
import { IgrCancelButtonClickEventArgs } from './igr-cancel-button-click-event-args';
import { ControlDisplayDensity } from "igniteui-react-core";
export declare class IgrGridColumnOptions extends IgrGridColumnOptionsBase<IIgrGridColumnOptionsProps> {
    private _reactRenderer;
    private _height;
    private _width;
    private _initialized;
    private _elRef;
    private _headerSectionRef;
    private _sortSectionRef;
    private _moveSectionRef;
    private _pinSectionRef;
    private _filterSectionRef;
    private _summarySectionRef;
    private _buttonSectionRef;
    private _headerColumnNameSectionRef;
    private _headerButtonsSectionRef;
    private _hideSectionRef;
    private _groupSectionRef;
    private _sortOptionsRef;
    private _moveOptionsRef;
    private _pinOptionsRef;
    private _hideOptionsRef;
    private _groupOptionsRef;
    private _filterOptionsRef;
    private _summaryOptionsRef;
    private _buttonOptionsRef;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    private _getMainRef;
    private _getHeaderSectionRef;
    private _getSortSectionRef;
    private _getMoveSectionRef;
    private _getPinSectionRef;
    private _getFilterSectionRef;
    private _getSummarySectionRef;
    private _getButtonSectionRef;
    private _getHeaderColumnNameSectionRef;
    private _getHeaderButtonsSectionRef;
    private _getHideSectionRef;
    private _getGroupSectionRef;
    private _getSortOptionsRef;
    private _getMoveOptionsRef;
    private _getPinOptionsRef;
    private _getHideOptionsRef;
    private _getGroupOptionsRef;
    private _getFilterOptionsRef;
    private _getSummaryOptionsRef;
    private _getButtonOptionsRef;
    render(): JSX.Element;
    private verifyReferences;
    constructor(props: IIgrGridColumnOptionsProps);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): GridColumnOptions;
    get i(): GridColumnOptions;
    get headerOptionsVisibleResolved(): boolean;
    get sortOptionsVisibleResolved(): boolean;
    get moveOptionsVisibleResolved(): boolean;
    get pinOptionsVisibleResolved(): boolean;
    get hideOptionsVisibleResolved(): boolean;
    get groupOptionsVisibleResolved(): boolean;
    get filterOptionsVisibleResolved(): boolean;
    get summaryOptionsVisibleResolved(): boolean;
    /**
     * Gets or sets the font to use for columnNames.
    */
    get columnNameTextStyle(): string;
    set columnNameTextStyle(v: string);
    /**
     * Gets or sets the amount of left padding to use for the left edge of the component.
    */
    get paddingLeft(): number;
    set paddingLeft(v: number);
    /**
     * Gets or sets the amount of left padding to use for the top edge of the component.
    */
    get paddingTop(): number;
    set paddingTop(v: number);
    /**
     * Gets or sets the amount of left padding to use for the right edge of the component.
    */
    get paddingRight(): number;
    set paddingRight(v: number);
    /**
     * Gets or sets the amount of left padding to use for the bottom edge of the component.
    */
    get paddingBottom(): number;
    set paddingBottom(v: number);
    get headerVisible(): boolean;
    set headerVisible(v: boolean);
    get sortOptionsVisible(): boolean;
    set sortOptionsVisible(v: boolean);
    get moveOptionsVisible(): boolean;
    set moveOptionsVisible(v: boolean);
    get pinOptionsVisible(): boolean;
    set pinOptionsVisible(v: boolean);
    get hideOptionsVisible(): boolean;
    set hideOptionsVisible(v: boolean);
    get groupOptionsVisible(): boolean;
    set groupOptionsVisible(v: boolean);
    get filterOptionsVisible(): boolean;
    set filterOptionsVisible(v: boolean);
    get summaryOptionsVisible(): boolean;
    set summaryOptionsVisible(v: boolean);
    get sortHeaderCaption(): string;
    set sortHeaderCaption(v: string);
    get sortAscendingCaption(): string;
    set sortAscendingCaption(v: string);
    get sortDescendingCaption(): string;
    set sortDescendingCaption(v: string);
    get moveHeaderCaption(): string;
    set moveHeaderCaption(v: string);
    get moveLeftCaption(): string;
    set moveLeftCaption(v: string);
    get moveRightCaption(): string;
    set moveRightCaption(v: string);
    get pinHeaderCaption(): string;
    set pinHeaderCaption(v: string);
    get pinLeftCaption(): string;
    set pinLeftCaption(v: string);
    get pinRightCaption(): string;
    set pinRightCaption(v: string);
    get applyFiltersButtonCaption(): string;
    set applyFiltersButtonCaption(v: string);
    get cancelFiltersButtonCaption(): string;
    set cancelFiltersButtonCaption(v: string);
    get clearColumnFiltersCaption(): string;
    set clearColumnFiltersCaption(v: string);
    /**
     * Gets or sets the display density to use for the summary list menu.
    */
    get summaryListDensity(): ControlDisplayDensity;
    set summaryListDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual display density used for the summary list menu.
    */
    get actualSummaryListDensity(): ControlDisplayDensity;
    set actualSummaryListDensity(v: ControlDisplayDensity);
    /**
     * Gets or sets the display Density to use for the buttons in the component.
    */
    get filterListDensity(): ControlDisplayDensity;
    set filterListDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual display filterListDensity to use for the component.
    */
    get actualFilterListDensity(): ControlDisplayDensity;
    set actualFilterListDensity(v: ControlDisplayDensity);
    get filterListPlaceholderText(): string;
    set filterListPlaceholderText(v: string);
    /**
     * Gets or sets the text color for the summary options menu.
    */
    get summaryListTextColor(): string;
    set summaryListTextColor(v: string);
    /**
     * Gets or sets the background color for the summary options menu.
    */
    get summaryListBackground(): string;
    set summaryListBackground(v: string);
    private _applyButtonClick;
    private _applyButtonClick_wrapped;
    get applyButtonClick(): (s: IgrGridColumnOptions, e: IgrApplyButtonClickEventArgs) => void;
    set applyButtonClick(ev: (s: IgrGridColumnOptions, e: IgrApplyButtonClickEventArgs) => void);
    private _cancelButtonClick;
    private _cancelButtonClick_wrapped;
    get cancelButtonClick(): (s: IgrGridColumnOptions, e: IgrCancelButtonClickEventArgs) => void;
    set cancelButtonClick(ev: (s: IgrGridColumnOptions, e: IgrCancelButtonClickEventArgs) => void);
}
export interface IIgrGridColumnOptionsProps extends IIgrGridColumnOptionsBaseProps {
    width?: string;
    height?: string;
    /**
 * Gets or sets the font to use for columnNames.
*/
    columnNameTextStyle?: string;
    /**
     * Gets or sets the amount of left padding to use for the left edge of the component.
    */
    paddingLeft?: number | string;
    /**
     * Gets or sets the amount of left padding to use for the top edge of the component.
    */
    paddingTop?: number | string;
    /**
     * Gets or sets the amount of left padding to use for the right edge of the component.
    */
    paddingRight?: number | string;
    /**
     * Gets or sets the amount of left padding to use for the bottom edge of the component.
    */
    paddingBottom?: number | string;
    headerVisible?: boolean | string;
    sortOptionsVisible?: boolean | string;
    moveOptionsVisible?: boolean | string;
    pinOptionsVisible?: boolean | string;
    hideOptionsVisible?: boolean | string;
    groupOptionsVisible?: boolean | string;
    filterOptionsVisible?: boolean | string;
    summaryOptionsVisible?: boolean | string;
    sortHeaderCaption?: string;
    sortAscendingCaption?: string;
    sortDescendingCaption?: string;
    moveHeaderCaption?: string;
    moveLeftCaption?: string;
    moveRightCaption?: string;
    pinHeaderCaption?: string;
    pinLeftCaption?: string;
    pinRightCaption?: string;
    applyFiltersButtonCaption?: string;
    cancelFiltersButtonCaption?: string;
    clearColumnFiltersCaption?: string;
    /**
     * Gets or sets the display density to use for the summary list menu.
    */
    summaryListDensity?: ControlDisplayDensity | string;
    /**
     * Gets the actual display density used for the summary list menu.
    */
    actualSummaryListDensity?: ControlDisplayDensity | string;
    /**
     * Gets or sets the display Density to use for the buttons in the component.
    */
    filterListDensity?: ControlDisplayDensity | string;
    /**
     * Gets the actual display filterListDensity to use for the component.
    */
    actualFilterListDensity?: ControlDisplayDensity | string;
    filterListPlaceholderText?: string;
    /**
     * Gets or sets the text color for the summary options menu.
    */
    summaryListTextColor?: string;
    /**
     * Gets or sets the background color for the summary options menu.
    */
    summaryListBackground?: string;
    applyButtonClick?: (s: IgrGridColumnOptions, e: IgrApplyButtonClickEventArgs) => void;
    cancelButtonClick?: (s: IgrGridColumnOptions, e: IgrCancelButtonClickEventArgs) => void;
}
