import * as React from 'react';
import { GridColumnSummaryOptions } from './GridColumnSummaryOptions';
import { IgrGridColumnOptionsSectionBase } from "./igr-grid-column-options-section-base";
import { IIgrGridColumnOptionsSectionBaseProps } from "./igr-grid-column-options-section-base";
import { ControlDisplayDensity } from "igniteui-react-core";
export declare class IgrGridColumnSummaryOptions extends IgrGridColumnOptionsSectionBase<IIgrGridColumnOptionsSectionBaseProps> {
    private _mainDiv;
    private _initialized;
    private _elRef;
    private _reactRenderer;
    private _portalManager;
    private _getMainRef;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        ref: (ref: any) => void;
        children: any[];
    }, any>;
    constructor(props: IIgrGridColumnSummaryOptionsProps);
    private requestRender;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    protected initializeProperties(): void;
    updateStyle(): void;
    destroy(): void;
    componentWillUnmount(): void;
    componentDidMount(): void;
    initializeContent(): void;
    protected createImplementation(): GridColumnSummaryOptions;
    get i(): GridColumnSummaryOptions;
    /**
 * Gets or sets the text inside the summary button.
*/
    get summaryCaption(): string;
    set summaryCaption(v: string);
    /**
     * Gets or sets the display density used for the summary list.
    */
    get summaryListDensity(): ControlDisplayDensity;
    set summaryListDensity(v: ControlDisplayDensity);
    /**
     * Gets the actual display density used for the summary list.
    */
    get actualSummaryListDensity(): ControlDisplayDensity;
    set actualSummaryListDensity(v: ControlDisplayDensity);
    get activeCount(): number;
    set activeCount(v: number);
    get summaryListTextColor(): string;
    set summaryListTextColor(v: string);
    get summaryListBackground(): string;
    set summaryListBackground(v: string);
    onApply(): void;
    onCancel(): void;
    closeMenu(): void;
}
export interface IIgrGridColumnSummaryOptionsProps extends IIgrGridColumnOptionsSectionBaseProps {
    /**
 * Gets or sets the text inside the summary button.
*/
    summaryCaption?: string;
    /**
     * Gets or sets the display density used for the summary list.
    */
    summaryListDensity?: ControlDisplayDensity | string;
    /**
     * Gets the actual display density used for the summary list.
    */
    actualSummaryListDensity?: ControlDisplayDensity | string;
    activeCount?: number | string;
    summaryListTextColor?: string;
    summaryListBackground?: string;
}
