import * as React from 'react';
import { IgrGridActionsBaseDirective, IIgrGridActionsBaseDirectiveProps } from "./igr-grid-actions-base-directive";
import { GridEditingActions } from "./GridEditingActions";
/**
 * Grid Editing Actions for the Action Strip
 * @igxParent IgxActionStripComponent
*/
export declare class IgrGridEditingActions<P extends IIgrGridEditingActionsProps = IIgrGridEditingActionsProps> extends IgrGridActionsBaseDirective<P> {
    protected createImplementation(): GridEditingActions;
    /**
                                 * @hidden
                                 */
    get i(): GridEditingActions;
    constructor(props: P);
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * An input to enable/disable action strip row adding button
    */
    get addRow(): boolean;
    set addRow(v: boolean);
    /**
     * An input to enable/disable action strip row editing button
    */
    get editRow(): boolean;
    set editRow(v: boolean);
    /**
     * An input to enable/disable action strip row deleting button
    */
    get deleteRow(): boolean;
    set deleteRow(v: boolean);
    /**
     * An input to enable/disable action strip child row adding button
    */
    get addChild(): boolean;
    set addChild(v: boolean);
    /**
     * Enter row or cell edit mode depending the grid rowEditable option
     * @example
     * ```typescript
     * this.gridEditingActions.startEdit();
     * ```
    
    */
    startEdit(evt: any): void;
}
export interface IIgrGridEditingActionsProps extends IIgrGridActionsBaseDirectiveProps {
    /**
     * An input to enable/disable action strip row adding button
    */
    addRow?: boolean | string;
    /**
     * An input to enable/disable action strip row editing button
    */
    editRow?: boolean | string;
    /**
     * An input to enable/disable action strip row deleting button
    */
    deleteRow?: boolean | string;
    /**
     * An input to enable/disable action strip child row adding button
    */
    addChild?: boolean | string;
}
