import * as React from 'react';
import { IgrGridActionsBaseDirective, IIgrGridActionsBaseDirectiveProps } from "./igr-grid-actions-base-directive";
import { GridPinningActions } from "./GridPinningActions";
/**
 * Grid Pinning Actions for the Action Strip
 * @igxParent IgxActionStripComponent
*/
export declare class IgrGridPinningActions<P extends IIgrGridPinningActionsProps = IIgrGridPinningActionsProps> extends IgrGridActionsBaseDirective<P> {
    protected createImplementation(): GridPinningActions;
    /**
                                 * @hidden
                                 */
    get i(): GridPinningActions;
    constructor(props: P);
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Pin the row according to the context.
     * @example
     * ```typescript
     * this.gridPinningActions.pin();
     * ```
    
    */
    pin(evt: any): void;
    /**
     * Unpin the row according to the context.
     * @example
     * ```typescript
     * this.gridPinningActions.unpin();
     * ```
    
    */
    unpin(evt: any): void;
    scrollToRow(evt: any): void;
}
export interface IIgrGridPinningActionsProps extends IIgrGridActionsBaseDirectiveProps {
}
