import * as React from 'react';
import { IgrGridStateOptions } from "./igr-grid-state-options";
import { GridStateBaseDirective } from "./GridStateBaseDirective";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrGridStateBaseDirective<P extends IIgrGridStateBaseDirectiveProps = IIgrGridStateBaseDirectiveProps> extends React.Component<P, {}> {
    protected createImplementation(): GridStateBaseDirective;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): GridStateBaseDirective; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrGridStateBaseDirective;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: P["id"];
        class: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    get options(): IgrGridStateOptions;
    set options(v: IgrGridStateOptions);
    get name(): string;
    set name(v: string);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrGridStateBaseDirectiveProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    options?: IgrGridStateOptions;
    name?: string;
}
