import * as React from 'react';
import { IgrGridToolbarBaseActionCollection } from "./igr-grid-toolbar-base-action-collection";
import { IgrGridToolbarContent, IIgrGridToolbarContentProps } from "./igr-grid-toolbar-content";
import { GridToolbarActions } from "./GridToolbarActions";
import { IgrGridToolbarBaseAction } from "./igr-grid-toolbar-base-action";
/**
 * Provides a way to template the action portion of the toolbar in the grid.
 * @igxModule IgxGridToolbarModule
 * @igxParent IgxGridToolbarComponent
 * @example
 * ```html
 * ```
*/
export declare class IgrGridToolbarActions extends IgrGridToolbarContent<IIgrGridToolbarActionsProps> {
    protected createImplementation(): GridToolbarActions;
    /**
                                 * @hidden
                                 */
    get i(): GridToolbarActions;
    protected _initializeAdapters(): void;
    protected _updateAdapters(): void;
    constructor(props: IIgrGridToolbarActionsProps);
    componentDidMount(): void;
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    private _actions;
    private _actualActions;
    get actualActions(): IgrGridToolbarBaseAction[];
    private _contentActions;
    get contentActions(): IgrGridToolbarBaseAction[];
    private _actionsAdapter;
    get actions(): IgrGridToolbarBaseActionCollection;
    get name(): string;
    set name(v: string);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
export interface IIgrGridToolbarActionsProps extends IIgrGridToolbarContentProps {
    name?: string;
}
