import * as React from 'react';
import { IgrOverlaySettings } from "./igr-overlay-settings";
import { IgrGridToolbarBaseAction, IIgrGridToolbarBaseActionProps } from "./igr-grid-toolbar-base-action";
import { GridToolbarAdvancedFiltering } from "./GridToolbarAdvancedFiltering";
/**
 * Provides a pre-configured button to open the advanced filtering dialog of the grid.
 * @igxModule IgxGridToolbarModule
 * @igxParent IgxGridToolbarComponent
 * @example
 * ```html
 * Custom text
 * ```
*/
export declare class IgrGridToolbarAdvancedFiltering extends IgrGridToolbarBaseAction<IIgrGridToolbarAdvancedFilteringProps> {
    protected createImplementation(): GridToolbarAdvancedFiltering;
    /**
                                 * @hidden
                                 */
    get i(): GridToolbarAdvancedFiltering;
    protected onImplementationCreated(): void;
    constructor(props: IIgrGridToolbarAdvancedFilteringProps);
    componentDidMount(): void;
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    get overlaySettings(): IgrOverlaySettings;
    set overlaySettings(v: IgrOverlaySettings);
    get name(): string;
    set name(v: string);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
export interface IIgrGridToolbarAdvancedFilteringProps extends IIgrGridToolbarBaseActionProps {
    overlaySettings?: IgrOverlaySettings;
    name?: string;
}
