import * as React from 'react';
import { IgrGridToolbarContent, IIgrGridToolbarContentProps } from "./igr-grid-toolbar-content";
import { GridToolbarTitle } from "./GridToolbarTitle";
/**
 * Provides a way to template the title portion of the toolbar in the grid.
 * @igxModule IgxGridToolbarModule
 * @igxParent IgxGridToolbarComponent
 * @example
 * ```html
 * My custom title
 * ```
*/
export declare class IgrGridToolbarTitle extends IgrGridToolbarContent<IIgrGridToolbarTitleProps> {
    protected createImplementation(): GridToolbarTitle;
    /**
                                 * @hidden
                                 */
    get i(): GridToolbarTitle;
    protected onImplementationCreated(): void;
    constructor(props: IIgrGridToolbarTitleProps);
    componentDidMount(): void;
    render(): React.DetailedReactHTMLElement<any, HTMLElement>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    get name(): string;
    set name(v: string);
    setNativeElement(element: any): void;
}
export interface IIgrGridToolbarTitleProps extends IIgrGridToolbarContentProps {
    name?: string;
}
