import { ImageStretchOptions } from "./ImageStretchOptions";
import { ImageResourceType } from "./ImageResourceType";
import { IgrCellInfo } from "./igr-cell-info";
import { ImageCellModel as ImageCellModel_internal } from "./ImageCellModel";
/**
 * Backing information for an image cell in the grid.
*/
export declare class IgrImageCellInfo extends IgrCellInfo {
    protected createImplementation(): ImageCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): ImageCellModel_internal;
    constructor();
    /**
     * Sets or gets the resource path to use to get the image for the cell.
    */
    get imagePath(): string;
    set imagePath(v: string);
    /**
     * Sets or gets the image stretching behavior for the image.
    */
    get imageStretchOption(): ImageStretchOptions;
    set imageStretchOption(v: ImageStretchOptions);
    /**
     * Sets or gets the image resource type. Indicates which type of resource should be fetched and how ImagePath should be interpreted.
    */
    get imageResourceType(): ImageResourceType;
    set imageResourceType(v: ImageResourceType);
}
