import { IgrCellInfo } from "./igr-cell-info";
import { NumericCellModel as NumericCellModel_internal } from "./NumericCellModel";
/**
 * Backing information for a numeric cell in the grid.
*/
export declare class IgrNumericCellInfo extends IgrCellInfo {
    protected createImplementation(): NumericCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): NumericCellModel_internal;
    constructor();
    /**
     * Sets or gets the numeric value to use for the cell.
    */
    get numericValue(): number;
    set numericValue(v: number);
    /**
     * Sets or gets whether there is a decimal numeric value to use for the cell.
    */
    get hasDecimalValue(): boolean;
    set hasDecimalValue(v: boolean);
    /**
     * The format string to apply to the value
    */
    get formatStringOverride(): string;
    set formatStringOverride(v: string);
    get formatSpecifiers(): any[];
    set formatSpecifiers(v: any[]);
    /**
     * The format options to apply to the value
    */
    get formatOverride(): any;
    set formatOverride(v: any);
    /**
     * Sets or gets the text prepended to a negative numeric value
    */
    get negativePrefix(): string;
    set negativePrefix(v: string);
    /**
     * Sets or gets the text prepended to a positive numeric value
    */
    get positivePrefix(): string;
    set positivePrefix(v: string);
    /**
     * Sets or gets the text appended to a negative numeric value
    */
    get negativeSuffix(): string;
    set negativeSuffix(v: string);
    /**
     * Sets or gets the text appended to a positive numeric value
    */
    get positiveSuffix(): string;
    set positiveSuffix(v: string);
    /**
     * The maximum number of decimal places to display when formatting
    */
    get maxFractionDigits(): number;
    set maxFractionDigits(v: number);
    /**
     * The minimum number of decimal places to display when formatting
    */
    get minFractionDigits(): number;
    set minFractionDigits(v: number);
    /**
     * The minimum number of integer digits to display when formatting
    */
    get minIntegerDigits(): number;
    set minIntegerDigits(v: number);
    /**
     * Sets or gets if the grouping separator is shown
    */
    get showGroupingSeparator(): boolean;
    set showGroupingSeparator(v: boolean);
    findByName(name: string): any;
}
