import { IgrPositionStrategy } from "./igr-position-strategy";
import { IgrScrollStrategy } from "./igr-scroll-strategy";
export interface IgrOverlaySettings {
    /**
     * Attaching target for the component to show
    */
    target?: any;
    /**
     * Position strategy to use with these settings
    */
    positionStrategy?: IgrPositionStrategy;
    /**
     * Scroll strategy to use with these settings
    */
    scrollStrategy?: IgrScrollStrategy;
    /**
     * Set if the overlay should be in modal mode
    */
    modal?: boolean | string;
    /**
     * Set if the overlay should close on outside click
    */
    closeOnOutsideClick?: boolean | string;
    /**
     * Set if the overlay should close when `Esc` key is pressed
    */
    closeOnEscape?: boolean | string;
}
