import { IgrColumn } from "./igr-column";
import { PinColumnCancellableEventArgsDetail as PinColumnCancellableEventArgsDetail_internal } from "./PinColumnCancellableEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * The event arguments before a column's pin state is changed.
 * `insertAtIndex`specifies at which index in the pinned/unpinned area the column is inserted.
 * Can be changed in the `columnPin` event.
 * `isPinned` returns the actual pin state of the column. When pinning/unpinning is succesfull,
 * the value of `isPinned` will change accordingly when read in the "-ing" and "-ed" event.
*/
export declare class IgrPinColumnCancellableEventArgsDetail {
    protected createImplementation(): PinColumnCancellableEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PinColumnCancellableEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    get column(): IgrColumn;
    set column(v: IgrColumn);
    /**
     * If pinned, specifies at which index in the pinned area the column is inserted.
     * If unpinned, specifies at which index in the unpinned area the column is inserted.
    */
    get insertAtIndex(): number;
    set insertAtIndex(v: number);
    /**
     * Returns the actual pin state of the column.
     * If pinning/unpinning is succesfull, value of `isPinned` will change accordingly when read in the "-ing" and "-ed" event.
    */
    get isPinned(): boolean;
    set isPinned(v: boolean);
    /**
     * Provides the ability to cancel the event.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
