import { IgrColumn } from "./igr-column";
import { IgrBaseEventArgsDetail } from "./igr-base-event-args-detail";
import { PinColumnEventArgsDetail as PinColumnEventArgsDetail_internal } from "./PinColumnEventArgsDetail";
/**
 * The event arguments after a column's pin state is changed.
 * `insertAtIndex`specifies at which index in the pinned/unpinned area the column was inserted.
 * `isPinned` returns the actual pin state of the column after the operation completed.
*/
export declare class IgrPinColumnEventArgsDetail extends IgrBaseEventArgsDetail {
    protected createImplementation(): PinColumnEventArgsDetail_internal;
    /**
                                 * @hidden
                                 */
    get i(): PinColumnEventArgsDetail_internal;
    constructor();
    get column(): IgrColumn;
    set column(v: IgrColumn);
    /**
     * If pinned, specifies at which index in the pinned area the column is inserted.
     * If unpinned, specifies at which index in the unpinned area the column is inserted.
    */
    get insertAtIndex(): number;
    set insertAtIndex(v: number);
    /**
     * Returns the actual pin state of the column.
     * If pinning/unpinning is succesfull, value of `isPinned` will change accordingly when read in the "-ing" and "-ed" event.
    */
    get isPinned(): boolean;
    set isPinned(v: boolean);
    findByName(name: string): any;
}
