import { IgrRowType } from "./igr-row-type";
import { PinRowEventArgsDetail as PinRowEventArgsDetail_internal } from "./PinRowEventArgsDetail";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Event emitted when a row's pin state changes.
*/
export declare class IgrPinRowEventArgsDetail {
    protected createImplementation(): PinRowEventArgsDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PinRowEventArgsDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * The ID of the row, that was pinned/unpinned.
     * ID is either the primaryKey value or the data record instance.
    */
    get rowID(): any;
    set rowID(v: any);
    get row(): IgrRowType;
    set row(v: IgrRowType);
    /**
     * The index at which to pin the row in the pinned rows collection.
    */
    get insertAtIndex(): number;
    set insertAtIndex(v: number);
    /**
     * Whether or not the row is pinned or unpinned.
    */
    get isPinned(): boolean;
    set isPinned(v: boolean);
    /**
     * Provides reference to the owner component.
    */
    get owner(): any;
    set owner(v: any);
    /**
     * Provides the ability to cancel the event.
    */
    get cancel(): boolean;
    set cancel(v: boolean);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
