import { PivotAggregationType } from "./PivotAggregationType";
import { PivotAggregator as PivotAggregator_internal } from "./PivotAggregator";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Interface describing a IPivotAggregator class.
 * Used for specifying custom aggregator lists.
*/
export declare class IgrPivotAggregator {
    protected createImplementation(): PivotAggregator_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PivotAggregator_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Aggregation unique key.
    */
    get key(): string;
    set key(v: string);
    /**
     * Aggregation label to show in the UI.
    */
    get label(): string;
    set label(v: string);
    /**
     * Aggregation name that will be used from a list of predefined aggregations.
     * If not set will use the specified aggregator function.
    */
    get aggregatorName(): PivotAggregationType;
    set aggregatorName(v: PivotAggregationType);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
