import { IgrPivotDimensionStrategy } from "./igr-pivot-dimension-strategy";
import { IgrPivotDimensionCollection } from "./igr-pivot-dimension-collection";
import { IgrPivotValueCollection } from "./igr-pivot-value-collection";
import { IgrPivotKeys } from "./igr-pivot-keys";
import { PivotConfiguration as PivotConfiguration_internal } from "./PivotConfiguration";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Configuration of the pivot grid.
*/
export declare class IgrPivotConfiguration {
    protected createImplementation(): PivotConfiguration_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PivotConfiguration_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * A strategy to transform the rows.
    */
    get rowStrategy(): IgrPivotDimensionStrategy;
    set rowStrategy(v: IgrPivotDimensionStrategy);
    /**
     * A strategy to transform the columns.
    */
    get columnStrategy(): IgrPivotDimensionStrategy;
    set columnStrategy(v: IgrPivotDimensionStrategy);
    private _rows;
    /**
     * A list of the rows.
    */
    get rows(): IgrPivotDimensionCollection;
    set rows(v: IgrPivotDimensionCollection);
    private _columns;
    /**
     * A list of the columns.
    */
    get columns(): IgrPivotDimensionCollection;
    set columns(v: IgrPivotDimensionCollection);
    private _values;
    /**
     * A list of the values.
    */
    get values(): IgrPivotValueCollection;
    set values(v: IgrPivotValueCollection);
    private _filters;
    /**
     * Dimensions to be displayed in the filter area.
    */
    get filters(): IgrPivotDimensionCollection;
    set filters(v: IgrPivotDimensionCollection);
    /**
     * Pivot data keys used for data generation. Can be used for custom remote scenarios where the data is pre-populated.
    */
    get pivotKeys(): IgrPivotKeys;
    set pivotKeys(v: IgrPivotKeys);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
