import * as React from 'react';
import { IgrPivotGrid } from "./igr-pivot-grid";
import { PivotDataSelector } from "./PivotDataSelector";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrPivotDataSelector<P extends IIgrPivotDataSelectorProps = IIgrPivotDataSelectorProps> extends React.Component<P, {}> {
    protected createImplementation(): PivotDataSelector;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PivotDataSelector; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrPivotDataSelector;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: P["id"];
        class: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    get columnsExpanded(): boolean;
    set columnsExpanded(v: boolean);
    get rowsExpanded(): boolean;
    set rowsExpanded(v: boolean);
    get filtersExpanded(): boolean;
    set filtersExpanded(v: boolean);
    get valuesExpanded(): boolean;
    set valuesExpanded(v: boolean);
    /**
     * An @Input property that sets the grid.
    */
    get grid(): IgrPivotGrid;
    set grid(v: IgrPivotGrid);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrPivotDataSelectorProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    columnsExpanded?: boolean | string;
    rowsExpanded?: boolean | string;
    filtersExpanded?: boolean | string;
    valuesExpanded?: boolean | string;
    /**
     * An @Input property that sets the grid.
    */
    grid?: IgrPivotGrid;
}
