import { GridColumnDataType } from "./GridColumnDataType";
import { IgrGridResourceStrings } from "./igr-grid-resource-strings";
import { IgrPivotDimension } from "./igr-pivot-dimension";
import { IgrPivotDateDimensionOptions } from "./igr-pivot-date-dimension-options";
import { PivotDateDimension as PivotDateDimension_internal } from "./PivotDateDimension";
export declare class IgrPivotDateDimension extends IgrPivotDimension {
    protected createImplementation(): PivotDateDimension_internal;
    /**
                                 * @hidden
                                 */
    get i(): PivotDateDimension_internal;
    constructor();
    /**
     * Enables/Disables a particular dimension from pivot structure.
    */
    get enabled(): boolean;
    set enabled(v: boolean);
    /**
     * Gets/Sets data type
    */
    get dataType(): GridColumnDataType;
    set dataType(v: GridColumnDataType);
    /**
     * Gets/Sets the resource strings.
     * @remarks
     * By default it uses EN resources.
    */
    get resourceStrings(): IgrGridResourceStrings;
    set resourceStrings(v: IgrGridResourceStrings);
    /**
     * Gets/Sets the base dimension that is used by this class to determine the other dimensions and their values.
     * Having base dimension set is required in order for the Date Dimensions to show.
    */
    get baseDimension(): IgrPivotDimension;
    set baseDimension(v: IgrPivotDimension);
    /**
     * Gets/Sets the options for the predefined date dimensions whether to show quarter, years and etc.
    */
    get options(): IgrPivotDateDimensionOptions;
    set options(v: IgrPivotDateDimensionOptions);
    findByName(name: string): any;
}
