import { IgrPivotDimension } from "./igr-pivot-dimension";
import { IgrFilteringExpressionsTree } from "./igr-filtering-expressions-tree";
import { SortingDirection } from "./SortingDirection";
import { GridColumnDataType } from "./GridColumnDataType";
import { PivotDimensionDetail as PivotDimensionDetail_internal } from "./PivotDimensionDetail";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Configuration of a pivot dimension.
*/
export declare class IgrPivotDimensionDetail {
    protected createImplementation(): PivotDimensionDetail_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PivotDimensionDetail_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Allows defining a hierarchy when multiple sub groups need to be extracted from single member.
    */
    get childLevel(): IgrPivotDimension;
    set childLevel(v: IgrPivotDimension);
    /**
     * Field name to use in order to extract value.
    */
    get memberName(): string;
    set memberName(v: string);
    /**
     * Enables/Disables a particular dimension from pivot structure.
    */
    get enabled(): boolean;
    set enabled(v: boolean);
    /**
     * A predefined or defined via the `igxPivotSelector` filter expression tree for the current dimension to be applied in the filter pipe.
    */
    get filter(): IgrFilteringExpressionsTree;
    set filter(v: IgrFilteringExpressionsTree);
    /**
     * The sorting direction of the current dimension. Determines the order in which the values will appear in the related dimension.
    */
    get sortDirection(): SortingDirection;
    set sortDirection(v: SortingDirection);
    /**
     * The dataType of the related data field.
    */
    get dataType(): GridColumnDataType;
    set dataType(v: GridColumnDataType);
    /**
     * The width of the dimension cells to be rendered.Can be pixel or %.
    */
    get width(): string;
    set width(v: string);
    /**
     * Level of the dimension.
    */
    get level(): number;
    set level(v: number);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
