import { IgrDataCloneStrategy } from "./igr-data-clone-strategy";
import { IgrPivotKeys } from "./igr-pivot-keys";
import { IgrPivotDimension } from "./igr-pivot-dimension";
import { IgrPivotValue } from "./igr-pivot-value";
/**
 * Interface describing Pivot data processing for dimensions.
 * Should contain a process method and return records hierarchy based on the provided dimensions.
*/
export interface IgrPivotDimensionStrategy {
    process(collection: any, dimensions: IgrPivotDimension[], values: IgrPivotValue[], cloneStrategy: IgrDataCloneStrategy, pivotKeys: IgrPivotKeys): any[];
}
