import { PivotKeys as PivotKeys_internal } from "./PivotKeys";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Interface describing the Pivot data keys used for data generation.
 * Can be used for custom remote scenarios where the data is pre-populated.
*/
export declare class IgrPivotKeys {
    protected createImplementation(): PivotKeys_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PivotKeys_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Field that stores children for hierarchy building.
    */
    get children(): string;
    set children(v: string);
    /**
     * Field that stores reference to the original data records.
    */
    get records(): string;
    set records(v: string);
    /**
     * Field that stores aggregation values.
    */
    get aggregations(): string;
    set aggregations(v: string);
    /**
     * Field that stores dimension level based on its hierarchy.
    */
    get level(): string;
    set level(v: string);
    /**
     * Separator used when generating the unique column field values.
    */
    get columnDimensionSeparator(): string;
    set columnDimensionSeparator(v: string);
    /**
     * Separator used when generating the unique row field values.
    */
    get rowDimensionSeparator(): string;
    set rowDimensionSeparator(v: string);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
