import { IgrPivotAggregator } from "./igr-pivot-aggregator";
import { IgrPivotAggregatorCollection } from "./igr-pivot-aggregator-collection";
import { GridColumnDataType } from "./GridColumnDataType";
import { PivotValue as PivotValue_internal } from "./PivotValue";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Configuration of a pivot value aggregation.
*/
export declare class IgrPivotValue {
    protected createImplementation(): PivotValue_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): PivotValue_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Field name to use in order to extract value.
    */
    get member(): string;
    set member(v: string);
    /**
     * Display name to show instead of member for the column header of this value. *
    */
    get displayName(): string;
    set displayName(v: string);
    /**
     * Active aggregator definition with key, label and aggregator.
    */
    get aggregate(): IgrPivotAggregator;
    set aggregate(v: IgrPivotAggregator);
    private _aggregateList;
    /**
     * List of aggregates to show in aggregate drop-down.
    */
    get aggregateList(): IgrPivotAggregatorCollection;
    set aggregateList(v: IgrPivotAggregatorCollection);
    /**
     * Enables/Disables a particular value from pivot aggregation.
    */
    get enabled(): boolean;
    set enabled(v: boolean);
    /**
     * Allow conditionally styling of the IgxPivotGrid cells.
    */
    get styles(): any;
    set styles(v: any);
    /**
     * Enables a data type specific template of the cells
    */
    get dataType(): GridColumnDataType;
    set dataType(v: GridColumnDataType);
    findByName(name: string): any;
    setNativeElement(element: any): void;
}
