import { IgrPositionSettings } from "./igr-position-settings";
/**
 * [Documentation](https://www.infragistics.com/products/ignite-ui-angular/angular/components/overlay-position)
 * Position strategies determine where to display the component in the provided IgxOverlayService.
*/
export interface IgrPositionStrategy {
    /**
     * PositionSettings to use when position the component in the overlay
    */
    settings?: IgrPositionSettings;
    /**
     * Clone the strategy instance.
     * ```typescript
     * settings.positionStrategy.clone();
     * ```
    
    */
    clone(): IgrPositionStrategy;
}
