import { GroupSummaryDisplayMode } from "./GroupSummaryDisplayMode";
import { IgrCellInfo } from "./igr-cell-info";
import { SectionHeaderCellModel as SectionHeaderCellModel_internal } from "./SectionHeaderCellModel";
/**
 * Backing information for a section header cell in the grid.
*/
export declare class IgrSectionHeaderCellInfo extends IgrCellInfo {
    protected createImplementation(): SectionHeaderCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): SectionHeaderCellModel_internal;
    constructor();
    /**
     * Sets or gets the resolved text for the section header cell.
    */
    get resolvedText(): string;
    set resolvedText(v: string);
    /**
     * Sets or gets the resolved summary text for the section header cell.
    */
    get resolvedSummaryText(): string;
    set resolvedSummaryText(v: string);
    /**
     * Sets or gets how summaries are displayed in the section header cell.
    */
    get summaryDisplayMode(): GroupSummaryDisplayMode;
    set summaryDisplayMode(v: GroupSummaryDisplayMode);
}
