import { GroupSummaryDisplayMode } from "./GroupSummaryDisplayMode";
import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { SectionHeader } from "./SectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
export declare class IgrSectionHeader<P extends IIgrSectionHeaderProps = IIgrSectionHeaderProps> extends IgrDefinitionBase<P> {
    protected createImplementation(): SectionHeader;
    /**
                                 * @hidden
                                 */
    get i(): SectionHeader;
    constructor(props: P);
    get selectedBackground(): string;
    set selectedBackground(v: string);
    get actualSelectedBackground(): string;
    set actualSelectedBackground(v: string);
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    get paddingLeft(): number;
    set paddingLeft(v: number);
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    get paddingTop(): number;
    set paddingTop(v: number);
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    get paddingRight(): number;
    set paddingRight(v: number);
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    get paddingBottom(): number;
    set paddingBottom(v: number);
    get isCollapsable(): boolean;
    set isCollapsable(v: boolean);
    get summaryDisplayMode(): GroupSummaryDisplayMode;
    set summaryDisplayMode(v: GroupSummaryDisplayMode);
}
export interface IIgrSectionHeaderProps extends IIgrDefinitionBaseProps {
    selectedBackground?: string;
    actualSelectedBackground?: string;
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    paddingLeft?: number | string;
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    paddingTop?: number | string;
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    paddingRight?: number | string;
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    paddingBottom?: number | string;
    isCollapsable?: boolean | string;
    summaryDisplayMode?: GroupSummaryDisplayMode | string;
}
