import { IgrDefinitionBase, IIgrDefinitionBaseProps } from "./igr-definition-base";
import { SummaryRow } from "./SummaryRow";
export declare abstract class IgrSummaryRow<P extends IIgrSummaryRowProps = IIgrSummaryRowProps> extends IgrDefinitionBase<P> {
    /**
                                 * @hidden
                                 */
    get i(): SummaryRow;
    constructor(props: P);
    /**
     * Gets or sets the background color for summary cells when selected.
    */
    get selectedBackground(): string;
    set selectedBackground(v: string);
    /**
     * Gets the actual background color for summary cells when selected.
    */
    get actualSelectedBackground(): string;
    set actualSelectedBackground(v: string);
    /**
     * Gets or sets the text color for the summary labels.
    */
    get summaryLabelTextColor(): string;
    set summaryLabelTextColor(v: string);
    /**
     * Gets the actual text color for the summary labels.
    */
    get actualSummaryLabelTextColor(): string;
    set actualSummaryLabelTextColor(v: string);
    /**
     * Gets or sets the text style for the summary labels.
    */
    get summaryNameTextStyle(): string;
    set summaryNameTextStyle(v: string);
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    get paddingLeft(): number;
    set paddingLeft(v: number);
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    get paddingTop(): number;
    set paddingTop(v: number);
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    get paddingRight(): number;
    set paddingRight(v: number);
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    get paddingBottom(): number;
    set paddingBottom(v: number);
}
export interface IIgrSummaryRowProps extends IIgrDefinitionBaseProps {
    /**
     * Gets or sets the background color for summary cells when selected.
    */
    selectedBackground?: string;
    /**
     * Gets the actual background color for summary cells when selected.
    */
    actualSelectedBackground?: string;
    /**
     * Gets or sets the text color for the summary labels.
    */
    summaryLabelTextColor?: string;
    /**
     * Gets the actual text color for the summary labels.
    */
    actualSummaryLabelTextColor?: string;
    /**
     * Gets or sets the text style for the summary labels.
    */
    summaryNameTextStyle?: string;
    /**
     * Gets or sets the amount of left padding to use for the cell content for this column.
    */
    paddingLeft?: number | string;
    /**
     * Gets or sets the amount of top padding to use for the cell content for this column.
    */
    paddingTop?: number | string;
    /**
     * Gets or sets the amount of right padding to use for the cell content of this column.
    */
    paddingRight?: number | string;
    /**
     * Gets or sets the amount of bottom padding to use for the cell content of this column.
    */
    paddingBottom?: number | string;
}
