import { IgrTemplateHeaderCellUpdatingEventArgs } from "./igr-template-header-cell-updating-event-args";
import { IgrHeader, IIgrHeaderProps } from "./igr-header";
import { TemplateHeader } from "./TemplateHeader";
/**
 * A type of header with customizable content.
*/
export declare class IgrTemplateHeader extends IgrHeader<IIgrTemplateHeaderProps> {
    protected createImplementation(): TemplateHeader;
    /**
                                 * @hidden
                                 */
    get i(): TemplateHeader;
    constructor(props: IIgrTemplateHeaderProps);
    private _cellUpdating;
    private _cellUpdating_wrapped;
    /**
     * Called when the header cell content is being created or updated.
    */
    get cellUpdating(): (s: IgrTemplateHeader, e: IgrTemplateHeaderCellUpdatingEventArgs) => void;
    set cellUpdating(ev: (s: IgrTemplateHeader, e: IgrTemplateHeaderCellUpdatingEventArgs) => void);
}
export interface IIgrTemplateHeaderProps extends IIgrHeaderProps {
    /**
     * Called when the header cell content is being created or updated.
    */
    cellUpdating?: (s: IgrTemplateHeader, e: IgrTemplateHeaderCellUpdatingEventArgs) => void;
}
