import { IgrTemplateSectionHeaderCellUpdatingEventArgs } from "./igr-template-section-header-cell-updating-event-args";
import { IgrSectionHeader, IIgrSectionHeaderProps } from "./igr-section-header";
import { TemplateSectionHeader } from "./TemplateSectionHeader";
/**
 * Used to configure the appearance of the section header cells.
*/
export declare class IgrTemplateSectionHeader<P extends IIgrTemplateSectionHeaderProps = IIgrTemplateSectionHeaderProps> extends IgrSectionHeader<P> {
    protected createImplementation(): TemplateSectionHeader;
    /**
                                 * @hidden
                                 */
    get i(): TemplateSectionHeader;
    constructor(props: P);
    private _cellUpdating;
    private _cellUpdating_wrapped;
    /**
     * Called when the cell content is being created or updated.
    */
    get cellUpdating(): (s: IgrTemplateSectionHeader, e: IgrTemplateSectionHeaderCellUpdatingEventArgs) => void;
    set cellUpdating(ev: (s: IgrTemplateSectionHeader, e: IgrTemplateSectionHeaderCellUpdatingEventArgs) => void);
}
export interface IIgrTemplateSectionHeaderProps extends IIgrSectionHeaderProps {
    /**
     * Called when the cell content is being created or updated.
    */
    cellUpdating?: (s: IgrTemplateSectionHeader, e: IgrTemplateSectionHeaderCellUpdatingEventArgs) => void;
}
