import { EditorType } from "./EditorType";
import { IgrDataGridColumn, IIgrDataGridColumnProps } from "./igr-data-grid-column";
import { TextColumn } from "./TextColumn";
/**
 * Represents a Text grid column, used to allow the developer to display a formatted text in a cell.
*/
export declare class IgrTextColumn extends IgrDataGridColumn<IIgrTextColumnProps> {
    protected createImplementation(): TextColumn;
    /**
                                 * @hidden
                                 */
    get i(): TextColumn;
    constructor(props: IIgrTextColumnProps);
    /**
     * Gets or sets the editor type used for editing cells in this column.
    */
    get editorType(): EditorType;
    set editorType(v: EditorType);
    /**
     * Gets or sets the ComboBox data source.
    */
    get editorDataSource(): any;
    set editorDataSource(v: any);
    /**
     * Gets or sets the ComboBox text field.
    */
    get editorTextField(): string;
    set editorTextField(v: string);
    /**
     * Gets or sets the ComboBox value field.
    */
    get editorValueField(): string;
    set editorValueField(v: string);
}
export interface IIgrTextColumnProps extends IIgrDataGridColumnProps {
    /**
     * Gets or sets the editor type used for editing cells in this column.
    */
    editorType?: EditorType | string;
    /**
     * Gets or sets the ComboBox data source.
    */
    editorDataSource?: any;
    /**
     * Gets or sets the ComboBox text field.
    */
    editorTextField?: string;
    /**
     * Gets or sets the ComboBox value field.
    */
    editorValueField?: string;
}
