import { SortIndicatorStyle } from "./SortIndicatorStyle";
import { ColumnOptionsIconAlignment } from "./ColumnOptionsIconAlignment";
import { ColumnOptionsIconBehavior } from "./ColumnOptionsIconBehavior";
import { IgrTextCellInfo } from "./igr-text-cell-info";
import { TextHeaderCellModel as TextHeaderCellModel_internal } from "./TextHeaderCellModel";
/**
 * Backing information for a text header cell.
*/
export declare class IgrTextHeaderCellInfo extends IgrTextCellInfo {
    protected createImplementation(): TextHeaderCellModel_internal;
    /**
                                 * @hidden
                                 */
    get i(): TextHeaderCellModel_internal;
    constructor();
    /**
     * Sets or gets whether the filter UI should be visible in the header.
    */
    get isColumnOptionsEnabled(): boolean;
    set isColumnOptionsEnabled(v: boolean);
    get sortIndicatorStyle(): SortIndicatorStyle;
    set sortIndicatorStyle(v: SortIndicatorStyle);
    /**
     * Gets or sets the alignment of the column options icon within the header cell.
    */
    get columnOptionsIconAlignment(): ColumnOptionsIconAlignment;
    set columnOptionsIconAlignment(v: ColumnOptionsIconAlignment);
    /**
     * Gets or sets the color for the column options icon in the header.
    */
    get columnOptionsIconColor(): string;
    set columnOptionsIconColor(v: string);
    /**
     * Gets or sets how the column option icon will behave in the header.
    */
    get columnOptionsIconBehavior(): ColumnOptionsIconBehavior;
    set columnOptionsIconBehavior(v: ColumnOptionsIconBehavior);
}
