import { IgrToggleViewEventArgs } from "./igr-toggle-view-event-args";
import { IgrToggleViewCancelableEventArgs } from "./igr-toggle-view-cancelable-event-args";
import { IgrOverlaySettings } from "./igr-overlay-settings";
import { ToggleDirective as ToggleDirective_internal } from "./ToggleDirective";
import { ContentChildrenManager } from "igniteui-react-core";
export declare class IgrToggleDirective {
    protected createImplementation(): ToggleDirective_internal;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): ToggleDirective_internal;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor();
    protected _provideImplementation(i: any): void;
    /**
     * Identifier which is registered into `IgxNavigationService`
     * ```typescript
     * let myToggleId = this.toggle.id;
     * ```
    */
    get id(): string;
    set id(v: string);
    findByName(name: string): any;
    setNativeElement(element: any): void;
    /**
     * Opens the toggle.
     * ```typescript
     * this.myToggle.open();
     * ```
    
    */
    open(overlaySettings: IgrOverlaySettings): void;
    /**
     * Opens or closes the toggle, depending on its current state.
     * ```typescript
     * this.myToggle.toggle();
     * ```
    
    */
    toggle(overlaySettings: IgrOverlaySettings): void;
    /**
     * Repositions the toggle.
     * ```typescript
     * this.myToggle.reposition();
     * ```
    
    */
    reposition(): void;
    setOffset(deltaX: number, deltaY: number): void;
    private _opened;
    private _opened_wrapped;
    get opened(): (s: IgrToggleDirective, e: IgrToggleViewEventArgs) => void;
    set opened(ev: (s: IgrToggleDirective, e: IgrToggleViewEventArgs) => void);
    private _opening;
    private _opening_wrapped;
    get opening(): (s: IgrToggleDirective, e: IgrToggleViewCancelableEventArgs) => void;
    set opening(ev: (s: IgrToggleDirective, e: IgrToggleViewCancelableEventArgs) => void);
    private _closed;
    private _closed_wrapped;
    get closed(): (s: IgrToggleDirective, e: IgrToggleViewEventArgs) => void;
    set closed(ev: (s: IgrToggleDirective, e: IgrToggleViewEventArgs) => void);
    private _closing;
    private _closing_wrapped;
    get closing(): (s: IgrToggleDirective, e: IgrToggleViewCancelableEventArgs) => void;
    set closing(ev: (s: IgrToggleDirective, e: IgrToggleViewCancelableEventArgs) => void);
    private _appended;
    private _appended_wrapped;
    get appended(): (s: IgrToggleDirective, e: IgrToggleViewEventArgs) => void;
    set appended(ev: (s: IgrToggleDirective, e: IgrToggleViewEventArgs) => void);
}
